/*
 * MainFile.java
 * Copyright (c) 2006, Lyria.
 * All rights reserved.
 */

package eu.w4.ac.command;

import leon.app.*;


/**
 * This class contains the main method used to create Leonardi applications. It must be used for fat
 * clients (win viewer, swing viewer...). The usage is :<BR>
 *
 * <UL>
 *   <li><CODE>java LyMain [appname &lt;project&gt;.ini]+</CODE></li>
 * </UL>
 *
 * where <CODE>appname</CODE> is the name of the application and <CODE>&lt;project&gt;.ini</CODE>
 * the path of the ini file.
 *
 * @author  W4
 * @see     leon.app.LyApplication
 * @see     leon.app.LySession
 */
public class MainFile extends LyMain
{
	/**
	 * Main method. For each LyApplication started it creates a new LySession based on this
	 * application.
	 *
	 * @param argv The parameters that describe the applications that must be created (see usage in
	 *             the class description).
	 * @see   leon.app.LyApplication
	 * @see   leon.app.LySession
	 */
	public static void main(String[] argv)
	{
		startApplication("$APPLICATION_ID$", "$APPLICATION_INI$");
	}
} // end class MainFile
