
//********************************************//
//********************************************//
//                                            //
//    COPIED FROM TPL. DO NOT MODIFY HERE     //
//                                            //
//                                            //
//********************************************//
//********************************************//

package leon;

/**
 * Class containing the product properties
 */
public abstract class ProductProperties
{
  private ProductProperties()
  {
  }

  /**
   * Returns a boolean indicating if the product is official or not.
   * @return a boolean indicating if the product is official or not.
   */
  public static boolean isOfficial()
  {
    return true;
  }

  /**
   * Returns the product version.
   * @return the product version.
   */
  public static String getVersion()
  {
    return "8.9.0.40";
  }

  /**
   * Returns the product full version, containing the name, version and week/year of production.
   * @return the product full version, containing the name, version and week/year of production.
   */
  public static String getFullVersion()
  {
    return "<@(#) Application Composer 8.9.0.40 (2013.2) - Java>";
  }

  /**
   * Returns the product full name.
   * @return the product full name.
   */
  public static String getFullName()
  {
    return "BUSINESS FIRST Application Engine";
  }

  /**
   * Returns the product short name (technical name).
   * @return the product short name (technical name).
   */
  public static String getShortName()
  {
    return "Application Engine";
  }

  /**
   * Returns the product name with no space.
   * @return the product name with no space.
   */
  public static String getNameNoSpace()
  {
    return "applicationComposer";
  }

  /**
   * Returns the software home directory name for the isntaller.
   * @return the software home directory name for the isntaller.
   */
  public static String getInstallerSoftwareHomeDirectoryName()
  {
    return "@INSTALLER_SOFTWARE_HOME_DIR_NAME@";
  }

  /**
   * Returns the minimum required version of the common core library.
   * @return the minimum required version of the common core library.
   */
  public static String getCommonCoreLibraryMinimumVersion()
  {
    return "@COMMON_CORE_MANDATORY_VERSION@";
  }

  /**
   * Returns the minimum required version of the common client library.
   * @return the minimum required version of the common client library.
   */
  public static String getCommonClientLibraryMinimumVersion()
  {
    return "@COMMON_CLIENT_MANDATORY_VERSION@";
  }

  /**
   * Returns a printable form of this product properties.
   * @return a printable form of this product properties.
   */
  public static String getPrintableProperties()
  {
    final StringBuilder message = new StringBuilder();
    message.append(getFullVersion() + "\n");
    message.append(getFullName() + " " + getVersion() + "\n");
    return message.toString();
  }

  /**
   * Prints this product properties to stdout.
   */
  public static void printProperties()
  {
    System.out.println(getPrintableProperties());
  }
}
