/*
 * LyAdvancedViewManagerInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.app;

import leon.control.*;


/**
 * Specific interface for advanced methods between application and view manager.
 *
 * @author  Lyria S.A.
 * @version $Id: LyAdvancedViewManagerInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 */
public interface LyAdvancedViewManagerInterface
{

	/**
	 * File version
	 */
	String __VERSION =
		"$Id: LyAdvancedViewManagerInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Method invoked to complete a show view (used within eclipse mode).
	 *
	 * @param controller The view controller.
	 * @param pluginId   The plugin id.
	 */
	void completeShowView(LyController controller, String pluginId);

	/**
	 * Handles the controller's view displayed.
	 *
	 * @param controller The controller to handle.
	 */
	void handleShowView(LyController controller);

	/**
	 * Indicates if the session closing needs a confirmation (used within eclipse mode).
	 *
	 * @param  session The LySession to close.
	 * @return A boolean which indicates if a confirmation is required or not.
	 */
	boolean needConfirmOnClose(LySession session);
}