/*
 * LyApplicationListener.java
 * Copyright (c) 2012, W4.
 * All rights reserved.
 */
package leon.app;

import leon.data.LyObjectSource;

/**
 * Listener interface for LyApplication creation and deletion
 */
public interface LyApplicationListener
{
	/**
	 * Call when a new LyApplication is added in the list of all applications.
	 * @param application the added application
	 */
	void applicationAdded(LyApplication application);

	/**
	 * Call when a LyApplication was removed from the list of all applications.
	 * @param application the removed application
	 */
	void applicationRemoved(LyApplication application);

	/**
	 * Call when a LyObjectSource was added on the specified application
	 * @param application the application
	 * @param objectSource the added LyObjectSource
	 */
	void objectSourceAdded(LyApplication application, LyObjectSource objectSource);

	/**
	 * Call when a LyApplication is started
	 * @param application the application
	 */
	void applicationStarted(LyApplication application);
}
