/*
 * LyContextData.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.app;

import leon.control.*;
import leon.data.*;
import leon.info.*;


/**
 * Small structure which is useful as a client data to keep contetual information. Parameters can be
 * freely set and used by the application implementation.
 *
 * @author  Lyria S.A.
 * @version $Id: LyContextData.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @see     leon.view.LyViewManager#askQuestion(leon.view.LyComponent, String,
 *          leon.view.setinterface.LyQuestionAnswerInterface, Object)
 */
public class LyContextData
{
	/**
	 * File version
	 */
	public static final String __VERSION =
		"$Id: LyContextData.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/** freely set parameter (as client data). */
	public LyController		   _client;

	/** freely set parameter (as client data). */
	public LyAction			   _action;

	/** freely set parameter (as client data). */
	public LyClassInfo		   _classInfo;

	/** freely set parameter (as client data). */
	public LyObjectList		   _objects;

	/** freely set parameter (as client data). */
	public Object			   _parameter;

	/** freely set parameter (as client data). */
	public Object			   _clientData;

	/**
	 * Constructor. Initializes all parameters to null.
	 */
	public LyContextData()
	{
		_client = null;
		_action = null;
		_classInfo = null;
		_objects = null;
		_parameter = null;
		_clientData = null;
	}
} // end class LyContextData
