/*
 * LyInitializationFailedException.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.app;

/**
 * Class definThrown to indicate that we can't initialize the application.
 *
 * @author  Lyria S.A.
 * @version $Id: LyInitializationFailedException.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @see     leon.app.LyApplication
 * @see     leon.app.LyDataSession
 */
public class LyInitializationFailedException extends RuntimeException
{
	/**
	 * Serial version UID
	 */
	private static final long	serialVersionUID	= 3021576417874522722L;
	/**
	 * File version
	 */
	public static final String __VERSION =
		"$Id: LyInitializationFailedException.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Constructor with no detail message.<br />
	 * Only calls the super implementation.
	 */
	public LyInitializationFailedException()
	{
		super();
	}

	/**
	 * Constructor with the specified detail message.<br />
	 * Only calls the super implementation.
	 *
	 * @param message The detail message.
	 */
	public LyInitializationFailedException(String message)
	{
		super(message);
	}
}