/*
 * LyProcessActionInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.app;

import leon.control.*;
import leon.data.*;
import leon.info.*;


/**
 * Interface for action processing.
 *
 * @author  Lyria S.A.
 * @version $Id: LyProcessActionInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @see     leon.app.LySession
 * @see     leon.app.behavior.LySessionBehavior
 */
public interface LyProcessActionInterface
{
	/**
	 * File version
	 */
	String __VERSION = "$Id: LyProcessActionInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Process an action.
	 *
	 * @param  session   Session in which the action is executed.
	 * @param  parent    The source controller.
	 * @param  action    The action to execute.
	 * @param  classInfo The class on which the action applies.
	 * @param  objects   The list of objects on which the action applies.
	 * @return The controller result of this action if exists, null otherwise.
	 * @see    leon.app.behavior.LySessionBehavior#invokeAction(LySession, LyController, LyAction,
	 *         LyClassInfo, LyObjectList, boolean)
	 */
	LyController processAction(LySession session, LyController parent, LyAction action,
		LyClassInfo classInfo, LyObjectList objects);
}