/*
 * LyPrintBehavior.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.app.behavior;

import leon.app.behaviorinterface.*;
import leon.control.*;


/**
 * This class implements the default behavior for a LyPrintController.
 *
 * @author  Lyria S.A.
 * @version $Id: LyPrintBehavior.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @see     leon.control.LyPrintController
 * @see     leon.app.behaviorinterface.LyPrintBehaviorInterface
 */
public class LyPrintBehavior extends LyActionBehavior
	implements LyPrintBehaviorInterface
{
	/**
	 * File version
	 */
	public static final String __VERSION =
		"$Id: LyPrintBehavior.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Default constructor.
	 */
	public LyPrintBehavior()
	{
	}

	/**
	 * Method invoked before printing the object or object list.<br />
	 * <i>The default implementation</i> does nothing and returns false.
	 *
	 * @param  printer current LySimplePrintController instance
	 * @return true if the process is done (stop generic behavior) false otherwise.
	 */
	public boolean printBegin(LySimplePrintController printer)
	{
		return false;
	}

	/**
	 * Method invoked after printing the object or object list.<br />
	 * <i>The default implementation</i> does nothing and returns false.
	 *
	 * @param  printer current LySimplePrintController instance
	 * @return true is process is done (stop generic behavior) false otherwise.
	 */
	public boolean printEnd(LySimplePrintController printer)
	{
		return false;
	}
} // end class LyPrintBehavior
