/*
 * LyClassBehaviorInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.app.behaviorinterface;

/**
 * Generic interface for all behaviors that applies on action. This interface represents the default
 * behavior for consult, set, filter and delete actions.
 *
 * @author  Lyria S.A.
 * @version $Id: LyClassBehaviorInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @see     leon.app.behaviorinterface.LySetBehaviorInterface
 * @see     leon.app.behaviorinterface.LyCreateBehaviorInterface
 * @see     leon.app.behaviorinterface.LyDeleteBehaviorInterface
 * @see     leon.app.behaviorinterface.LyFilterBehaviorInterface
 */
public interface LyClassBehaviorInterface extends LySetBehaviorInterface,
	LyCreateBehaviorInterface,
	LyDeleteBehaviorInterface,
	LyFilterBehaviorInterface,
	LyOutlineBehaviorInterface
{
	/**
	 * File version
	 */
	String __VERSION = "$Id: LyClassBehaviorInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

}