/*
 * LyCreateBehaviorInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.app.behaviorinterface;

import leon.control.*;
import leon.data.*;


/**
 * This interface defines methods to implement in order to modify the behavior of a creation/clone
 * action.
 *
 * @see leon.control.LyCreateController
 */
public interface LyCreateBehaviorInterface extends LySetBehaviorInterface
{
	/**
	 * File version
	 */
	String __VERSION = "$Id: LyCreateBehaviorInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Final step of the object creation process.
	 *
	 * @param  create the current LyCreateController instance
	 * @param  values Set of values corresponding to the object to create
	 * @return true if the create process is successfull, false otherwise
	 */
	boolean endCreation(LyCreateController create, LyValueSet values);
}