/*
 * LyEditTableBehaviorInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.app.behaviorinterface;

import leon.control.*;


/**
 * This interface defines methods to implement in order to modify the default behavior of an edit
 * table controller.
 *
 * @author  Lyria S.A.
 * @version $Id: LyEditTableBehaviorInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @see     leon.control.LyEditTableController
 */
public interface LyEditTableBehaviorInterface extends LyTableBehaviorInterface
{
	/**
	 * File version
	 */
	String __VERSION = "$Id: LyEditTableBehaviorInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Indicates if tools should be displayed at the end of an edit table row.<br />
	 * These tools allow the end-user to cancel or validate modifications made on a single line.
	 * @param tableController the table controller
	 * @return true is tools should be displayed, false otherwise.
	 */
	boolean displayRowTools(LyEditTableController tableController);
}