/*
 * LyImportBehaviorInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.app.behaviorinterface;

import leon.control.*;
import leon.info.*;


/**
 * This interface defines the methods to implement in order to modify the behavior of an import
 * action.
 *
 * @author  Lyria S.A.
 * @version $Id: LyImportBehaviorInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @see     LyImportController
 */
public interface LyImportBehaviorInterface extends LyActionBehaviorInterface
{
	/**
	 * File version
	 */
	String __VERSION = "$Id: LyImportBehaviorInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Checks if the import can be done with the given list of selected fields.
	 *
	 * @param  controller the current import controller
	 * @param  fields     the fields we want to check
	 * @return an error message if the import can not be done with the given selected files, null if
	 *         everything is fine
	 */
	String checkFields(LyImportController controller, LyInfoList<LyFieldInfo> fields);
}