/*
 * LyOutlineBehaviorInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.app.behaviorinterface;

import leon.control.*;
import leon.info.*;


/**
 * Generic interface for all behaviors that applies on outline action.
 *
 * @see LyOutlineController
 */
public interface LyOutlineBehaviorInterface extends LyFormBehaviorInterface
{
	/**
	 * File version
	 */
	String __VERSION = "$Id: LyOutlineBehaviorInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Get action used for fast edition of given field.
	 *
	 * @param  outline   the current LyOutlineController instance.
	 * @param  fieldInfo the fieldInfo to be edited.
	 * @return The action to be used for fast editing or null if field id not editable.
	 */
	LyAction getSetAction(LyOutlineController outline, LyFieldInfo fieldInfo);
}