/*
 * LyPrintBehaviorInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.app.behaviorinterface;

import leon.control.*;


/**
 * This interface defines methods to implement to have a specific printing behavior.
 *
 * @author  Lyria S.A.
 * @version $Id: LyPrintBehaviorInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @see     leon.control.LyPrintController
 */
public interface LyPrintBehaviorInterface extends LyActionBehaviorInterface
{
	/**
	 * File version
	 */
	String __VERSION = "$Id: LyPrintBehaviorInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Method invoked before printing the object or object list.
	 *
	 * @param  printer current LySimplePrintController instance
	 * @return true if the process is done (stop generic behavior) false otherwise.
	 */
	boolean printBegin(LySimplePrintController printer);

	/**
	 * Method invoked after printing the object or object list.
	 *
	 * @param  printer current LySimplePrintController instance
	 * @return true if the process is done (stop generic behavior) false otherwise.
	 */
	boolean printEnd(LySimplePrintController printer);
}