/*
 * LyUserInputBehaviorInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.app.behaviorinterface;

import leon.control.*;
import leon.view.event.*;


/**
 * This interface defines the method to implement in order to manage a user input controller.
 *
 * @author  Lyria S.A.
 * @version $Id: LyUserInputBehaviorInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @see     leon.control.LyUserInputController
 */
public interface LyUserInputBehaviorInterface extends LyActionBehaviorInterface
{
	/**
	 * File version
	 */
	String __VERSION = "$Id: LyUserInputBehaviorInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Invoked when the user validates the input content.
	 *
	 * @param controller the current LyUserInputController instance
	 * @param demand     demand parameters sent by the view component.
	 */
	void userInputDemand(LyController controller, LyDemand demand);
}