/*
 * LyWebServicesBehaviorInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.app.behaviorinterface;

import leon.info.LyFieldInfo;

/**
 * This interface defines the method to implement in order to manage a user input controller.
 *
 * @author  Lyria S.A.
 * @version $Id: LyWebServicesBehaviorInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @see     leon.control.LyUserInputController
 */
public interface LyWebServicesBehaviorInterface extends	LyUserInputBehaviorInterface {

	/**
	 * File version
	 */
	String __VERSION = "$Id: LyWebServicesBehaviorInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Here you can update the given field info.
	 * Use only for response containing complex type.
	 *  
	 * @param fieldInfo a fieldinfo
	 * @return fieldInfo an updated fieldInfo
	 */
	public LyFieldInfo updateFieldInfo(LyFieldInfo fieldInfo);
	
	/**
	 * Here you can specify the type of a field info.
	 * Use only for response containing complex type.
	 * 
	 * @param name
	 * @return the type of the field
	 */
	public int getFieldInfoType(String name);
}
