/**
 * LyContextInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * Current version: $Id: LyContextInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 */

package leon.control;

import leon.data.*;


/**
 * This interface is implemented by controllers which accept contextual views.
 */
public interface LyContextInterface
{
	/**
	 * File version
	 */
	String __VERSION = "$Id: LyContextInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Set current controller context.
	 *
	 * @param  context current context or null if none is specified
	 * @return True if controlled view was resetted, false otherwise.
	 * @see    LyContextInterface#getContext
	 */
	boolean setContext(LyWorkSpace context);

	/**
	 * Get current controller context.
	 *
	 * @return current context or null if none is specified
	 * @see    LyContextInterface#getContext
	 */
	LyWorkSpace getContext();
}