/**
 * LyControllerContextInterface2.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * Current version: $Id: LyControllerContextInterface2.java 28422 2010-11-03 12:03:38Z ehelmste $
 */

package leon.control;

import leon.data.*;


/**
 * This interface is implemented by controllers which have a LyContext object for updates and may
 * have a context depending on the controller making the request. Additionnally, controllers
 * implementing this interface define a root controller context in lySession. Internal use ONLY for
 * ImportTableController.
 *
 * @see leon.app.LySession#getRootContextController
 */
public interface LyControllerContextInterface2 extends LyControllerContextInterface
{
	/**
	 * File version
	 */
	String __VERSION =
		"$Id: LyControllerContextInterface2.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Get current controller context.
	 *
	 * @param  controller Controller wich is requesting the context
	 * @return current context or null if none is specified
	 * @see    LyControllerContextInterface#getControllerContext
	 */
	LyContext getControllerContext(LyController controller);
}