/*
 * LyFilterEndInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * Current version: $Id: LyFilterEndInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 */

package leon.control;

import leon.info.*;


/**
 * Implemented by the client of a filter edition form (either an elementary filter such as
 * LyFilterController or an extented filter view (LyFilterEditorController).
 *
 * <P>This interface is implemented by a listener (usually a table controller or the extended filter
 * controller when an elementary filter is created). The listener is notified when the filter has
 * been set by the user in the filtering form.</P>
 *
 * @see LyFilterController#actionDemand
 */
public interface LyFilterEndInterface
{
	/** File Version */
	String __VERSION = "$Id: LyFilterEndInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Gets initial : indicates to the filter controller the default filter parameters.
	 *
	 * @return the initial filter or null if no filter is set
	 */
	LyFilter getFilter();

	/**
	 * The filter edition form is closed : notify registred listener.
	 *
	 * @param parent       reference to the filter controller (filter form which is closing)
	 * @param actionDemand actionDemand on filter controller : id of the command such as
	 *                     LyFormController.DEMAND_VALIDATE, LyFormController.DEMAND_APPLY,
	 *                     LyFormController.DEMAND_CANCEL
	 * @param filter       the filter that was created in the form
	 */
	void endFilter(LyController parent, String actionDemand, LyFilter filter);

}