/*
 * LyFindInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * Current version: $Id: LyFindInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 */

package leon.control;

/**
 * Implemented by the client of a find form.
 *
 * <P>This interface is implemented by a listener (usually a panel controller when a search is
 * started). The listener is notified when a search has been set by the user in the find form.</P>
 *
 * @see LyFindController#actionDemand
 */
public interface LyFindInterface
{
	/** File Version */
	String __VERSION = "$Id: LyFindInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Find object in the view and select it.
	 *
	 * @param find           find controller that manages the find form.
	 * @param from           index to start from (-1 : begin)
	 * @param next           next selection or previous one.
	 * @return the index of the found object
	 */
	int findObject(LyFindController find, int from, boolean next);
}