/*
 * LyFormResultInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * Current version: $Id: LyFormResultInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 */

package leon.control;

import leon.data.*;
import leon.info.*;


/**
 * This interface is provided to allow a form to notify to its parent controller that an object was
 * created for a given relation.
 */
public interface LyFormResultInterface
{
	/** File Version */
	String __VERSION = "$Id: LyFormResultInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Notify object creation to parent.
	 *
	 * @param object   Object created by the creation form.
	 * @param relation Relation for which the object was created.
	 */
	void notifyFormResult(LyObject object, LyRelationFieldInfo relation);
}