/*
 * LySelectFileListenerInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.control;


import leon.view.event.*;


/**
 * This interface defines the method to implement in order to manage a user input controller.
 *
 * @author  Lyria S.A.
 * @version $Id: LySelectFileListenerInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @see     leon.control.LyUserInputController
 */
public interface LySelectFileListenerInterface 
{
	/** File Version */
	String __VERSION = "$Id: LySelectFileListenerInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Invoked when the user validates the input content.
	 *
	 * @param controller the current LySelectFileController instance
	 * @param demand     demand parameters sent by the view component.
	 */
	void selectFileDemand(LySelectFileController controller, LyDemand demand);
}