/*
 * LySortEndInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * Current version: $Id: LySortEndInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 */

package leon.control;

import leon.info.*;


/**
 * Implemented by the client of a sort edition form.
 *
 * <P>This interface is implemented by a listener (usually a table controller or the extended filter
 * controller when an elementary filter is created). The listener is notified when the sort has been
 * set by the user in the filtering form.</P>
 *
 * @see LySortWizardController#actionDemand
 */
public interface LySortEndInterface
{
	/** File Version */
	String __VERSION = "$Id: LySortEndInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Gets initial : indicates to the sort controller the default sort parameters.
	 *
	 * @return the initial sort or null if no sort is set
	 */
	LySort getSort();

	/**
	 * The sort edition form is closed : notify registred listener.
	 *
	 * @param parent       reference to the filter controller (filter form which is closing)
	 * @param actionDemand actionDemand on sort controller : id of the command such as
	 *                     LyFormController.DEMAND_VALIDATE, LyFormController.DEMAND_APPLY,
	 *                     LyFormController.DEMAND_CANCEL
	 * @param sort         the sort that was created in the form
	 */
	void endSort(LyController parent, String actionDemand, LySort sort);

}