/**
 * LyTransverseInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * Current version: $Id: LyTransverseInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 */

package leon.control;

import leon.info.*;


/**
 * This interface is implemented by controllers that control transverse actions.
 */
public interface LyTransverseInterface
{
	/** File Version */
	String __VERSION = "$Id: LyTransverseInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Sets relation parent : this method is invoked when this controller is a child of another form
	 * (dynamic popup creation of an object in a relation field).
	 *
	 * @param client   The client to call back with the result of the action.
	 * @param relation the relation fieldInfo which is updated as the result of the current action
	 *                 (usually dynamic popup creation)
	 */
	void setRelationParent(LyFormResultInterface client, LyRelationFieldInfo relation);
}