/**
 * LyXRefAreaController.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * Current version: $Id: LyXRefAreaController.java 28422 2010-11-03 12:03:38Z ehelmste $
 */

package leon.control;

import leon.app.*;
import leon.data.*;
import leon.info.*;


/**
 * This controller implements a cross referenced view It is based on a coumpound area.
 *
 * @see LyCompoundAreaController
 */
public class LyXRefAreaController extends LyCompoundAreaController
{
	/** File Version */
	public static final String __VERSION =
		"$Id: LyXRefAreaController.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Constructor.
	 *
	 * @param session   current session associated to the controller. The controller automatically
	 *                  registers on the specified session.
	 * @param parent    parent controller (or null for 'root' controller). Controller hierarchy
	 *                  indicates a child controller (for example a dialog created from a main view)
	 * @param action    related action. If an action is specified, the controller uses action
	 *                  parameters (action name, action specific XML view description ...)
	 * @param classInfo classInfo associated with this controller
	 * @param context   current context (may be null if the view is not contextual to a list of
	 *                  objects).
	 */
	public LyXRefAreaController(LySession session, LyController parent, LyAction action,
		LyClassInfo classInfo, LyObjectList context)
	{
		super(session, parent,
			((action instanceof LyCompoundAction) ? action : new LyCompoundAction(action)),
			classInfo, context);
	}
}