 /**
 * LyCreateStickerBuilder.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * Current version: $Id: LyTextBuilder.java 18286 2009-11-19 10:30:29Z jls $
 */

package leon.control.builder;

import leon.control.*;
import leon.info.*;
import leon.view.*;


/**
 * Creates a view for a sticker.
 *
 * @see LyTextController
 */
public class LyCreateStickerBuilder extends LyAreaBuilder
{
	public static final String __VERSION =
		"$Id: LyTextBuilder.java 18286 2009-11-19 10:30:29Z jls $";

	/**
	 * Default constructor.
	 *
	 * @param parent Parent controller of this builder
	 */
	public LyCreateStickerBuilder(LyController parent)
	{
		super(parent);
	}

	/**
	 * Builds the view component for the specified parent controller. The component may create the
	 * XML Tree or the internal view.
	 *
	 * @return the view Component
	 */
	public LyComponent build()
	{
		LyCreateStickerController	stickerController = (LyCreateStickerController)_parent;
		LySticker					sticker = stickerController.getSticker();
		LyArea						area = new LyArea();
		LyNotice					notice = new LyNotice(sticker.getId() + "_notice");
		LyLabel						label = new LyLabel();
		
		label.setLabel(sticker.getContent());
		notice.setLabel(label);
		notice.setStyle(LyNotice.Style.STICKER);
		notice.setColor("LY_STICKER_BACKGROUND");
		notice.setController(_parent.getId());
		area.addPanel(notice);
		
		_component = area;
		
		return area;
	}
} // end class LyCreateStickerBuilder
