package leon.control.builder;

import leon.control.*;
import leon.info.*;
import leon.misc.*;
import leon.view.*;

/**
 * Implement the builder for the __showMessage action.
 * This builder change the command bar to have a close button
 *
 */
public class LyMessageBuilder extends LyUserInputBuilder
{
	public LyMessageBuilder()
	{
		this(null);
	}

	/**
	 * Default constructor.
	 *
	 * @param parent parent controller
	 */
	public LyMessageBuilder(LyController parent)
	{
		super(parent);
	}

	@Override
	protected LyCommands buildCommands()
	{
		LyAction action = ((LyAreaController)_parent).getAction();

		if (action.hasMark(LyAction.MARK_NO_COMMANDS))
			return null;

		LyEnvironment environment = _parent.getEnvironment();
		LyCommands commands = new LyCommands();
		LyCommand  command;

		commands = new LyCommands();
		command = new LyCommand(LyFormController.DEMAND_CANCEL, "LY_CLOSE");
		command.setAction(LyCommand.Action.CANCEL);

		if (environment.checkImage("LY_COMMAND_CLOSE"))
			command.setImage("LY_COMMAND_CLOSE");
			
		commands.addCommand(command);

		command = buildHelpCommand();
		if (command != null)
			commands.addCommand(command);

		return commands;
	} // end method buildCommands
}
