/**
 * LyShareSessionBuilder.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * Current version: $Id: LyUserInputBuilder.java 28422 2010-11-03 12:03:38Z ehelmste $
 */

package leon.control.builder;

import leon.control.*;
import leon.misc.*;


/**
 * Creates a view to type in a new simple find selection view.
 *
 * @see LyUserInputController
 */
public class LyShareSessionBuilder extends LyUserInputBuilder
{
	/**
	 * Default constructor.
	 *
	 */
	public LyShareSessionBuilder()
	{
		super();
	}

	/**
	 * Default constructor.
	 *
	 * @param parent parent controller
	 */
	public LyShareSessionBuilder(LyController parent)
	{
		super(parent);
	}

	/**
	 * Creates the form content.
	 */
	protected void buildFormContent()
	{
		LyEnvironment	environment = _parent.getEnvironment();
		String			message = environment.getMessage("LY_CONFIRM_SHARING_SESSION");

		addLabel("SHARE_SESSION_TIP", null, message);
	}
} // end class LyShareSessionBuilder
