/**
 * LyArrayStructFieldSetController.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * Current version: $Id: LyArrayStructFieldSetController.java 28422 2010-11-03 12:03:38Z ehelmste $
 */

package leon.control.form;

import leon.control.*;
import leon.data.*;
import leon.info.*;


/**
 * Field controler for modification of an array of struct.
 * @see LySetController
 */
public class LyArrayStructFieldSetController extends LyArrayFieldSetController
{
	/** File version */
	public static final String __VERSION =
		"$Id: LyArrayStructFieldSetController.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Constructor.
	 * @param parent parent set controller
	 * @param fieldInfo array field handled by this controller
	 */
	public LyArrayStructFieldSetController(LySetController parent,
		LyArrayFieldInfo fieldInfo)
	{
		super(parent, fieldInfo);
	}

	/**
	 * @see leon.control.form.LyArrayFieldSetController#getFieldController(int)
	 */
	public LyFieldController getFieldController(int index)
	{
		LyFieldController fieldController = super.getFieldController(index);

//              if (!(fieldController instanceof LyStructFieldSetController))
//                      return fieldController;

		LyObject		  object = getObject();

		if ((index >= 0) && (object != null))
		{
			LyObjectId[] values = (LyObjectId[])object.getValue(_fieldInfo);

			if ((values != null) && (values.length > index))
			{
				LyObject structObject = values[index].getLogicalObject();

				((LyStructFieldSetController)fieldController).setStructObject(structObject);
			}
		}

		return fieldController;
	}
} // end class LyArrayStructFieldSetController
