/**
 * LyRelationFieldController.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * Current version: $Id: LyRelationFieldController.java 28422 2010-11-03 12:03:38Z ehelmste $
 */

package leon.control.form;

import leon.control.*;
import leon.info.*;


/**
 * Default field controller for a relation.
 * @see LyFormController
 */
public class LyRelationFieldController extends LyFieldController
{
	/** File version */
	public static final String __VERSION =
		"$Id: LyRelationFieldController.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Constructor.
	 * @param parent  parent controller (or null for 'root' controller).
	 * @param relation field handled by this controller
	 */
	public LyRelationFieldController(LyAreaController parent, LyRelationFieldInfo relation)
	{
		super(parent, relation);
	}

	/**
	 * Internal method to invoke on a relation a transverse action for a given classInfo.
	 * @param action    Transverse action.
	 * @param classInfo Class info on which the action is applied.
	 */
	public void invokeTransverseAction(LyAction action, LyClassInfo classInfo)
	{
		LyAreaController controller = (LyAreaController)invokeAction(action, classInfo, null,
				false);

		if (controller != null)
		{
			if ((controller instanceof LyTransverseInterface)
					&& (_formController instanceof LyFormResultInterface))
				((LyTransverseInterface)controller).setRelationParent((LyFormResultInterface)
					_formController, (LyRelationFieldInfo)_fieldInfo);
			controller.showView();
		}
	}
} // end class LyRelationFieldController
