/*
 * LyErrorListener.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * Current version: $Id: LyErrorListener.java 28422 2010-11-03 12:03:38Z ehelmste $
 */
package leon.data;

/**
 * Listener for error events.
 *
 * @author nla
 */
public interface LyErrorListener extends LyDataSourceListener
{
	/** File version */
	String __VERSION = "$Id: LyErrorListener.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Method for receiving an error creation.
	 *
	 * @param  event Event notifying the addition of an error.
	 * @return True indicating if the event was used, false otherwise.
	 */
	boolean errorAdded(LyDataSourceEvent event);

	/**
	 * Method for receiving an error deletion.
	 *
	 * @param  event Event notifying the deletion of an error.
	 * @return True indicating if the event was used, false otherwise.
	 */
	boolean errorRemoved(LyDataSourceEvent event);
}