/*
 * LyEventInfo.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * $Id: LyEventInfo.java 28422 2010-11-03 12:03:38Z ehelmste $
 */

package leon.data;

/**
 * This class is used to store additional informations for data events.
 *
 * @see LyDataSourceEvent
 * @see LyWorkSpaceEvent
 */
public class LyEventInfo
{
	/** File version */
	public static final String __VERSION =
		"$Id: LyEventInfo.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**  */
	LyObject				   _object;

	/**  */
	LyValueSet				   _values;

	/**  */
	LyEventInfo				   _additionalEventInfo;

	/**
	 */
	public LyEventInfo()
	{
		super();
	}

	/**
	 * @return Returns the object.
	 */
	public LyObject getObject()
	{
		return _object;
	}

	/**
	 * @return Returns the values.
	 */
	public LyValueSet getValues()
	{
		return _values;
	}

	/**
	 * @return Returns the additionalEventInfo.
	 */
	public LyEventInfo getAdditionalEventInfo()
	{
		return _additionalEventInfo;
	}

	/**
	 * @param object The object to set.
	 */
	public void setObject(LyObject object)
	{
		_object = object;
	}

	/**
	 * @param values The values to set.
	 */
	public void setValues(LyValueSet values)
	{
		_values = values;
	}

	/**
	 * @param additionalEventInfo The additionalEventInfo to set.
	 */
	public void setAdditionalEventInfo(LyEventInfo additionalEventInfo)
	{
		_additionalEventInfo = additionalEventInfo;
	}

} // end class LyEventInfo
