/*
 * LyGetDataSourceListenersInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.data;

import java.util.*;


/**
 * This interface is used by LyDataSource (and LyObjectSource) when receiving a response to a
 * request from a request encoder, to avoid posting an event to listeners that have already been
 * informed.
 *
 * @see LyResponse
 * @see leon.peer.LyRequestEncoder
 * @see LyDataSource
 * @see LyObjectSource
 */
public interface LyGetDataSourceListenersInterface
{
	/** File version */
	String __VERSION =
		"$Id: LyGetDataSourceListenersInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Gets list of listeners that have been notified of the response of the last request to request
	 * encoder.
	 *
	 * @return List of notified listeners (may be null).
	 */
	Vector<LyDataSourceListener> getDataSourceListeners();
}