/*
 * LyWorkSpaceCounterListener.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.data;

/**
 * This interface is the listener interface for receiving object events on workspaces for counter
 * incrementation and decrementation.
 *
 * @see LyWorkSpace
 * @see LyWorkSpaceEvent
 */
public interface LyWorkSpaceCounterListener
{
	/** File version */
	String __VERSION = "$Id: LyWorkSpaceCounterListener.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Called when the counter associated with the specified object has been incremented or
	 * decremented.
	 *
	 * @param  event Event notifying counter change.
	 * @return True if the event is used by the listener, false otherwise.
	 */
	boolean counterChanged(LyWorkSpaceEvent event);
}