/*
 * LyClassControl.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.data.datainterface;

import leon.data.*;
import leon.info.*;
import leon.info.misc.*;


/**
 * Generic interface for all class controls.
 */
public interface LyClassControl extends LyControlInterface
{
	/** File version */
	String __VERSION = "$Id: LyClassControl.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Global control of values before creating or modifying an object. If needed, extra values may
	 * be added during this control.
	 *
	 * @param  control   the description of the control.
	 * @param  object    the modified object.
	 * @param  newValues Set of values to control.
	 * @param  args      the list of arguments specified in the XML description of the control
	 * @return STATUS_ERROR if the control raises an error STATUS_WARNING if the control raises a
	 *         warning STATUS_OK if the control is correct All other positive short values for user
	 *         specific warning level.
	 */
	short validate(LyControl control, LyObject object,
		LyValueSet newValues, LyArgument[] args);
}