/*
 * LyFieldInfoControl.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.data.datainterface;

import leon.data.*;
import leon.info.*;
import leon.info.misc.*;


/**
 * Generic interface for all fieldInfo controls.
 */
public interface LyFieldInfoControl extends LyControlInterface
{
	/** File version */
	String __VERSION = "$Id: LyFieldInfoControl.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Dynamic check the value for the given field. This method is called when there is a
	 * modification of the field in the user interface (Value changed, focus lost...).
	 *
	 * @param  control  the description of the control.
	 * @param  object   the modified object.
	 * @param  newValue field info value to check. This parameter cannot be null.
	 * @param  args     the list of arguments specified in the XML description of the control
	 * @return STATUS_ERROR if the control raises an error STATUS_WARNING if the control raises a
	 *         warning STATUS_OK if the control is correct All other positive short values for user
	 *         specific warning level.
	 */
	short checkNewValue(LyControl control, LyObject object,
		LyFieldInfoValue newValue, LyArgument[] args);
}