package leon.data.datainterface;

import leon.data.LyOperation;
import leon.data.LyResponse;

/**
 * Generic interface to execute a user operation in a context
 *
 */
public interface LyUserOperationInterface
{
	/**
	 * Execute a user operation
	 * @param operation the operation to execute
	 * @param userData the user data
	 * @param local true to execute the operation in local mode
	 * @param refresh true to force refresh
	 * @param redo true to indicate a redo
	 * @param control the control to execute
	 * @return
	 */
	public LyResponse send(LyOperation operation, Object userData, 
			boolean local, boolean refresh, boolean redo, int control);
}
