/*
 * LyChoiceItem.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.info;

/**
 * Interface for LyChoiceOption and LyChoiceOptionGroup.
 */
public interface LyChoiceItem
{
	String __version = "$Id: LyChoiceItem.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Accessor to the id of the choice item.
	 *
	 * @return the id of this choice item
	 */
	String getId();

	/**
	 * Accessor to the name of this choice item.
	 *
	 * @return the name of this choice item
	 */
	String getName();

	/**
	 * Accessor to the alias of the choice item.
	 *
	 * @return the alias of this choice item
	 */
	String getAlias();

	/**
	 * Accessor to the value of this options group.
	 *
	 * @return Value of this options group.
	 */
	Object getValue();

	/**
	 * Gets the short value corresponding to the internal value. Used to optimize processings when
	 * internal values are shorts.
	 *
	 * @return Short value corresponding to this group, 1 if value can't be casted to a short.
	 */
	short getShortValue();
}