/*
 * LyFieldInfoFormatException.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.info;

/**
 * Thrown to indicate that the application has attempted to convert a string to a value for a field
 * info with the parse method but that the string does not have an appropriate format.
 *
 * @author  Lyria
 * @see     LyFieldInfo
 * @version $Id: LyFieldInfoFormatException.java 28997 2010-12-23 10:17:15Z bmichel $
 */
public final class LyFieldInfoFormatException extends RuntimeException
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1201321123728691715L;
	public static final String __VERSION =
		"$Id: LyFieldInfoFormatException.java 28997 2010-12-23 10:17:15Z bmichel $";

	/**
	 * Constructs a <code>LyFieldInfoFormatException</code> with no detailed message.
	 */
	public LyFieldInfoFormatException()
	{
		super();
	}

	/**
	 * Constructs a <code>LyFieldInfoFormatException</code> with the specified detailed message.
	 *
	 * @param message Detailed message.
	 */
	public LyFieldInfoFormatException(String message)
	{
		super(message);
	}
}