/*
 * LyCharType.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.info;

/**
 * This class defines a characters type (list of valid characters) associated to a text.
 */
public class LyInfoCharType extends LyInfo
{
	public static final String __VERSION =
		"$Id: LyInfoCharType.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/** Value of the unit. */
	String					   _value;

	/* Constructor */

	/**
	 * Constructor of a characters type.
	 *
	 * @param id    Id of the chartype.
	 * @param value Value of the chartype.
	 */
	LyInfoCharType(String id, String value)
	{
		this(id);
		construct(value);
	}

	/**
	 * Constructor of a characters type.
	 *
	 * @param id Id of the chartype.
	 */
	LyInfoCharType(String id)
	{
		super(id, false);
	}

	/**
	 * Construction of a characters type.
	 *
	 * @param value Value of the chartype.
	 */
	void construct(String value)
	{
		super.construct();
		setValue(value);
	}

	/**
	 * Gets value of the chartype.
	 */
	public final String getValue()
	{
		load();
		return _value;
	}
    
    /**
     * Sets value of the chartype.
     */
    protected void setValue(String value)
    {
        _value = ((value == null) ? null : value.intern());
    }
} // end class LyInfoCharType
