/*
 * LyUnsupportedFieldBindingException.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.info;

/**
 * Thrown to indicate that the specified field binding can't be done generically (without specific
 * coding). This exception can occur for different reasons : - for a simple binding (one to one) :
 * this is due to unsupported type conversion from field type to field info type (see valid type
 * conversions for each type of the field info), - for a multiple binding (one to many) : this is
 * thrown for an unsupported composition (due to invalid field types or too many fields specified in
 * this binding), (see valid compositions for each type of field info), - for a partial binding
 * (many to one) : this is thrown for an unsupported splitting (due to invalid field info types or
 * too many field infos specified for this binding), (see valid splittings for each type of field
 * info), conversion from field type to field info type
 *
 * @author  Lyria
 * @see     LyFieldInfo
 * @version $Id: LyUnsupportedFieldBindingException.java 28997 2010-12-23 10:17:15Z bmichel $
 */
public class LyUnsupportedFieldBindingException extends RuntimeException
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1782020757305670580L;
	public static final String __VERSION =
		"$Id: LyUnsupportedFieldBindingException.java 28997 2010-12-23 10:17:15Z bmichel $";

	/**
	 * Constructs a <code>LyUnsupportedFieldBindingException</code> with no detail message.
	 */
	public LyUnsupportedFieldBindingException()
	{
		super();
	}

	/**
	 * Constructs a <code>LyUnsupportedFieldBindingException</code> with the specified detail
	 * message.
	 *
	 * @param message the detail message.
	 */
	public LyUnsupportedFieldBindingException(String message)
	{
		super(message);
	}
}