/*
 * LyLdapClassBinding.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.info.binding;

import leon.info.*;


/**
 * Container for the binding information found in the data description for classInfo.
 */
public class LyLdapClassBinding extends LyClassBinding
{
	public static final String __VERSION =
		"$Id: LyLdapClassBinding.java 31911 2011-08-05 11:50:32Z achebbin $";

	/** FDN format for LDAP servers. */
	String					   _fdnFormat;
  String             _rdn;
  String             _classFilter;

 

    /**
     * Constructor.
     * @param binding  content of the binding information
     */
    public LyLdapClassBinding(String binding)
    {
        super(binding, null, null);
    }
    
	/**
	 * Constructor.
	 * @param binding  content of the binding information
	 * @param location identify which data provider should be used.
	 * @param filter   filter used when loading objects.
	 */
	public LyLdapClassBinding(String binding, String location, LyFilter filter)
	{
		super(binding, location, filter);
	}

	/**
	 */
	public String getFdnFormat()
	{
		return _fdnFormat;
	}

	/**
	 */
	public void setFdnFormat(String fdnFormat)
	{
		_fdnFormat = fdnFormat;
	}

  public String getRdn()
  {
    return _rdn;
  }

  public void setRdn(String rdnName)
  {
    _rdn = rdnName;
  }
  
  public String getClassFilter()
  {
    return _classFilter;
  }

  public void setClassFilter(String classFilter)
  {
    _classFilter = classFilter;
  }
	/**
	 * Compare current object with another.
	 * @param o object to compare
	 */
	public boolean equals(Object o)
	{
		if (this == o)
			return true;

		if (!(o instanceof LyLdapClassBinding))
			return false;

		if (!super.equals(o))
			return false;

		LyLdapClassBinding o1 = (LyLdapClassBinding)o;

		// Compare values
		if (getFdnFormat() == null)
		{
			if (o1.getFdnFormat() != null)
				return false;
		}
		else if (getFdnFormat().equals(o1.getFdnFormat()))
			return false;

		return true;
	}
} // end class LyLdapClassBinding
