/*
 * LyLdapFieldBinding.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.info.binding;

/**
 * Container for the binding information found in the data description for fieldInfo.
 */
public class LyLdapFieldBinding extends LyFieldBinding
{
  public static final String __VERSION = "$Id: LyLdapFieldBinding.java 34502 2012-03-13 08:55:18Z jlsaouli $";

  boolean                    _parentBinding;

  boolean                    _binary;

  /**
   * Constructor.
   * @param binding content of the binding information
   */
  public LyLdapFieldBinding(String binding)
  {
    this(binding, false, false);
  }

  /**
   * Constructor.
   * @param binding content of the binding information
   * @param parent boolean indicating if binding is parent.
   */
  public LyLdapFieldBinding(String binding, boolean parent, boolean binary)
  {
    super(binding, null, null, false);

    _parentBinding = parent;
    _binary = binary;
  }

  /**
   * Returns the parent value of this binding.
   */
  public boolean isParent()
  {
    return _parentBinding;
  }

  /**
   * Sets the parent value of this binding.
   */
  protected void setParent(boolean parent)
  {
	  _parentBinding = parent;
  }
  
  /**
   * Returns the binary value of this binding.
   */
  public boolean isBinary()
  {
    return _binary;
  }

  /**
   * Sets the binary value of this binding.
   */
  protected void setBinary(boolean binary)
  {
    _binary = binary;
  }
} // end class LyLdapFieldBinding
