/*
 * LyInfoDaemon.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.info.daemon;

import leon.info.*;


/**
 * This class holds informations for local multiple relations managed by a join class. This join is
 * defined by a join class, a source relation and a target relation in the join class. The source
 * relation must pointed to the class of the local relation managed by the join class. The target
 * relation must pointed to the class(es) pointed by the local relation managed by the join class.
 * <p>See also entity <DAEMON> of leon.dtd.</p>
 * @see leon.info.daemon.LyJoinDaemon
 * @see leon.info.daemon.LyReverseDaemon
 */
public abstract class LyInfoDaemon extends LyTag
{
	public static final String __VERSION =
		"$Id: LyInfoDaemon.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Default contructor.
	 */
	public LyInfoDaemon()
	{
	}

	/**
	 * Final step of parsing : check consistency of the daemon.
	 * @param     parent Object info for which this daemon is checked.
	 * @exception IllegalStateException If one of these checks fails.
	 */
	public void check(LyObjectInfo parent)
	{
	}
}