/*
 * LyReverseDaemon.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.info.daemon;

import leon.info.*;


/**
 * This class holds informations for reverse local multiple relations.
 * <p>See also tag <REVERSE> of leon.dtd.</p>
 * @see leon.data.daemon.LyReverseRelationDaemon
 */
public final class LyReverseDaemon extends LyInfoDaemon
{
	public static final String    __VERSION =
		"$Id: LyReverseDaemon.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/** The reverse relation. */
	protected LyRelationFieldInfo _reverseRelation;

	/**
	 * Default constructor.
	 */
	public LyReverseDaemon()
	{
		super();

		_reverseRelation = null;
	}

	/**
	 * Constructor with all parameters.
	 */
	public LyReverseDaemon(LyRelationFieldInfo reverseRelation)
	{
		_reverseRelation = reverseRelation;
	}

	/**
	 * Accessor to the reverse relation.
	 * @return The reverse relation.
	 */
	public LyRelationFieldInfo getReverseRelation()
	{
		return _reverseRelation;
	}

	/**
	 * Modifier of the reverse relation.
	 * @param reverseRelation The relation field info representing the reverse relation.
	 */
	public void setReverseRelation(LyRelationFieldInfo reverseRelation)
	{
		_reverseRelation = reverseRelation;
	}
} // end class LyReverseDaemon
