/*
 * LyComparatorInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.info.infointerface;

import leon.data.*;
import leon.info.*;


/**
 * Interface used to compare two objects with a sort criterion.
 */
public interface LyComparatorInterface
{
	String __VERSION = "$Id: LyComparatorInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Method to compare two objects according a given sort criterion. The given objects are not
	 * null and are not equals.
	 * @param  criterion the sort criterion.
	 * @param  object1   the first object
	 * @param  object2   the second object
	 * @return O if the two values are equals, a positive value if value of object1 is "greater"
	 *         than value of object2, a negative value otherwise.
	 */
	int compare(LySortCriterion criterion, LyObject object1, LyObject object2);
}