/*
 * LyCompleteValueFormatterInterface.java
 * Copyright (c) 2000-2009, Lyria-W4
 * All rights reserved.
 * Current version: $Id $
 */
package leon.info.infointerface;

import leon.info.*;


/**
 * @author ban
 */
public interface LyCompleteValueFormatterInterface
{
	String __VERSION =
		"$Id: LyCompleteValueFormatterInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Method to complete a partially filled value from a format.
	 * @param  fieldInfo the fieldInfo for which a value is to be completed
	 * @param  value     the value to complete
	 * @param  unit      the destination unit of the string value
	 * @return The complete string corresponding to the given value and unit, or null if the default
	 *         completion should be performed.
	 */
	String completeValue(LyFieldInfo fieldInfo, Object value, LyUnit unit);
}