/**
 * LyConverterInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * Current version: $Id: LyConverterInterface.java 33186 2011-11-17 11:02:46Z jlsaouli $
 */

package leon.info.infointerface;

import leon.info.*;


/**
 * Interface implemented by classes which convert field value.
 * @author Lyria
 */
public interface LyConverterInterface
{
	String __VERSION = "$Id: LyConverterInterface.java 33186 2011-11-17 11:02:46Z jlsaouli $";

	/**
	 * Method to convert a value from the field unit to the given one.
	 * @param  fieldInfo   the fieldInfo to convert
	 * @param  value       the value to convert
	 * @param  destination the destination unit of the converted value
	 * @return null if the conversion failed, the converted value otherwise.
	 */
	Object convertToFieldUnit(LyFieldInfo fieldInfo, Object value,
		LyUnit destination);

	/**
	 * Method to convert a value from a given unit to the field unit.
	 * @param  fieldInfo the fieldInfo to convert
	 * @param  value     the value to convert
	 * @param  source    the source unit of the parameter value
	 * @return null if the conversion failed, the converted value otherwise.
	 */
	Object convertFromFieldUnit(LyFieldInfo fieldInfo, Object value,
		LyUnit source);
}