/*
 * LyExtraInfoInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.info.infointerface;

import java.io.*;


/**
 * Interface used to compare two objects with a sort criterion.
 */
public interface LyExtraInfoInterface
{
	String __VERSION = "$Id: LyExtraInfoInterface.java 40733 2012-09-11 07:29:25Z jlsaouli $";

    /**
     * Accessor to the file of this info.
     * @return the file of this info.
     */
    public String getFile();
   
	/**
    * Accessor to the file of this info.
	 * @param the file of this info
	 */
	public void setFile(String file);

    /**
     * Get owner of this extra info.
     * @return The owner of this extra info.
     */
    public String getUser();
    
    /**
     * Method for saving extra info file.
     * @return True if successful.
     */
    public boolean saveFile(LyXmlWriterInterface writer);
    
    /**
     * Method for deleting extra info file.
     * @return True if successful.
     */
    public boolean deleteFile();
    
    /**
     * Method for freeing extra info (and sub-infos).
     */
    public void free();
    
    /**
     * Method to rewrite XML corresponding to this component.
     *
     * @param pw the printWriter on which the XML is written.
     */
    public void writeXml(PrintWriter pw);
    
    /**
     * Method to rewrite XML corresponding to this component.
     *
     * @param pw The printWriter on which the XML is written.
     * @param header Boolean indicating if header must be written.
     * @param header Boolean indicating if body must be written.
     */
    public void writeXml(PrintWriter pw, boolean header, boolean body);
}