/*
 * LyXmlWriterInterface.java
 * Copyright (c) 2012, W4.
 * All rights reserved.
 */
package leon.info.infointerface;

import leon.misc.LyXmlPrintWriter;

public interface LyXmlWriterInterface
{
	/**
	 * Gets name of the file used to save given info.
	 * @return the filename for given info.
	 */
	public String getFile(LyExtraInfoInterface info);
	
    /**
     * Method to rewrite XML corresponding to this component.
     *
     * @param pw 	 PrintWriter on which the XML is written.
     * @param info	 Info to be written.
     */
    public void writeXml(LyXmlPrintWriter pw, LyExtraInfoInterface info);
}
