/*
 * LyClassRef.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.info.misc;

import leon.info.*;


/**
 * Pair of (classInfo, filter) referenced by relation.
 */
public class LyClassRef extends LyTag
{
	protected LyClassInfo  _classInfo;

	protected LyFilter	   _filter;


	/**
     * Default constructor.
     */
    protected LyClassRef()
    {  
    }
    
    /**
     * Constructor.
     */
    public LyClassRef(LyClassInfo classInfo)
    {
        this(classInfo, null);
    }
    
	/**
	 * Constructor.
	 */
	public LyClassRef(LyClassInfo classInfo, LyFilter filter)
	{
	    _classInfo = classInfo;
	    _filter = filter;
	}
    
	/**
	 * Accessor for classInfo.
	 */
	public final LyClassInfo getClassInfo()
	{
		return _classInfo;
	}

	/**
	 * Accessor for value.
	 */
	public final LyFilter getFilter()
	{
		return _filter;
	}
    
    /**
     * Sets classInfo.
     */
    public final void setClassInfo(LyClassInfo classInfo)
    {
        _classInfo = classInfo;
    }

    /**
     * Sets filter.
     */
    public final void setFilter(LyFilter filter)
    {
        _filter = filter;
    }
    
    /**
     * Compare two parameters by value.
     * @param  object object to compare to
     * @return true if equals by value
     */
    public boolean equals(Object object)
    {
        if (this == object)
            return true;
        
        if (object instanceof LyClassRef)
        {
            LyClassRef compare = (LyClassRef)object;

            if ((_classInfo == compare._classInfo)
                    && (_filter == compare._filter))
                return true;
        }
        
        return false;
    }
} // end class LyData
