/*
 * LyData.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.info.misc;

import leon.info.*;


/**
 * This class is used to store a data on object infos. A data is composed of a name, a value and a
 * model type.
 */
public class LyData extends LyTag
{
	public static final String __VERSION = "$Id: LyData.java 28422 2010-11-03 12:03:38Z ehelmste $";

	protected Object		 _name;

	protected Object		 _value;


	/**
     * Default constructor.
     */
    protected LyData()
    {  
    }
    
	/**
	 * Constructor.
	 */
	public LyData(Object name, Object value, LyTag.Model modelType)
	{
		if (name instanceof String)
			_name = ((String)name).intern();
		else
			_name = name;
		if (value instanceof String)
			_value = ((String)value).intern();
		else
			_value = value;
		setModelType(modelType);
	}

	/**
	 * Constructor.
	 */
	public LyData(Object name, Object value)
	{
		this(name, value, LyTag.Model.FULL);
	}

    /**
     * Constructor.
     */
    public LyData(Object name)
    {
        this(name, null, LyTag.Model.FULL);
    }
    
	/**
	 * Accessor for name.
	 */
	public Object getName()
	{
		return _name;
	}

	/**
	 * Accessor for value.
	 */
	public Object getValue()
	{
		return _value;
	}
    
	/**
     * Setter for name.
     */
    protected void setName(Object name)
    {
        _name = name;
    }

    /**
     * Setter for value.
     */
    protected void setValue(Object value)
    {
        _value = value;
    }
    
    /**
     * Sets parent.
     */
    public void setParent(LyTag parent)
    {
        setParent(parent.getParent());
    }
} // end class LyData
