/*
 * LyModel.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.info.model;

import leon.info.*;


/**
 * This class is used to store a model informations. A model has a type which is a string. Strings
 * prefixed with "_" are reserved by Leonardi.
 */
public class LyModel extends LyTag
{
	public static final String __VERSION = "$Id: LyModel.java 28422 2010-11-03 12:03:38Z ehelmste $";

	public static String	   TYPE_DATA = "_data";
	public static String	   TYPE_BIND = "_bind";
	public static String	   TYPE_GUI = "_gui";
	public static String	   TYPE_ALL = "_model";

	protected String		   _type;

	protected String		   _xmlFile;

	protected String		   _version;

	protected String		   _schema;

    /**
	  * Constructor.
	  */
    protected LyModel()
    {
    }
	
	/**
	 * Constructor.
	 */
	public LyModel(String type, String xmlFile, String version, String schema)
	{
		setType(type);
		setXmlFile(xmlFile);
		setVersion(version);
		setSchema(schema);
	}

	/**
	 * Accessor for name.
	 */
	public String getType()
	{
		return _type;
	}

	/**
	 * Accessor for value.
	 */
	public String getXmlFile()
	{
		return _xmlFile;
	}

	/**
	 * Accessor for model type.
	 */
	public String getVersion()
	{
		return _version;
	}

	/**
	 * Accessor for schema.
	 */
	public String getSchema()
	{
		return _schema;
	}
    
    /**
     * Sets name.
     */
    protected void setType(String type)
    {
        _type = type;
    }

    /**
     * Sets value.
     */
    protected void setXmlFile(String xmlFile)
    {
        _xmlFile = xmlFile;
    }

    /**
     * Sets model type.
     */
    protected void setVersion(String version)
    {
        _version = version;
    }

    /**
     * Sets schema.
     */
    protected void setSchema(String schema)
    {
        _schema = schema;
    }
} // end class LyModel
