/*
 * LyFieldSave.java
 */

package leon.info.save;

import java.util.*;

import leon.info.*;


/**
 * Save of a field controller
 */
public class LyMultiCompositionFieldSave extends LyFieldSave
{
	public Vector<LyFormSave>  _formSaves;
    
    public LyMultiCompositionFieldSave()
    {
    }
    
    public LyMultiCompositionFieldSave(LyFieldSave fieldSave, Vector<LyFormSave> formSaves)
    {
        super(fieldSave._fieldInfo, fieldSave._newValue, fieldSave._oldValue);
        
        _formSaves = formSaves;
    }
    
    public LyMultiCompositionFieldSave(LyFieldInfo fieldInfo, Vector<LyFormSave> formSaves)
    {
        super(fieldInfo, null, null);
        
        _formSaves = formSaves;
    }
    
    public void addFormSave(LyFormSave formSave)
    {
        if (_formSaves == null)
            _formSaves = new Vector<LyFormSave>(1);
        _formSaves.add(formSave);
    }
    
    public String saveAsString()
    {
        StringBuffer    buffer = new StringBuffer();
        
        buffer.append("<MULTI_COMPOSITION_SAVE>\n");
        buffer.append(super.saveAsString());
        if (_formSaves != null)
        {
            int              i, n = _formSaves.size();
            LyFormSave  formSave;
            
            buffer.append("\n");
            
            for (i = 0; i < n; i++)
            {
                formSave = _formSaves.get(i);
                buffer.append(formSave.saveAsString());
                buffer.append("\n");
            }
        }
        buffer.append("</MULTI_COMPOSITION_SAVE>");
        
        return buffer.toString();
    }
}