/*
 * LyImageHandlerInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */
package leon.misc;

/**
 * Internal use for generated class LyImageHandler. Do not modify.
 * @version $Id: LyImageHandlerInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LyImageHandlerInterface
{

	String __VERSION = "$Id: LyImageHandlerInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Retrieves an image from the Application environment.
	 * @param  env   current Environment for loading images
	 * @param  key   current requested image key
	 * @param  path  current image path
	 * @param  image image found by the environment
	 * @return a reference to the image object, or null if it could not be found.
	 */
	Object checkImage(LyEnvironment env, String key, String path, Object image);

	/**
	 * Builds a message from a key and an array of arguments. Strings are found in the
	 * messages_XXX.properties files (see LyResourceBundle for more details).
	 * @param  env       current Environment for loading images
	 * @param  key       the message key
	 * @param  arguments the arguments array used to build the message
	 * @param  result    string found in the environment
	 * @return The message formated with the arguments. If not found, the key is returned followed
	 *         by the string representation of the arguments.
	 * @see    leon.misc.LyStrings#getString(String,Object[])
	 * @see    leon.misc.LyStrings
	 */
	String checkMessage(LyEnvironment env, String key, Object[] arguments, String result);
}