/*
 * LyEventRegister.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.notifier;

import java.util.*;


/**
 * Interface for registering events (used when recording tests).
 */
public interface LyEventRegister
{
	String __VERSION = "$Id: LyEventRegister.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Register an event.
	 *
	 * @param appId      Id of the application concerned by the event.
	 * @param notifierId Id of the notifier that received the event.
	 * @param groupId    The messages group id.
	 * @param type       Message type.
	 * @param classId    Object class id.
	 * @param objectId   The object id.
	 * @param values     List of values (may be null).
	 * @param delay      Delay in which the event was processed.
	 */
	void registerEvent(String appId, String notifierId, String groupId,
        LyEventNotifier.EventType type, String classId, String objectId,
        HashMap<String, Object> values, long delay);
}