/*
 * LyCommentInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.parser;

/**
 * This interface is used to add and retrieve comments from an object result of parsing. Comments
 * may be added before or after the tag corresponding to the object.
 * @version $Id: LyCommentInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LyCommentInterface
{
	String __VERSION = "$Id: LyCommentInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Stores comments before the tag (comments at Start).
	 * @param comments comments to store
	 */
	void setCommentsStart(String comments);

	/**
	 * Stores comments after the tag (comments at END).
	 * @param comments comments to store
	 */
	void setCommentsEnd(String comments);

	/**
	 * Gets stored comments before the tag (comments at Start).
	 * @return starts comments on tag
	 */
	String getCommentsStart();

	/**
	 * Gets stored comments after the tag (comments at END).
	 * @return comments comments to store
	 */
	String getCommentsEnd();
}