package leon.peer;

import leon.data.LyObject;
import leon.info.LyFieldInfo;


/**
 * This interface is used to define a method capable of getting blob content. All classes needing this features must implements
 * this interface.
 */
public interface LyBlobRequestInterface 
{
	
	/**
	 * Load the real blob content from the locator : return a physical locator like a file path
	 * @param object the object which helds the blob field and values
	 * @param fieldInfo blob fieldinfo to load
	 * @param locator value of the field, usually a locator for making object reference
	 * @return the physical locator
	 */
	String getBlobContent(LyObject object, LyFieldInfo fieldInfo, String locator);
	
}
