/*
 * LyFecthAttachmentInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.peer;

import java.io.*;
import leon.data.*;


/**
 * Implemented by a provider that implements attachment fetching (usually through a blob).
 *
 * @see leon.peer.util.LyBlobFileHandler
 */
public interface LyFetchAttachmentInterface
{
	String __VERSION = "$Id: LyFetchAttachmentInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Finds an attachment in the data provider and save its content to the target output stream.
	 *
	 * @param  id      identifier of the object on the provider
	 * @param  fieldId identifier of the field which contains the atttachment
	 * @param  out     output stream to write content to
	 * @return true if the request was correctly processed
	 */
	boolean fetchAttachment(LyObjectId objectId, String fieldId, OutputStream out);
}