/*
 * LyPeerField.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.peer;

import leon.data.*;


/**
 * Abstract class that holds common methods for all peer fields. Wrapper that implements LyField for
 * physical fields.
 */
public abstract class LyPeerField
	implements LyField
{
	public static final String __VERSION =
		"$Id: LyPeerField.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Constructs a peer field.
	 */
	public LyPeerField()
	{
	}

	/**
	 * Builds the appropriate field value (LyValue) corresponding to this field from an untyped
	 * value object. The default field value representation for peer fields is LyPeerFieldValue.
	 *
	 * @param  value Untyped value.
	 * @return A field value for the given field that corresponds to the specified value.
	 */
	public LyValue buildFieldValue(Object value)
	{
		return new LyPeerFieldValue(this, value);
	}
}