/*
 * LyPeerFieldValue.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.peer;

import leon.data.*;


/**
 * This class is a value wrapper, it offers methods for constructing, accessing and modifying values
 * corresponding to a peerField (physical field).
 *
 * @see LyPeerField
 */
public class LyPeerFieldValue extends LyValue
{
	public static final String __VERSION =
		"$Id: LyPeerFieldValue.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Constructs a value for the given fieldInfo from an untyped object.
	 *
	 * @param peerField Physical field for which a value is created.
	 * @param value     Value given as an untyped object.
	 */
	public LyPeerFieldValue(LyPeerField peerField, Object value)
	{
		super(peerField, value);
	}

	/**
	 * Gets the peerField to which this value corresponds. Result of LyValue.getField casted as to
	 * LyPeerField.
	 *
	 * @return PeerField of this field value.
	 */
	public LyPeerField getPeerField()
	{
		return (LyPeerField)getField();
	}
} // end class LyPeerFieldValue
