/*
 * LyFileInfoConnection.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.peer.file;

import leon.app.*;
import leon.data.*;
import leon.peer.util.*;


/**
 * This class is used as a connection for local files.
 * @version $Id: LyFileInfoConnection.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 * @see     LyFileConnection
 */
public class LyFileInfoConnection extends LyFileConnection
{
	public static final String __VERSION =
		"$Id: LyFileInfoConnection.java 28422 2010-11-03 12:03:38Z ehelmste $";


	/**
	 * Constructor.
	 * @param classInfo ClassInfo used by the request encoder.
	 */
	public LyFileInfoConnection(LyApplication application, String baseDirectory)
	{
		super(application, baseDirectory);
	}


	/**
	 * Return the path of the file containing the data.
	 */
	protected String getFilePath(LyClass peerClass)
	{
		// Get the path of the directory containing the file
		StringBuffer file_path = new StringBuffer(getPath());

		file_path.append(_application.getEnvironment().getString().FILE_SEPARATOR);
		file_path.append(((LyTableClass)peerClass).getName());
		file_path.append(".res");

		return (file_path.toString());
	}
} // end class LyFileInfoConnection
