/**
  * LyHsqldbConnection.java
  * Copyright (c) 2000-2009, Lyria-W4.
  * All rights reserved.
  */

package leon.peer.sql.hsqldb;

import javax.sql.*;

import leon.app.*;
import leon.peer.sql.*;

/**
 * This class is used as a connection for Hsql relational database.
 * @version $Id: LyHsqldbConnection.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 * @see     LySqlConnection
 */
public class LyHsqldbConnection extends LySqlConnection
{
	/**
	 * Constructor.
	 * @param application Application of the data provider that manages this connection.
	 * @param name        Name of the database.
	 */
	public LyHsqldbConnection(LyApplication application, String name)
	{
		this(application, name, null);
	}

	/**
	 * Constructor.
	 * @param application Application of the data provider that manages this connection.
	 * @param name        Name of the database.
	 * @param dataSource  JDBC DataSource providing the JDBC connection.
	 */
	public LyHsqldbConnection(LyApplication application, String name,
		DataSource dataSource)
	{
		super(application, name, dataSource);
	}

	public boolean close()
	{
		sendQueryRequest("SHUTDOWN");
		return super.close();
	}
	
	
}
