/*
 * LyIdbDataProvider.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.peer.sql.idb;

import leon.app.*;
import leon.data.*;
import leon.info.location.*;
import leon.peer.*;
import leon.peer.sql.*;


/**
 * This class is used by DataSources to transmit their requests to an instance of SqlRequestEncoder
 * for an InstantDB database.
 * @version $Id: LyIdbDataProvider.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 * @see     LyDataProvider
 * @see     LySqlRequestEncoder
 * @see     LySqlConnection
 */
public class LyIdbDataProvider extends LySqlDataProvider
{
	public static final String __VERSION =
		"$Id: LyIdbDataProvider.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Default constructor Initialization is done with the init method.
	 */
	public LyIdbDataProvider(LyApplication application, LyLocation location)
	{
		super(application, location);
	}

	/**
	 * Create a specific request encoder for the specified dataSource.
	 * @param  dataSource reference to the dataSource associated to this request encoder.
	 * @return the specific LyRequestEncoder for the specified dataSource.
	 */
	public LyRequestEncoder getRequestEncoder(LyDataSource dataSource)
	{
		LySqlRequestEncoder encoder = new LyIdbRequestEncoder(this, dataSource, _valueSep);

		encoder.setTrim(_trim);
		return encoder;
	}
}