/*
 * LyJoinDataProvider.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.peer.union;

import leon.data.*;


/**
 * This interface defines methods for data providers supporting join requests. of RequestEncoder.
 * @see    LyJoinRequestEncoder
 * @see    LyUnionRequestEncoder
 * @author Lyria
 */
public interface LyJoinDataProvider
{
	String __VERSION = "$Id: LyJoinDataProvider.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Create a specific join request encoder for the specified dataSource.
	 * <P>This method is used internally, but subclasses should override this method and create an
	 * instance of their own (specific) request encoder.</P>
	 * <P>Default returns a LyRequestEncoder instance.</P>
	 * @param  dataSource reference to the dataSource associated to this request encoder.
	 * @return the specific LyJoinRequestEncoder for the specified dataSource.
	 */
	LyJoinRequestEncoder getJoinRequestEncoder(LyDataSource dataSource);
}