/*
 * W4BpmDataProvider.java
 * Copyright (c) 2000-2011, W4.
 * All rights reserved.
 */
package leon.peer.w4;

import leon.app.*;
import leon.data.*;
import leon.info.*;
import leon.info.location.*;
import leon.misc.*;
import leon.peer.*;
import leon.peer.util.*;


public abstract class W4BpmDataProvider extends LyTableDataProvider
{
    public static final String CLS_W4_ACTOR_CLS = "w4_actor_cls";

    public static final String CLS_W4_ROLE_CLS = "w4_role_cls";

    public static final String CLS_W4_TASK_CLS = "w4_task_cls";

    public static final String CLS_W4_EVENT_CLS = "w4_event_cls";

    public static final String CLS_W4_WORKCASE_CLS = "w4_workcase_cls";

    public static final String BPM_PARAM_PROCESS_ID = "processId";

    public static final String BPM_PARAM_COMMUNICATION_MODE = "communicationMode";

    public static final String BPM_PARAM_SERVER = "server";

    public static final String BPM_PARAM_INSTANCE = "instance";

    public static final String BPM_PARAM_PORT_NUMBER = "portNumber";

    public static final String BPM_PARAM_USER_PASSWORD = "userPassword";

    public static final String BPM_PARAM_USER_LOGIN = "userLogin";

    public static final String BPM_PARAM_FORCE_ACTOR_LOGOUT = "forceActorLogout";

    public W4BpmDataProvider(LyApplication application, LyLocation location)
    {
        super(application, location);
    }

    public abstract boolean isAdmin();

    public abstract LyRequestEncoder getRequestEncoder(LyDataSource dataSource);

    public abstract W4BpmRequestEncoder getBpmRequestEncoder(LyDataSource dataSource);

    public abstract LyObject startGetNewWorkcase(String workcaseId);

    public abstract LyObject startGetNewWorkcase(String workcaseId, String domain);

    public abstract LyObject startGetNewWorkcase(String workcaseId, String domain, String workcaseName);

    public abstract boolean isStartGetNewWorkcaseEnabled(String workcaseId);

    public abstract boolean isStartGetNewWorkcaseEnabledInDomain(String workcaseId);

    public abstract String getCurrentProcessId();

    public abstract String buildWorkcaseGraphicalFollowUpUrl(LyViewManagerInterface viewManager, LyAction action,
        String workcaseId) throws Exception;
}
