/*
 * W4BpmRequestEncoder.java
 * Copyright (c) 2000-2011, W4.
 * All rights reserved.
 */
package leon.peer.w4.suite;

import java.util.*;

import leon.data.*;
import leon.info.*;
import leon.peer.*;
import leon.peer.util.*;
import leon.peer.w4.*;
import eu.w4.bpm.*;
import eu.w4.bpm.service.*;


public abstract class W4SuiteRequestEncoder extends W4BpmRequestEncoder
{
    public static int MAX_REQUEST_SIZE = -1;

    public static final String FLD_W4_TASK_OUTVALUE = "outvalue";

    public static final String FLD_W4_TASK_SAVED_CONTEXT = "w4_task_saved_context";

    public static final String APPLICATION_NAME_VAR = "__leon.application.name";

    public W4SuiteRequestEncoder(LyDataProvider provider, LyDataSource dataSource)
    {
        super(provider, dataSource);
    }

    public abstract BPMId getBPMId(LyObjectId objectId);

    public abstract BPMId getInternalBPMId(String internalId);

    public abstract String getIdFromFilter(LyFilter filter);

    public abstract Map<String, String> getIdsFromFilter(LyFilter filter);

    public abstract String findStepName(LyFilter filter);

    public abstract void setCurrentProcessId(String mask);

    public abstract String getCurrentProcessId();

    public abstract Object get(Object object, LyColumnField field, Class<?> valueClass);

    public abstract Object getPeerValue(BPMIdentifiedEntity snapshot, LyColumnField field, Class<?> valueClass)
        throws BPMException, LyUnsupportedFieldBindingException;

    public abstract Object checkPeerValue(Object w4Value, Class<?> valueClass, boolean isList);

    public abstract Vector<LyRowObject> createTask(Object object) throws Exception;

    public abstract BPMTaskSnapshot createTask(W4SuiteConnection w4connection, LyObject workcaseObj, BPMId stepId)
        throws Exception;

    public abstract Vector<LyRowObject> createWorkcase(Object object) throws Exception;

    public abstract Vector<LyRowObject> createRole(Object object) throws Exception;

    public abstract Vector<LyRowObject> createActor(Object object) throws Exception;

    public abstract void deleteActor(Object object) throws Exception;

    public abstract void deleteRole(Object object) throws Exception;

    public abstract void createActorOtherAttributes(LyValueSet newValues, BPMService factory, BPMSessionId sessionId,
        BPMId actorId) throws Exception;

    public abstract Vector<LyRowObject> setActor(Object object) throws Exception;

    public abstract Vector<LyRowObject> setRole(Object object) throws Exception;

    public abstract Vector<LyRowObject> setWorkcase(Object object) throws Exception;

    public abstract Vector<LyRowObject> setTask(Object object) throws Exception;

    public abstract void deleteWorkcases(List<Object> objects) throws Exception;

    public abstract boolean cancelObjects(W4BpmConnection w4connection, LyObjectList objects) throws Exception;

    public abstract void cancelWorkcases(LyObjectList objects, W4SuiteConnection w4connection) throws Exception;

    public abstract void cancelTasks(LyObjectList objects, W4SuiteConnection w4connection) throws Exception;

    public abstract void reassignTask(W4BpmConnection connection, LyObject taskObj, LyObject reassignObj,
        boolean preserveData);

    public abstract void redoTask(W4SuiteConnection w4connection, LyObject taskObj) throws BPMException;

    public abstract BPMVariableMap completeVariables(LyRowObject rowObject, W4SuiteConnection connection)
        throws BPMException;

    public abstract BPMVariableMap completeVariables(LyRowObject rowObject, W4SuiteConnection connection,
        boolean throwBPMExceptions) throws BPMException;

    public abstract Vector<LyRowObject> createDomain(Object object) throws Exception;

    public abstract void deleteDomain(Object object) throws Exception;

    public abstract Object getWorkcaseVariableMap(W4BpmConnection connection, LyObjectId workcaseId,
        LyObject variableObj) throws Exception;

    public abstract Object getTaskVariableMap(W4BpmConnection connection, LyObjectId taskId, LyObject variableObj)
        throws Exception;

    public abstract LyValueSet setDomain(Object object) throws Exception;
}
