/*
 * LyXmlConnection.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.peer.xml;

import java.io.*;
import java.util.*;
import leon.app.*;
import leon.data.*;
import leon.peer.*;


/**
 * This class is used as a connection for XML provider.
 * @version $Id: LyXmlConnection.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 * @see     LyConnection
 */
public class LyXmlConnection extends LyConnection
{
	public static final String __VERSION =
		"$Id: LyXmlConnection.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Constructor.
	 */
	public LyXmlConnection(LyApplication application)
	{
		super(application);
	}

	/**
	 */
	public Reader getReader(LyClass peerClass)
	{
		return null;
	}

	/**
	 * Write lines in the file containing objects data.
	 * @return true if the operation was successful.
	 */
	public boolean writeXml(LyClass peerClass, Vector<String> lines)
	{
		//To be implemented in sub classes
		return false;
	}

	/**
	 * Open the file of peerClass and write the begining of file.
	 * @return the PrintWriter of file of peerClass.
	 */
	public PrintWriter openFile(LyClass peerClass)
	{
		//To be implemented in sub classes
		return null;
	}

	/**
	 * Write a line in the file containing objects data.
	 * @return true if the operation was successful.
	 */
	public void writeLine(String line, PrintWriter pw)
	{
		//To be implemented in sub classes
	}

	/**
	 * Close the PrintWriter and write the end of file.
	 * @return true if the operation was successful.
	 */
	public void closeFile(PrintWriter pw)
	{
		//To be implemented in sub classes
	}
} // end class LyXmlConnection
