<%@ page import="leon.app.*, leon.misc.*, java.util.*, leon.view.web.*, leon.view.web.jquery.*, leon.view.web.jquery.common.*, leon.view.web.jquery.controller.*"%>
<%
	// Current user session
	LySession		leonardiSession = (LySession)request.getAttribute(LyWebConstants.RA_LY_SESSION);
	LyEnvironment		environment = leonardiSession.getEnvironment();
	LyJQViewManager		viewManager = (LyJQViewManager)environment.getViewManager();
	boolean 		isRtlMode = viewManager.isRtlMode();
	String			targetCode = viewManager.getTargetCode();
	String			appName = environment.translate("LY_APPLICATION");
	String			title = environment.translate("LY_LOGIN_TITLE");
	String			favicon = environment.getImageUrl("LY_WEB_FAVICON");
	String			waitIcon = environment.getImageUrl("LY_JQUERY_ANIMATED_WAIT_ICON");
	String  		skin = environment.getSkin();
	LyApplication	leonardiApplication = leonardiSession.getApplication();
	String[][]		languages = leonardiApplication.getSupportedLanguages();
	String			cookieTheme = viewManager.getCookieTheme(request);
	String			cssFile = environment.getUrl("LY_JQUERY_CSS_FILE");
	String			leftImage = environment.getImageUrl("LY_LOGIN_PAGE_LEFT_IMAGE");
	String			appBackground = environment.getImageUrl("LY_LOGIN_AREA_BACKGROUND_IMAGE");
	LyColor			color = environment.getLyColor("LY_DEFAULT_BACKGROUND");
	String			bgColor = LyColors.getHexString(color);
	String			userImage = environment.getImageUrl("LY_LOGIN_PAGE_USER_IMAGE");
	String			passwordImage = environment.getImageUrl("LY_LOGIN_PAGE_PASSWORD_IMAGE");
	String			loginFormContent = (String)request.getAttribute("loginFormContent");
	String			direction = "";
	
	if (isRtlMode)
		direction = "rtl";
	
	if (cookieTheme != null)
		skin = cookieTheme;
	
	appName = TemplateUtils.getConvertedHTML(appName);
	
	LyTemplatesUtilsBean	templateManager = viewManager.getVeloTemplatesBean();
	Map<String, Object>		params = new HashMap<String, Object>();
	params.put("environment", environment);
	params.put("jQuerySkin", environment.getSkin());
	

	String imports = templateManager.mergeTemplate(LyJQConstants.IMPORT_TEMPLATE, params);
	
	
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html dir="<%=direction%>" xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title><%=title%> <%=appName%></title>
		<%
			if ((favicon != null) && (favicon.length() > 0))
			{
		%>
		<link rel="shortcut icon" href="<%=favicon%>"/>
		<%
			}
		%>
    	
		<script type="text/javascript">
		    var targetParam = '<%=targetCode%>';
		    appName = "./";
		</script>

		<%=imports%>
<!--  
		<script type="text/javascript" src="./leon/scripts/jquery/jquery/jquery.min.js"></script> 
		<script type="text/javascript" src="./leon/scripts/jquery/jquery/ajax/eventsUtils.js"></script> 
		<script type="text/javascript" src="./leon/scripts/jquery/jquery/ui/jquery-ui.min.js"></script>
		<script type="text/javascript" src="./leon/scripts/jquery/LyJQUtils.js"></script>  
		<script type="text/javascript" src="./leon/scripts/jquery/jquery/ui.themeselect/ui.themeselect.js"></script>
		<script  type="text/javascript" src="./leon/scripts/jquery/jquery/ajaxloader/jquery.ajaxloader.1.5.0.min.js"></script>
		-->
		<link type="text/css" rel="stylesheet" href="<%=cssFile%>"/>
		<link rel="stylesheet" href="./leon/css/login/login-style.css" type="text/css" media="all"/> 
		<!-- link rel="stylesheet" type="text/css" href="./leon/css/jquery-ui/themes/<%=skin%>/jquery-ui.css"/> -->
		
		<style>
		.tata-ajax-loader{z-index:999999999 !important;background-color:transparent !important;opacity: 1 !important;}
		</style>
		
		<script type="text/javascript">
		
		var addValidateOnEnter = function(event, ui) {
			if (jQuery(event.target).find(':input').length > 0) {
				jQuery(event.target).find(':input').each(function(index, elem) {
				
					if ( jQuery(elem).not('button') && jQuery(elem).not(':hidden') && !jQuery(elem).attr('readonly') && !jQuery(elem).attr('disabled')) {
						jQuery(elem).focus();
						return false;
					}
				});
			}
			var validateButton = jQuery(event.target).find('button.commands-button[onclick*="_validate"]');
			if (validateButton && validateButton.length == 1) {
				jQuery(event.target).keyup(function(event) {
					if (event.keyCode == 13) {
						validateButton.click(function() {
							return false;							
						});
						validateButton.trigger('click');
					}
				});
			}
		};
		
	        jQuery(document).ready(function() {
	        	setTimeout("showLoginForm()", 500);
		});
		
		function showLoginForm()
		{
			initLoader("<%=waitIcon%>");

			// Remove titlebar
			var loginFormTable = jQuery("#loginformtable");
			var loginFormSpan = jQuery("#loginform");
			var titlebar = loginFormSpan.find(".designer-v2");
			var loginImg = loginFormSpan.find(".FieldContent img:eq(0)");

			titlebar.replaceWith("<img src='<%=leftImage%>' />");
			loginImg.remove();

			var captions = loginFormSpan.find(".FieldCaption").each(function (index) {

				var parentTr = jQuery(this).parent();
				var fieldCaption = parentTr.find(".FieldCaption");
				var fieldContent = parentTr.find(".FieldContent").detach();
				var fieldInputName = fieldContent.find('input[name*="login"]');
				var fieldInputPassword = fieldContent.find('input[name*="password"]');

				if (fieldInputName.size() > 0)
					fieldCaption.prepend("<img src='<%=userImage%>' valign='middle' />");

				if (fieldInputPassword.size() > 0)
					fieldCaption.prepend("<img src='<%=passwordImage%>' valign='middle' />");

				parentTr.after("<tr id='trfieldcontent" + index + "'></tr>");
				fieldCaption.attr("align","<%if(isRtlMode) {%>right<% } %><%if(!isRtlMode){%>left<% } %>");
				fieldContent.appendTo('#trfieldcontent' + index + '');
				
				if (index == 0)
				{
					var contentTable = jQuery(this).parent().parent();

					contentTable.prepend("<tr><td height='20'>&nbsp;</td></tr>");
					contentTable.append("<tr><td height='20'>&nbsp;</td></tr>");
				}
			});

			loginFormTable.dialog({
				width:'auto',
				show: "fade",
				closeOnEscape: false,
				draggable: false,
				resizable: false,
				position : 'center',
				open : addValidateOnEnter,
				autoOpen : false
			});

			if (jQuery.browser.msie)
			{
				if (jQuery.browser.version < 7.9999)
				{
					var $headerSel = jQuery("#loginform").parent().find('.ui-dialog-titlebar:first');
					
					$headerSel .outerWidth(jQuery("#loginform").closest('.ui-dialog').width());
				}
			}

			loginFormTable.parent().removeClass("ui-widget");
			loginFormTable.parent().find(".ui-dialog-titlebar-close").remove();
			loginFormTable.dialog("open");
		}
		
		</script>
	</head>
	
	<body class='ly-body'>
	<img src='<%=leftImage%>' style='position:absolute;top:25px;<%if(isRtlMode) {%>right<% } %><%if(!isRtlMode){%>left<% } %>:20px;z-index:100;' />	

	<div id="cont" style='background:url(<%=appBackground%>);background-repeat:no-repeat;background-color:<%=bgColor%>;'>
		<table id="loginformtable" border='0' style='display:none;' title='<%=appName%>' cellpadding='0' cellspacing='0'>
			<tr>
				<td>
					<div id="loginform" title='<%=appName%>'>
						<%=loginFormContent%>
						<script>initThemeRoller(false,"", "");</script>
					</div>
				</td>
				<td style="width:25px;">&nbsp;</td>
				<td style='width:230px;'>
					<span style='z-index:100;' id="messagesCell">
						<font class='toolLabel'><%=environment.getMessage("LY_LOGIN_MESSAGE1")%>
						<br />
						<br />
						<%=environment.getMessage("LY_LOGIN_MESSAGE2")%></font>
					</span>
				</td>
			</tr>
		</table>
	</div>
	
	<div id="bg" class='ui-widget-header'>
		<div>
			<table cellspacing="0" cellpadding="0">
				<tr>
					<td><img src="./leon/css/images/login/bg.png" alt=""/> </td>
				</tr>
			</table>
		</div>
	</div>
	
	<div id="dialog" title="Basic dialog" hidden="true"></div>
	<div id="dialogsContainer"></div>


<%
if (environment.testResource("LY_WEB_PUSH_MODE") || environment.testEnv("LY_REPLAY"))
{
%>
	<iframe src='./leon/pages/push_page.jsp' name='push_frame' id='push_frame'
		style="position:absolute;top:0px;left:0px;width:1px;height:1px;visibility:hidden;"></iframe>
<%
}
%>

	<div style="position:absolute; top: 20px; <%if(isRtlMode) {%>left<% } %><%if(!isRtlMode){%>right<% } %>: 20px; z-index: 100;">										
<%
if ((languages != null) && (languages.length > 1))
{
	for (int i = 0; i < languages.length; i++)
	{
		String	flag = "";
		
		if ("en".equals(languages[i][0]))
			flag = "LY_ENGLISH_FLAG";
		else if ("fr".equals(languages[i][0]))
			flag = "LY_FRENCH_FLAG";
		else if ("es".equals(languages[i][0]))
			flag = "LY_SPANISH_FLAG";
		else if ("ar".equals(languages[i][0]))
			flag = "LY_ARABIC_FLAG";
%>
		<span style='padding:10px;'><a href="<%=LyJQConstants.PATH_ACTION_HOME%>?_language=<%=languages[i][0]%>"><img border="0" title="<%=environment.translate(languages[i][1])%>" src="<%=environment.getImageUrl(flag)%>" /></a></span>
<%
	}
}
%>
	</div>

	</body>
</html>
