// LyFileScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyFileScript.js 33137 2011-11-14 13:08:56Z nhamon $

// This function updates an hidden field with a file field.
function UpdateFile(form, fieldName, isDirectory)
{
	var field = form.elements[fieldName];
	var fileField = form.elements[fieldName + "File"];

	if (fileField.value != "")
	{
		var dir = fileField.value;

		// If directory field, remove file from path
		// and keep only directory path
		if (isDirectory)
		{
			var pos = dir.lastIndexOf("/");

			if (pos < 0)
				pos = dir.lastIndexOf("\\");

			if (pos > 0)
				dir = dir.substring(0, pos + 1)
		}

		field.value = dir;
	}
}

// This function set the disable state of a file input.
function DisableFileInput(form, fieldName, disable)
{
	var field = form.elements[fieldName];
	var fileField = form.elements[fieldName + "File"];

	fileField.disabled = disable;
}

// This function uploads a file to the server
function SendFile(form, controller, fieldName, frameName, fileErrorMessage, path, encoding, target)
{
	var oldTarget = form.target;
	var oldAction = form.action;
	var oldEncoding = form.encoding;

	try
	{
		var params = "_upload=true&" + controllerParam + "=" + controller + "&" + sourceParam + "=" + fieldName;

		if ((typeof target != "undefined") && (target != null) && (target != "null"))
			params += "&target_session=" + target;

		form.encoding = encoding;
		form.target = frameName;
		form.action = _rootUrl + path + "?" + params;

		// And we submit the form
		form.submit();

		form.encoding = oldEncoding;
		form.target = oldTarget;
		form.action = oldAction;
		getLeonardiTopFrame().showWaitDiv(true, true);
	}
	catch (ex)
	{
		// When a file input is displayed in the HTML form, the submit of form may
		// launch an error. Display a message asking the user to check values of
		// file inputs.
		alert(fileErrorMessage);
	}
}