// LyFormatScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyFormatScript.js 33851 2012-01-17 16:42:40Z nhamon $

// This function tests if the field has a valid value.
function CheckFormatField(form, fieldName, format, error, isDate)
{
	var value = form.elements[fieldName].value;
	var initialValue = value;
	var n0 = 0, n2 = 0, n3 = 0;
	var formatTmp;
	var valueTmp;
	var fixTmp;
	var result;
	var checked = true;
	var last = false;
	var changed = false;

	var finalValue="";

	if ((typeof value == "undefined") || (value.length == 0))
		return;

	do
	{
		n0 = format.indexOf('[', 0);
//		n1 = format.indexOf(':', 0);
		n2 = format.indexOf(']', 0);

		fixTmp = "";
		// If fixed string starting
		if (n0 > 0)
		{
			fixTmp = format.substring(1, n0 - 1);
			format = format.substring(n0);

			n0 = value.indexOf(fixTmp);

			if (n0 == 0)
				value = value.substring(fixTmp.length);
			else
			{
				checked = false;
				break;
			}

			continue;
		}

//		if ((n1 >= 0) && (n1 < n2))
//			n3 = n1;
//		else
			n3 = n2;

		formatTmp = format.substring(n0 + 1, n3);

		// If there is still something after this format
		if ((format.length != 0) && (n2 < format.length - 1))
		{
			// Retrieve the next '['
			n0 = format.indexOf('[', 1);

			// If no next, it means there is a fix string at the end
			if (n0 < 0)
			{
				n0 = format.length;
				last = true;
			}

			fixTmp="";

			//FFT00532
			if (n2 == (n0-1))
				fixTmp="";
			else
				fixTmp = format.substring(n2 + 2, n0 - 1);



			valueLength = getValueLength(formatTmp);
			n4 = value.indexOf(fixTmp, 0);

			if (   ( (fixTmp.length > 0) && (valueLength < n4) )
				|| (fixTmp.length == 0) )
				n4 = valueLength;



			if (last)
			{
				// If too many characters
				if ((value.length - n4) > fixTmp.length)
					n4 = -1;
			}

			if (n4 < 0)
			{
				checked = false;
				break;
			}
			else
			{
				valueTmp = value.substring(0, n4);
				value = value.substring(n4 + fixTmp.length);
			}

			// FFT00098 : error on validation with format
//			format = format.substring(n2 + 3 + fixTmp.length);
			format = format.substring(n2 + 1 + fixTmp.length);
		}
		else if (formatTmp.length != 0)
		{
			valueTmp = value;
			format = format.substring(n2 + 4);
		}

		result = CheckFormat(formatTmp, valueTmp);

		if (result == "")
		{
			checked = false;
			break;
		}
		else if (result != valueTmp)
		{
			changed = true;
			finalValue += result+fixTmp;
		}
		else
		{
			finalValue += valueTmp+fixTmp;
		}
	}
	while (format.length != 0)

	if ( changed && checked)
	{
		if (isDate != "true")
			form.elements[fieldName].value = finalValue;
	}
	else if (!checked)
	{
		if (error != null)
		{
			var message = ReplaceString(error, "%1", initialValue);
			alert(message);
		}

		// Reset field
		if (isDate == "true")
		{
			if (error != null)
				form.elements[fieldName].value = '';

			return "false";
		}
//FFT00533
//		else
//			form.elements[fieldName].value = form.elements[fieldName].defaultValue;
	}
}

// This function compute the length of a value from a format
function getValueLength(format)
{
	var n = format.indexOf('-', 0);
	var min = format.substring(0, n);
	var max = format.substring(n + 1);

	if(max.length >= min.length)
		return max.length;
	else
		return min.length;

}

// This function tests if a value is valid for the given format.
// @return the value if correct, a new value if modifications needed, a
// blank string if wrong.
function CheckFormat(format, value)
{
	var n = format.indexOf('-', 0);
	var min = format.substring(0, n);
	var max = format.substring(n + 1);

	if (IsInteger(min) && IsInteger(max))
	{
		if (!IsInteger(value))
			return "";

		var minInt = parseInt(min);
		var maxInt = parseInt(max);

		// Remove leading '0'
		value = removeLeadingZeros(value);
		var valueInt = parseInt(value);

		maxLength = max.length;
		if ( (minInt < 0) && ( (min.length-1) > max.length) )
		{
			maxLength = min.length-1;
		}

		while (value.length < max.length)
		{
			value = "0"+value;
		}

		if ((valueInt < minInt) || (valueInt > maxInt))
			return "";
		else
			return value;
	}
	else
	{
		if ((value < min) || (value > max))
			return "";
		else
			return value;
	}
}

// This function test the number of selected characters
// inside a text area.
// return true if the number of selected characters does
// not exceeds the maxlength, false otherwise.
function CheckTextArea(maxlength, errorMessage, textArea)
{
	var value = textArea.value;

	// if the length is ok
	if (value.length <= maxlength)
		return true;

	// raise Error
	var message = ReplaceString(errorMessage, "%1", value.length + "");

	alert(message);

	return false;
}