// LyTreeScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyTreeScript.js 28422 2010-11-03 12:03:38Z ehelmste $

// Scroll down to the active node
function ShowActiveNode(name)
{
	var netscapeNavigation = (navigator.appName == "Netscape");

	if (!netscapeNavigation)
		location = "#" + name;
}

var lastTreeNodeSelected = "";

// Select a node.
function InvokeTreeNodeSelection(treeId, treeNodeId, controllerId, path, singleSelection, event)
{
	var extend = event.ctrlKey;
	var shift = event.shiftKey;

	if (singleSelection)
	{
		clearSelectionIds(treeId);
		addSelectionId(treeId, treeNodeId);
	}
	else if (!extend)
	{
		clearSelectionIds(treeId);

		if (shift)
			selectTreeNodes(treeId, lastTreeNodeSelected, treeNodeId);
		else
			addSelectionId(treeId, treeNodeId);
	}
	else
	{
		if (hasSelectionId(treeId, treeNodeId))
			removeSelectionId(treeId, treeNodeId);
		else
			addSelectionId(treeId, treeNodeId);
	}

	lastTreeNodeSelected = treeNodeId;

	var selectedIds = getSelectionIds(treeId);

	InvokeSelection("_select", selectedIds, controllerId, (extend ? "true" : "false"), path);
}

// Select tree nodes from beginIndex to endIndex
function selectTreeNodes(treeId, lastTreeNodeId, newTreeNodeId)
{
	var ie= (navigator.appName == "Microsoft Internet Explorer")?1:0;
	var tree = document.getElementById(treeId);
	var started = (lastTreeNodeId == "" ? true : false);
	var contentAll = tree.getElementsByTagName("TR");
	var length = contentAll.length;

	for (var i = 0; i < length; i++)
	{
		var divObject = contentAll[i];

		if ((divObject.id == lastTreeNodeId) || (divObject.id == newTreeNodeId))
		{
			started = !started;
			addSelectionId(treeId, divObject.id);
		}
		else if (started)
			addSelectionId(treeId, divObject.id);
	}
}

function EmptyFunction()
{
}

// Select a node.
function SelectTreeNode(treeNodeId, controllerId, path)
{
	InvokeSelection("_select", treeNodeId, controllerId, "false", path);
}

// Consult a node.
function ConsultTreeNode(nodeId, controllerId, treeId, path)
{
	InvokeAction(treeId, null, null, controllerId, nodeId, null);
}

// Change the expand state of a node
function ExpandTreeNode(nodeId, controllerId, path)
{
	InvokeAction(null, path, null, controllerId, nodeId, "expand");
}

// Change the color of a tree node
function SetTreeNodeColor(cellId, fontId, color, textColor)
{
	var frame = findTargetByContent(null, cellId);

	if (frame != null)
	{
		var tdObj = frame.document.getElementById(cellId);
		var fontObj = frame.document.getElementById(fontId);

		tdObj.style.backgroundColor = color;
		fontObj.style.color = textColor;
	}
}

// Called when a contextual menu is performed on a tree node
function InvokeTreeNodePopup(treeNodeId, htmlTreeId, treeId, controllerId, path, selectPath, event)
{
	if (!hasSelectionId(htmlTreeId, treeNodeId))
	{
		SelectTreeNode(treeNodeId, controllerId, selectPath);

		setTimeout("InvokePopup('" + treeId + "','" + ReplaceString(treeNodeId,"\\","\\\\") +
			"','" + path + "','" + controllerId + "',false," +
			event.clientX + "," + event.clientY + ")", 300);
	}
	else
		InvokePopup(treeId, treeNodeId, path, controllerId, false, event.clientX, event.clientY);
}
