<%@ page import="java.util.*,leon.app.*,leon.data.*,leon.info.*,leon.control.*,leon.misc.*,leon.view.*,leon.view.web.*"%>

<%!
	public String getDisplayTime(LyDataSession session)
	{
		long time = session.getCreationTime();

		return LyDateFormatter.format(new Date(time), "MM/dd HH:mm:ss");
	}

	public String getObjects(LyApplication application, LyClassInfo classInfo)
	{
		LyObjectSource source = application.getObjectSource(classInfo);
		LyResponse response = source.getObjects(null, null, null, -1, true, null);
		LyObjectList objects = response.getObjects();

		if (objects.getSize() == 0)
			return null;

		return "Class '" + application.getEnvironment().translate(classInfo.getName()) + "': " + objects.getSize();
	}
%>

<%

	System.gc();

	String					skinRootURL = (String)request.getAttribute(LyWebConstants.RA_LY_SKIN_URL);
	String					appName = (String)request.getAttribute(LyWebConstants.RA_LY_APP_NAME);
	Properties				properties = System.getProperties();
	String[]				propertyNames = new String[] {"java.runtime.name", "java.vm.version"};
	Vector<LyApplication>	applications = LyApplication.getApplications();

%>

<html>
<head>
<title>Audit page</title>

	<style type='text/css' media='screen'>
		@import url('<%=skinRootURL%>');
	</style>

	<script>

		function ShowDiv(divId)
		{
			var div = document.getElementById(divId);

			div.style.display = (div.style.display == "none" ? "block" : "none");
		}

	</script>

</head>

<body>

<table border='0' align='center'>
 <tr>
  <td height='30' colspan='3'>
  	&nbsp;
  </td>
 </tr>
 <tr>
  <td class='mainInfo' colspan='3' align='center' nowrap='yes'>
  	Audit for <%=appName%> application
  </td>
 </tr>
 <tr>
  <td height='50' colspan='3'>
  	&nbsp;
  </td>
 </tr>

 <%
 	for (int i = 0; i < propertyNames.length; i++)
 	{
 %>
 <tr>
  <td class='lblObl'>
  	<%=propertyNames[i]%> :
  </td>
  <td class='lbl' align='right' nowrap='yes'>
  	<%=properties.get(propertyNames[i])%>
  </td>
  <td>
  	&nbsp;
  </td>
 </tr>
 <%
 	}
 %>

 <tr>
  <td height='20' colspan='3'>
  	&nbsp;
  </td>
 </tr>
 <tr>
  <td class='lblObl'>
  	LyApplication instances :
  </td>
  <td class='lbl' align='right'>
  	<%=applications.size()%>
  </td>
  <td>
  	<a class='toolLabel' href="javascript:ShowDiv('applicationDetailDiv');">Detail</a>
  </td>
 </tr>
 <tr>
  <td colspan='3'>
  	<div id='applicationDetailDiv' style='display:none;'>

  		<table border='0'>
		 <%
			for (int i = 0; i < applications.size(); i++)
			{
		 %>
  			<tr>
  				<td class='lbl' width='30'>&nbsp;</td>
  				<td class='lbl' nowrap='yes'>
  					<%=(i + 1) + ". " + applications.elementAt(i).getId()%>, valid: <%=applications.elementAt(i).isValid()%>, sleeping: <%=applications.elementAt(i).isSleeping()%>
  				</td>
  			</tr>
		 <%
			}
		 %>
  		</table>

  	</div>
  </td>
 </tr>
 <tr>
  <td class='lblObl'>
  	LySession instances :
  </td>
  <td class='lbl' align='right'>
  	<%=LySession._nbSessions%>
  </td>
  <td>
  	<a class='toolLabel' href="javascript:ShowDiv('sessionDetailDiv');">Detail</a>
  </td>
 </tr>
 <tr>
  <td colspan='3'>
  	<div id='sessionDetailDiv' style='display:none;'>

  		<table border='0'>
		 <%
			for (int i = 0; i < applications.size(); i++)
			{
				LyApplication leonApplication = applications.elementAt(i);
				Vector<LyDataSession> sessions = leonApplication.getSessions();

				for (int j = 0; j < sessions.size(); j++)
				{
		 %>
  			<tr>
  				<td class='lbl' width='30'>&nbsp;</td>
  				<td class='lbl' nowrap='yes'>
  					<%=(j + 1)%>. user: <%=sessions.elementAt(j).getUser()%>, state: <%=sessions.elementAt(j).getState()%>, creation date: <%=getDisplayTime(sessions.elementAt(j))%>
  				</td>
  			</tr>
		 <%
				}
			}
		 %>
  		</table>

  	</div>

  </td>
 </tr>
 <tr>
  <td class='lblObl'>
  	LyObject instances :
  </td>
  <td class='lbl' align='right'>
  	<%=LyObject._nbObjects%>
  </td>
  <td>
  	<a class='toolLabel' href="javascript:ShowDiv('objectDetailDiv');">Detail</a>
  </td>
 </tr>
 <tr>
  <td colspan='3'>
  	<div id='objectDetailDiv' style='display:none;'>

  		<table border='0'>
		 <%
			for (int i = 0; i < applications.size(); i++)
			{
				LyApplication leonApplication = applications.elementAt(i);
				LyInfoList<LyClassInfo> classes = leonApplication.getClassInfos();
				int count = 0;

				for (int j = 0; j < classes.getSize(); j++)
				{

					String objects = getObjects(leonApplication, classes.getInfo(j));

					if (objects != null)
					{
						count++;
		 %>
  			<tr>
  				<td class='lbl' width='30'>&nbsp;</td>
  				<td class='lbl' nowrap='yes'>
  					<%=count + ". " + objects%>
  				</td>
  			</tr>
		 <%
		 			}
				}
			}
		 %>
  		</table>

  	</div>
  </td>
 </tr>
 <tr>
  <td class='lblObl'>
  	LyController instances :
  </td>
  <td class='lbl' align='right'>
  	<%=LyController._nbControllers%>
  </td>
  <td>
  	&nbsp;
  </td>
 </tr>
 <tr>
  <td>
  </td>
  <td colspan='2'>
  </td>
 </tr>
 <tr>
  <td class='lblObl'>
  	LyView instances :
  </td>
  <td class='lbl' align='right'>
  	<%=LyView._nbViews%>
  </td>
  <td>
  	&nbsp;
  </td>
 </tr>
 <tr>
  <td>
  </td>
  <td colspan='2'>
  </td>
 </tr>
 <tr>
  <td class='lblObl'>
  	LyComponent instances :
  </td>
  <td class='lbl' align='right'>
  	<%=LyComponent._nbComponents%>
  </td>
  <td>
  	&nbsp;
  </td>
 </tr>
</table>

</body>
</html>
