/*
 * LyDialog.java Copyright (c) 2000-2009, Lyria-W4. All rights reserved.
 */

package leon.view;

import leon.misc.*;


/**
 * This class represents a Dialog component.
 *
 * @author   Lyria
 * @version  $Id: LyDialog.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @see      LyComponent
 */
public class LyDialog extends LyDialogBase
{
	public static final String __VERSION = "$Id: LyDialog.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Default constructor.
	 */
	protected LyDialog()
	{
	}
	
	/**
	 * Constructor with all required attributes.
	 */
	public LyDialog(String id, LyEnvironment environment)
	{
		super(id);

		setEnvironment(environment);
	}

	/* Protected methods for construction from parser  */

	/**
	 * Construction from a LyViewNode.
	 *
	 * @param  node  node from which the component is constructed.
	 *
	 * @see    LyViewNodeFactory#buildElement
	 */
	protected LyDialog(LyViewNode node)
	{
		super(node);

		setEnvironment(node.getEnvironment());
	}
} // end class LyDialog
