/*
 * LyDictionary.java Copyright (c) 2000-2009, Lyria-W4. All rights reserved. Current Version: $Id: LyDictionary.java,v 6.3
 * 2007/12/05 09:01:21 jls Exp $.
 */

package leon.view;

/**
 * The LyDictionary class implements generic behavior for the DICTIONNARY components as described in
 * views.dtd regardless of the requested target (win, swing, html...). It represents a dictionary
 * component.
 *
 * @see  leon.view.LyComponent
 */
public class LyDictionary extends LyDictionaryBase
{
	public static final String __VERSION = "$Id: LyDictionary.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/** Indicates if the root node is visible or not. */
	boolean _rootHidden;

	/**
	 * Constructor with all required attributes.
	 */
	public LyDictionary()
	{
		super();
	}

	/* Protected methods for construction from parser  */

	/**
	 * Construction from a LyViewNode.
	 *
	 * @param  node  Node from which the component is constructed.
	 *
	 * @see    leon.view.LyViewNodeFactory#buildElement
	 */
	protected LyDictionary(LyViewNode node)
	{
		super(node);
	}

	/**
	 * Retrieves an option from its id.
	 */
	public LyEntry getEntry(String id)
	{
		return (LyEntry)getComponent(id);
	}

	/**
	 * Indicates if this dictionary has its root hidden or not.
	 */
	public boolean isRootHidden()
	{
		return _rootHidden;
	}

	/**
	 * Indicates that this dictionary has its root hidden or not. WARNING : this indicator is not
	 * dynamic and must be set during the dictionary initialization.
	 *
	 * @param  hidden  true to hide the root, false otherwise.
	 */
	public void setRootHidden(boolean hidden)
	{
		_rootHidden = hidden;
	}

} // end class LyDictionary
