/*
 * LyFrame.java Copyright (c) 2000-2009, Lyria-W4. All rights reserved.
 */

package leon.view;

import leon.misc.*;


/**
 * This class represents a Frame component.
 *
 * @author   Lyria
 * @version  $Id: LyFrame.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @see      LyComponent
 */
public class LyFrame extends LyFrameBase
{
	public static final String __VERSION = "$Id: LyFrame.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/** Indicates whether this frame is a root frame. */
	protected boolean	_isRootFrame;
	
	/**
	 * Default constructor.
	 */
	protected LyFrame()
	{
	}
	
	/**
	 * Constructor with all required attributes.
	 */
	public LyFrame(String id, LyEnvironment environment)
	{
		super(id);

		setEnvironment(environment);
		_isRootFrame = false;
	}

	/* Protected methods for construction from parser  */

	/**
	 * Construction from a LyViewNode.
	 *
	 * @param  node  node from which the component is constructed.
	 *
	 * @see    LyViewNodeFactory#buildElement
	 */
	protected LyFrame(LyViewNode node)
	{
		super(node);

		setEnvironment(node.getEnvironment());
	}
	
	/**
	 * Sets the <code>_isRootFrame</code> attribute.
	 */
	public void setRootFrame(boolean rootFrame)
	{
		_isRootFrame = rootFrame;
	}
	
	/**
	 * Returns the <code>_isRootFrame</code> attribute.
	 */
	public boolean isRootFrame()
	{
		return _isRootFrame;
	}
} // end class LyFrame
