/*
 * LyMap.java Copyright (c) 2000-2009, Lyria-W4. All rights reserved. Current Version: $Id: LyMap.java,v 6.5 2008/06/30 12:49:36
 * jlu Exp $.
 */

package leon.view;

import leon.view.setinterface.*;


/**
 * The LyMap class implements generic behavior for the MAP components as described in views.dtd
 * regardless of the requested target (win, swing, html...). It represents a map.
 *
 * @see  LyComponent
 */
public class LyMap extends LyMapBase
	implements LyResetContentInterface
{
	public static final String __VERSION = "$Id: LyMap.java 31811 2011-07-28 12:41:24Z jlsaouli $";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_EXTERN_NORTH = "extern_north";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_EXTERN_EASTNORTH = "extern_eastnorth";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_EXTERN_NORTHEAST = "extern_northeast";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_EXTERN_EAST = "extern_east";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_EXTERN_EASTSOUTH = "extern_eastsouth";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_EXTERN_SOUTHEAST = "extern_southeast";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_EXTERN_SOUTH = "extern_south";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_EXTERN_SOUTHWEST = "extern_southwest";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_EXTERN_WESTSOUTH = "extern_westsouth";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_EXTERN_WEST = "extern_west";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_EXTERN_WESTNORTH = "extern_westnorth";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_EXTERN_NORTHWEST = "extern_northwest";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_NORTH = "north";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_EASTNORTH = "eastnorth";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_NORTHEAST = "northeast";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_EAST = "east";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_EASTSOUTH = "eastsouth";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_SOUTHEAST = "southeast";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_SOUTH = "south";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_SOUTHWEST = "southwest";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_WESTSOUTH = "westsouth";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_WEST = "west";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_WESTNORTH = "westnorth";

	/** Layout position : Position of a child node compared with its parent. */
	public static final String LAYOUT_INFO_NORTHWEST = "northwest";

	/** Border. */
	protected boolean	_border = true;
	
	/**
	 * Constructor with all required attributes.
	 */
	public LyMap()
	{
	}

	/**
	 * Construction from a LyViewNode.
	 */
	protected LyMap(LyViewNode node)
	{
		super(node);
	}

	/**
	 * Inserts a sub-component mapRegion at given position.
	 *
	 * @param  mapRegion  The mapRegion to add to components list.
	 * @param  pos        Position where the sub-component is inserted.
	 */
	public void insertMapRegion(LyMapRegion mapRegion, int pos)
	{
		// V3.1/FFT00317
		if (mapRegion != null)
			super.insertMapRegion(mapRegion, pos);
	}

	/* Implementation of LyResetContentInterface */

	/**
	 * Reset the view for a new XML Structure. Reinitialization.
	 *
	 * @see  LyResetContentInterface#resetContent
	 */
	public void resetContent()
	{
		resetContent(false);
	}

	/**
	 * Reset the view for a new XML Structure. Reinitialization.
	 *
	 * @see  LyResetContentInterface#resetContent(boolean)
	 */
	public void resetContent(boolean full)
	{
		if (_internalView instanceof LyResetContentInterface)
			((LyResetContentInterface)_internalView).resetContent();
	}
	
	public void setBorder(boolean border)
	{
		_border = border;
	}
	
	public boolean hasBorder()
	{
		return _border;
	}
} // end class LyMap
