/*
 * LyText.java Copyright (c) 2000-2009, Lyria-W4. All rights reserved.
 */

package leon.view;

/**
 * The LyText class is a generated Java implementation that corresponds to the element TEXT of the
 * descriptive grammar of the views (views.dtd). <B>&lt;TEXT&gt; : Input Field of Text Type</B> An
 * input field of Text type allows displaying a graphical input or text consultation component. It
 * does not comprise any element. It is possible to specify if the text should be hidden, if it
 * should respect a given format, if it can be divided into several lines and the maximum number of
 * characters that it can contain.
 *
 * @see  leon.view.LyFieldItem See also tag <A href="../../conf/dtd/view/TEXT.html">TEXT</A> of
 *       grammar leon_views.dtd.
 */
public class LyText extends LyTextBase
{
	/** Default NCOLS value. */
	public static int		DEFAULT_NCOLS = 40;

	/** default NCOLS value in edit table. */
	public static int      DEFAULT_NCOLS_EDITTABLE = 20;

	public static int      DEFAULT_RICH_NCOLS_EDITTABLE = 60;

	/** Default NROWS value. */
	public static int		DEFAULT_NROWS = 5;

	/** Indicates if we use arrows for formatted text inputs. */
	public static boolean	SHOW_ARROWS = true;

	boolean _showArrows;

	/**
	 * Default constructor.
	 */
	public LyText()
	{
		super();
	}

	/* Protected methods for construction from parser  */

	/**
	 * Construction from a LyViewNode.
	 *
	 * @param  node  Node from which the component is constructed.
	 *
	 * @see    leon.view.LyViewNodeFactory#buildElement
	 */
	protected LyText(LyViewNode node)
	{
		super(node);
	}

	/**
	 * Initialisation of the data structure.
	 *
	 * @see  leon.view.LyComponent#init
	 */
	protected void init()
	{
		super.init();
		_showArrows = true;
	}

	/**
	 * Initializes attribute showArrows to the given value.
	 *
	 * @param  showArrows  Boolean indicating if attribute showArrows is set or unset.
	 */
	public void showArrows(boolean showArrows)
	{
		if (showArrows == _showArrows)
			return;

		_showArrows = showArrows;
	}

	/**
	 * Checks if value of attribute showArrows is set.
	 *
	 * @return  true if showArrows is set, false otherwise.
	 */
	public boolean isShowArrows()
	{
		return _showArrows;
	}
} // end class LyText
