/*
 * LyTitleBar.java Copyright (c) 2000-2009, Lyria-W4. All rights reserved. Current Version: $Id: LyTitleBar.java,v 6.4
 * 2007/12/05 09:01:23 jls Exp $.
 */

package leon.view;

import leon.view.setinterface.*;


/**
 * The LyTitleBar class implements generic behavior for the TITLEBAR components as described in
 * views.dtd regardless of the requested target (win, swing, html...). It represents a title bar.
 *
 * @see  leon.view.LyComponent
 */
public class LyTitleBar extends LyTitleBarBase
{
	public static final String __VERSION = "$Id: LyTitleBar.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Constructor with all required attributes.
	 */
	public LyTitleBar()
	{
		super();
	}

	/* Protected methods for construction from parser  */

	/**
	 * Construction from a LyViewNode.
	 *
	 * @param  node  Node from which the component is constructed.
	 *
	 * @see    leon.view.LyViewNodeFactory#buildElement
	 */
	protected LyTitleBar(LyViewNode node)
	{
		super(node);
	}

	/**
	 * Affectation of the popup menu.
	 */
	public void setPopupMenu(LyPopupMenu popup)
	{
		if (_internalView instanceof LySetPopupMenuInterface)
			((LySetPopupMenuInterface)_internalView).setPopupMenu(popup);
	}
} // end class LyTitleBar
