/*
 * LyToolBar.java Copyright (c) 2000-2009, Lyria-W4. All rights reserved.
 */

package leon.view;

import leon.misc.*;


/**
 * The LyToolBar class is a generated Java implementation that corresponds to the element TOOLBAR of
 * the descriptive grammar of the views (views.dtd). <B>&lt;TOOLBAR&gt; : Tool bar</B> A tool bar
 * allows displaying a set of action buttons. A tool bar can itself contain tool bars, which allows
 * grouping together the action buttons into logical groups and sub-groups.
 *
 * @see  leon.view.LyComponent See also tag <A href="../../conf/dtd/view/TOOLBAR.html">TOOLBAR</A>
 *       of grammar leon_views.dtd.
 */
public class LyToolBar extends LyToolBarBase
{
	public static final String __VERSION = "$Id: LyToolBar.java 29043 2011-01-03 16:39:02Z nhamon $";

	/** Specific environnement of this toolbar. */
	LyEnvironment _environment;

	/**
	 * Default constructor.
	 */
	public LyToolBar()
	{
		super();
		_environment = null;
	}

	/**
	 * Construction from a LyViewNode.
	 *
	 * @param  node  Node from which the component is constructed.
	 *
	 * @see    leon.view.LyViewNodeFactory#buildElement
	 */
	protected LyToolBar(LyViewNode node)
	{
		// Retrieve attributes from node attributes
		super(node);
		_environment = null;
	}

	/**
	 * Gets specific environment of this toolbar.
	 *
	 * @return  specific environment of this toolbar.
	 */
	public LyEnvironment getEnvironment()
	{
		if (_environment != null)
			return _environment;

		return super.getEnvironment();
	}

	/**
	 * Sets specific environment of this toolbar.
	 *
	 * @param  environment  Specific environment of this toolbar.
	 */
	public void setEnvironment(LyEnvironment environment)
	{
		_environment = environment;
	}
    
    /**
     * Internal code used as identifier for web components.
     * @return Internal code as a string.
     */
    public String getInternalId()
    {
    	// Since all the the toolbars built by Leonardi have the same identifier ("_toolbar"),
    	// we use the parent identifier to avoid every toolbar to have the same id code.
        if (LyEnvironment.TEST_MODE && (_internalId == null) && (_id != null) && (_parent != null))
        	_internalId = _parent.getIdCode() + INTERNAL_ID_SEP + _id;
		
		return super.getInternalId();
	}
} // end class LyToolBar
