/**
 * LyChoiceFieldBeanInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.beaninterface;

/**
 * Interface for a choice field bean in a set view.
 *
 * @version $Id: LyChoiceFieldBeanInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LyChoiceFieldBeanInterface extends LySetFieldBeanInterface
{
	String __VERSION = "$Id: LyChoiceFieldBeanInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Method used to enable/disable an option within the choice field.
	 * @param i        Index of the option to be enabled/disabled.
	 * @param enable   Boolean indicating if option is enabled or  disabled.
	 */
	void enableOption(int i, boolean enable);

	/**
     * Method used to check/uncheck an option within the choice field.
     * @param i        Index of the option to be checked/unchecked.
     * @param enable   Boolean indicating if option is checked or unchecked.
     */
	void checkOption(int i, boolean check);
}