/*
 * LyValidateInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.beaninterface;

/**
 * Interface to validate input done on a bean.
 *
 * @version $Id: LyValidateInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LyValidateInterface
{
	String __VERSION = "$Id: LyValidateInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/** Return codes for validateInput method. */
	short  STATUS_CANCEL = -2;
	short  STATUS_IGNORE = -1;
	short  STATUS_OK = 0;
	short  STATUS_KO = 1;
	short  STATUS_WARNING = 2;

	/**
	 * Validate input done on the bean that implements this interface.
	 *
	 * @return One of the STATUS_XXX codes.
	 */
	short validateInput();
}