/*
 * LySelectionListener.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.event;

/**
 * Client may register on components which implement this interface to receive notifications from
 * the component.
 *
 * @version $Id: LyActionTransmitter.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LyActionTransmitter
{
	String __VERSION = "$Id: LyActionTransmitter.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Adds the specified action listener to receive action events from this component.
	 * (LyActionTransmitter interface)
	 *
	 * @param listener client for the action event
	 */
	void addActionListener(LyActionListener listener);

	/**
	 * Removes the specified action listener to receive action events from this component.
	 * (LyActionTransmitter interface)
	 *
	 * @param listener client for the action event
	 */
	void removeActionListener(LyActionListener listener);

	/**
	 * Processes events on this component. (LyActionTransmitter interface)
	 */
	void processActionEvent(LyActionEvent actionEvent);
}