/*
 * LyActivateViewDemand.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.event;

/**
 * This class implements an activation view event created from the presentation layer, which is sent
 * to the associated controller and sent to its controller using RMI.
 *
 * @version $Id: LyActivateViewDemand.java 28997 2010-12-23 10:17:15Z bmichel $
 * @author  Lyria
 * @see     LyDemand
 */
public class LyActivateViewDemand extends LyDemand
{
	/**
	 * 
	 */
	private static final long serialVersionUID = -5149545380868683031L;

	public static final String __VERSION =
		"$Id: LyActivateViewDemand.java 28997 2010-12-23 10:17:15Z bmichel $";

	/** Default type. */
	public static final short  TYPE_ACTIVATE = 1;

	/**
	 * Constructor.
	 */
	public LyActivateViewDemand(String sourceId)
	{
		super(LyActivateViewDemand.TYPE_ACTIVATE, sourceId);
	}

	/**
	 * Convert the demand type to a string (print and dump).
	 */
	protected String getDemandType(int typ)
	{
		switch (typ)
		{
		case TYPE_ACTIVATE:
			return "TYPE_ACTIVATE";

		default:
			return super.getDemandType(typ);
		}
	}
} // end class LyActivateViewDemand
