/*
 * LyDemandPlayer.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.event;

import leon.misc.*;


/**
 * Interface used to take controls of demands in test modes.
 */
public interface LyDemandPlayer extends LyPlayer
{
	String __VERSION = "$Id: LyDemandPlayer.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Invoked when a demand is sent on the demand transmitter.
	 *
	 * @param  transmitter Demand transmitter that received the demand.
	 * @param  listenerId  Id of the listener.
	 * @param  demand      Demand to process.
	 * @return True if the demand was processed, false otherwise. If the demand was not processed,
	 *         it's executed by the demand transmitter.
	 */
	boolean processDemand(LyDemandTransmitter transmitter,
		String listenerId, LyDemand demand);
}