/*
 * LyEventListener.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.event;

/**
 * An interface that all event listener interfaces must extend.
 *
 * @version $Id: LyEventTransmitter.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LyEventTransmitter
{
	String __VERSION = "$Id: LyEventTransmitter.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Gets the action transmitter of the current component.
	 *
	 * @return the action transmitter of this component
	 */
	LyActionTransmitter getActionTransmitter();

	/**
	 * Gets the selection transmitter of the current component.
	 *
	 * @return the selection transmitter of this component
	 */
	LySelectionTransmitter getSelectionTransmitter();
}