/*
 * LyHelpDemand.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.event;

/**
 * This class implements a help event created from the presentation layer, which is sent to the
 * associated controller and sent to its controller using RMI.
 *
 * @version $Id: LyHelpDemand.java 28997 2010-12-23 10:17:15Z bmichel $
 * @author  Lyria
 * @see     LyDemand
 * @see     LyActionDemand
 * @see     LySelectionDemand
 * @see     LyMenuDemand
 */
public class LyHelpDemand extends LyDemand
{
	/**
	 * 
	 */
	private static final long serialVersionUID = -6827571683018341224L;

	public static final String __VERSION =
		"$Id: LyHelpDemand.java 28997 2010-12-23 10:17:15Z bmichel $";

	/** Default type. */
	public static final short  TYPE_HELP = 301;

	// Context of the request
	protected String		   _context;

	/**
	 * Constructor.
	 */
	public LyHelpDemand(String sourceId)
	{
		this(LyHelpDemand.TYPE_HELP, sourceId);
	}

	/**
	 * Constructor.
	 */
	public LyHelpDemand(int demandType, String sourceId)
	{
		super(demandType, sourceId);
	}

	/**
	 * Accessor to the context associated to this request.
	 *
	 * @return the context value if any
	 */
	public String getContext()
	{
		return _context;
	}

	/**
	 * Accessor to the value associated to this action.
	 *
	 * @param context the context
	 */
	public void setContext(String context)
	{
		_context = context;
	}

	/**
	 * Convert the demand type to a string (print and dump).
	 */
	protected String getDemandType(int typ)
	{
		switch (typ)
		{
		case TYPE_HELP:
			return "TYPE_HELP";

		default:
			return super.getDemandType(typ);
		}
	}
} // end class LyHelpDemand
