/*
 * LyMessageWindowRegister.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.event;

/**
 * Interface for registering message windows (used when recording tests).
 */
public interface LyMessageWindowRegister
{
	String __VERSION = "$Id: LyMessageWindowRegister.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Register a message.
	 *
	 * @param messageId The message id to register.
	 * @param type      Type of the message.
	 * @param message   The message.
	 */
	void registerMessageWindow(Object messageId, String type, String message);

	/**
	 * Sets the result for a message.
	 *
	 * @param message The message id.
	 * @param result  The result.
	 */
	void setMessageWindowResult(Object messageId, int result);
}