/*
 * LyParameterValues.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.event;

import leon.view.*;


/**
 * Submit data from one or several forms Implementation depends on the nature of the view (win ,html
 * ...).
 *
 * @version $Id: LyParameterValues.java 33969 2012-01-30 09:12:52Z nhamon $
 * @author  Lyria
 */
public interface LyParameterValues
{
	String __VERSION = "$Id: LyParameterValues.java 33969 2012-01-30 09:12:52Z nhamon $";

	/**
	 * Returns a string containing the lone value of the specified parameter, or null if the
	 * parameter does not exist.
	 */
	String getParameter(String param);

	/**
	 * Returns the parameter names for this request as an enumeration of strings, or an empty
	 * enumeration if there are no parameters or the input stream is empty.
	 */
	String[] getParameterNames();

	/**
	 * Returns the values of the specified parameter for the request as an array of strings, or null
	 * if the named parameter does not exist.
	 */
	String[] getParameterValues(String param);

    /**
     * Update a view with the specified values.
     */
    void updateViewFromValues(LyComponent component, LyComponent priorityComponent, boolean needValueChange);

    /**
     * Update a view with the specified values.
     */
    void updateViewFromValues(LyComponent component, boolean needValueChange);

    /**
     * Update a view with the specified values.
     */
    void updateViewFromValues(LyComponent component);
}