/*
 * LySelectionListener.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.event;

/**
 * Client may register on components which implement this interface to receive notifications from
 * the component.
 *
 * @version $Id: LySelectionTransmitter.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LySelectionTransmitter
{
	String __VERSION = "$Id: LySelectionTransmitter.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Adds the specified selection listener to receive selection events from this component.
	 * (LyEventTransmitter interface)
	 *
	 * @param listener client for the action event
	 */
	void addSelectionListener(LySelectionListener listener);

	/**
	 * Removes the specified selection listener from this component. (LyEventTransmitter interface)
	 *
	 * @param listener client for the action event
	 */
	void removeSelectionListener(LySelectionListener listener);

	/**
	 * Processes events on this component. (LySelectionTransmitter interface)
	 */
	void processSelectionEvent(LySelectionEvent selectionEvent);
}