/*
 * LyGanttInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.getinterface;

import java.util.*;


/**
 * Interface for Gantt component.
 *
 * @version $Id: LyGanttInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LyGanttInterface
{
	String __VERSION = "$Id: LyGanttInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Return the center date of the Gantt component.
	 */
	Date getCenterDate();

	/**
	 * Center the planning on a given date.
	 */
	void centerOnDate(Date date);

	/**
	 * Perform a vertical zoom in.
	 */
	void verticalZoomIn();

	/**
	 * Perform a vertical zoom out.
	 */
	void verticalZoomOut();

	/**
	 * Return the vertical zoom factor.
	 */
	float getVerticalZoom();

	/**
	 * Display the time frame.
	 */
	void displayTimeFrame();

	/**
	 * Start the division of an interval.
	 */
	void startDivideInterval();
}