/*
 * LyGetChartConverterInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.getinterface;

import leon.view.*;


/**
 * Abstract access to a method. Hides the specific implementation of the view (win, swing, html...)
 * A value, and may have its value set.
 *
 * @version $Id: LyGetChartConverterInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LyGetChartConverterInterface
{
	String __VERSION = "$Id: LyGetChartConverterInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Get the Chart Converter (if any).
	 *
	 * @return the graphical chart Converter.
	 */
	LyChartConverter getChartConverter();
	
	/**
	 * Get the dimension of the component used to represent the chart.
	 * 
	 * @return an array of two integers (width and height of the component).
	 */
	int[] getComponentDimension();
}