/*
 * LyIsVisibleInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.getinterface;

/**
 * Abstract access to a method. Hides the specific implementation of the view (win, swing, html...)
 * Checks if the view is visible or not. The view component may implement this interface to properly
 * answer to controller requests
 *
 * @version $Id: LyIsVisibleInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LyIsVisibleInterface
{
	String __VERSION = "$Id: LyIsVisibleInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Checks if the component is visible or not.
	 *
	 * @return true if the component is showing (a visible component is never freed()).
	 */
	boolean isVisible();
}