/*
 * LyGraphicalArea.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;

/**
 * The LyGraphicalArea interface represents the abstract graphical component
 * for the area of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyArea
 */
public interface LyGraphicalArea
	extends LyGraphicalContainer
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute redirect to the given value.
	 * @param redirect New value of redirect.
	 */
	public void setRedirect(String redirect);

	/**
	 * Updates attribute refresh to the given value.
	 * @param refresh New value of refresh.
	 */
	public void setRefresh(int refresh);

	/**
	 * Updates attribute layoutInfo to the given value.
	 * @param layoutInfo New value of layoutInfo.
	 */
	public void setLayoutInfo(String layoutInfo);

	/**
	 * Updates attribute open to the given value.
	 * @param open Boolean indicating if attribute open is set or unset.
	 */
	public void setOpen(boolean open);

	/**
	 * Inserts a sub-component panels at given position.
	 * @param panels The panels to add to panels list.
	 * @param pos	Position where the sub-component is inserted.
	 */
	public void addPanel(LyPanel panels, int pos);

	/**
	 * Removes a sub-component panels.
	 * @param panels The panels to remove to panels list.
	 */
	public void removePanel(LyPanel panels);
}