/*
 * LyGraphicalCaption.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.setinterface.*;

/**
 * The LyGraphicalCaption interface represents the abstract graphical component
 * for the caption of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyCaption
 */
public interface LyGraphicalCaption
	extends LyGraphicalComponent,
			LySetLabelInterface,
			LySetEnabledInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute label to the given value.
	 * @param label New value of label.
	 */
	public void setLabel(String label);

	/**
	 * Updates attribute enabled to the given value.
	 * @param enabled Boolean indicating if attribute enabled is set or unset.
	 */
	public void setEnabled(boolean enabled);
}