/*
 * LyGraphicalChart.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;

/**
 * The LyGraphicalChart interface represents the abstract graphical component
 * for the chart of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyChart
 */
public interface LyGraphicalChart
	extends LyGraphicalPanel
{
	public static final String			__VERSION = "$Id$";




	/* Methods for updating graphical components */

	/**
	 * Inserts a sub-component columns at given position.
	 * @param columns The columns to add to columns list.
	 * @param pos	Position where the sub-component is inserted.
	 */
	public void addColumn(LyColumn columns, int pos);

	/**
	 * Removes a sub-component columns.
	 * @param columns The columns to remove to columns list.
	 */
	public void removeColumn(LyColumn columns);
}