/*
 * LyGraphicalColumn.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;

/**
 * The LyGraphicalColumn interface represents the abstract graphical component
 * for the column of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyColumn
 */
public interface LyGraphicalColumn
	extends LyGraphicalComponent
{
	public static final String			__VERSION = "$Id$";




	/* Methods for updating graphical components */

	/**
	 * Inserts a sub-component chartValues at given position.
	 * @param chartValues The chartValues to add to chartValues list.
	 * @param pos	Position where the sub-component is inserted.
	 */
	public void addChartValue(LyChartValue chartValues, int pos);

	/**
	 * Removes a sub-component chartValues.
	 * @param chartValues The chartValues to remove to chartValues list.
	 */
	public void removeChartValue(LyChartValue chartValues);
}