/*
 * LyGraphicalComponent.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * Current Version: $Id: LyGraphicalComponent.java 28422 2010-11-03 12:03:38Z ehelmste $.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;


/**
 * The LyGraphicalComponent class implements root object for all graphical components.
 */
public interface LyGraphicalComponent extends LyViewComponent,
	LyFreeInterface
{
	String __VERSION = "$Id: LyGraphicalComponent.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Free resources allocated to this component.
	 *
	 * @see LyFreeInterface#free
	 */
	void free();

	/**
	 * Gets view component corresponding to this graphical object.
	 *
	 * @return The view component for this graphical component.
	 */
	LyComponent getViewComponent();
}