/*
 * LyGraphicalDay.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;

/**
 * The LyGraphicalDay interface represents the abstract graphical component
 * for the day of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyDay
 */
public interface LyGraphicalDay
	extends LyGraphicalComponent,
			LySetValueInterface,
			LySetColorInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute type to the given value.
	 * @param type New value of type.
	 */
	public void setType(LyDay.Type type);

	/**
	 * Updates attribute dayOfWeek to the given value.
	 * @param dayOfWeek New value of dayOfWeek.
	 */
	public void setDayOfWeek(LyDay.DayOfWeek dayOfWeek);

	/**
	 * Updates attribute value to the given value.
	 * @param value New value of value.
	 */
	public void setValue(String value);

	/**
	 * Updates attribute color to the given value.
	 * @param color New value of color.
	 */
	public void setColor(String color);
}