/*
 * LyGraphicalDialog.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;

/**
 * The LyGraphicalDialog interface represents the abstract graphical component
 * for the dialog of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyDialog
 */
public interface LyGraphicalDialog
	extends LyGraphicalView,
			LySetLabelInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute label to the given value.
	 * @param label New value of label.
	 */
	public void setLabel(String label);

	/**
	 * Sets sub-component area.
	 * @param area New value of area
	 */
	public void setArea(LyArea area);
}