/*
 * LyGraphicalEntry.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;

/**
 * The LyGraphicalEntry interface represents the abstract graphical component
 * for the entry of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyEntry
 */
public interface LyGraphicalEntry
	extends LyGraphicalComponent,
			LySetValidityInterface,
			LySetImageInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute checked to the given value.
	 * @param checked Boolean indicating if attribute checked is set or unset.
	 */
	public void setChecked(boolean checked);

	/**
	 * Updates attribute open to the given value.
	 * @param open Boolean indicating if attribute open is set or unset.
	 */
	public void setOpen(boolean open);

	/**
	 * Updates attribute validity to the given value.
	 * @param validity New value of validity.
	 */
	public void setValidity(LyTreeNode.Validity validity);

	/**
	 * Updates attribute image to the given value.
	 * @param image New value of image.
	 */
	public void setImage(String image);
}