/*
 * LyGraphicalFormField.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;

/**
 * The LyGraphicalFormField interface represents the abstract graphical component
 * for the formField of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyFormField
 */
public interface LyGraphicalFormField
	extends LyGraphicalPanel,
			LySetEditableInterface,
			LySetOptionalInterface,
			LySetEnabledInterface,
			LySetStateInterface,
			LySetHiddenInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute editable to the given value.
	 * @param editable Boolean indicating if attribute editable is set or unset.
	 */
	public void setEditable(boolean editable);

	/**
	 * Updates attribute optional to the given value.
	 * @param optional Boolean indicating if attribute optional is set or unset.
	 */
	public void setOptional(boolean optional);

	/**
	 * Updates attribute enabled to the given value.
	 * @param enabled Boolean indicating if attribute enabled is set or unset.
	 */
	public void setEnabled(boolean enabled);

	/**
	 * Updates attribute checked to the given value.
	 * @param checked Boolean indicating if attribute checked is set or unset.
	 */
	public void setChecked(boolean checked);

	/**
	 * Updates attribute state to the given value.
	 * @param state New value of state.
	 */
	public void setState(short state);

	/**
	 * Updates attribute message to the given value.
	 * @param message New value of message.
	 */
	public void setMessage(String message);

	/**
	 * Updates attribute hidden to the given value.
	 * @param hidden Boolean indicating if attribute hidden is set or unset.
	 */
	public void setHidden(boolean hidden);

	/**
	 * Sets sub-component toolBar.
	 * @param toolBar New value of toolBar
	 */
	public void setToolBar(LyToolBar toolBar);
}