/*
 * LyGraphicalFrame.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;

/**
 * The LyGraphicalFrame interface represents the abstract graphical component
 * for the frame of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyFrame
 */
public interface LyGraphicalFrame
	extends LyGraphicalView,
			LySetLabelInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute label to the given value.
	 * @param label New value of label.
	 */
	public void setLabel(String label);

	/**
	 * Sets sub-component messages.
	 * @param messages New value of messages
	 */
	public void setMessages(LyMessages messages);
}