/*
 * LyGraphicalHRef.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.setinterface.*;

/**
 * The LyGraphicalHRef interface represents the abstract graphical component
 * for the hRef of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyHRef
 */
public interface LyGraphicalHRef
	extends LyGraphicalFieldItem,
			LySetLabelInterface,
			LySetImageInterface,
			LySetVisitedInterface,
			LySetSensitiveInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute label to the given value.
	 * @param label New value of label.
	 */
	public void setLabel(String label);

	/**
	 * Updates attribute image to the given value.
	 * @param image New value of image.
	 */
	public void setImage(String image);

	/**
	 * Updates attribute visited to the given value.
	 * @param visited Boolean indicating if attribute visited is set or unset.
	 */
	public void setVisited(boolean visited);

	/**
	 * Updates attribute sensitive to the given value.
	 * @param sensitive Boolean indicating if attribute sensitive is set or unset.
	 */
	public void setSensitive(boolean sensitive);
}