/*
 * LyGraphicalHRefs.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;

/**
 * The LyGraphicalHRefs interface represents the abstract graphical component
 * for the hRefs of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyHRefs
 */
public interface LyGraphicalHRefs
	extends LyGraphicalFieldItem,
			LySetHRefsInterface
{
	public static final String			__VERSION = "$Id$";




	/* Methods for updating graphical components */

	/**
	 * Inserts a sub-component hRefs at given position.
	 * @param hRefs The hRefs to add to hRefs list.
	 * @param pos	Position where the sub-component is inserted.
	 */
	public void addHRef(LyHRef hRefs, int pos);

	/**
	 * Removes a sub-component hRefs.
	 * @param hRefs The hRefs to remove to hRefs list.
	 */
	public void removeHRef(LyHRef hRefs);
}