/*
 * LyGraphicalHeader.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;


/**
 * The LyGraphicalHeader interface represents the abstract graphical component
 * for the header of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyHeader
 */
public interface LyGraphicalHeader
	extends LyGraphicalComponent
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute sort to the given value.
	 * @param sort New value of sort.
	 */
	public void setSort(int sort);

	/**
	 * Updates attribute increasing to the given value.
	 * @param increasing Boolean indicating if attribute increasing is set or unset.
	 */
	public void setIncreasing(boolean increasing);

	/**
	 * Updates attribute fixed to the given value.
	 * @param fixed Boolean indicating if attribute fixed is set or unset.
	 */
	public void setFixed(boolean fixed);

	/**
	 * Updates attribute columnWidth to the given value.
	 * @param columnWidth New value of columnWidth.
	 */
	public void setColumnWidth(double columnWidth);

	/**
	 * Updates attribute borderWidth to the given value.
	 * @param borderWidth New value of borderWidth.
	 */
	public void setBorderWidth(int borderWidth);

	/**
	 * Updates attribute borderColor to the given value.
	 * @param borderColor New value of borderColor.
	 */
	public void setBorderColor(String borderColor);
}