/*
 * LyGraphicalInterval.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;

/**
 * The LyGraphicalInterval interface represents the abstract graphical component
 * for the interval of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyInterval
 */
public interface LyGraphicalInterval
	extends LyGraphicalComponent,
			LySetLabelInterface,
			LySetFontInterface,
			LySetColorInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute label to the given value.
	 * @param label New value of label.
	 */
	public void setLabel(String label);

	/**
	 * Updates attribute centerLabel to the given value.
	 * @param centerLabel New value of centerLabel.
	 */
	public void setCenterLabel(String centerLabel);

	/**
	 * Updates attribute tooltip to the given value.
	 * @param tooltip New value of tooltip.
	 */
	public void setTooltip(String tooltip);

	/**
	 * Updates attribute font to the given value.
	 * @param font New value of font.
	 */
	public void setFont(String font);

	/**
	 * Updates attribute color to the given value.
	 * @param color New value of color.
	 */
	public void setColor(String color);

	/**
	 * Updates attribute beginDate to the given value.
	 * @param beginDate New value of beginDate.
	 */
	public void setBeginDate(String beginDate);

	/**
	 * Updates attribute endDate to the given value.
	 * @param endDate New value of endDate.
	 */
	public void setEndDate(String endDate);

	/**
	 * Updates attribute leftResizable to the given value.
	 * @param leftResizable Boolean indicating if attribute leftResizable is set or unset.
	 */
	public void setLeftResizable(boolean leftResizable);

	/**
	 * Updates attribute rightResizable to the given value.
	 * @param rightResizable Boolean indicating if attribute rightResizable is set or unset.
	 */
	public void setRightResizable(boolean rightResizable);

	/**
	 * Updates attribute movable to the given value.
	 * @param movable Boolean indicating if attribute movable is set or unset.
	 */
	public void setMovable(boolean movable);

	/**
	 * Updates attribute drawVerticalLines to the given value.
	 * @param drawVerticalLines Boolean indicating if attribute drawVerticalLines is set or unset.
	 */
	public void setDrawVerticalLines(boolean drawVerticalLines);

	/**
	 * Updates attribute verticalLinesColor to the given value.
	 * @param verticalLinesColor New value of verticalLinesColor.
	 */
	public void setVerticalLinesColor(String verticalLinesColor);

	/**
	 * Updates attribute dependencies to the given value.
	 * @param dependencies New value of dependencies.
	 */
	public void setDependencies(String dependencies);

	/**
	 * Inserts a sub-component periods at given position.
	 * @param periods The periods to add to periods list.
	 * @param pos	Position where the sub-component is inserted.
	 */
	public void addPeriod(LyPeriod periods, int pos);

	/**
	 * Removes a sub-component periods.
	 * @param periods The periods to remove to periods list.
	 */
	public void removePeriod(LyPeriod periods);
}