/*
 * LyGraphicalLabel.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.setinterface.*;

/**
 * The LyGraphicalLabel interface represents the abstract graphical component
 * for the label of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyLabel
 */
public interface LyGraphicalLabel
	extends LyGraphicalFieldItem,
			LySetLabelInterface,
			LySetImageInterface,
			LySetFontInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute label to the given value.
	 * @param label New value of label.
	 */
	public void setLabel(String label);

	/**
	 * Updates attribute image to the given value.
	 * @param image New value of image.
	 */
	public void setImage(String image);

	/**
	 * Updates attribute font to the given value.
	 * @param font New value of font.
	 */
	public void setFont(String font);
}