/*
 * LyGraphicalList.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;

/**
 * The LyGraphicalList interface represents the abstract graphical component
 * for the list of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyList
 */
public interface LyGraphicalList
	extends LyGraphicalFieldItem,
			LySetListOptionsInterface
{
	public static final String			__VERSION = "$Id$";




	/* Methods for updating graphical components */

	/**
	 * Inserts a sub-component listOptions at given position.
	 * @param listOptions The listOptions to add to listOptions list.
	 * @param pos	Position where the sub-component is inserted.
	 */
	public void addListOption(LyListOption listOptions, int pos);

	/**
	 * Removes a sub-component listOptions.
	 * @param listOptions The listOptions to remove to listOptions list.
	 */
	public void removeListOption(LyListOption listOptions);
}