/*
 * LyGraphicalMapContent.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;

/**
 * The LyGraphicalMapContent interface represents the abstract graphical component
 * for the mapContent of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyMapContent
 */
public interface LyGraphicalMapContent
	extends LyGraphicalComponent
{
	public static final String			__VERSION = "$Id$";




	/* Methods for updating graphical components */

	/**
	 * Inserts a sub-component components at given position.
	 * @param components The components to add to components list.
	 * @param pos	Position where the sub-component is inserted.
	 */
	public void addComponent(LyComponent components, int pos);

	/**
	 * Removes a sub-component components.
	 * @param components The components to remove to components list.
	 */
	public void removeComponent(LyComponent components);
}