/*
 * LyGraphicalMapNode.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.setinterface.*;

/**
 * The LyGraphicalMapNode interface represents the abstract graphical component
 * for the mapNode of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyMapNode
 */
public interface LyGraphicalMapNode
	extends LyGraphicalComponent,
			LySetLabelInterface,
			LySetSelectedInterface,
			LySetHiddenInterface,
			LySetImageInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute label to the given value.
	 * @param label New value of label.
	 */
	public void setLabel(String label);

	/**
	 * Updates attribute leftLabel to the given value.
	 * @param leftLabel New value of leftLabel.
	 */
	public void setLeftLabel(String leftLabel);

	/**
	 * Updates attribute rightLabel to the given value.
	 * @param rightLabel New value of rightLabel.
	 */
	public void setRightLabel(String rightLabel);

	/**
	 * Updates attribute topLabel to the given value.
	 * @param topLabel New value of topLabel.
	 */
	public void setTopLabel(String topLabel);

	/**
	 * Updates attribute bottomLabel to the given value.
	 * @param bottomLabel New value of bottomLabel.
	 */
	public void setBottomLabel(String bottomLabel);

	/**
	 * Updates attribute x to the given value.
	 * @param x New value of x.
	 */
	public void setX(float x);

	/**
	 * Updates attribute y to the given value.
	 * @param y New value of y.
	 */
	public void setY(float y);

	/**
	 * Updates attribute z to the given value.
	 * @param z New value of z.
	 */
	public void setZ(float z);

	/**
	 * Updates attribute selected to the given value.
	 * @param selected Boolean indicating if attribute selected is set or unset.
	 */
	public void setSelected(boolean selected);

	/**
	 * Updates attribute hidden to the given value.
	 * @param hidden Boolean indicating if attribute hidden is set or unset.
	 */
	public void setHidden(boolean hidden);

	/**
	 * Updates attribute image to the given value.
	 * @param image New value of image.
	 */
	public void setImage(String image);

	/**
	 * Updates attribute viewerImage to the given value.
	 * @param viewerImage New value of viewerImage.
	 */
	public void setViewerImage(String viewerImage);

	/**
	 * Updates attribute layer to the given value.
	 * @param layer New value of layer.
	 */
	public void setLayer(int layer);

	/**
	 * Updates attribute colorFrameInt to the given value.
	 * @param colorFrameInt New value of colorFrameInt.
	 */
	public void setColorFrameInt(String colorFrameInt);

	/**
	 * Updates attribute colorFrameExt to the given value.
	 * @param colorFrameExt New value of colorFrameExt.
	 */
	public void setColorFrameExt(String colorFrameExt);

	/**
	 * Updates attribute fontColor to the given value.
	 * @param fontColor New value of fontColor.
	 */
	public void setFontColor(String fontColor);
}