/*
 * LyGraphicalMapRegion.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;

/**
 * The LyGraphicalMapRegion interface represents the abstract graphical component
 * for the mapRegion of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyMapRegion
 */
public interface LyGraphicalMapRegion
	extends LyGraphicalComponent,
			LySetSelectedInterface,
			LySetHiddenInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute smallImage to the given value.
	 * @param smallImage New value of smallImage.
	 */
	public void setSmallImage(String smallImage);

	/**
	 * Updates attribute smallImageTooltip to the given value.
	 * @param smallImageTooltip New value of smallImageTooltip.
	 */
	public void setSmallImageTooltip(String smallImageTooltip);

	/**
	 * Updates attribute weight to the given value.
	 * @param weight New value of weight.
	 */
	public void setWeight(float weight);

	/**
	 * Updates attribute selected to the given value.
	 * @param selected Boolean indicating if attribute selected is set or unset.
	 */
	public void setSelected(boolean selected);

	/**
	 * Updates attribute hidden to the given value.
	 * @param hidden Boolean indicating if attribute hidden is set or unset.
	 */
	public void setHidden(boolean hidden);

	/**
	 * Inserts a sub-component mapRegions at given position.
	 * @param mapRegions The mapRegions to add to mapRegions list.
	 * @param pos	Position where the sub-component is inserted.
	 */
	public void addMapRegion(LyMapRegion mapRegions, int pos);

	/**
	 * Removes a sub-component mapRegions.
	 * @param mapRegions The mapRegions to remove to mapRegions list.
	 */
	public void removeMapRegion(LyMapRegion mapRegions);
}