/*
 * LyGraphicalMenuBar.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;

/**
 * The LyGraphicalMenuBar interface represents the abstract graphical component
 * for the menuBar of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyMenuBar
 */
public interface LyGraphicalMenuBar
	extends LyGraphicalComponent
{
	public static final String			__VERSION = "$Id$";




	/* Methods for updating graphical components */

	/**
	 * Inserts a sub-component menus at given position.
	 * @param menus The menus to add to menus list.
	 * @param pos	Position where the sub-component is inserted.
	 */
	public void addMenu(LyMenu menus, int pos);

	/**
	 * Removes a sub-component menus.
	 * @param menus The menus to remove to menus list.
	 */
	public void removeMenu(LyMenu menus);
}