/*
 * LyGraphicalMessages.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;

/**
 * The LyGraphicalMessages interface represents the abstract graphical component
 * for the messages of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyMessages
 */
public interface LyGraphicalMessages
	extends LyGraphicalComponent
{
	public static final String			__VERSION = "$Id$";




	/* Methods for updating graphical components */

	/**
	 * Inserts a sub-component messages at given position.
	 * @param messages The messages to add to messages list.
	 * @param pos	Position where the sub-component is inserted.
	 */
	public void addMessage(LyMessage messages, int pos);

	/**
	 * Removes a sub-component messages.
	 * @param messages The messages to remove to messages list.
	 */
	public void removeMessage(LyMessage messages);
}