/*
 * LyGraphicalNumber.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.setinterface.*;

/**
 * The LyGraphicalNumber interface represents the abstract graphical component
 * for the number of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyNumber
 */
public interface LyGraphicalNumber
	extends LyGraphicalFieldItem,
			LySetLabelInterface,
			LySetNumberInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute label to the given value.
	 * @param label New value of label.
	 */
	public void setLabel(String label);

	/**
	 * Updates attribute format to the given value.
	 * @param format New value of format.
	 */
	public void setFormat(String format);

	/**
	 * Updates attribute vMin to the given value.
	 * @param vMin New value of vMin.
	 */
	public void setVMin(double vMin);

	/**
	 * Updates attribute vMax to the given value.
	 * @param vMax New value of vMax.
	 */
	public void setVMax(double vMax);

	/**
	 * Updates attribute pitch to the given value.
	 * @param pitch New value of pitch.
	 */
	public void setPitch(double pitch);

	/**
	 * Updates attribute decimals to the given value.
	 * @param decimals New value of decimals.
	 */
	public void setDecimals(int decimals);
}