/*
 * LyGraphicalOption.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.setinterface.*;

/**
 * The LyGraphicalOption interface represents the abstract graphical component
 * for the option of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyOption
 */
public interface LyGraphicalOption
	extends LyGraphicalComponent,
			LySetEnabledInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute checked to the given value.
	 * @param checked Boolean indicating if attribute checked is set or unset.
	 */
	public void setChecked(boolean checked);

	/**
	 * Updates attribute enabled to the given value.
	 * @param enabled Boolean indicating if attribute enabled is set or unset.
	 */
	public void setEnabled(boolean enabled);
}