/*
 * LyGraphicalPopupMenu.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;

/**
 * The LyGraphicalPopupMenu interface represents the abstract graphical component
 * for the popupMenu of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyPopupMenu
 */
public interface LyGraphicalPopupMenu
	extends LyGraphicalComponent,
			LySetEnabledInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute enabled to the given value.
	 * @param enabled Boolean indicating if attribute enabled is set or unset.
	 */
	public void setEnabled(boolean enabled);

	/**
	 * Inserts a sub-component components at given position.
	 * @param components The components to add to components list.
	 * @param pos	Position where the sub-component is inserted.
	 */
	public void addComponent(LyComponent components, int pos);

	/**
	 * Removes a sub-component components.
	 * @param components The components to remove to components list.
	 */
	public void removeComponent(LyComponent components);
}