/*
 * LyGraphicalRelation.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;

/**
 * The LyGraphicalRelation interface represents the abstract graphical component
 * for the relation of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyRelation
 */
public interface LyGraphicalRelation
	extends LyGraphicalFieldItem,
			LySetLinksInterface
{
	public static final String			__VERSION = "$Id$";




	/* Methods for updating graphical components */

	/**
	 * Inserts a sub-component links at given position.
	 * @param links The links to add to links list.
	 * @param pos	Position where the sub-component is inserted.
	 */
	public void addLink(LyLink links, int pos);

	/**
	 * Removes a sub-component links.
	 * @param links The links to remove to links list.
	 */
	public void removeLink(LyLink links);
}