/*
 * LyGraphicalSelectBar.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;

/**
 * The LyGraphicalSelectBar interface represents the abstract graphical component
 * for the selectBar of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LySelectBar
 */
public interface LyGraphicalSelectBar
	extends LyGraphicalPanel,
			LySetLabelInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute label to the given value.
	 * @param label New value of label.
	 */
	public void setLabel(String label);

	/**
	 * Updates attribute startItem to the given value.
	 * @param startItem New value of startItem.
	 */
	public void setStartItem(int startItem);

	/**
	 * Inserts a sub-component components at given position.
	 * @param components The components to add to components list.
	 * @param pos	Position where the sub-component is inserted.
	 */
	public void addComponent(LyComponent components, int pos);

	/**
	 * Removes a sub-component components.
	 * @param components The components to remove to components list.
	 */
	public void removeComponent(LyComponent components);
}