/*
 * LyGraphicalSelectItem.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.setinterface.*;

/**
 * The LyGraphicalSelectItem interface represents the abstract graphical component
 * for the selectItem of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LySelectItem
 */
public interface LyGraphicalSelectItem
	extends LyGraphicalComponent,
			LySetLabelInterface,
			LySetImageInterface,
			LySetSelectedInterface,
			LySetEnabledInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute label to the given value.
	 * @param label New value of label.
	 */
	public void setLabel(String label);

	/**
	 * Updates attribute image to the given value.
	 * @param image New value of image.
	 */
	public void setImage(String image);

	/**
	 * Updates attribute selected to the given value.
	 * @param selected Boolean indicating if attribute selected is set or unset.
	 */
	public void setSelected(boolean selected);

	/**
	 * Updates attribute enabled to the given value.
	 * @param enabled Boolean indicating if attribute enabled is set or unset.
	 */
	public void setEnabled(boolean enabled);
}