/*
 * LyGraphicalSubIndex.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;

/**
 * The LyGraphicalSubIndex interface represents the abstract graphical component
 * for the subIndex of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LySubIndex
 */
public interface LyGraphicalSubIndex
	extends LyGraphicalComponent,
			LySetLabelInterface
{
	public static final String			__VERSION = "$Id: LyGraphicalSubIndex.java 28422 2010-11-03 12:03:38Z ehelmste $";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute label to the given value.
	 * @param label New value of label.
	 */
	public void setLabel(String label);

	/**
	 * Inserts a sub-component components at given position.
	 * @param components The components to add to components list.
	 * @param pos	Position where the sub-component is inserted.
	 */
	public void addComponent(LyComponent components, int pos);

	/**
	 * Removes a sub-component components.
	 * @param components The components to remove to components list.
	 */
	public void removeComponent(LyComponent components);
}