/*
 * LyGraphicalTab.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.setinterface.*;

/**
 * The LyGraphicalTab interface represents the abstract graphical component
 * for the tab of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyTab
 */
public interface LyGraphicalTab
	extends LyGraphicalComponent,
			LySetEnabledInterface,
			LySetColorInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute enabled to the given value.
	 * @param enabled Boolean indicating if attribute enabled is set or unset.
	 */
	public void setEnabled(boolean enabled);

	/**
	 * Updates attribute color to the given value.
	 * @param color New value of color.
	 */
	public void setColor(String color);
}