/*
 * LyGraphicalTable.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;

/**
 * The LyGraphicalTable interface represents the abstract graphical component
 * for the table of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyTable
 */
public interface LyGraphicalTable
	extends LyGraphicalPanel,
			LySetEnabledInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute enabled to the given value.
	 * @param enabled Boolean indicating if attribute enabled is set or unset.
	 */
	public void setEnabled(boolean enabled);

	/**
	 * Updates attribute nRows to the given value.
	 * @param nRows New value of nRows.
	 */
	public void setNRows(int nRows);

	/**
	 * Sets sub-component headers.
	 * @param headers New value of headers
	 */
	public void setHeaders(LyHeaders headers);

	/**
	 * Sets sub-component footers.
	 * @param footers New value of footers
	 */
	public void setFooters(LyFooters footers);
}