/*
 * LyGraphicalTabs.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;

/**
 * The LyGraphicalTabs interface represents the abstract graphical component
 * for the tabs of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyTabs
 */
public interface LyGraphicalTabs
	extends LyGraphicalContainer
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute selectedTab to the given value.
	 * @param selectedTab New value of selectedTab.
	 */
	public void setSelectedTab(String selectedTab);

	/**
	 * Inserts a sub-component tabs at given position.
	 * @param tabs The tabs to add to tabs list.
	 * @param pos	Position where the sub-component is inserted.
	 */
	public void addTab(LyTab tabs, int pos);

	/**
	 * Removes a sub-component tabs.
	 * @param tabs The tabs to remove to tabs list.
	 */
	public void removeTab(LyTab tabs);
}