/*
 * LyGraphicalTitleBar.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.setinterface.*;

/**
 * The LyGraphicalTitleBar interface represents the abstract graphical component
 * for the titleBar of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyTitleBar
 */
public interface LyGraphicalTitleBar
	extends LyGraphicalComponent,
			LySetImageInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute image to the given value.
	 * @param image New value of image.
	 */
	public void setImage(String image);

	/**
	 * Updates attribute imageToolTip to the given value.
	 * @param imageToolTip New value of imageToolTip.
	 */
	public void setImageToolTip(String imageToolTip);

	/**
	 * Updates attribute rightImage to the given value.
	 * @param rightImage New value of rightImage.
	 */
	public void setRightImage(String rightImage);

	/**
	 * Updates attribute rightImageToolTip to the given value.
	 * @param rightImageToolTip New value of rightImageToolTip.
	 */
	public void setRightImageToolTip(String rightImageToolTip);

	/**
	 * Updates attribute leftLabel to the given value.
	 * @param leftLabel New value of leftLabel.
	 */
	public void setLeftLabel(String leftLabel);

	/**
	 * Updates attribute centerLabel to the given value.
	 * @param centerLabel New value of centerLabel.
	 */
	public void setCenterLabel(String centerLabel);

	/**
	 * Updates attribute rightLabel to the given value.
	 * @param rightLabel New value of rightLabel.
	 */
	public void setRightLabel(String rightLabel);
}