/*
 * LyGraphicalTool.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.setinterface.*;

/**
 * The LyGraphicalTool interface represents the abstract graphical component
 * for the tool of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyTool
 */
public interface LyGraphicalTool
	extends LyGraphicalPanel,
			LySetLabelInterface,
			LySetImageInterface,
			LySetEnabledInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute label to the given value.
	 * @param label New value of label.
	 */
	public void setLabel(String label);

	/**
	 * Updates attribute tooltip to the given value.
	 * @param tooltip New value of tooltip.
	 */
	public void setTooltip(String tooltip);

	/**
	 * Updates attribute image to the given value.
	 * @param image New value of image.
	 */
	public void setImage(String image);

	/**
	 * Updates attribute pressed to the given value.
	 * @param pressed Boolean indicating if attribute pressed is set or unset.
	 */
	public void setPressed(boolean pressed);

	/**
	 * Updates attribute enabled to the given value.
	 * @param enabled Boolean indicating if attribute enabled is set or unset.
	 */
	public void setEnabled(boolean enabled);
}