/*
 * LyGraphicalToolBar.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;

/**
 * The LyGraphicalToolBar interface represents the abstract graphical component
 * for the toolBar of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyToolBar
 */
public interface LyGraphicalToolBar
	extends LyGraphicalComponent,
			LySetImageInterface,
			LySetColorInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute image to the given value.
	 * @param image New value of image.
	 */
	public void setImage(String image);

	/**
	 * Updates attribute open to the given value.
	 * @param open Boolean indicating if attribute open is set or unset.
	 */
	public void setOpen(boolean open);

	/**
	 * Updates attribute color to the given value.
	 * @param color New value of color.
	 */
	public void setColor(String color);

	/**
	 * Inserts a sub-component components at given position.
	 * @param components The components to add to components list.
	 * @param pos	Position where the sub-component is inserted.
	 */
	public void addComponent(LyComponent components, int pos);

	/**
	 * Removes a sub-component components.
	 * @param components The components to remove to components list.
	 */
	public void removeComponent(LyComponent components);
}