/*
 * LyGraphicalTree.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.graphic;

import leon.view.*;
import leon.view.setinterface.*;

/**
 * The LyGraphicalTree interface represents the abstract graphical component
 * for the tree of views.dtd regardless of the target (swing, swt, dhtml...).
 * @see leon.view.LyTree
 */
public interface LyGraphicalTree
	extends LyGraphicalPanel,
			LySetLabelInterface
{
	public static final String			__VERSION = "$Id$";


	/* Methods for updating graphical components */

	/**
	 * Updates attribute label to the given value.
	 * @param label New value of label.
	 */
	public void setLabel(String label);

	/**
	 * Updates attribute activeNode to the given value.
	 * @param activeNode New value of activeNode.
	 */
	public void setActiveNode(String activeNode);

	/**
	 * Sets sub-component treeNode.
	 * @param treeNode New value of treeNode
	 */
	public void setTreeNode(LyTreeNode treeNode);
}