package leon.view.mobile;

import java.io.*;
import java.util.*;

import leon.view.LyAreaBase.Border;
import leon.view.*;
import leon.view.LyCommands.Align;
import leon.view.graphic.*;

public class LyMobileCommands extends LyMobileObject
	implements LyGraphicalCommands
{
	/** The commands generic component. */
    protected LyCommands					_commands;
    
    protected String 						_id;
    
    protected LyCommands 					_template;
    
    protected Border 						_border;
    
    protected String 						_font;
    
    protected String 						_color;
    
    protected String 						_fontColor;
    
    protected Hashtable<String, String> 	_datas;
    
	//protected LyConstraint 				_constraint;
    
    protected Align 						_align;
    
    protected ArrayList<LyCommand> 			_commandes;
	
	public LyMobileCommands(LyCommands commands)
	{
		super(commands);
		
		_commands = commands;
		
		_commandes = new ArrayList<LyCommand>();
		
	}

	
	public void writeXml(PrintWriter pw)
	{
		// Write tag with its attributes
		init();
		/*pw.print("<COMMANDS");
		if (_id != null)
			pw.print(" id='" + LyString.getXmlStringStrict(_id) + "'");
		if (_template != null)
			pw.print(" template='" + _template.getId() + "'");
		if ((_template == null)
			|| (_border != _template.getBorder()))
		{
			if (_border == LyArea.Border.NONE)
				pw.print(" border='NONE'");
			else if ((_border == LyArea.Border.IN) && (_template != null))
				pw.print(" border='IN'");
			else if (_border == LyArea.Border.OUT)
				pw.print(" border='OUT'");
			else if (_border == LyArea.Border.SOLID)
				pw.print(" border='SOLID'");
			else if (_border == LyArea.Border.RAISED)
				pw.print(" border='RAISED'");
			else if (_border == LyArea.Border.LOWERED)
				pw.print(" border='LOWERED'");
		}
		if ((_template == null)
			|| (_align != _template.getAlign()))
		{
			if (_align == Align.LEFT)
				pw.print(" align='LEFT'");
			else if (_align == Align.RIGHT)
				pw.print(" align='RIGHT'");
			else if ((_align == Align.CENTER) && (_template != null))
				pw.print(" align='CENTER'");
		}
		if (((_template == null) && (_font != getStringValue("COMMANDS.font", "$ALL.font")))
				|| ((_template != null) && (_font != _template.getFont())))
			pw.print(" font='" + LyString.getXmlStringStrict(_font) + "'");
		if (((_template == null) && (_color != getStringValue("COMMANDS.color", "$ALL.color")))
				|| ((_template != null) && (_color != _template.getColor())))
			pw.print(" color='" + LyString.getXmlStringStrict(_color) + "'");
		if (((_template == null) && (_fontColor != getStringValue("COMMANDS.fontColor", "$ALL.fontColor")))
				|| ((_template != null) && (_fontColor != _template.getFontColor())))
			pw.print(" fontColor='" + LyString.getXmlStringStrict(_fontColor) + "'");

		if ((_commands.getChildCount() == 0) && (_datas == null))
		{
			pw.println("/>");
			return;
		}
		else
			pw.println(">");*/

		// Write sub-components
		LyComponent	command;
		int			i, n;
		n = (_commandes == null ? 0 : _commandes.size());
		for (i = 0; i < n; i++)
		{
			command = _commandes.get(i);
			if ((command == null)
					|| (command.getId() == SEP_ID))
				pw.println("<SEP/>");
			else
				((LyMobileCommand)command.getInternalView()).writeXml(pw);
		}

		//TODO : STAGE : Constraint
		/*if (_constraint != null)
			_constraint.writeXml(pw, debug);*/

		//pw.println("</COMMANDS>");

	}
	
	public void writeJson(PrintWriter pw, String sessionId)
	{
		writeJson(pw, true, sessionId);
	}
	
	
	public void writeJson(PrintWriter pw, boolean first, String sessionId)
	{
		boolean isFirstElement = first;
		init();
		LyComponent	command;
		int			i, n;
		n = (_commandes == null ? 0 : _commandes.size());
		for (i = 0; i < n; i++)
		{						
			command = _commandes.get(i);
			if ((command == null)
					|| (command.getId() == SEP_ID))
			{
				isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
				pw.println("{SEP:[]}");
			}				
			else
			{
				if(isFirstElement)
				{
					((LyMobileCommand)command.getInternalView()).writeJson(pw, sessionId);
					isFirstElement = false;
				}
				else
				{
					((LyMobileCommand)command.getInternalView()).writeJson(pw, true, sessionId);
				}
			}
				
		}
	}

	
	public void init()
	{
		_id = _commands.getId();
		_template = _commands.getTemplate();
		_border = _commands.getBorder();
		_font = _commands.getFont();
		_color = _commands.getColor();
		_fontColor = _commands.getFontColor();
		_datas = _commands.getDatas();
		//_constraint = _commands.getConstraint();
		_align = _commands.getAlign();
		
		_commandes.clear();
		
		for(int j = 0; j < _commands.getCommandCount(); j++)
		{
			_commandes.add(_commands.getCommand(j));
		}
		
	}

}
