package leon.view.mobile;

import java.io.*;
import java.util.*;

import leon.view.*;
import leon.view.graphic.*;
import leon.view.web.*;

public class LyMobileDialog extends LyWebPageWriter
	implements LyGraphicalDialog
{
    /** The dialog generic component. */
    protected LyDialog         	 		_dialog;

	protected LyDialog					_template;

	protected String					_label;

	protected String					_controller;

	protected String					_parentId;

	protected int						_width;

	protected int						_height;

	protected boolean					_resizable;

	protected int						_minWidth;

	protected int						_minHeight;

	protected int						_x;

	protected int						_y;

	protected boolean					_modal;

	protected boolean					_decorated;

	protected String					_target;
	
	protected Hashtable<String, String>	_datas;
	
	protected LyArea					_area;


	public LyMobileDialog(LyDialog dialog)
	{
		super(dialog);

		_dialog = dialog;
		super.init();
		init();
	
	}

	
	public void writeXml(PrintWriter pw)
	{
		// Write tag with its attributes
		init();
		/*pw.print("<DIALOG");
		pw.print(" id='" + LyString.getXmlStringStrict(_id) + "'");
		if (_template != null)
			pw.print(" template='" + _template.getId() + "'");
		if (((_template == null) && (_label != null))
				|| ((_template != null) && (_label != _template.getLabel())))
			pw.print(" label='" + LyString.getXmlStringStrict(_label) + "'");
		if (_controller != null)
			pw.print(" controller='" + LyString.getXmlStringStrict(_controller) + "'");
		if (((_template == null) && (_parentId != null))
				|| ((_template != null) && (_parentId != _template.getParentId())))
			pw.print(" parentId='" + LyString.getXmlStringStrict(_parentId) + "'");
		if (((_template == null) && (_width != getIntValue("DIALOG.width", -1)))
				|| ((_template != null) && (_width != _template.getWidth())))
			pw.print(" width='" + _width + "'");
		if (((_template == null) && (_height != getIntValue("DIALOG.height", -1)))
				|| ((_template != null) && (_height != _template.getHeight())))
			pw.print(" height='" + _height + "'");
		if (((_template == null) && _resizable)
				|| ((_template != null) && (_resizable != _template.isResizable())))
			pw.print(" resizable='" + _resizable + "'");
		if (((_template == null) && (_minWidth != getIntValue("DIALOG.minWidth", -1)))
				|| ((_template != null) && (_minWidth != _template.getMinWidth())))
			pw.print(" minWidth='" + _minWidth + "'");
		if (((_template == null) && (_minHeight != getIntValue("DIALOG.minHeight", -1)))
				|| ((_template != null) && (_minHeight != _template.getMinHeight())))
			pw.print(" minHeight='" + _minHeight + "'");
		if (((_template == null) && (_x != getIntValue("DIALOG.x", 0)))
				|| ((_template != null) && (_x != _template.getX())))
			pw.print(" x='" + _x + "'");
		if (((_template == null) && (_y != getIntValue("DIALOG.y", 0)))
				|| ((_template != null) && (_y != _template.getY())))
			pw.print(" y='" + _y + "'");
		if (((_template == null) && _modal)
				|| ((_template != null) && (_modal != _template.isModal())))
			pw.print(" modal='" + _modal + "'");
		if (((_template == null) && !_decorated)
				|| ((_template != null) && (_decorated != _template.isDecorated())))
			pw.print(" decorated='" + _decorated + "'");
		if (((_template == null) && (_target != null))
				|| ((_template != null) && (_target != _template.getTarget())))
			pw.print(" target='" + LyString.getXmlStringStrict(_target) + "'");

		if ((_dialog.getChildCount() == 0) && (_datas == null))
		{
			pw.println("/>");
			return;
		}
		else
			pw.println(">");*/

		// Write sub-components
		if (_area != null)
			((LyMobileArea)_area.getInternalView()).writeXml(pw);

		//TODO : Stage : writeDatas
		//writeDatas(pw);

		//pw.println("</DIALOG>");

	}
	
	public void writeJson(PrintWriter pw, String sessionId)
	{
		// Write tag with its attributes
		init();
		pw.println("{");
		// Write sub-components
		if (_area != null)
			((LyMobileArea)_area.getInternalView()).writeJson(pw, sessionId);
		pw.println("}");
	}

	@Override
	public void init()
	{
		_id = _dialog.getId();
		_template = _dialog.getTemplate();
		_label = _dialog.getLabel();
		_controller = _dialog.getController();
		_parentId = _dialog.getParentId();
		_width = _dialog.getWidth();
		_height = _dialog.getHeight();
		_resizable = _dialog.isResizable();
		_minWidth = _dialog.getMinWidth();
		_minHeight = _dialog.getMinHeight();
		_x = _dialog.getX();
		_y = _dialog.getY();
		_modal = _dialog.isModal();
		_decorated = _dialog.isDecorated();
		_target = _dialog.getTarget();
		_datas = _dialog.getDatas();
		_area = _dialog.getArea();
		
	}

	
	public void setLabel(String label)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void setArea(LyArea area)
	{
		// TODO Auto-generated method stub
		
	}


	public void writeHtml(LyWebPageWriter pw)
	{
		// TODO Auto-generated method stub
		
	}


	@Override
	public Vector<LyWebPageWriter> getPageWriters()
	{
		// TODO Auto-generated method stub
		return null;
	}


	@Override
	public String getRedirect(String frame)
	{
		// TODO Auto-generated method stub
		return null;
	}

}
