package leon.view.mobile;

import java.io.*;

import leon.misc.*;
import leon.view.*;
import leon.view.graphic.*;

public class LyMobileFooter extends LyMobileTableObject
implements LyGraphicalFooter
{
	/** The footer generic component. */
	protected LyFooter          _footer;

	protected String			_id;

	protected LyFooter			_template;

	protected String			_label;

	protected String			_tooltip;

	protected LyHeader.Align	_align;

	protected String			_font;

	protected String			_color;

	protected String			_fontColor;

	protected boolean			_wrap;


	public LyMobileFooter(LyFooter footer)
	{
		super(footer);

		_footer = footer;

	}


	public void writeXml(PrintWriter pw)
	{
		// Write tag with its attributes
		init();
		pw.print("<FOOTER");
		if (_id != null)
			pw.print(" id='" + LyString.getXmlStringStrict(_id) + "'");
		if (_template != null)
			pw.print(" template='" + _template.getId() + "'");
		if (((_template == null) && (_label != null))
				|| ((_template != null) && (_label != _template.getLabel())))
			pw.print(" label='" + LyString.getXmlStringStrict(_label) + "'");
		if (((_template == null) && (_tooltip != null))
				|| ((_template != null) && (_tooltip != _template.getTooltip())))
			pw.print(" tooltip='" + LyString.getXmlStringStrict(_tooltip) + "'");
		if ((_template == null)
				|| (_align != _template.getAlign()))
		{
			if ((_align == LyHeader.Align.LEFT) && (_template != null))
				pw.print(" align='LEFT'");
			else if (_align == LyHeader.Align.RIGHT)
				pw.print(" align='RIGHT'");
			else if (_align == LyHeader.Align.CENTER)
				pw.print(" align='CENTER'");
		}
		if (((_template == null) && (_font != getStringValue("FOOTER.font", "$ALL.font")))
				|| ((_template != null) && (_font != _template.getFont())))
			pw.print(" font='" + LyString.getXmlStringStrict(_font) + "'");
		if (((_template == null) && (_color != getStringValue("FOOTER.color", "$ALL.color")))
				|| ((_template != null) && (_color != _template.getColor())))
			pw.print(" color='" + getColorValue(_color) + "'");
		if (((_template == null) && (_fontColor != getStringValue("FOOTER.fontColor", "$ALL.fontColor")))
				|| ((_template != null) && (_fontColor != _template.getFontColor())))
			pw.print(" fontColor='" + getColorValue(_fontColor) + "'");
		if (((_template == null) && _wrap)
				|| ((_template != null) && (_wrap != _template.isWrap())))
			pw.print(" wrap='" + _wrap + "'");
		pw.println("/>");

	}

	public void writeJson(PrintWriter pw, String sessionId)
	{
		boolean isFirstElement = true;
		init();
		pw.println("\"FOOTER\": {");

		if (_id != null)
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("\"id\": \"" + LyString.getJsonString(_id) + "\"");
		}

		if (((_template == null) && (_label != null))
				|| ((_template != null) && (_label != _template.getLabel())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("\"label\": \"" + LyString.getJsonString(_label) + "\"");
		}

		if (((_template == null) && (_tooltip != null))
				|| ((_template != null) && (_tooltip != _template.getTooltip())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("\"tooltip\": \"" + LyString.getJsonString(_tooltip) + "\"");
		}

		if ((_template == null)
				|| (_align != _template.getAlign()))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			if ((_align == LyHeader.Align.LEFT) && (_template != null))
				pw.print("\"align\": \"LEFT\"");
			else if (_align == LyHeader.Align.RIGHT)
				pw.print("\"align\": \"RIGHT\"");
			else if (_align == LyHeader.Align.CENTER)
				pw.print("\"align\": \"CENTER\"");
		}

		if (((_template == null) && (_font != null))
				|| ((_template != null) && (_font != _template.getFont())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("\"font\": \"" + LyString.getJsonString(_font) + "\"");
		}

		if (((_template == null) && (_color != null))
				|| ((_template != null) && (_color != _template.getColor())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("\"color\": \"" + getColorValue(_color) + "\"");
		}

		if (((_template == null) && (_fontColor != null))
				|| ((_template != null) && (_fontColor != _template.getFontColor())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("\"fontColor\": \"" + getColorValue(_fontColor) + "\"");
		}
		if (((_template == null) && _wrap)
				|| ((_template != null) && (_wrap != _template.isWrap())))
			pw.print("\"wrap\": \"" + _wrap + "\"");
		
		pw.println("}");
	}


	public void init()
	{

		_id = _footer.getId();
		_template = _footer.getTemplate();
		_label = _footer.getLabel();
		_tooltip = _footer.getTooltip();
		_align = _footer.getAlign();
		_font = _footer.getFont();
		_color = _footer.getColor();
		_fontColor = _footer.getFontColor();
		_wrap = _footer.isWrap();

	}


	public void setLabel(String label)
	{
		// TODO Auto-generated method stub

	}


	public int writeXml(PrintWriter pw, int nb)
	{
		writeXml(pw);
		return nb-1;
	}

}
