package leon.view.mobile;

import java.io.*;
import java.util.*;

import leon.view.*;
import leon.view.graphic.*;

public class LyMobileFrame extends LyMobileObject
	implements LyGraphicalFrame
{
    /** The frame generic component. */
    protected LyFrame 						_frame;
    
    protected String						_id;

	protected LyFrame						_template;

	protected String						_label;

	protected String						_controller;

	protected String						_parentId;

	protected int							_width;

	protected int							_height;

	protected boolean						_resizable;

	protected boolean						_decorated;

	protected int							_minWidth;

	protected int							_minHeight;

	protected int							_x;

	protected int							_y;

	protected String						_target;

	protected LyIcon						_icon;

	protected LyMenuBar						_menuBar;

	protected LyArea						_area;

	protected LyMessages					_messages;
	
	protected Hashtable<String, String>		_datas;

	public LyMobileFrame(LyFrame frame)
	{
		super(frame);
		
		_frame = frame;

	}

	
	public void writeXml(PrintWriter pw)
	{
		// Write tag with its attributes
		init();
		/*pw.print("<FRAME");
		pw.print(" id='" + LyString.getXmlStringStrict(_id) + "'");
		if (_template != null)
			pw.print(" template='" + _template.getId() + "'");
		if (((_template == null) && (_label != null))
				|| ((_template != null) && (_label != _template.getLabel())))
			pw.print(" label='" + LyString.getXmlStringStrict(_label) + "'");
		if (_controller != null)
			pw.print(" controller='" + LyString.getXmlStringStrict(_controller) + "'");
		if (((_template == null) && (_parentId != null))
				|| ((_template != null) && (_parentId != _template.getParentId())))
			pw.print(" parentId='" + LyString.getXmlStringStrict(_parentId) + "'");
		if (((_template == null) && (_width != getIntValue("FRAME.width", -1)))
				|| ((_template != null) && (_width != _template.getWidth())))
			pw.print(" width='" + _width + "'");
		if (((_template == null) && (_height != getIntValue("FRAME.height", -1)))
				|| ((_template != null) && (_height != _template.getHeight())))
			pw.print(" height='" + _height + "'");
		if (((_template == null) && !_resizable)
				|| ((_template != null) && (_resizable != _template.isResizable())))
			pw.print(" resizable='" + _resizable + "'");
		if (((_template == null) && !_decorated)
				|| ((_template != null) && (_decorated != _template.isDecorated())))
			pw.print(" decorated='" + _decorated + "'");
		if (((_template == null) && (_minWidth != getIntValue("FRAME.minWidth", -1)))
				|| ((_template != null) && (_minWidth != _template.getMinWidth())))
			pw.print(" minWidth='" + _minWidth + "'");
		if (((_template == null) && (_minHeight != getIntValue("FRAME.minHeight", -1)))
				|| ((_template != null) && (_minHeight != _template.getMinHeight())))
			pw.print(" minHeight='" + _minHeight + "'");
		if (((_template == null) && (_x != getIntValue("FRAME.x", 0)))
				|| ((_template != null) && (_x != _template.getX())))
			pw.print(" x='" + _x + "'");
		if (((_template == null) && (_y != getIntValue("FRAME.y", 0)))
				|| ((_template != null) && (_y != _template.getY())))
			pw.print(" y='" + _y + "'");
		if (((_template == null) && (_target != null))
				|| ((_template != null) && (_target != _template.getTarget())))
			pw.print(" target='" + LyString.getXmlStringStrict(_target) + "'");

		if ((_frame.getChildCount() == 0) && (_datas == null))
		{
			pw.println("/>");
			return;
		}
		else
			pw.println(">");*/

		// Write sub-components
		if (_icon != null)
			((LyMobileIcon)_icon.getInternalView()).writeXml(pw);
		if (_menuBar != null)
			((LyMobileMenuBar)_menuBar.getInternalView()).writeXml(pw);
		if (_area != null)
			((LyMobileArea)_area.getInternalView()).writeXml(pw);
		if (_messages != null)
			((LyMobileMessages)_messages.getInternalView()).writeXml(pw);

		//writeDatas(pw);

		//pw.println("</FRAME>");

	}
	
	public void writeJson(PrintWriter pw, String sessionId)
	{
		boolean isFirstElement = true;
		pw.println("{");
		if (_icon != null)
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			((LyMobileIcon)_icon.getInternalView()).writeJson(pw, sessionId);
		}			
		if (_menuBar != null)
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			((LyMobileMenuBar)_menuBar.getInternalView()).writeJson(pw, sessionId);
		}	
		if (_area != null)
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			((LyMobileArea)_area.getInternalView()).writeJson(pw, sessionId);
		}	
		if (_messages != null)
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			((LyMobileMessages)_messages.getInternalView()).writeJson(pw, sessionId);
		}	
		
		pw.println("}");
	}

	
	public void init()
	{
		_id = _frame.getId();
		_template = _frame.getTemplate();
		_label = _frame.getLabel();
		_controller = _frame.getController();
		_parentId = _frame.getParentId();
		_width = _frame.getWidth();
		_height = _frame.getHeight();
		_resizable = _frame.isResizable();
		_decorated = _frame.isDecorated();
		_minWidth = _frame.getMinWidth();
		_minHeight = _frame.getMinHeight();
		_x = _frame.getX();
		_y = _frame.getY();
		_target = _frame.getTarget();

		// Initialize sub components
		_icon = _frame.getIcon();
		_menuBar = _frame.getMenuBar();
		_area = _frame.getArea();
		_messages = _frame.getMessages();
		
		_datas = _frame.getDatas();
		
	}

	
	public void setLabel(String label)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void setMessages(LyMessages messages)
	{
		// TODO Auto-generated method stub
		
	}

}
