package leon.view.mobile;

import java.io.*;

import leon.misc.*;
import leon.view.*;
import leon.view.graphic.*;

public class LyMobileHRef extends LyMobileObject
	implements LyGraphicalHRef
{
	/** The href generic component. */
    protected LyHRef			_href;

	protected String			_id;

	protected LyHRef			_template;

	protected String			_label;

	protected String			_image;

	protected boolean			_visited;

	protected boolean			_sensitive;

	protected String			_bean;

	protected String			_font;

	protected String			_color;

	protected String			_fontColor;

	protected String			_disabledFontColor;

	protected String			_visitedFontColor;

	protected String			_highlightColor;

	protected int				_nCols;

	public LyMobileHRef(LyHRef href)
	{
		super(href);
		
		_href = href;
		
		_font = getFontValue(getStringValue("MOBILE_HREF.font"));

		_color = getStringValue("MOBILE_HREF.color");

		_fontColor = getStringValue("MOBILE_HREF.fontColor");
	}

	
	public void writeXml(PrintWriter pw)
	{
		init();
		pw.print("<HREF");
		/*if (_id != null)
			pw.print(" id='" + LyString.getXmlStringStrict(_id) + "'");
		if (_template != null)
			pw.print(" template='" + _template.getId() + "'");*/
		if (((_template == null) && (_label != null))
				|| ((_template != null) && (_label != _template.getLabel())))
			pw.print(" label='" + LyString.getXmlStringStrict(_label) + "'");
		/*if (((_template == null) && (_image != getStringValue("HREF.image", "$ALL.image")))
				|| ((_template != null) && (_image != _template.getImage())))
			pw.print(" image='" + LyString.getXmlStringStrict(_image) + "'");
		if (((_template == null) && _visited)
				|| ((_template != null) && (_visited != _template.isVisited())))
			pw.print(" visited='" + _visited + "'");
		if (((_template == null) && !_sensitive)
				|| ((_template != null) && (_sensitive != _template.isSensitive())))
			pw.print(" sensitive='" + _sensitive + "'");
		if (((_template == null) && (_bean != null))
				|| ((_template != null) && (_bean != _template.getBean())))
			pw.print(" bean='" + LyString.getXmlStringStrict(_bean) + "'");*/
		if (((_template == null) && (_font != null))
				|| ((_template != null) && (_font != _template.getFont())))
			pw.print(" font='" + LyString.getXmlStringStrict(_font) + "'");
		if (((_template == null) && (_color != null))
				|| ((_template != null) && (_color != _template.getColor())))
			pw.print(" color='" + getColorValue(_color) + "'");
		if (((_template == null) && (_fontColor != null))
				|| ((_template != null) && (_fontColor != _template.getFontColor())))
			pw.print(" fontColor='" + getColorValue(_fontColor) + "'");
		/*if (((_template == null) && (_disabledFontColor != getStringValue("HREF.disabledFontColor", "$ALL.disabledFontColor")))
				|| ((_template != null) && (_disabledFontColor != _template.getDisabledFontColor())))
			pw.print(" disabledFontColor='" + LyString.getXmlStringStrict(_disabledFontColor) + "'");
		if (((_template == null) && (_visitedFontColor != getStringValue("HREF.visitedFontColor", "$ALL.visitedFontColor")))
				|| ((_template != null) && (_visitedFontColor != _template.getVisitedFontColor())))
			pw.print(" visitedFontColor='" + LyString.getXmlStringStrict(_visitedFontColor) + "'");
		if (((_template == null) && (_highlightColor != getStringValue("HREF.highlightColor", "$ALL.highlightColor")))
				|| ((_template != null) && (_highlightColor != _template.getHighlightColor())))
			pw.print(" highlightColor='" + LyString.getXmlStringStrict(_highlightColor) + "'");
		if (((_template == null) && (_nCols != getIntValue("HREF.nCols", -1)))
				|| ((_template != null) && (_nCols != _template.getNCols())))
			pw.print(" nCols='" + _nCols + "'");*/
		pw.println("/>");

	}
	
	public void writeJson(PrintWriter pw, String sessionId)
	{
		boolean isFirstElement = true;
		init();
		pw.println("{\"HREF\": [");
			
		if (((_template == null) && (_label != null))
				|| ((_template != null) && (_label != _template.getLabel())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"label\": \"" + LyString.getJsonString(_label) + "\"}");
		}

		if (((_template == null) && (_font != null))
				|| ((_template != null) && (_font != _template.getFont())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"font\": \"" + LyString.getJsonString(_font) + "\"}");
		}
		
		if (((_template == null) && (_color != null))
				|| ((_template != null) && (_color != _template.getColor())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"color\": \"" + getColorValue(_color) + "\"}");
		}
		
		if (((_template == null) && (_fontColor != null))
				|| ((_template != null) && (_fontColor != _template.getFontColor())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"fontColor\": \"" + getColorValue(_fontColor) + "\"}");
		}
			

		pw.println("]}");
	}

	
	public void init()
	{
		_id = _href.getId();
		_template = _href.getTemplate();
		if(_href.getLabel() != null && !_href.getLabel().equals(""))
		{
			_label = getString(_href.getLabel());
		}
		else
		{
			_label = null;
		}
		_image = _href.getImage();
		_visited = _href.isVisited();
		_sensitive = _href.isSensitive();
		_bean = _href.getBean();
		_nCols = _href.getNCols();
	}

	
	public void setLabel(String label)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void setImage(String image)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void setVisited(boolean visited)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void setSensitive(boolean sensitive)
	{
		// TODO Auto-generated method stub
		
	}

}
