package leon.view.mobile;

import java.io.*;
import java.util.*;

import leon.view.*;
import leon.view.graphic.*;

public class LyMobileHRefs extends LyMobileObject
implements LyGraphicalHRefs
{
	/** The hrefs generic component. */
	protected LyHRefs			_hrefs;

	protected String			_id;

	protected LyHRefs			_template;

	protected ArrayList<LyHRef>		_hRefs;

	public LyMobileHRefs(LyHRefs hrefs)
	{
		super(hrefs);

		_hrefs = hrefs;
		_hRefs = new ArrayList<LyHRef>();
	}


	public void writeXml(PrintWriter pw)
	{
		init();
		pw.print("<HREFS");

		if ((_hrefs.getChildCount() == 0) && (_hrefs.getDatas() == null))
		{
			pw.println("/>");
			return;
		}
		else
			pw.println(">");

		// Write sub-components
		LyComponent	hRefs;
		int			i, n;

		n = (_hRefs == null ? 0 : _hRefs.size());
		for (i = 0; i < n; i++)
		{
			hRefs = _hRefs.get(i);
			((LyMobileHRef)hRefs.getInternalView()).writeXml(pw);
		}


		pw.println("</HREFS>");
	}

	public void writeJson(PrintWriter pw, String sessionId)
	{
		boolean isFirstElement = true;
		init();
		pw.println("{\"HREFS\": [");

		if ((_hrefs.getChildCount() == 0) && (_hrefs.getDatas() == null))
		{
			pw.println("]}");
			return;
		}


		// Write sub-components
		LyComponent	hRefs;
		int			i, n;

		n = (_hRefs == null ? 0 : _hRefs.size());
		for (i = 0; i < n; i++)
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			hRefs = _hRefs.get(i);
			((LyMobileHRef)hRefs.getInternalView()).writeJson(pw, sessionId);
		}

		pw.println("]}");
	}


	public void init()
	{
		_id = _hrefs.getId();
		_template = _hrefs.getTemplate();

		_hRefs.clear();
		for(int i = 0; i < _hrefs.getHRefCount(); i++)
		{
			_hRefs.add(_hrefs.getHRef(i));
		}

	}


	public void addHRef(LyHRef hRefs, int pos)
	{
		// TODO Auto-generated method stub

	}


	public void removeHRef(LyHRef hRefs)
	{
		// TODO Auto-generated method stub

	}
}
