package leon.view.mobile;

import java.io.*;

import leon.misc.*;
import leon.view.*;
import leon.view.LyHeader.*;
import leon.view.graphic.*;

public class LyMobileHeader extends LyMobileTableObject
	implements LyGraphicalHeader
{
	/** The header generic component. */
    protected LyHeader          _header;
    
	protected String			_id;

	protected LyHeader			_template;

	protected String			_label;

	protected String			_image;

	protected int				_sort;

	protected boolean			_increasing;

	protected boolean			_sortable;

	protected boolean			_resizable;

	protected boolean			_fixed;

	protected boolean			_wrap;

	protected Align				_align;

	protected String			_tooltip;

	protected String			_overview;

	protected double			_columnWidth;

	protected int				_borderWidth;

	protected String			_borderColor;
    
    public LyMobileHeader(LyHeader header)
	{
		super(header);
		
		_header = header;

	}
    
	
	public void writeXml(PrintWriter pw)
	{
		// Write tag with its attributes
		init();
		
		pw.print("<HEADER");
		if (_id != null)
			pw.print(" id='" + LyString.getXmlStringStrict(_id) + "'");
		/*if (_template != null)
			pw.print(" template='" + _template.getId() + "'");*/
		if (((_template == null) && (_label != null))
				|| ((_template != null) && (_label != _template.getLabel())))
			pw.print(" label='" + LyString.getXmlStringStrict(_label) + "'");
		/*if (((_template == null) && (_image != getStringValue("HEADER.image", "$ALL.image")))
				|| ((_template != null) && (_image != _template.getImage())))
			pw.print(" image='" + LyString.getXmlStringStrict(_image) + "'");*/
		if (((_template == null) && (_sort != getIntValue("HEADER.sort", -1)))
				|| ((_template != null) && (_sort != _template.getSort())))
			pw.print(" sort='" + _sort + "'");
		if (((_template == null) && _increasing)
				|| ((_template != null) && (_increasing != _template.isIncreasing())))
			pw.print(" increasing='" + _increasing + "'");
		if (((_template == null) && !_sortable)
				|| ((_template != null) && (_sortable != _template.isSortable())))
			pw.print(" sortable='" + _sortable + "'");
		/*if (((_template == null) && !_resizable)
				|| ((_template != null) && (_resizable != _template.isResizable())))
			pw.print(" resizable='" + _resizable + "'");*/
		/*if (((_template == null) && _fixed)
				|| ((_template != null) && (_fixed != _template.isFixed())))
			pw.print(" fixed='" + _fixed + "'");*/
		/*if (((_template == null) && _wrap)
				|| ((_template != null) && (_wrap != _template.isWrap())))
			pw.print(" wrap='" + _wrap + "'");*/
		/*if ((_template == null)
			|| (_align != _template.getAlign()))
		{
			if ((_align == Align.LEFT) && (_template != null))
				pw.print(" align='LEFT'");
			else if (_align == Align.RIGHT)
				pw.print(" align='RIGHT'");
			else if (_align == Align.CENTER)
				pw.print(" align='CENTER'");
		}*/
		if (((_template == null) && (_tooltip != null))
				|| ((_template != null) && (_tooltip != _template.getTooltip())))
			pw.print(" tooltip='" + LyString.getXmlStringStrict(_tooltip) + "'");
		/*if (((_template == null) && (_overview != null))
				|| ((_template != null) && (_overview != _template.getOverview())))
			pw.print(" overview='" + LyString.getXmlStringStrict(_overview) + "'");*/
		/*if (((_template == null) && (_columnWidth != getDoubleValue("HEADER.columnWidth", 0F)))
				|| ((_template != null) && (_columnWidth != _template.getColumnWidth())))
			pw.print(" columnWidth='" + _columnWidth + "'");*/
		/*if (((_template == null) && (_borderWidth != getIntValue("HEADER.borderWidth", -1)))
				|| ((_template != null) && (_borderWidth != _template.getBorderWidth())))
			pw.print(" borderWidth='" + _borderWidth + "'");*/
		/*if (((_template == null) && (_borderColor != getStringValue("HEADER.borderColor", "$ALL.borderColor")))
				|| ((_template != null) && (_borderColor != _template.getBorderColor())))
			pw.print(" borderColor='" + LyString.getXmlStringStrict(_borderColor) + "'");*/
		pw.println("/>");

	}
	
	public void writeJson(PrintWriter pw, String sessionId)
	{
		boolean isFirstElement = true;
		init();
		pw.println("{\"HEADER\": [");
		
		if (_id != null)
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"id\": \"" + LyString.getJsonString(_id) + "\"}");
		}
			
		if (((_template == null) && (_label != null))
				|| ((_template != null) && (_label != _template.getLabel())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"label\": \"" + LyString.getJsonString(_label) + "\"}");
		}

		if (((_template == null) && (_sort != getIntValue("HEADER.sort", -1)))
				|| ((_template != null) && (_sort != _template.getSort())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"sort\": \"" + _sort + "\"}");
		}
		
		if (((_template == null) && _increasing)
				|| ((_template != null) && (_increasing != _template.isIncreasing())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"increasing\": \"" + _increasing + "\"}");
		}
		
		if (((_template == null) && !_sortable)
				|| ((_template != null) && (_sortable != _template.isSortable())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"sortable\": \"" + _sortable + "\"}");
		}
		
		if (((_template == null) && (_tooltip != null))
				|| ((_template != null) && (_tooltip != _template.getTooltip())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"tooltip\": \"" + LyString.getJsonString(_tooltip) + "\"}");
		}		

		pw.println("]}");
	}

	
	public void init()
	{
		
		_id = _header.getId();
		_template = _header.getTemplate();
		if(!_header.getLabel().equals(""))
		{
			_label =  getString(_header.getLabel());
		}
		_image = _header.getImage();
		_sort = _header.getSort();
		_increasing = _header.isIncreasing();
		_sortable = _header.isSortable();
		_resizable = _header.isResizable();
		_fixed = _header.isFixed();
		_wrap = _header.isWrap();
		_align = _header.getAlign();
		_tooltip = _header.getTooltip();
		_overview = _header.getOverview();
		_columnWidth = _header.getColumnWidth();
		_borderWidth = _header.getBorderWidth();
		_borderColor = _header.getBorderColor();
		
	}

	
	public void setSort(int sort)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void setIncreasing(boolean increasing)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void setFixed(boolean fixed)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void setBorderWidth(int borderWidth)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void setBorderColor(String borderColor)
	{
		// TODO Auto-generated method stub
		
	}

	
	public int writeXml(PrintWriter pw, int nb)
	{
		init();
		
		pw.print("<HEADER");
		if (_id != null)
			pw.print(" id='" + LyString.getXmlStringStrict(_id) + "'");
		if (((_template == null) && (_label != null))
				|| ((_template != null) && (_label != _template.getLabel())))
			pw.print(" label='" + LyString.getXmlStringStrict(_label) + "'");

		if (((_template == null) && (_sort != getIntValue("HEADER.sort", -1)))
				|| ((_template != null) && (_sort != _template.getSort())))
			pw.print(" sort='" + _sort + "'");
		if (((_template == null) && _increasing)
				|| ((_template != null) && (_increasing != _template.isIncreasing())))
			pw.print(" increasing='" + _increasing + "'");
		if (((_template == null) && !_sortable)
				|| ((_template != null) && (_sortable != _template.isSortable())))
			pw.print(" sortable='" + _sortable + "'");
		if (((_template == null) && (_tooltip != null))
				|| ((_template != null) && (_tooltip != _template.getTooltip())))
			pw.print(" tooltip='" + LyString.getXmlStringStrict(_tooltip) + "'");
		pw.println("/>");
		
		return nb-1;
	}

	/**
	 * Sets attribute columnWidth to the given value.
	 * @param columnWidth New value of columnWidth.
	 */
	public void setColumnWidth(double columnWidth)
	{
	}
}
