package leon.view.mobile;

import java.io.*;

import leon.misc.*;
import leon.view.*;
import leon.view.graphic.*;

public class LyMobileLink extends LyMobileObject
implements LyGraphicalLink
{
	/** The link generic component. */
	protected LyLink 	_link;

	protected LyLink 	_template;

	protected String 	_id;

	protected boolean 	_selected;

	protected String 	_label;

	public LyMobileLink(LyLink 	link)
	{
		super(link);

		_link = link;

	}


	public void writeXml(PrintWriter pw)
	{
		// Write tag with its attributes
		init();
		pw.print("<LINK");
		pw.print(" id='" + LyString.getXmlStringStrict(_id) + "'");
		pw.print(" label='" + LyString.getXmlStringStrict(_label) + "'");
		if (((_template == null) && _selected)
				|| ((_template != null) && (_selected != _template.isSelected())))
			pw.print(" selected='" + _selected + "'");
		pw.println("/>");

	}

	public void writeJson(PrintWriter pw, String sessionId)
	{
		boolean isFirstElement = true;
		init();
		pw.println("{\"LINK\": [");

		isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
		pw.print("{\"id\": \"" + LyString.getJsonString(_id) + "\"}");

		isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
		pw.print("{\"label\": \"" + LyString.getJsonString(_label) + "\"}");

		if (((_template == null) && _selected)
				|| ((_template != null) && (_selected != _template.isSelected())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"selected\": \"" + _selected + "\"}");
		}
		pw.println("]}");
	}


	public void init()
	{
		_template = _link.getTemplate();
		_id = _link.getId();
		_selected = _link.isSelected();
		if(_link.getLabel() != null && !_link.getLabel().equals(""))
		{
			_label = getString(_link.getLabel());
		}
		else
		{
			_label = null;
		}

	}


	public void setSelected(boolean selected)
	{
		// TODO Auto-generated method stub

	}

}
