package leon.view.mobile;

import java.io.*;
import java.util.*;

import leon.view.*;
import leon.view.LyList.SelectionMode;
import leon.view.graphic.*;

public class LyMobileList extends LyMobileObject
	implements LyGraphicalList
{
	/** The list generic component. */
    protected LyList						_list;
    
    protected String						_id;

	protected LyList						_template;

	protected SelectionMode					_selectionMode;

	protected int							_nCols;

	protected int							_nRows;

	protected String						_bean;

	protected String						_font;

	protected String						_color;

	protected String						_fontColor;

	protected String						_tipFont;

	protected String						_tipColor;

	protected String						_tipFontColor;

	protected String						_selectedColor;

	protected String						_inactiveSelectColor;
	
	protected String						_selectedFontColor;

	protected String						_inactiveSelectFontColor;

	protected ArrayList<LyListOption>		_listOptions;
	
	protected Hashtable<String, String> 	_datas;

	public LyMobileList(LyList list)
	{
		super(list);
		
		_list = list;
		
		_listOptions = new ArrayList<LyListOption>();

	}

	
	public void writeXml(PrintWriter pw)
	{
		// Write tag with its attributes
		init();
		/*pw.print("<LIST");
		if (_id != null)
			pw.print(" id='" + LyString.getXmlStringStrict(_id) + "'");
		if (_template != null)
			pw.print(" template='" + _template.getId() + "'");
		if ((_template == null)
			|| (_selectionMode != _template.getSelectionMode()))
		{
			if ((_selectionMode == SelectionMode.SINGLE) && (_template != null))
				pw.print(" selectionMode='SINGLE'");
			else if (_selectionMode == SelectionMode.MULTIPLE)
				pw.print(" selectionMode='MULTIPLE'");
		}
		if (((_template == null) && (_nCols != getIntValue("LIST.nCols", -1)))
				|| ((_template != null) && (_nCols != _template.getNCols())))
			pw.print(" nCols='" + _nCols + "'");
		if (((_template == null) && (_nRows != getIntValue("LIST.nRows", -1)))
				|| ((_template != null) && (_nRows != _template.getNRows())))
			pw.print(" nRows='" + _nRows + "'");
		if (((_template == null) && (_bean != null))
				|| ((_template != null) && (_bean != _template.getBean())))
			pw.print(" bean='" + LyString.getXmlStringStrict(_bean) + "'");
		if (((_template == null) && (_font != getStringValue("LIST.font", "$ALL.font")))
				|| ((_template != null) && (_font != _template.getFont())))
			pw.print(" font='" + LyString.getXmlStringStrict(_font) + "'");
		if (((_template == null) && (_color != getStringValue("LIST.color", "$ALL.color")))
				|| ((_template != null) && (_color != _template.getColor())))
			pw.print(" color='" + LyString.getXmlStringStrict(_color) + "'");
		if (((_template == null) && (_fontColor != getStringValue("LIST.fontColor", "$ALL.fontColor")))
				|| ((_template != null) && (_fontColor != _template.getFontColor())))
			pw.print(" fontColor='" + LyString.getXmlStringStrict(_fontColor) + "'");
		if (((_template == null) && (_tipFont != getStringValue("LIST.tipFont", "$ALL.tipFont")))
				|| ((_template != null) && (_tipFont != _template.getTipFont())))
			pw.print(" tipFont='" + LyString.getXmlStringStrict(_tipFont) + "'");
		if (((_template == null) && (_tipColor != getStringValue("LIST.tipColor", "$ALL.tipColor")))
				|| ((_template != null) && (_tipColor != _template.getTipColor())))
			pw.print(" tipColor='" + LyString.getXmlStringStrict(_tipColor) + "'");
		if (((_template == null) && (_tipFontColor != getStringValue("LIST.tipFontColor", "$ALL.tipFontColor")))
				|| ((_template != null) && (_tipFontColor != _template.getTipFontColor())))
			pw.print(" tipFontColor='" + LyString.getXmlStringStrict(_tipFontColor) + "'");
		if (((_template == null) && (_selectedColor != getStringValue("LIST.selectedColor", "$ALL.selectedColor")))
				|| ((_template != null) && (_selectedColor != _template.getSelectedColor())))
			pw.print(" selectedColor='" + LyString.getXmlStringStrict(_selectedColor) + "'");
		if (((_template == null) && (_inactiveSelectColor != getStringValue("LIST.inactiveSelectColor", "$ALL.inactiveSelectColor")))
				|| ((_template != null) && (_inactiveSelectColor != _template.getInactiveSelectColor())))
			pw.print(" inactiveSelectColor='" + LyString.getXmlStringStrict(_inactiveSelectColor) + "'");
		if (((_template == null) && (_selectedFontColor != getStringValue("LIST.selectedFontColor", "$ALL.selectedFontColor")))
				|| ((_template != null) && (_selectedFontColor != _template.getSelectedFontColor())))
			pw.print(" selectedFontColor='" + LyString.getXmlStringStrict(_selectedFontColor) + "'");
		if (((_template == null) && (_inactiveSelectFontColor != getStringValue("LIST.inactiveSelectFontColor", "$ALL.inactiveSelectFontColor")))
				|| ((_template != null) && (_inactiveSelectFontColor != _template.getInactiveSelectFontColor())))
			pw.print(" inactiveSelectFontColor='" + LyString.getXmlStringStrict(_inactiveSelectFontColor) + "'");

		if ((_list.getChildCount() == 0) && (_datas == null))
		{
			pw.println("/>");
			return;
		}
		else
			pw.println(">");*/

		// Write sub-components
		LyComponent	listOptions;
		int			i, n;

		n = (_listOptions == null ? 0 : _listOptions.size());
		for (i = 0; i < n; i++)
		{
			listOptions = _listOptions.get(i);
			((LyMobileListOption)listOptions.getInternalView()).writeXml(pw);
		}


		//pw.println("</LIST>");

	}
	
	public void writeJson(PrintWriter pw, String sessionId)
	{
		boolean isFirstElement = true;
		init();
		LyComponent	listOptions;
		int			i, n;

		n = (_listOptions == null ? 0 : _listOptions.size());
		for (i = 0; i < n; i++)
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			listOptions = _listOptions.get(i);
			((LyMobileListOption)listOptions.getInternalView()).writeJson(pw, sessionId);
		}		
	}

	
	public void init()
	{
		
		_id = _list.getId();
		_template = _list.getTemplate();
		_selectionMode = _list.getSelectionMode();
		_nCols = _list.getNCols();
		_nRows = _list.getNRows();
		_bean = _list.getBean();
		_font = _list.getFont();
		_color = _list.getColor();
		_fontColor = _list.getFontColor();
		_tipFont = _list.getTipFont();
		_tipColor = _list.getTipColor();
		_tipFontColor = _list.getTipFontColor();
		_selectedColor = _list.getSelectedColor();
		_inactiveSelectColor = _list.getInactiveSelectColor();
		_selectedFontColor = _list.getSelectedFontColor();
		_inactiveSelectFontColor = _list.getInactiveSelectFontColor();
		_datas = _list.getDatas();
		
		_listOptions.clear();
		
		for(int i = 0; i < _list.getListOptionCount(); i++)
		{
			_listOptions.add(_list.getListOption(i));
		}
		
	}

	
	public void addListOption(LyListOption listOptions, int pos)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void removeListOption(LyListOption listOptions)
	{
		// TODO Auto-generated method stub
		
	}

}
