package leon.view.mobile;

import java.io.*;
import java.util.*;

import leon.view.*;
import leon.view.graphic.*;

public class LyMobileRows extends LyMobileTableObject
	implements LyGraphicalRows
{
    /** The rows generic component. */
    protected LyRows                _rows;
    
	protected ArrayList<LyRow>		_row;
    
	public LyMobileRows(LyRows rows)
	{
		super(rows);
		
		_rows = rows;
		
		_row = new ArrayList<LyRow>();

	}

	@Override
	public void writeXml(PrintWriter pw)
	{
		// Write tag
		init();
		//pw.println("<ROWS>");

		// Write sub-components
		LyComponent	rows;
		int			i, n;

		n = (_row == null ? 0 : _row.size());
		for (i = 0; i < n; i++)
		{
			rows = _row.get(i);
			((LyMobileRow)rows.getInternalView()).writeXml(pw);
		}


		//pw.println("</ROWS>");
	}
	
	public void writeJson(PrintWriter pw, String sessionId, boolean printSeparator)
	{
		boolean isFirstElement = !printSeparator;
		init();
		
		LyComponent	rows;
		int			i, n;

		n = (_row == null ? 0 : _row.size());
		for (i = 0; i < n; i++)
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			rows = _row.get(i);
			((LyMobileRow)rows.getInternalView()).writeJson(pw, sessionId);
		}
		
	}
	
	public void writeJson(PrintWriter pw, String sessionId)
	{
		writeJson(pw, sessionId, false);
	}

	@Override
	public void init()
	{
		_row.clear();
		
		for(int i = 0; i < _rows.getRowCount(); i++)
		{
			_row.add(_rows.getRow(i));
		}
		
	}

	@Override
	public int writeXml(PrintWriter pw, int nb)
	{
		init();

		LyComponent	rows;
		int			i, n;

		n = (_row == null ? 0 : _row.size());
		for (i = 0; i < n; i++)
		{
			rows = _row.get(i);
			((LyMobileRow)rows.getInternalView()).writeXml(pw, nb);
		}
		return nb;
		
	}

}
