package leon.view.mobile;

import java.io.*;
import java.util.*;

import leon.misc.*;
import leon.view.*;
import leon.view.graphic.*;

public class LyMobileTitleBar extends LyMobileObject
	implements LyGraphicalTitleBar
{
	/** The titleBar generic component. */
    protected LyTitleBar					_titleBar;
    
    protected String 						_id;
    
    protected LyTitleBar 					_template;
    
    protected String 						_font;
    
    protected String 						_color;
    
    protected String 						_fontColor;
    
    protected Hashtable<String, String> 	_datas;
    
	//protected LyConstraint 				_constraint;
    
    protected String 						_image;
    
    protected String 						_imageToolTip;
    
    protected boolean 						_imageSensitive;
    
    protected String 						_rightImage;
    
    protected String 						_rightImageToolTip;
    
    protected String 						_leftLabel;
    
    protected String 						_centerLabel;
    
    protected String 						_rightLabel;
    
    protected boolean 						_rightLabelSensitive;
    
    protected LyToolBar 					_toolBar;
    
	public LyMobileTitleBar(LyTitleBar titleBar)
	{
		super(titleBar);
        
        _titleBar = titleBar; 
		
		_font = getFontValue(getStringValue("MOBILE_TITLEBAR.font"));

		_color = getStringValue("MOBILE_TITLEBAR.color");

		_fontColor = getStringValue("MOBILE_TITLEBAR.fontColor");

	}

	
	public void writeXml(PrintWriter pw)
	{
		// Write tag with its attributes
		init();
		pw.print("<TITLEBAR");
		/*if (_id != null)
			pw.print(" id='" + LyString.getXmlStringStrict(_id) + "'");
		if (_template != null)
			pw.print(" template='" + _template.getId() + "'");
		if (((_template == null) && (_image != getStringValue("TITLEBAR.image", "$ALL.image")))
				|| ((_template != null) && (_image != _template.getImage())))
			pw.print(" image='" + LyString.getXmlStringStrict(_image) + "'");
		if (((_template == null) && (_imageToolTip != null))
				|| ((_template != null) && (_imageToolTip != _template.getImageToolTip())))
			pw.print(" imageToolTip='" + LyString.getXmlStringStrict(_imageToolTip) + "'");
		if (((_template == null) && _imageSensitive)
				|| ((_template != null) && (_imageSensitive != _template.isImageSensitive())))
			pw.print(" imageSensitive='" + _imageSensitive + "'");
		if (((_template == null) && (_rightImage != getStringValue("TITLEBAR.rightImage", "$ALL.rightImage")))
				|| ((_template != null) && (_rightImage != _template.getRightImage())))
			pw.print(" rightImage='" + LyString.getXmlStringStrict(_rightImage) + "'");
		if (((_template == null) && (_rightImageToolTip != null))
				|| ((_template != null) && (_rightImageToolTip != _template.getRightImageToolTip())))
			pw.print(" rightImageToolTip='" + LyString.getXmlStringStrict(_rightImageToolTip) + "'");*/
		if (((_template == null) && (_leftLabel != null))
				|| ((_template != null) && (_leftLabel != _template.getLeftLabel())))
			pw.print(" leftLabel='" + LyString.getXmlStringStrict(_leftLabel) + "'");
		if (((_template == null) && (_centerLabel != null))
				|| ((_template != null) && (_centerLabel != _template.getCenterLabel())))
			pw.print(" centerLabel='" + LyString.getXmlStringStrict(_centerLabel) + "'");
		/*if (((_template == null) && (_rightLabel != null))
				|| ((_template != null) && (_rightLabel != _template.getRightLabel())))
			pw.print(" rightLabel='" + LyString.getXmlStringStrict(_rightLabel) + "'");
		if (((_template == null) && _rightLabelSensitive)
				|| ((_template != null) && (_rightLabelSensitive != _template.isRightLabelSensitive())))
			pw.print(" rightLabelSensitive='" + _rightLabelSensitive + "'");
		if (((_template == null) && (_font != getStringValue("TITLEBAR.font", "$ALL.font")))
				|| ((_template != null) && (_font != _template.getFont())))
			pw.print(" font='" + LyString.getXmlStringStrict(_font) + "'");
		if (((_template == null) && (_color != getStringValue("TITLEBAR.color", "$ALL.color")))
				|| ((_template != null) && (_color != _template.getColor())))
			pw.print(" color='" + LyString.getXmlStringStrict(_color) + "'");
		if (((_template == null) && (_fontColor != getStringValue("TITLEBAR.fontColor", "$ALL.fontColor")))
				|| ((_template != null) && (_fontColor != _template.getFontColor())))
			pw.print(" fontColor='" + LyString.getXmlStringStrict(_fontColor) + "'");*/

		if ((_titleBar.getChildCount() == 0) && (_datas == null))
		{
			pw.println("/>");
			return;
		}
		else
			pw.println(">");

		// Write sub-components
		if (_toolBar != null)
			((LyMobileToolBar)_toolBar.getInternalView()).writeXml(pw);
		//TODO : STAGE : Interet constraint ?
		/*if (_constraint != null)
			_constraint.writeXml(pw, debug);*/

		pw.println("</TITLEBAR>");

	}
	
	public void writeJson(PrintWriter pw, String sessionId)
	{
		boolean isFirstElement = true;
		init();
		pw.println("{\"TITLEBAR\": [");

		if (((_template == null) && (_leftLabel != null))
				|| ((_template != null) && (_leftLabel != _template.getLeftLabel())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"leftLabel\": \"" + LyString.getJsonString(_leftLabel) + "\"}");
		}
		if (((_template == null) && (_centerLabel != null))
				|| ((_template != null) && (_centerLabel != _template.getCenterLabel())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"centerLabel\": \"" + LyString.getJsonString(_centerLabel) + "\"}");
		}


		if ((_titleBar.getChildCount() == 0) && (_datas == null))
		{
			pw.println("]}");
			return;
		}

		// Write sub-components
		if (_toolBar != null)
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			((LyMobileToolBar)_toolBar.getInternalView()).writeJson(pw, sessionId);
		}

		pw.println("]}");

	}

	
	public void init()
	{
        
		_id = _titleBar.getId();
		_template = _titleBar.getTemplate();
		_datas = _titleBar.getDatas();
		//_constraint = _titleBar.getConstraint();
		_image = _titleBar.getImage();
		_imageToolTip = _titleBar.getImageToolTip();
		_imageSensitive = _titleBar.isImageSensitive();
		_rightImage = _titleBar.getRightImage();
		_rightImageToolTip = _titleBar.getRightImageToolTip();
		if(_titleBar.getLeftLabel() != null && ! _titleBar.getLeftLabel().equals(""))
		{
			String tmp = getEnvironment().translate(_titleBar.getLeftLabel());
			StringBuffer res = new StringBuffer();
			if(tmp.indexOf(":") != -1)
			{
				res.append(getString(tmp.substring(0, tmp.indexOf(":")).trim()));
				res.append(" : ");
				if(tmp.indexOf(":") != tmp.lastIndexOf(":"))
				{
					res.append(getString(tmp.substring(tmp.indexOf(":")+1,tmp.lastIndexOf(":")).trim()));
					res.append(" : ");
					res.append(getString(tmp.substring(tmp.lastIndexOf(":")+1).trim()));
				}
				else
				{
					res.append(getString(tmp.substring(tmp.indexOf(":")+1).trim()));
				}
				_leftLabel = res.toString();
			}
			else
			{
				_leftLabel = getString(tmp);
			}
			
		}
		else
		{
			_leftLabel = null;
		}
		_centerLabel = _titleBar.getCenterLabel();
		_rightLabel = _titleBar.getRightLabel();
		_rightLabelSensitive = _titleBar.isRightLabelSensitive();
		_toolBar = _titleBar.getToolBar();
		
	}

	
	public void setImage(String image)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void setImageToolTip(String imageToolTip)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void setRightImage(String rightImage)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void setRightImageToolTip(String rightImageToolTip)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void setLeftLabel(String leftLabel)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void setCenterLabel(String centerLabel)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void setRightLabel(String rightLabel)
	{
		// TODO Auto-generated method stub
		
	}

}
