package leon.view.mobile;

import java.io.*;
import java.util.*;

import leon.misc.*;
import leon.view.*;
import leon.view.LyToolBarBase.Fill;
import leon.view.LyToolBarBase.HAlign;
import leon.view.LyToolBarBase.Style;
import leon.view.LyToolBarBase.VAlign;
import leon.view.graphic.*;

public class LyMobileToolBar extends LyMobileTableObject
	implements LyGraphicalToolBar
{
	/** The toolBar generic component. */
    protected LyToolBar                    		_toolBar;
    
    protected String 							_id;
    protected LyToolBar 						_template;
    protected String 							_label;
    protected String 							_controller;
    protected String 							_font;
    protected String 							_color;
    protected String 							_fontColor;
    protected boolean 							_open;
    protected Hashtable<String, String> 		_datas;
	//protected LyConstraint 					_constraint;
    protected String 							_image;
    protected Fill 								_fill;
    protected Style 							_style;
    protected HAlign 							_hAlign;
    protected VAlign 							_vAlign;
    protected ArrayList<LyComponent> 			_components;

	public LyMobileToolBar(LyToolBar toolBar)
	{
		super(toolBar);
        
        _toolBar = toolBar;
        
		_components = new ArrayList<LyComponent>();
		
		_font = getFontValue(getStringValue("MOBILE_TOOLBAR.font"));

		_color = getStringValue("MOBILE_TOOLBAR.color");

		_fontColor = getStringValue("MOBILE_TOOLBAR.fontColor");	
        
	}

	
	public void writeXml(PrintWriter pw)
	{		
		// Write tag with its attributes
		init();
		pw.print("<TOOLBAR");
		if (_id != null)
			pw.print(" id='" + LyString.getXmlStringStrict(_id) + "'");
		/*if (_template != null)
			pw.print(" template='" + _template.getId() + "'");*/
		if (((_template == null) && (_label != null))
				|| ((_template != null) && (_label != _template.getLabel())))
			pw.print(" label='" + _label + "'");
		if (_controller != null)
			pw.print(" controller='" + LyString.getXmlStringStrict(_controller) + "'");
		/*if (((_template == null) && (_image != getStringValue("TOOLBAR.image", "$ALL.image")))
				|| ((_template != null) && (_image != _template.getImage())))
			pw.print(" image='" + LyString.getXmlStringStrict(_image) + "'");
		if ((_template == null)
			|| (_fill != _template.getFill()))
		{
			if ((_fill == Fill.DEFAULT) && (_template != null))
				pw.print(" fill='DEFAULT'");
			else if (_fill == Fill.HORIZONTAL)
				pw.print(" fill='HORIZONTAL'");
			else if (_fill == Fill.VERTICAL)
				pw.print(" fill='VERTICAL'");
		}
	
		if ((_template == null)
			|| (_style != _template.getStyle()))
		{
			if ((_style == Style.DEFAULT) && (_template != null))
				pw.print(" style='DEFAULT'");
			else if (_style == Style.BORDER)
				pw.print(" style='BORDER'");
			else if (_style == Style.MENU)
				pw.print(" style='MENU'");
			else if (_style == Style.SEPARATOR)
				pw.print(" style='SEPARATOR'");
			else if (_style == Style.EXPAND)
				pw.print(" style='EXPAND'");
		}
		if ((_template == null)
			|| (_hAlign != _template.getHAlign()))
		{
			if ((_hAlign == HAlign.LEFT) && (_template != null))
				pw.print(" hAlign='LEFT'");
			else if (_hAlign == HAlign.RIGHT)
				pw.print(" hAlign='RIGHT'");
		}
		if ((_template == null)
			|| (_vAlign != _template.getVAlign()))
		{
			if ((_vAlign == VAlign.TOP) && (_template != null))
				pw.print(" vAlign='TOP'");
			else if (_vAlign == VAlign.BOTTOM)
				pw.print(" vAlign='BOTTOM'");
			else if (_vAlign == VAlign.MIDDLE)
				pw.print(" vAlign='MIDDLE'");
		}
		if (((_template == null) && !_open)
				|| ((_template != null) && (_open != _template.isOpen())))
			pw.print(" open='" + _open + "'");*/
		if (((_template == null) && (_font != null))
				|| ((_template != null) && (_font != _template.getFont())))
			pw.print(" font='" + LyString.getXmlStringStrict(_font) + "'");
		if (((_template == null) && (_color != null))
				|| ((_template != null) && (_color != _template.getColor())))
			pw.print(" color='" + getColorValue(_color) + "'");
		if (((_template == null) && (_fontColor != null))
				|| ((_template != null) && (_fontColor != _template.getFontColor())))
			pw.print(" fontColor='" + getColorValue(_fontColor) + "'");

		if ((_toolBar.getChildCount() == 0) && (_datas == null))
		{
			pw.println("/>");
			return;
		}
		else
			pw.println(">");

		// Write sub-components
		LyComponent	components;
		int			i, n;
		
		n = (_components == null ? 0 : _components.size());
		for (i = 0; i < n; i++)
		{
			//TODO : Stage : Attention SEP non implémenté
			components = _components.get(i);
			if ((components != null)
					&& (components.getId() != SEP_ID))
				((LyMobileObject)components.getInternalView()).writeXml(pw);
		}
		//TODO : Stage : constraint
		/*if (_constraint != null)
			_constraint.writeXml(pw, debug);*/
		
		//TODO : STAGE : writeDatas
		//writeDatas(pw);

		pw.println("</TOOLBAR>");

	}
	
	public void writeJson(PrintWriter pw, String sessionId)
	{		
		boolean isFirstElement = true;
		init();
		pw.println("{\"TOOLBAR\": [");
		
		if (_id != null)
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"id\": \"" + LyString.getJsonString(_id) + "\"}");
		}
		
		if (((_template == null) && (_label != null))
				|| ((_template != null) && (_label != _template.getLabel())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"label\": \"" + LyString.getJsonString(_label) + "\"}");
		}
		if (_controller != null)
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"controller\": \"" + LyString.getJsonString(_controller) + "\"}");
		}
		if (((_template == null) && (_font != null))
				|| ((_template != null) && (_font != _template.getFont())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"font\": \"" + LyString.getJsonString(_font) + "\"}");
		}
		if (((_template == null) && (_color != null))
				|| ((_template != null) && (_color != _template.getColor())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"color\": \"" + getColorValue(_color) + "\"}");
		}
		if (((_template == null) && (_fontColor != null))
				|| ((_template != null) && (_fontColor != _template.getFontColor())))
		{
			isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
			pw.print("{\"fontColor\": \"" + getColorValue(_fontColor) + "\"}");
		}

		if ((_toolBar.getChildCount() == 0) && (_datas == null))
		{
			pw.println("]}");
			return;
		}

		// Write sub-components
		LyComponent	components;
		int			i, n;
		
		n = (_components == null ? 0 : _components.size());
		for (i = 0; i < n; i++)
		{
			//TODO : Stage : Attention SEP non implémenté
			components = _components.get(i);
			if ((components != null)
					&& (components.getId() != SEP_ID))
			{
				LyMobileObject object = ((LyMobileObject)components.getInternalView());
				if(object instanceof LyMobileTool)
				{
					if(isFirstElement)
					{
						((LyMobileTool)components.getInternalView()).writeJson(pw, sessionId);
						isFirstElement = false;
					}
					else
					{
						((LyMobileTool)components.getInternalView()).writeJson(pw, true, sessionId);
					}
				}
				else
				{
					isFirstElement = printJsonAttributeSeparator(isFirstElement, pw);
					object.writeJson(pw, sessionId);
				}
				
			}
				
		}

		pw.println("]}");

	}

	
	public void init()
	{
        _id = _toolBar.getId();
		_template = _toolBar.getTemplate();
		if(_toolBar.getLabel() != null && !_toolBar.getLabel().equals(""))
		{
			_label = getString(_toolBar.getLabel());
		}
		else
		{
			_label = null;
		}
		_controller = _toolBar.getController();
		_open = _toolBar.isOpen();
		_datas = _toolBar.getDatas();
		//_constraint = _toolBar.getConstraint();
		_image = _toolBar.getImage();
		_fill = _toolBar.getFill();
		_style = _toolBar.getStyle();
		_hAlign = _toolBar.getHAlign();
		_vAlign = _toolBar.getVAlign();

		_components.clear();
		for(int j = 0; j < _toolBar.getComponentCount(); j++)
		{
			_components.add(_toolBar.getComponent(j));
		}
		
	}

	
	public void setImage(String image)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void setOpen(boolean open)
	{
		// TODO Auto-generated method stub
		
	}

	public void setColor(String color)
	{
		// TODO Auto-generated method stub
		
	}

	public void addComponent(LyComponent components, int pos)
	{
		// TODO Auto-generated method stub
		
	}

	
	public void removeComponent(LyComponent components)
	{
		// TODO Auto-generated method stub
		
	}

	
	public int writeXml(PrintWriter pw, int nb)
	{
		writeXml(pw);
		return nb;
	}

}
