/*
 * LyPrintRelationDesc.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 * Current version: $Id: LyPrintRelationDesc.java 28422 2010-11-03 12:03:38Z ehelmste $
 */
package leon.view.print;

/**
 * Represents the print description of a composition or facet relation.
 *
 * @author nla
 */
public class LyPrintRelationDesc
{
	public static final String __VERSION =
		"$Id: LyPrintRelationDesc.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/** The concerned relation. */
	protected Object		   _relation;

	/** A field which compose the relation or a print description. */
	protected Object		   _field;

	/**
	 * Constructor.
	 */
	public LyPrintRelationDesc(Object relation, Object field)
	{
		_relation = relation;
		_field = field;
	}

	/**
	 * Get the relation.
	 *
	 * @return The relation.
	 */
	public Object getRelation()
	{
		return _relation;
	}

	/**
	 * Get the field or print relation description.
	 *
	 * @return The field or print relation description.
	 */
	public Object getField()
	{
		return _field;
	}
} // end class LyPrintRelationDesc
