/*
 * LyResetContentInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.setinterface;

/**
 * Some components may dynamically update the content when the XML structure is deeply modified.
 *
 * @version $Id: LyResetContentInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LyResetContentInterface
{
	String __VERSION = "$Id: LyResetContentInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Reset the view for a new XML Structure. Reinitialization.
	 */
	void resetContent();

	/**
	 * Reset the view for a new XML Structure. Reinitialization.
	 * 
	 * @param full indicates whether old components must be removed from graphical view.
	 */
	void resetContent(boolean full);
}