/*
 * LySetLinksInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.setinterface;

import leon.view.*;


/**
 * Abstract access to a method. Hides the specific implementation of the view (win, swing, html...)
 *
 * @version $Id: LySetLinksInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LySetLinksInterface
{
	String __VERSION = "$Id: LySetLinksInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Adds the given link at the given position.
	 *
	 * @param link the link to add
	 * @param pos  the posiition where the link has to be added
	 */
	void addLink(LyLink link, int pos);

	/**
	 * Removes the given link.
	 *
	 * @param link the link to remove
	 */
	void removeLink(LyLink link);
}