/*
 * LySetListOptionsInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */
package leon.view.setinterface;

import leon.view.*;


/**
 * Abstract access to a method. Hides the specific implementation of the view (win, swing, html...)
 * A value, and may have its value set.
 *
 * @version $Id: LySetListOptionsInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LySetListOptionsInterface
{
	String __VERSION = "$Id: LySetListOptionsInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Adds the given list option at the given position to the current list.
	 *
	 * @param listOption the list option to add
	 * @param position   the position where the list option has to be added
	 */
	void addListOption(LyListOption listOption, int position);

	/**
	 * Removes the given list option from the current list.
	 *
	 * @param listOption the list option to remove
	 */
	void removeListOption(LyListOption listOption);
}