/*
 * LySetNumberInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.setinterface;

/**
 * Abstract access to a method. Hides the specific implementation of the view (win, swing, html...)
 * A value, and may have its value set.
 *
 * @version $Id: LySetNumberInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LySetNumberInterface
{
	String __VERSION = "$Id: LySetNumberInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Sets the number format.
	 *
	 * @param format New value of format.
	 */
	void setFormat(String format);

	/**
	 * Sets the number minimum value.
	 *
	 * @param vMin New value of the minimum.
	 */
	void setVMin(double vMin);

	/**
	 * Sets the number maximum value.
	 *
	 * @param vMax New value of maximum.
	 */
	void setVMax(double vMax);

	/**
	 * Sets the number pitch.
	 *
	 * @param pitch New value of pitch.
	 */
	void setPitch(double pitch);

	/**
	 * Sets the number of decimals.
	 *
	 * @param decimals New value of the number of decimals.
	 */
	void setDecimals(int decimals);
}