/*
 * LySetPrintModeInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.setinterface;

/**
 * Sets the related view to switch to print mode. The view/controller may need to do some
 * modifications before printing the content.
 *
 * @version $Id: LySetPrintModeInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LySetPrintModeInterface
{
	String __VERSION = "$Id: LySetPrintModeInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * (Des)Activate the print mode. This method is invoked with true before printing thask, with
	 * false at the end. The view/controller may need to change the content at that time.
	 *
	 * @param status true if printing is active, false otherwise.
	 */
	void setPrintMode(boolean status);
}