/*
 * LySetSensitiveInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.setinterface;

/**
 * Abstract access to a method. Hides the specific implementation of the view (win, swing, html...)
 * A value, and may have its value set.
 *
 * @version $Id: LySetSensitiveInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LySetSensitiveInterface
{
	String __VERSION = "$Id: LySetSensitiveInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Sets the sensitive attribute of the component with the given value.
	 *
	 * @param sensitive true if the component must be sensitive, false otherwise
	 */
	void setSensitive(boolean sensitive);
}