/*
 * LySetTabInterface.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */
package leon.view.setinterface;

/**
 * Abstract access to a method. Hides the specific implementation of the view (win, swing, html...)
 * A value, and may have its value set.
 *
 * @version $Id: LySetTabInterface.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LySetTabInterface
{
	String __VERSION = "$Id: LySetTabInterface.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * This method allows to enable or disable a specific tab.
	 *
	 * @param tabLabel the label or identifier of the tab to enable or disable
	 * @param enabled  true if the tab is enabled, false otherwise
	 */
	void setEnabled(String tabId, boolean enabled);

	/**
	 * This method allows to change the label of a specific tab.
	 *
	 * @param tabId the label or identifier of the tab to be changed
	 * @param newLabel the new label of the tab to be changed
	 */
	void setLabel(String tabId, String newLabel);
}