/**
 * LySession.java Copyright (c) 2000-2009,
 * Lyria-W4.
 * All rights reserved.
 */

package leon.view.web;

import javax.servlet.http.*;

import leon.app.*;
import leon.view.web.struts.action.*;


/**
 * The instance of session for web viewers.
 *
 * @see     leon.app.LySession
 */
public class LyWebSession extends LySession
{
	public static final String __VERSION =
		"$Id: LyWebSession.java 31884 2011-08-03 14:19:12Z nhamon $";
    
	/**
	 * Http session associated with this web session.
	 */
	protected HttpSession			_httpSession;
	
    /**
     * Constructor of web session.
     *
     * @param application     The application owner of the session.
     * @param registerSession Indicates if the session must be registered on the application
     *                        (default is true), or if this is a temporary session which should be
     *                        ignored.
     */
    public LyWebSession(LyApplication application, boolean registerSession)
    {
        super(application, registerSession);
    }

    /**
     * Constructor of web session.
     *
     * @param application     The application owner of the session.
     * @param registerSession Indicates if the session must be registered on the application
     *                        (default is true), or if this is a temporary session which should be
     *                        ignored.
     * @param id              The identifier of the session.
     */
    public LyWebSession(LyApplication application, boolean registerSession, String sessionId)
    {
        this(application, registerSession);
        
        if ((sessionId != null) && (sessionId != LyStrutsSessionBean.DEFAULT_SESSION))
        	_id = sessionId;
    }

    /**
     * Gets the current request.
     *
     * @return the request
     */
    public HttpServletRequest getCurrentRequest()
    {
    	return null;
    }

    /**
     * Gets the current response.
     *
     * @return the response
     */
    public HttpServletResponse getCurrentResponse()
    {
    	return null;
    }
} // end class LyWebSession
