/**
 * 
 */
package leon.view.web.jquery;

import java.awt.*;

import leon.view.*;
import leon.view.common.*;

/**
 * LyJQChartConverter
 * 
 * @author sel
 * 
 */
public class LyJQChartConverter extends LyCommonFreeChartConverter
{
	/** Indicates whether a specific paints has been set. */
	private boolean		_specificPaints;
	
	/**
	 * Default constructor.
	 *
	 */
	public LyJQChartConverter()
	{
		super();
		_specificPaints = false;
	}	

	/**
	 * Affect a chart to this view.
	 *
	 * @param  chart  the chart created by LyChartController
	 */
	public LyJQChartConverter(LyChart chart)
	{
		super(chart);
		_specificPaints = false;
	}

	@Override
	public LyChart invertChart(LyChart chart)
	{
		// Overridden to set the method public : do not remove !
		return super.invertChart(chart);
	}

	@Override
	public void setPaints(Paint[] paints)
	{
		super.setPaints(paints);
		_specificPaints = true;
	}
	
	@Override
	public Paint[] getPaints()
	{
		if (!_specificPaints)
			return null;
		
		return super.getPaints();
	}
}
