/*
 * LyWeb2Container.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */
package leon.view.web.jquery;

import leon.view.LyArea;
import leon.view.LyContainer;
import leon.view.LyPanel;
import leon.view.LySplitter;
import leon.view.LyTabs;
import leon.view.graphic.LyGraphicalContainer;
import leon.view.web.jquery.component.LyJQInternalView;

/**
 * Type : leon.view.web.web2.LyWeb2Container The peer component of LyContainer for the web2 viewer.
 * @version $Revision: -1M $
 * @author ychaari last modified by bas
 */
public abstract class LyJQContainer extends LyJQInternalView implements
															LyGraphicalContainer
{

	/**
	 * Constructor
	 * @param container
	 */
	public LyJQContainer(LyContainer container)
	{
		super(container);
	}

	/**
	 * Check if the Panel is a Splitter
	 * @param panel
	 * @return
	 */
	public boolean isSplitter(LyPanel panel)
	{
		return (panel instanceof LySplitter);
	}

	/**
	 * Check if the Panel is a Area
	 * @param panel
	 * @return
	 */
	public boolean isArea(LyPanel panel)
	{
		return (panel instanceof LyArea);
	}

	/**
	 * Check if the Panel is a Tabs
	 * @param panel
	 * @return
	 */
	public boolean isTabs(LyPanel panel)
	{
		return (panel instanceof LyTabs);
	}
}