/*
 * LyStrutsPage.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.web.jquery;

import java.util.*;
import leon.view.*;
import leon.view.web.*;


/**
 * This class implements a page content (store a page or a DIV tag of a page in a buffer) for web
 * viewer.
 *
 * @version $Id: LyStrutsPage.java 16172 2009-01-06 11:04:44Z jls $
 * @author  Lyria
 */
public class LyJQPage extends LyWebPageWriter
{
	public static final String __VERSION =
		"$Id: LyStrutsPage.java 16172 2009-01-06 11:04:44Z jls $";

	/**
	 * Class constructor of a Page object for the struts target.<br>
	 * Call the super implementation and initialization is done through the {@link LyWebPage#init()}
	 * method.
	 *
	 * @param component    the component who is the content of this page
	 * @param writeDivOnly indicates that only a partial rendering of a DIV tag is used
	 */
	public LyJQPage(LyComponent component, boolean writeDivOnly)
	{
		super(component);
		
		if (!writeDivOnly)
			super.initViewComponent(component);
		init();
		_writeDivOnly = writeDivOnly;
	}

	/*
	 * (non-Javadoc)
	 * @see leon.view.graphic.LyGraphicalObject#initViewComponent(leon.view.LyComponent)
	 */
	protected void initViewComponent(LyComponent viewComponent)
	{
		_viewComponent = viewComponent;
		// avoid setting viewComponent internal view when rendering a DIV tag
		// only
	}

	/*
	 * (non-Javadoc)
	 * @see leon.view.web.LyWebPageWriter#getPageWriters()
	 */
	public Vector<LyWebPageWriter> getPageWriters()
	{
		Vector<LyWebPageWriter> v = new Vector<LyWebPageWriter>(1);

		v.addElement(this);
		return v;
	}

	/*
	 * (non-Javadoc)
	 * @see leon.view.web.LyWebPageWriter#getRedirect(java.lang.String)
	 */
	public String getRedirect(String frame)
	{
		return null;
	}

	/*
	 * (non-Javadoc)
	 * @see leon.view.web.LyWebComponent#writeHtml(leon.view.web.LyWebPageWriter)
	 */
	public void writeHtml(LyWebPageWriter pw)
	{
	}
} // end class LyStrutsPage
