/*
 * LyStrutsServlet.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */
package leon.view.web.jquery;


import java.awt.*;
import java.util.*;

import javax.servlet.*;
import javax.servlet.http.*;

import leon.misc.*;
import leon.view.web.*;
import leon.view.web.jquery.controller.*;
import leon.view.web.mobile.*;

import org.springframework.context.*;
import org.springframework.web.context.support.*;
import org.springframework.web.servlet.*;


/**
 * @version $Id: LyStrutsServlet.java 31874 2011-08-03 10:03:44Z kchenal $
 * @author  Lyria S.A.
 */
public class LyJQServlet extends DispatcherServlet
{
	/**
	 * 
	 */
	private static final long serialVersionUID = -5955068839831742253L;

	public static final String __VERSION =
		"$Id: LyStrutsServlet.java 31874 2011-08-03 10:03:44Z kchenal $";

	/** Keep the information : which request / Servlet / response are currently being processed. */
	public static HashMap<Thread, LyWebRequestInfo> _webRequestInfos =
		new HashMap<Thread, LyWebRequestInfo>();

	
	/**
	 * Constructor.
	 *
	 * @param area the area component
	 */
	public LyJQServlet()
	{
		super();
	}

	/*
	 * (non-Javadoc)
	 *
	 * @see javax.servlet.Servlet#init(javax.servlet.ServletConfig)
	 */
	public void init(ServletConfig config)
		throws ServletException
	{
		super.init(config);

		try
		{
			if (!GraphicsEnvironment.isHeadless()) 
				System.setProperty("java.awt.headless", "true");
		}
		catch (Throwable t)
		{
		}
	}
	
	@Override
	protected void doDispatch(HttpServletRequest request, HttpServletResponse response) throws Exception
	{
		HttpSession				httpSession = request.getSession();
		ServletContext			context = httpSession.getServletContext();
		ApplicationContext		appContext = WebApplicationContextUtils.getWebApplicationContext(context);
		LyTemplatesUtilsBean	veloTemplatesManager = (LyTemplatesUtilsBean)appContext.getBean("veloTemplates");
		
		if (veloTemplatesManager.isLoadingData())
		{
			String				loadingApplicationJsp = "/loadingApplication.jsp";
			RequestDispatcher	dispatcher = getServletContext().getRequestDispatcher(loadingApplicationJsp);
			
			dispatcher.forward(request,response);
			
			return;
		}

		int	requestCount = LyWebConstants.REQU_COUNT;

        request.setCharacterEncoding(LyString.DEFAULT_CHARSET);
        response.setContentType("text/html;charset=" + LyString.DEFAULT_CHARSET);

        LyWebConstants.REQU_COUNT++;

		try
		{
			if ("true".equals(request.getParameter(LyWebConstants.NEW_SESSION)))
				request.getSession().invalidate();
			
			synchronized (_webRequestInfos)
			{
				_webRequestInfos.put(Thread.currentThread(),
						new LyWebRequestInfo(requestCount, this, request, response));
			}
			
			//String userAgent = request.getHeader("user-agent");
			
			if (request.getParameter(LyWebConstants.MOBILE) != null
					|| (request.getHeader(LyWebConstants.MOBILE) != null))
			{
				if ((request.getHeader("ping") != null)
						|| (request.getParameter("ping") != null))
					return;

				LyMobileDecodeRequest.getInstance(false).decode(request, response);
				
				return;
			}
			
			super.doDispatch(request, response);
		}
		finally
		{
			synchronized (_webRequestInfos)
			{
				_webRequestInfos.remove(Thread.currentThread());
			}
		}
	}

	/**
	 * Accessor to the information about current request in progress : TyServlet, request, response
	 * Current means for 'current Thread.
	 *
	 * @return the information if available or null if it could not bee found.
	 */
	public static LyWebRequestInfo getWebRequestInfo()
	{
		synchronized (_webRequestInfos)
		{
			return _webRequestInfos.get(Thread.currentThread());
		}
	}
} // end class LyStrutsServlet
