package leon.view.web.jquery.component;

import leon.misc.*;
import leon.view.*;
import leon.view.web.*;
import leon.view.web.jquery.*;
import leon.view.web.jquery.common.*;

/**
 * @author atalbi
 */
public abstract class LyJQInternalView extends LyWebObject
{
	/** The calculated ID. */
	protected String			_id;

	protected String			_idprefix		= "component_";

	/** Web 2 view Manager **/
	protected LyJQViewManager	_viewManager	= (LyJQViewManager) getViewManager();

	
	public LyJQInternalView(LyComponent viewComponent)
	{
		super(viewComponent);
	}

	/**
	 * When being translated to html, velocity special characters are removed, So we have to retreat them to be
	 * conserved in page code
	 * @return revised internal id
	 */
	public String getTreatedInternalId()
	{
		String	id = getViewComponent().getId();
		
		if (id == null)
			id = getViewComponent().getInternalId();
		
		return TemplateUtils.replaceSpecialCharacters(id);
	}

	/**
	 * @return formatted id for javacript responses
	 */
	public String getJavascriptStrId()
	{
		String	id = getViewComponent().getId();
		
		if (id == null)
			id = getViewComponent().getInternalId();
		
		return LyString.getJavascriptString(id);
	}

	/**
	 * @return jquery component internal view id
	 */
	public String getId()
	{
		_id = _idprefix + getViewComponent().getIdCode();
		
		if (LyEnvironment.TEST_MODE && (_id != null))
			_id = LyString.replace(_id, new char[] {(char)3, '\\'}, new char[] {'_', '_'});
		
		return _id;
	}

	/**
	 * this method is to be implemented by internal views to get the reload script for the page element
	 * @return reload component script
	 */
	public abstract String getReloadScript();

	/**
	 * set view component param
	 * @param name
	 * @param value
	 */
	public void setProperty(String name, String value)
	{
		// to be implemented by children components
	}

	public boolean isIE()
	{
		if (_viewManager.getBrowser() == LyWebViewManager.BROWSER_MSIE)
			return true;

		return false;
	}

	public String getJSWithoutTranslateString(String label)
	{
		return LyString.getJavascriptString(label);
	}
	
	public static String getConvertedHTML(String label)
	{
		return TemplateUtils.getConvertedHTML(label);
	}
	
	public String getEncoding()
	{
		return LyString.DEFAULT_CHARSET;
	}
}