package leon.view.web.jquery.component.area;

import java.awt.Frame;

import leon.misc.LyEnvironment;
import leon.view.LyPanel;
import leon.view.web.jquery.component.panel.LyJQPanel;

/**
 * Type : leon.view.web.web2.frame.LyJQDrawingArea The peer component of LyArea for the web2 viewer.
 * @version $Revision: -1M $
 * @author ychaari, last modified by $Author: (local) $
 */
public class LyJQDrawingArea extends LyJQPanel
{

	/** Default frame. */
	protected static Frame	_frame;

	/**
	 * Class constructor of a Drawing Area for the web2 target.<br>
	 * Call the super implementation
	 * @param panel the panel component
	 */
	public LyJQDrawingArea(LyPanel panel)
	{
		super(panel);
	}

	/**
	 * Gets the default frame.
	 * @return The default frame.
	 */
	public static Frame getDefaultFrame()
	{
		if (_frame == null)
		{
			_frame = new Frame();
			// ensure that the peer is ready.
			// a peer is required for some methods such as createImage()
			// see also : LyEnvironment.getImage()
			if (LyEnvironment.isOperatingSystem(LyEnvironment.OS_WINDOWS))
				_frame.addNotify();
		}

		return _frame;
	}
}
