package leon.view.web.jquery.component.commands;

import java.util.HashMap;
import java.util.Map;

import leon.view.LyCommand;
import leon.view.LyComponent;
import leon.view.graphic.LyGraphicalCommand;
import leon.view.web.LyWebPageWriter;
import leon.view.web.jquery.component.LyJQInternalView;
import leon.view.web.jquery.controller.LyTemplatesUtilsBean;

/**
 * Ly command Jquery internal view
 * @author abkristou
 */
public class LyJQCommand extends LyJQInternalView	implements
													LyGraphicalCommand
{
	/** The command generic component. */
	protected LyCommand			_command;

	public LyJQCommand(LyCommand command)
	{
		super(command);
		_command = command;
	}

	/**
	 * @see leon.view.web.LyWebComponent#writeHtml(leon.view.web.LyWebPageWriter)
	 */
	public void writeHtml(LyWebPageWriter pw)
	{

	}

	/**
	 * command set label update script
	 */
	public void setLabel(String label)
	{
		LyTemplatesUtilsBean templateManager = _viewManager.getVeloTemplatesBean();
		Map<String, Object> params = new HashMap<String, Object>();
		params.put("command", _command);
		params.put("label", label);
		String editableCell = templateManager.mergeTemplate("commands/actions/setLabel.vm", params);
		_viewManager.addToUpdateScript(editableCell);
		params = null;
	}

	/**
	 * set command enabled script
	 */
	public void setEnabled(boolean enabled)
	{
		LyTemplatesUtilsBean templateManager = _viewManager.getVeloTemplatesBean();
		Map<String, Object> params = new HashMap<String, Object>();
		params.put("command", _command);
		params.put("enabled", enabled);

		String editableCell = templateManager.mergeTemplate("commands/actions/setEnabled.vm",
				params);

		_viewManager.addToUpdateScript(editableCell);
		params = null;
	}

	/**
	 * @return image size
	 */
	public int[] getImgSize()
	{
		return super.getImageSize(_command.getImage());
	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.web.jquery.component.LyJQInternalView#getReloadScript()
	 */
	@Override
	public String getReloadScript()
	{
		return null;
	}

	/**
	 * @return if command have separactor
	 */
	public boolean isSep()
	{
		return ((_command == null) || (_command.getId() == LyComponent.SEP_ID)? true : false);
	}
}
