package leon.view.web.jquery.component.commands;

import java.util.ArrayList;
import java.util.List;

import leon.view.LyCommand;
import leon.view.LyCommands;
import leon.view.graphic.LyGraphicalCommands;
import leon.view.web.LyWebPageWriter;
import leon.view.web.jquery.component.LyJQInternalView;

/**
 * LyCommands JQuery internal view
 * @author abkristou
 */
public class LyJQCommands extends LyJQInternalView	implements
													LyGraphicalCommands
{

	public static final String	__VERSION	= "$Id: LyJQCommands.java 27248 2010-09-07 12:12:29Z (local) $";

	public LyCommands			_commands;

	public LyJQCommands(LyCommands commands)
	{
		super(commands);
		_commands = commands;
	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.web.LyWebComponent#writeHtml(leon.view.web.LyWebPageWriter)
	 */
	public void writeHtml(LyWebPageWriter pw)
	{
		// nop
	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.web.jquery.component.LyJQInternalView#getReloadScript()
	 */
	@Override
	public String getReloadScript()
	{
		return null;
	}

	/**
	 * get commands list
	 * @return commands list
	 */
	public List<LyCommand> getCommands()
	{
		List<LyCommand> commands = new ArrayList<LyCommand>();
		LyCommand command ;
		for (int commandIndex = 0; commandIndex < _commands.getCommandCount(); commandIndex++)
		{
			command = _commands.getCommand(commandIndex);
			commands.add(command);
		}
		return commands;
	}
}
