/* 
 * Lyria-W4 - afficheur_web2
 * LyJQCaption.java
 * Copyright (c) 2000-2009, Lyria-W4
 * All rights reserved.
 */
package leon.view.web.jquery.component.form.field;

import leon.view.LyCaption;
import leon.view.graphic.LyGraphicalCaption;
import leon.view.web.LyWebPageWriter;
import leon.view.web.jquery.component.LyJQInternalView;

/**
 * Type : leon.view.web.web2.component.form.field.LyWeb2Caption The peer component of LyCaption for the web2 viewer.
 * @version $Revision: 147 $
 * @author ychaari$
 */
public class LyJQCaption extends LyJQInternalView	implements
													LyGraphicalCaption
{

	/** The caption generic component. */
	protected LyCaption	_caption;

	/** Maximum length for not wrapped captions. */
	public static int	CAPTION_LENGTH_WRAP	= 50;
	
	private int colSpan;
	
	private int rowSpan;
	
	private int colWeight;
	
	private String vAlign;
	
	private String hAlign;
	
	

	/**
	 * Class constructor of a Caption object for the struts target.
	 * @param caption the generic Caption defined for every type of view targets.
	 */
	public LyJQCaption(LyCaption caption)
	{
		super(caption);
		_caption = caption;
	}

	/**
	 * Check if caption has a label
	 * @param label
	 * @return
	 */
	public boolean captionHasLabel(String label)
	{
		return !(label == null || label.trim().length() == 0);
	}

	/**
	 * Get the mandatory field sign
	 * @return
	 */
	public String getMandatoryFieldSign()
	{
		return getString("LY_CAPTION_ASTERISK", "");
	}

	/**
	 * @return the colSpan
	 */
	public int getColSpan() {
		return colSpan;
	}

	/**
	 * @param colSpan the colSpan to set
	 */
	public void setColSpan(int colSpan) {
		this.colSpan = colSpan;
	}

	/**
	 * @return the rowSpan
	 */
	public int getRowSpan() {
		return rowSpan;
	}

	/**
	 * @param rowSpan the rowSpan to set
	 */
	public void setRowSpan(int rowSpan) {
		this.rowSpan = rowSpan;
	}

	/**
	 * @return the colWeight
	 */
	public int getColWeight() {
		return colWeight;
	}

	/**
	 * @param colWeight the colWeight to set
	 */
	public void setColWeight(int colWeight) {
		this.colWeight = colWeight;
	}

	/**
	 * @return the vAlign
	 */
	public String getVAlign() {
		return vAlign;
	}

	/**
	 * @param vAlign the vAlign to set
	 */
	public void setVAlign(String vAlign) {
		this.vAlign = vAlign;
	}

	/**
	 * @return the hAlign
	 */
	public String getHAlign() {
		if (hAlign == "left")
		{	
			if(_viewManager.isRtlMode())
				return "right";
			else
				return "left";
		}
		else if (hAlign == "right")
		{
			if(_viewManager.isRtlMode())
				return "left";
			else
				return "right";
		}
		 
		return hAlign;
	}

	/**
	 * @param hAlign the hAlign to set
	 */
	public void setHAlign(String hAlign) {
		this.hAlign = hAlign;
	}

	/**
	 * @see leon.view.graphic.LyGraphicalCaption#setEnabled(boolean)
	 */
	public void setEnabled(boolean enabled)
	{
		// Nop
	}

	/**
	 * @see leon.view.graphic.LyGraphicalCaption#setLabel(java.lang.String)
	 */
	public void setLabel(String label)
	{
		// Nop
	}

	public void writeHtml(LyWebPageWriter pw)
	{
		// Nop
	}

	/**
	 * @see leon.view.web.jquery.component.LyJQInternalView#getReloadScript()
	 */
	@Override
	public String getReloadScript()
	{
		// TODO Auto-generated method stub
		return null;
	}
}