package leon.view.web.jquery.component.form.field.href;

import leon.view.*;
import leon.view.graphic.*;
import leon.view.web.*;
import leon.view.web.jquery.*;
import leon.view.web.jquery.component.fieldItem.*;

/**
 * LyHref jquery internal view
 * @author yochaari
 */
public class LyJQHRef extends LyJQFieldItem	implements
											LyGraphicalHRef
{

	/** The <b>location://</b> String value used within Path representation. */
	public static String	LOCATION	= "location://";

	/** The HRef generic component. */
	protected LyHRef		_hRef;

	/**
	 * Constructor.
	 * @param hRef the href component
	 */
	public LyJQHRef(LyHRef hRef)
	{
		super(hRef);
		_hRef = hRef;

		if (_formField == null)
		{
			LyComponent grandParent = hRef.getParent().getParent();

			if (grandParent instanceof LyFormField)
				_formField = (LyFormField) grandParent;
		}
	}

	/**
	 * Gets the HRef image.
	 * @return the image
	 * @see #setImage(String)
	 */
	public String getImage(LyHRef href)
	{
		String image = href.getImage();
		return ((image == null) ? null : getImageUrl(image));
	}



	public String getId(LyHRef href)
	{
		String id = getJSWithoutTranslateString(href.getId());
		
		if (id.startsWith(LOCATION))
			id = id.substring(LOCATION.length());
		else if (id.startsWith("file://"))
			id = id.substring("file://".length());
		
		return id;
	}

	public boolean startId(String id)
	{
		return (id.startsWith("file://") || id.startsWith("http://")
				|| id.startsWith(getEnv(LyJQConstants.LY_APP_DOC)) || id.startsWith(LOCATION));
	}

	/**
	 * get href target
	 * @return target
	 */
	public String getTarget()
	{
		if ((_hRef.getId() != null) && (_hRef.getId().indexOf("download.htm") >= 0))
			return "download_frame";
		
		String target = LyWebConstants.TARGET_FRAME;

		if (testResource(LyJQConstants.LY_WEB_FILE_NEW_WINDOW))
			target = "_blank";
		
		return target;
	}

	public void setImage(String image)
	{
		_viewManager.addToReloadComponents(_hRef.getParent());
	}

	public void setSensitive(boolean sensitive)
	{
		_viewManager.addToReloadComponents(_hRef.getParent());
	}

	public void setVisited(boolean visited)
	{
	}
	
	public void setLabel(String label)
	{
		_viewManager.addToReloadComponents(_hRef.getParent());
	}
	
	public boolean isHref()
	{
		return true;
	}
}