package leon.view.web.jquery.component.form.field.href;

import java.util.HashMap;
import java.util.Map;

import leon.view.LyHRef;
import leon.view.LyHRefs;
import leon.view.graphic.LyGraphicalHRefs;
import leon.view.web.jquery.common.TemplateUtils;
import leon.view.web.jquery.component.fieldItem.LyJQFieldItem;
import leon.view.web.jquery.controller.LyTemplatesUtilsBean;

/**
 * LyHrefs internal view implementation
 * @author yosr
 */
public class LyJQHRefs extends LyJQFieldItem implements
											LyGraphicalHRefs
{
	protected LyHRefs			_hRefs;

	protected static String		LY_MULTIPLE_RELATION_CONSULT_HEIGHT	= "LY_MULTIPLE_RELATION_CONSULT_HEIGHT";

	protected static String		LY_MULTIPLE_RELATION_CONSULT_WIDTH	= "LY_MULTIPLE_RELATION_CONSULT_WIDTH";

	protected static String		LY_HREFS_TEMPLATE					= "form/field/href/lyHrefsTemplate.vm";

	protected static String		HREFS_PARAM							= "hrefs";

	/**
	 * Constructor.
	 * @param hRefs the hrefs component
	 */
	public LyJQHRefs(LyHRefs hRefs)
	{
		super(hRefs);
		_hRefs = hRefs;
	}

	public int getHeight(LyHRefs hrefs)
	{
		int height = _hRefs.getNRows();

		if (height <= 0)
			height = _environment.getIntResource(LY_MULTIPLE_RELATION_CONSULT_HEIGHT);

		height = 22 * height + 2;
		return height;
	}

	public int getMultipleWidth()
	{
		return _environment.getIntResource(LY_MULTIPLE_RELATION_CONSULT_WIDTH);
	}

	/**
	 * Indicates if at least one of the href has an image.
	 * @return true if at least one of the href has an image, false otherwise
	 */
	public boolean containsImage(LyHRefs hRefs)
	{
		int i, n = hRefs.getHRefCount();
		LyHRef href;
		String image;

		for (i = 0; i < n; i++)
		{
			href = _hRefs.getHRef(i);
			image = href.getImage();

			// If an image was found return true
			if ((image != null) && (image.length() != 0))
				return true;
		}

		return false;
	}

	/**
	 * add href script
	 */
	public void addHRef(LyHRef hRefs, int pos)
	{
		refreshHrefs();
	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.graphic.LyGraphicalHRefs#removeHRef(leon.view.LyHRef)
	 */
	public void removeHRef(LyHRef hRefs)
	{
		refreshHrefs();
	}

	/**
	 * refresh href component
	 */
	public void refreshHrefs()
	{
		_viewManager.addToReloadComponents(_hRefs);
	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.web.jquery.component.fieldItem.LyJQFieldItem#getReloadScript()
	 */
	@Override
	public String getReloadScript()
	{
		Map<String, Object> params = new HashMap<String, Object>();
		params.put(HREFS_PARAM, _hRefs);

		LyTemplatesUtilsBean templateManager = _viewManager.getVeloTemplatesBean();
		String hrefs = templateManager.mergeTemplate(LY_HREFS_TEMPLATE, params);
		hrefs = TemplateUtils.getFormattedJs(hrefs);

		params = new HashMap<String, Object>();
		params.put("content", hrefs);
		params.put("componentId", getId());

		hrefs = templateManager.mergeTemplate("ajax/replaceWith.vm", params);
		params = null;
		return hrefs;
	}

	public boolean isHrefs()
	{
		return true;
	}
}
