/* 
 * Lyria-W4 - afficheur_web2
 * LyWeb2Label.java
 * Copyright (c) 2000-2009, Lyria-W4
 * All rights reserved.
 */
package leon.view.web.jquery.component.form.field.label;

import java.util.HashMap;
import java.util.Map;

import leon.view.LyLabel;
import leon.view.graphic.LyGraphicalLabel;
import leon.view.web.jquery.component.fieldItem.LyJQFieldItem;
import leon.view.web.jquery.component.table.LyJQTable;
import leon.view.web.jquery.controller.LyTemplatesUtilsBean;

/**
 * Type : leon.view.web.web2.component.form.field.label.LyJQLabel The peer component of LyLabel for the web2 viewer.
 * @version $Revision: 312 $
 * @author ychaari, last modified by $Author: bas $
 */
public class LyJQLabel extends LyJQFieldItem implements
											LyGraphicalLabel
{

	/** The label generic component. */
	protected LyLabel	_label;
	
	protected final String		LABEL_ID_TEMPLATE_PARAM		= "labelId";

	protected final String		LABEL_TEXT_TEMPLATE_PARAM	= "labelText";
	
	protected final String		LABEL_TEMPLATE				= "form/field/label/actions/setLabel.vm";

	/**
	 * Class constructor of a Label object for the struts target.
	 * @param label the generic Label defined for every type of view targets.
	 */
	public LyJQLabel(LyLabel label)
	{
		super(label);
		_label = label;
	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.graphic.LyGraphicalLabel#setFont(java.lang.String)
	 */
	public void setFont(String font)
	{
		// TODO Auto-generated method stub

	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.graphic.LyGraphicalLabel#setImage(java.lang.String)
	 */
	public void setImage(String image)
	{
		// TODO Auto-generated method stub
	}

	/**
	 * @see leon.view.web.jquery.component.fieldItem.LyJQFieldItem#setLabel(java.lang.String)
	 */
	@Override
	public void setLabel(String label)
	{
		LyTemplatesUtilsBean templateManager = _viewManager.getVeloTemplatesBean();
		Map<String, Object> params = new HashMap<String, Object>();
		params.put(LABEL_ID_TEMPLATE_PARAM, getId());
		params.put(LABEL_TEXT_TEMPLATE_PARAM, getHtmlString(label));
		if( getParentTable()!=null)
		{
			params.put("tableId",((LyJQTable) getParentTable().getInternalView()).getId());
		}		
		String newDiv = templateManager.mergeTemplate(LABEL_TEMPLATE, params);
		_viewManager.addToUpdateScript(newDiv);
		params = null;
	}

	/**
	 * Gets url from a label
	 */
	public String getUrl(String label)
	{
		String target = getTarget();
		return replaceUrl(label, target, _viewManager.isPrintMode());
	}

	public boolean isLabel()
	{
		return true;
	}
}