package leon.view.web.jquery.component.form.field.lyBoolean;

import leon.misc.LyString;
import leon.view.LyBoolean;
import leon.view.LyForm;
import leon.view.LyBoolean.Status;
import leon.view.graphic.LyGraphicalBoolean;
import leon.view.web.jquery.component.fieldItem.LyJQFieldItem;

/**
 * LyBoolean jquery internal view
 * @author yochaari
 */
public class LyJQBoolean extends LyJQFieldItem	implements
												LyGraphicalBoolean
{

	/** The boolean generic component. */
	protected LyBoolean		_boolean;

	protected static String	CHECKED_STATUS		= "checked";

	protected static String	UNCHECKED_STATUS	= "unchecked";

	protected static String	NON_SPECIFIED_STATE	= "none";

	/**
	 * Class constructor of a Boolean object for the struts target.
	 * @param booleanViewComp the generic Boolean defined for every type of view targets.
	 */
	public LyJQBoolean(LyBoolean booleanViewComp)
	{
		super(booleanViewComp);
		_boolean = booleanViewComp;
	}

	/**
	 * get choice status
	 * @param _boolean
	 * @return status
	 */
	public String getStatus(LyBoolean _boolean)
	{
		LyBoolean.Status status = _boolean.getStatus();
		if (status == LyBoolean.Status.CHECKED)
			return CHECKED_STATUS;
		else if (status == LyBoolean.Status.UNCHECKED)
			return UNCHECKED_STATUS;
		else
			return NON_SPECIFIED_STATE;
	}

	/**
	 * get choice tooltip
	 * @param tooltip
	 * @return tooltip
	 */
	public String getTooltip(String tooltip)
	{
		return LyString.getJavascriptString(tooltip);
	}

	/**
	 * Indicates if the field item is editable.
	 * @return true if it is editable, false otherwise
	 */
	public boolean isEditable()
	{
		if (!_formField.isEditable() || !_formField.isEnabled())
			return false;

		LyForm form = ((_formField.getParent() instanceof LyForm) ? (LyForm) _formField.getParent()
				: null);

		return ((form == null) || form.isEditable());
	}

	/**
	 * @see leon.view.graphic.LyGraphicalBoolean#setStatus(leon.view.LyBoolean.Status)
	 */
	public void setStatus(Status status)
	{
		_viewManager.addToReloadComponents(_boolean.getParent());
	}

	public boolean isBoolean()
	{
		return true;
	}
}