package leon.view.web.jquery.component.form.field.relation;

import leon.view.*;
import leon.view.graphic.*;
import leon.view.web.*;
import leon.view.web.jquery.common.*;
import leon.view.web.jquery.component.*;

/**
 * This class implements the Link object (as described in the DTD) for web2 viewer.
 * <p>
 * <b>LINK: Link</b><br>
 * A link represents a possible value in an input field of Relation type.
 * </p>
 * @author ous
 * @see leon.view.LyLink
 */
public class LyJQLink extends LyJQInternalView	implements
												LyGraphicalLink
{
	protected LyLink			_link;

	protected static String		LINK_ID_PARAM			= "linkId";

	protected static String		RELATION_ID_PARAM		= "relationId";

	protected static String		SELECTED_PARAM			= "selected";

	protected static String		SELECT_LINK_TEMPLATE	= "form/field/relation/ajax/selectLink.vm";

	public LyJQLink(LyLink link)
	{
		super(link);
		_link = link;
	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.web.LyWebComponent#writeHtml(leon.view.web.LyWebPageWriter)
	 */
	public void writeHtml(LyWebPageWriter pw)
	{
		// TODO Auto-generated method stub

	}
	
	public String getFormattedId() {
		return TemplateUtils.getFormattedJs(_link.getId());
	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.graphic.LyGraphicalLink#setSelected(boolean)
	 */
	public void setSelected(boolean selected)
	{
		((LyJQRelation) ((LyRelation) _link.getParent()).getInternalView()).reloadComponent();
	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.web.jquery.component.LyJQInternalView#getReloadScript()
	 */
	@Override
	public String getReloadScript()
	{
		// TODO Auto-generated method stub
		return null;
	}

}
