package leon.view.web.jquery.component.gauge;

import java.util.HashMap;
import java.util.Map;

import leon.view.LyGauge;
import leon.view.graphic.LyGraphicalGauge;
import leon.view.web.LyWebPageWriter;
import leon.view.web.jquery.component.LyJQInternalView;
import leon.view.web.jquery.controller.LyTemplatesUtilsBean;

/**
 * Type : leon.view.web.jquery.component.gauge The peer component of LyTab for the web2 viewer.
 * @version $Revision: -1M $
 * @author abkristou
 */
public class LyJQGauge extends LyJQInternalView	implements
												LyGraphicalGauge
{
	protected LyGauge	_gauge;

	private static final String	GAUGE_SET_LABEL	 = "gauge/actions/setLabel.vm";

	private static final String	GAUGE_SET_NVALUE = "gauge/actions/setNValue.vm";
	/**
	 * Constructor
	 * @param gauge
	 */
	public LyJQGauge(LyGauge gauge)
	{
		super(gauge);
		_gauge = gauge;
	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.web.LyWebComponent#writeHtml(leon.view.web.LyWebPageWriter)
	 */
	public void writeHtml(LyWebPageWriter pw)
	{
		// TODO Auto-generated method stub

	}

	/**
	 * get gauge label
	 * @return label
	 */
	public String getLabel()
	{
		int nMin = _gauge.getNMin();
		int nMax = _gauge.getNMax();
		int nValue = _gauge.getNValue();
		String label = _gauge.getLabel();

		float percent = ((float) nValue) / (nMax - nMin);
		if ((label == null) || (label.length() == 0))
		{
			int prop = (int) (percent * 100);
			Integer propInteger = new Integer(prop);

			label = propInteger.toString();
			label = label + "%";
		}
		return label;
	}

	/**
	 * get percent value
	 * @return percent label
	 */
	public Integer getPercent()
	{
		int nMin = _gauge.getNMin();
		int nMax = _gauge.getNMax();
		int nValue = _gauge.getNValue();

		float percent = ((float) nValue) / (nMax - nMin);
		int prop = (int) (percent * 100);
		Integer propInteger = new Integer(prop);

		return propInteger;
	}

	public void setLabel(String label)
	{
		LyTemplatesUtilsBean templateManager = _viewManager.getVeloTemplatesBean();
		Map<String, Object> params = new HashMap<String, Object>();
		params.put("gauge", _gauge);
		params.put("label", label);

		String editableCell = templateManager.mergeTemplate(GAUGE_SET_LABEL, params);

		_viewManager.addToUpdateScript(editableCell);
	}

	public void setNValue(int nValue)
	{
		LyTemplatesUtilsBean templateManager = _viewManager.getVeloTemplatesBean();
		Map<String, Object> params = new HashMap<String, Object>();
		int nMin = _gauge.getNMin();
		int nMax = _gauge.getNMax();
		float percent = ((float) nValue) / (nMax - nMin);
		int prop = (int) (percent * 100);
		Integer propInteger = new Integer(prop);
		params.put("gauge", _gauge);
		params.put("nValue", propInteger);

		String editableCell = templateManager.mergeTemplate(GAUGE_SET_NVALUE, params);

		_viewManager.addToUpdateScript(editableCell);
	}

	@Override
	public String getReloadScript()
	{
		// TODO Auto-generated method stub
		return null;
	}
	
	public boolean isGauge(){
		return true;
	}

}
