package leon.view.web.jquery.component.headers;

import leon.view.LyComponent;
import leon.view.LyHeaders;
import leon.view.LyTable;
import leon.view.graphic.LyGraphicalHeaders;
import leon.view.web.LyWebPageWriter;
import leon.view.web.jquery.component.LyJQInternalView;

/**
 * LyHeaders internal View Implementation
 * @author bsmichet
 */
public class LyJQHeaders extends LyJQInternalView	implements
													LyGraphicalHeaders
{

	public static final String	__VERSION	= "$Id: LyStrutsHeaders.java 23300 2009-12-17 13:56:41Z jlsaouli $";

	/** The headers generic component. */
	protected LyHeaders			_headers;

	/** Image for extended sort button. */
	protected String			_extendedSortButton;

	/** Image for simple sort button. */
	protected String			_simpleSortButton;

	/** Tooltip for sort mode swaping. */
	protected String			_swapSortMode;

	/**
	 * Class constructor of a Headers object for the struts target.
	 * @param headers the generic Headers defined for every type of view targets
	 */
	public LyJQHeaders(LyHeaders headers)
	{
		super(headers);
		_headers = headers;
	}

	/**
	 * Gets the depth of current sub-headers in its parent table component.
	 * @return the depth of current sub-headers in its parent table component.
	 */
	protected int getDepthInTable()
	{
		int depth = -1;
		LyComponent parent = _headers;

		while (!(parent instanceof LyTable))
		{
			depth++;
			parent = parent.getParent();
		}

		return depth;
	}

	/**
	 * Gets the depth of sub-headers for current table component.
	 * @return the depth of sub-headers.
	 */
	public int getDepth()
	{
		if (_headers == null)
			return 0;

		int i, n = _headers.getHeadersCount();
		int subDepth, depth = 0;
		LyHeaders subHeaders;
		LyJQHeaders subComponent;

		for (i = 0; i < n; i++)
		{
			subHeaders = _headers.getHeaders(i);
			subComponent = (LyJQHeaders) subHeaders.getInternalView();
			subDepth = subComponent.getDepth();

			if (subDepth >= depth)
				depth = subDepth + 1;
		}

		return depth;
	}

	/**
	 * Gets row span.
	 * @return row span
	 */
	public int getRowSpan()
	{
		return 1;
	}

	public int getColSpan()
	{
		return _headers.getHeaderCount();
	}

	/**
	 * get childs depth
	 * @return int
	 */
	public int getChildsDepth()
	{
		LyComponent hd;
		int maxNb = 1;
		int nb;
		for (int i = 0; i < _headers.getChildCount(); i++)
		{
			hd = _headers.getChild(i);
			if (hd instanceof LyHeaders)
			{
				nb = ((LyJQHeaders) ((LyHeaders) hd).getInternalView()).getChildsDepth();
				if (nb >= maxNb)
					maxNb = nb + 1;
			}
		}
		return maxNb;
	}

	public void writeHtml(LyWebPageWriter pw)
	{
		// TODO Auto-generated method stub

	}

	@Override
	public String getReloadScript()
	{
		// TODO Auto-generated method stub
		return null;
	}

}