/* 
 * Lyria-W4 - afficheur_web_2
 * LyWeb2Menu.java
 * Copyright (c) 2000-2009, Lyria-W4
 * All rights reserved.
 */
package leon.view.web.jquery.component.menu;

import java.util.*;

import leon.view.*;
import leon.view.graphic.*;
import leon.view.setinterface.*;
import leon.view.web.*;
import leon.view.web.jquery.component.*;

/**
 * LyWeb2Menu
 * @version $Revision$
 * @author slachiheb, last modified by $Author$
 */
public class LyJQMenu extends LyJQInternalView	implements
												LyGraphicalMenu,
												LySetVisibleInterface
{
	public LyMenu				_menu;

	protected static String		MENU_ID_PARAM				= "componentId";

	protected static String		MENU_PARAM					= "lyMenu";

	protected static String		MENU_CONTENT_PARAM			= "content";

	protected static String		MENUBAR_MENU_TEMPLATE		= "menuBar/item/lyMenuTemplate.vm";

	protected static String		MENUBAR_TEMPLATE			= "menuBar/lyMenuBarTemplate.vm";

	protected static String		MENUBAR_ELEMENT_TEMPLATE	= "menuBar/lyMenuBarElementTemplate.vm";

	protected static String		MENU_BAR_SCRIPT_TEMPLATE	= "menuBar/lyMenuBarScriptTemplate.vm";

	protected static String		MENUBAR_PARAM				= "lyMenuBar";

	protected static String		MENUBAR_ID_PARAM			= "lyMenuBarId";

	/**
	 * LyWeb2Menu
	 * @param viewComponent
	 */
	public LyJQMenu(LyMenu menu)
	{
		super(menu);
		_menu = menu;
	}

	/**
	 * get menu components
	 * @return components list
	 */
	public List<LyComponent> getComponents()
	{

		List<LyComponent> components = new ArrayList<LyComponent>();
		LyComponent lyComponent;
		for (int compIndex = 0; compIndex < _menu.getComponentCount(); compIndex++)
		{
			lyComponent = _menu.getComponent(compIndex);
			components.add(lyComponent);
		}
		return components;
	}

	/**
	 * method used by the lymenu velocity template
	 * @return true
	 */
	public boolean isMenu()
	{
		return true;
	}

	/**
	 * method used by the lymenu velocity template
	 * @return false
	 */
	public boolean isItem()
	{
		return false;
	}

	/**
	 * @see leon.view.setinterface.LySetVisibleInterface#setVisible(boolean)
	 */
	public void setVisible(boolean status)
	{
		_viewManager.addToReloadComponents(getParentMenuBar());
	}

	/**
	 * @see leon.view.graphic.LyGraphicalMenu#setEnabled(boolean)
	 */
	public void setEnabled(boolean enabled)
	{
		_viewManager.addToReloadComponents(getParentMenuBar());
	}

	/**
	 * return the parent menu bar
	 * @return
	 */
	private LyComponent getParentMenuBar()
	{
		LyComponent parentComponent = _menu.getParent();
		while (!(parentComponent instanceof LyMenuBar))
		{
			parentComponent = parentComponent.getParent();
		}

		return parentComponent;
	}

	/**
	 * @see leon.view.web.LyWebComponent#writeHtml(leon.view.web.LyWebPageWriter)
	 */
	public void writeHtml(LyWebPageWriter pw)
	{
		// TODO slachiheb Auto-generated method stub

	}

	public void addComponent(LyComponent components, int pos)
	{
		//

	}

	public void removeComponent(LyComponent components)
	{
		//
	}

	/**
	 * TODO slachiheb Add a comment
	 * @see leon.view.web.jquery.component.LyJQInternalView#getReloadScript()
	 */
	public String getReloadScript()
	{
		// TODO slachiheb Auto-generated method stub
		return null;
	}

}