/* 
 * Lyria-W4 - afficheur_web_2
 * LyWeb2MenuBar.java
 * Copyright (c) 2000-2009, Lyria-W4
 * All rights reserved.
 */
package leon.view.web.jquery.component.menubar;

import java.util.HashMap;
import java.util.Map;

import leon.view.LyMenu;
import leon.view.LyMenuBar;
import leon.view.graphic.LyGraphicalMenuBar;
import leon.view.web.LyWebPageWriter;
import leon.view.web.jquery.common.TemplateUtils;
import leon.view.web.jquery.component.LyJQInternalView;
import leon.view.web.jquery.controller.LyTemplatesUtilsBean;

/**
 * LyWeb2MenuBar
 * @version $Revision$
 * @author slachiheb, last modified by $Author$
 */
public class LyJQMenuBar extends LyJQInternalView	implements
													LyGraphicalMenuBar
{

	public LyMenuBar			_menuBar;

	protected static String		MENU_PARAM					= "lyMenu";

	protected static String		MENU_ID_PARAM				= "menuId";

	protected static String		MENUBAR_PARAM			= "lyMenuBar";

	protected static String		COMPONENT_ID_PARAM			= "componentId";

	protected static String		CONTENT_PARAM				= "content";

	protected static String		POSITION_PARAM				= "position";

	protected static String		MENU_BAR_ELEMENT_TEMPLATE	= "menuBar/lyMenuBarElementTemplate.vm";

	protected static String		MENU_BAR_TEMPLATE	= "menuBar/lyMenuBarTemplate.vm";

	protected static String		ADD_MENU_AJAX_SCRIPT		= "ajax/menuBar/addMenu.vm";


	/**
	 * @param viewComponent
	 */
	public LyJQMenuBar(LyMenuBar menuBar)
	{
		super(menuBar);
		_menuBar = menuBar;
	}

	/**
	 * @see leon.view.web.LyWebComponent#writeHtml(leon.view.web.LyWebPageWriter)
	 */
	public void writeHtml(LyWebPageWriter pw)
	{
		//
	}

	/**
	 * @see leon.view.graphic.LyGraphicalMenuBar#addMenu(leon.view.LyMenu, int)
	 */
	public void addMenu(LyMenu menu, int pos)
	{
		_viewManager.addToReloadComponents(_menuBar);
	}

	/**
	 * @see leon.view.graphic.LyGraphicalMenuBar#removeMenu(leon.view.LyMenu)
	 */
	public void removeMenu(LyMenu menus)
	{
		_viewManager.addToReloadComponents(_menuBar);
	}

	@Override
	public String getReloadScript()
	{
		Map<String, Object> params = new HashMap<String, Object>();
		params.put(MENUBAR_PARAM, _menuBar);
		LyTemplatesUtilsBean templateManager = _viewManager.getVeloTemplatesBean();
		String menubarScript = templateManager.mergeTemplate(MENU_BAR_TEMPLATE, params);
		params = null;

		menubarScript = TemplateUtils.getFormattedJs(menubarScript);
		params = new HashMap<String, Object>();
		params.put("content", menubarScript);
		params.put("componentId", getId());	
		return templateManager
		.mergeTemplate("ajax/replaceWith.vm", params);
	}

}
