/* 
 * Lyria-W4 - afficheur_web2
 * LyWeb2Message.java
 * Copyright (c) 2000-2009, Lyria-W4
 * All rights reserved.
 */
package leon.view.web.jquery.component.message;

import leon.view.LyMessage;
import leon.view.LyMessage.Align;
import leon.view.graphic.LyGraphicalMessage;
import leon.view.web.LyWebPageWriter;
import leon.view.web.jquery.component.LyJQInternalView;

/**
 * Type : leon.view.web.web2.message.LyWeb2Message The peer component of LyMessage for the web2 viewer.
 * @version $Revision: -1M $
 * @author ychaari, last modified by $Author: (local) $
 */
public class LyJQMessage extends LyJQInternalView	implements
													LyGraphicalMessage
{

	/** The message generic component. */
	protected LyMessage	_message;

	/**
	 * Constructor.
	 * @param message the message component
	 */
	public LyJQMessage(LyMessage message)
	{
		super(message);
		_message = message;
	}

	public float getSizePercentage(int size, int totalSize)
	{
		return ((float) size / (float) totalSize) * 100;
	}

	/**
	 * get message URL
	 * @return url
	 */
	public String getLinkUrl()
	{
		String controllerId = _message.getController();
		String messageId = _message.getId();

		return "javascript:invokeLyMessageSelectionAction('" + messageId + "','" + controllerId
				+ "')";
	}
	
	/**
	 * Gets value of align.
	 * 
	 * @return value of align.
	 */
	public Align getAlign() {
		Align fmkMessageAlign = _message.getAlign();
		if (_viewManager.isRtlMode())
		{
			if (fmkMessageAlign == Align.LEFT)
				return Align.RIGHT;
			if (fmkMessageAlign == Align.RIGHT)
				return Align.LEFT;
		}
		return fmkMessageAlign;
	}

	/**
	 * set message image : actually we refresh all the message bar
	 */
	public void setImage(String image)
	{
		refreshMessages();
	}

	public void setLabel(String label)
	{
		refreshMessages();
	}

	public void writeHtml(LyWebPageWriter pw)
	{
		refreshMessages();
	}

	/**
	 * notify view manager to refresh all the message bar
	 */
	protected void refreshMessages()
	{
		((LyJQMessages) _message.getParent().getInternalView()).refreshComponent();
	}

	@Override
	public String getReloadScript()
	{
		// TODO Auto-generated method stub
		return null;
	}
}