/* 
 * Lyria-W4 - afficheur_web2
 * LyWeb2Messages.java
 * Copyright (c) 2000-2009, Lyria-W4
 * All rights reserved.
 */
package leon.view.web.jquery.component.message;

import java.util.HashMap;
import java.util.Map;

import leon.view.LyMessage;
import leon.view.LyMessages;
import leon.view.LyMessages.Border;
import leon.view.graphic.LyGraphicalMessages;
import leon.view.web.LyWebPageWriter;
import leon.view.web.jquery.LyJQConstants;
import leon.view.web.jquery.common.TemplateUtils;
import leon.view.web.jquery.component.LyJQInternalView;
import leon.view.web.jquery.controller.LyTemplatesUtilsBean;

/**
 * Type : leon.view.web.web2.message.LyWeb2Messages The peer component of LyMessages for the web2 viewer.
 * @version $Revision: -1M $
 * @author ychaari, last modified by $Author: (local) $
 */
public class LyJQMessages extends LyJQInternalView	implements
													LyGraphicalMessages
{
	/** The messages generic component. */
	protected LyMessages		_messages;

	protected static String		MESSAGES_PARAM		= "lyMessages";

	protected static String		MESSAGE_TEMPLATE	= "message/LyMessageTemplate.vm";

	/**
	 * Class constructor of a Messages object for the web2 target.
	 * @param messages the generic Messages defined for every type of view targets.
	 */
	public LyJQMessages(LyMessages messages)
	{
		super(messages);
		_messages = messages;
	}

	/**
	 * Getting lyWeb2Message from a lyMessage object
	 * @param message
	 * @return
	 */
	public LyJQMessage getLyWeb2Message(LyMessage message)
	{
		return (LyJQMessage) message.getInternalView();
	}

	/**
	 * Check if messages element has border
	 * @param lyMessages
	 * @return
	 */
	public boolean hasBorder(LyMessages lyMessages)
	{
		Border border = lyMessages.getBorder();
		return (border != null && border != LyMessages.Border.NONE);
	}

	public void addMessage(LyMessage arg0, int arg1)
	{
		refreshComponent();
	}

	public void removeMessage(LyMessage arg0)
	{
		refreshComponent();
	}

	public void writeHtml(LyWebPageWriter arg0)
	{
		// Nop
	}

	/**
	 * notify the view manager to refresh the whole component
	 */
	public void refreshComponent()
	{
		_viewManager.addToReloadComponents(_messages);
	}

	/*
	 * @see leon.view.web.jquery.component.LyJQInternalView#getReloadScript()
	 */
	public String getReloadScript()
	{
		Map<String, Object> params = new HashMap<String, Object>();
		params.put(MESSAGES_PARAM, _messages);
		LyJQInternalView parentComponent =(LyJQInternalView) _messages.getParent().getInternalView();
		String parentId = parentComponent.getId();
		LyTemplatesUtilsBean templateManager = _viewManager.getVeloTemplatesBean();
		String messages = templateManager.mergeTemplate(MESSAGE_TEMPLATE, params);
		messages = TemplateUtils.getFormattedJs(messages);
		params = new HashMap<String, Object>();
		params.put(LyJQConstants.DIV_TO_APPEND_PARAM, messages);
		params.put(LyJQConstants.PARENT_ID_PARAM, parentId + "_messagesContainer");
		return templateManager.mergeTemplate(LyJQConstants.APPEND_SCRIPT_TEMPLATE, params);
	}
}