package leon.view.web.jquery.component.panel;

import leon.view.LyChart;
import leon.view.LyForm;
import leon.view.LyGantt;
import leon.view.LyMap;
import leon.view.LyNotice;
import leon.view.LyPanel;
import leon.view.LyPopupMenu;
import leon.view.LyTable;
import leon.view.LyTree;
import leon.view.graphic.LyGraphicalPanel;
import leon.view.setinterface.LySetPopupMenuInterface;
import leon.view.web.jquery.component.fieldItem.LyJQFieldItem;

/**
 * Type : leon.view.web.web2.panel.LyWeb2Panel The peer component of LyFrame for the web2 viewer.
 * @version $Revision: -1M $
 * @author bsmichet, last modified by $Author: (local) $
 */
public abstract class LyJQPanel extends LyJQFieldItem	implements
														LyGraphicalPanel,
														LySetPopupMenuInterface
{

	/**
	 * Constructor.
	 * @param panel the panel component
	 */
	public LyJQPanel(LyPanel panel)
	{
		super(panel);
	}

	/**
	 * Check if the panel is a Table.
	 * @param panel the panel component
	 * @return
	 */
	public boolean isTable(LyPanel panel)
	{
		return (panel instanceof LyTable);
	}

	/**
	 * Check if the panel is a Tree.
	 * @param panel the panel component
	 * @return boolean
	 */
	public boolean isTree(LyPanel panel)
	{
		return (panel instanceof LyTree);
	}

	/**
	 * Check if the panel is a chart.
	 * @param panel the panel component
	 * @return
	 */
	public boolean isChart(LyPanel panel)
	{
		return (panel instanceof LyChart);
	}

	/**
	 * Check if panel is a form
	 * @param panel
	 * @return
	 */
	public boolean isForm(LyPanel panel)
	{
		return (panel instanceof LyForm);
	}

	/**
	 * Check if panel is a gantt
	 * @param panel
	 * @return boolean
	 */
	public boolean isGantt(LyPanel panel)
	{
		return (panel instanceof LyGantt);
	}

	/**
	 * Check if the panel is a Notice.
	 * @param panel the panel component
	 * @return
	 */
	public boolean isNotice(LyPanel panel)
	{
		return (panel instanceof LyNotice);
	}

	/**
	 * Check if the panel is a Map.
	 * @param panel the panel component
	 * @return
	 */
	public boolean isMap(LyPanel panel)
	{
		return (panel instanceof LyMap);
	}

	/**
	 * Sets the popup menu with the given value.
	 * @param popup the new popup menu
	 */
	public void setPopupMenu(LyPopupMenu popup)
	{
		_viewManager.setPopupMenu(popup);
		
	}

	public boolean isPanel()
	{
		return true;
	}

}