package leon.view.web.jquery.component.rows;

import java.util.Iterator;
import java.util.Vector;

import leon.view.LyRow;
import leon.view.LyRows;
import leon.view.graphic.LyGraphicalRows;
import leon.view.web.LyWebPageWriter;
import leon.view.web.jquery.component.LyJQInternalView;

/**
 * LYRows JQUERY internal view
 * @author bahaSmichet
 */
public class LyJQRows extends LyJQInternalView	implements
												LyGraphicalRows
{
	public static final String	__VERSION	= "$Id: LyStrutsRows.java 23300 2009-12-17 13:56:41Z jlsaouli $";

	/** The rows generic component. */
	protected LyRows			_rows;

	/**
	 * Class constructor of a Rows object for the struts target.
	 * @param rows the generic Rows defined for every type of view targets.
	 */
	public LyJQRows(LyRows rows)
	{
		super(rows);
		_rows = rows;
	}

	/**
	 * get sub rows list
	 * @return rows list
	 */
	public Iterator<LyRow> getSubRowList()
	{
		Vector<LyRow> rowList = new Vector<LyRow>();
		for (int i = 0; i < _rows.getRowCount(); i++)
		{
			rowList.add(_rows.getRow(i));
		}
		return rowList.iterator();

	}

	public void writeHtml(LyWebPageWriter pw)
	{
		// TODO Auto-generated method stub

	}

	@Override
	public String getReloadScript()
	{
		// TODO Auto-generated method stub
		return null;
	}

	/**
	 * @return row sub rows number
	 */
	public int getRowsNbColumns()
	{
		int nb = 0;
		LyRow row;
		LyJQRows rowsIView;
		int nbColumns;
		for (int i = 0; i < _rows.getRowCount(); i++)
		{
			row = _rows.getRow(i);
			if (row.getComponentCount() > nb)
				nb = row.getComponentCount();
			if (row.getRows() != null) {
				rowsIView = ((LyJQRows) row.getRows().getInternalView());
				nbColumns = rowsIView.getRowsNbColumns();
				if (nbColumns > nb)
				nb = nbColumns;
			}
		}
		return nb;
	}

	/**
	 * check if cell contains image
	 */
	public boolean containsImage()
	{
		LyRow row;
		for (int i = 0; i < _rows.getRowCount(); i++)
		{
			row = _rows.getRow(i);
			if (row.getImage() != null && row.getImage() != "")
				return true;
		}
		return false;
	}

	/**
	 * @return number of rows
	 */

	public int getNbRows()
	{
		int nbRows = 0;
		LyRow row;
		for (int i = 0; i < _rows.getRowCount(); i++)
		{
			row = _rows.getRow(i);
			nbRows += 1;
			if (row.getRows() != null)
				nbRows += ((LyJQRows) row.getRows().getInternalView()).getNbRows();
		}
		return nbRows;
	}
}