package leon.view.web.jquery.component.selectBar;

import leon.view.LyComponent;
import leon.view.LySelectBar;
import leon.view.graphic.LyGraphicalSelectBar;
import leon.view.web.jquery.component.panel.LyJQPanel;

/**
 * Selectbar JQUERY internal view
 * @author bahaSmichet
 */
public class LyJQSelectBar extends LyJQPanel implements
											LyGraphicalSelectBar
{

	/** The select bar generic component. */
	protected LySelectBar	_selectBar;

	/** The select bar background color. */

	public LyJQSelectBar(LySelectBar selectBar)
	{
		super(selectBar);
		_selectBar = selectBar;
	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.graphic.LyGraphicalSelectBar#setStartItem(int)
	 */
	public void setStartItem(int startItem)
	{
		reloadItem();

	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.graphic.LyGraphicalSelectBar#addComponent(leon.view.LyComponent, int)
	 */
	public void addComponent(LyComponent components, int pos)
	{
		reloadItem();

	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.graphic.LyGraphicalSelectBar#removeComponent(leon.view.LyComponent)
	 */
	public void removeComponent(LyComponent components)
	{
		reloadItem();

	}
	
	/**
	 * reload the whole select bar
	 */
	public void reloadItem()
	{
		_viewManager.addToReloadComponents(_selectBar);
	}

}