package leon.view.web.jquery.component.selectItem;

import leon.view.LySelectItem;
import leon.view.graphic.LyGraphicalSelectItem;
import leon.view.web.LyWebPageWriter;
import leon.view.web.jquery.component.LyJQInternalView;

/**
 * SelectItem jquery internal view implementation
 * @author bahaSmichet
 */
public class LyJQSelectItem extends LyJQInternalView implements
													LyGraphicalSelectItem
{
	/** The select item generic component. */
	protected LySelectItem		_selectItem;

	/**
	 * Constructor.
	 * @param selectItem the select item component
	 */
	public LyJQSelectItem(LySelectItem selectItem)
	{
		super(selectItem);
		_selectItem = selectItem;
	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.web.LyWebComponent#writeHtml(leon.view.web.LyWebPageWriter)
	 */
	public void writeHtml(LyWebPageWriter pw)
	{
		reloadItem();

	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.graphic.LyGraphicalSelectItem#setLabel(java.lang.String)
	 */
	public void setLabel(String label)
	{
		reloadItem();

	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.graphic.LyGraphicalSelectItem#setImage(java.lang.String)
	 */
	public void setImage(String image)
	{
		reloadItem();

	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.graphic.LyGraphicalSelectItem#setSelected(boolean)
	 */
	public void setSelected(boolean selected)
	{
		reloadItem();

	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.graphic.LyGraphicalSelectItem#setEnabled(boolean)
	 */
	public void setEnabled(boolean enabled)
	{
		reloadItem();
	}

	/**
	 * notifie view manager to reload the whole item
	 */
	public void reloadItem()
	{
		_viewManager.addToReloadComponents(_selectItem);
	}

	@Override
	public String getReloadScript()
	{
		return null;
	}

}
