package leon.view.web.jquery.component.tab;

import java.util.*;

import leon.view.LyTab;
import leon.view.LyTabs;
import leon.view.graphic.LyGraphicalTabs;
import leon.view.setinterface.LySetTabInterface;
import leon.view.web.LyWebPageWriter;
import leon.view.web.jquery.LyJQContainer;
import leon.view.web.jquery.controller.*;

/**
 * Type : leon.view.web.web2.tabs.LyWeb2Tabs The peer component of LyTabs for the web2 viewer.
 * @version $Revision: -1M $
 * @author bsmichet, last modified by $Author: (local) $
 */
public class LyJQTabs extends LyJQContainer	implements
											LyGraphicalTabs,
											LySetTabInterface
{
	/** The selected generic tab component of this tabs component. */
	protected LyTab				_selectedTab;

	/** The tabs generic component. */
	protected LyTabs			_tabs;

	/**
	 * List of enabled tabs : for example if the tab at index i is enable, _enabledTab[i]=true.
	 */
	protected boolean[]			_enabledTab;

	public LyJQTabs(LyTabs tabs)
	{
		super(tabs);

		_tabs = tabs;

		_selectedTab = getSelectedTab();
	}

	public List<LyTab> getTabList()
	{

		List<LyTab> rowList = new ArrayList<LyTab>();
		for (int i = 0; i < _tabs.getTabCount(); i++)
		{
			rowList.add(_tabs.getTab(i));
		}
		return rowList;
	}

	/**
	 * get actually selected tab
	 * @return currently selected tab
	 */
	public LyTab getSelectedTab()
	{
		// Write the buffers for areas
		int i, nTabs = _tabs.getTabCount();
		LyTab tab;
		String selectedTab = _tabs.getSelectedTab();

		if ((selectedTab != null) && (selectedTab.length() == 0))
			selectedTab = null;

		selectedTab = translate(selectedTab);

		boolean selectFirst = (selectedTab == null);
		String label, id;

		for (i = 0; i < nTabs; i++)
		{
			tab = _tabs.getTab(i);
			label = translate(tab.getLabel());
			id = tab.getId();

			if ((tab.getLabel() == null) || (tab.getLabel().length() == 0))
				continue;

			if (((id != null) && id.equals(selectedTab))
					|| ((label != null) && label.equals(selectedTab)) || (selectFirst))
				return tab;
		}

		return ((nTabs > 0) ? _tabs.getTab(0) : null);
	}

	public void setEnabled(String tabId, boolean enabled)
	{
		// TODO Auto-generated method stub

	}

	public void setLabel(String tabId, String newLabel)
	{
		// TODO Auto-generated method stub

	}

	public void setSelectedTab(String selectedTab)
	{
		_viewManager.addToReloadComponents(_tabs);
	}

	/** reload the whole component if tab is added **/
	public void addTab(LyTab tab, int pos)
	{
		_viewManager.addToReloadComponents(_tabs);

	}

	/** reload the whole tabs component when a tab is removeds **/
	public void removeTab(LyTab tab)
	{
		_viewManager.addToReloadComponents(_tabs);

	}

	public void writeHtml(LyWebPageWriter pw)
	{
		LyTemplatesUtilsBean	templateManager = _viewManager.getVeloTemplatesBean();
		Map<String, Object>		params = new HashMap<String, Object>();

		params.put("tabs", _tabs);

		String	result = templateManager.mergeTemplate("tabs/lyTabsTemplate.vm", params);

		pw.append(result);

	}

	@Override
	public String getReloadScript()
	{
		// TODO Auto-generated method stub
		return null;
	}

}