package leon.view.web.jquery.component.tree;

import java.util.HashMap;
import java.util.Map;

import leon.view.LyTree;
import leon.view.LyTreeNode;
import leon.view.graphic.LyGraphicalTree;
import leon.view.setinterface.LySetVisibleInterface;
import leon.view.web.*;
import leon.view.web.jquery.common.TemplateUtils;
import leon.view.web.jquery.component.panel.LyJQPanel;
import leon.view.web.jquery.controller.LyTemplatesUtilsBean;

/**
 * LyTree JQuery internal view
 * @author atalbi
 */
public class LyJQTree extends LyJQPanel	implements
										LyGraphicalTree,
										LySetVisibleInterface
{

	/** Indicates whether the root node must be shown or not. */
	protected boolean	_hideRoot;

	/** The tree generic component. */
	protected LyTree	_tree;

	public LyJQTree(LyTree tree)
	{
		super(tree);
		_tree = tree;
		_hideRoot = false;
	}

	/**
	 * Indicates whether the root node must be shown or not.
	 * @param hideRoot true if root node must be hidden, false otherwise.
	 */
	public void setHideRoot(boolean hideRoot)
	{
		_hideRoot = hideRoot;
	}

	/**
	 * Indicates whether the root node must be shown or not.
	 * @return true if root node must be shown, false otherwise.
	 */
	public boolean isRootVisible()
	{
		return !_hideRoot;
	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.setinterface.LySetVisibleInterface#setVisible(boolean)
	 */
	public void setVisible(boolean status)
	{
		// TODO Auto-generated method stub

	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.graphic.LyGraphicalTree#setActiveNode(java.lang.String)
	 */
	public void setActiveNode(String activeNode)
	{
		// TODO Auto-generated method stub

	}

	/**
	 * (non-Javadoc)
	 * @see leon.view.graphic.LyGraphicalTree#setTreeNode(leon.view.LyTreeNode)
	 */
	public void setTreeNode(LyTreeNode treeNode)
	{
		if (treeNode == null)
		{
			LyTemplatesUtilsBean templateManager = _viewManager.getVeloTemplatesBean();
			Map<String, Object> params = new HashMap<String, Object>();
			params.put("treeId", getId());
			String removeNodeScript = templateManager.mergeTemplate(
					"ajax/tree/removeParentTreeNode.vm", params);
			_viewManager.addToUpdateScript(removeNodeScript);
			params = null;
			removeNodeScript = null;
		}
		else
			_viewManager.addToReloadComponents(_tree);

	}

	@Override
	public String getReloadScript()
	{
		LyTemplatesUtilsBean templateManager = _viewManager.getVeloTemplatesBean();
		Map<String, Object> params = new HashMap<String, Object>();
		params.put("lyTree", this);
				
		String data = templateManager.mergeTemplate("tree/lyTreeTemplate.vm", params);
		data = TemplateUtils.getFormattedJs(data);
		params = new HashMap<String, Object>();
		params.put("content", data);
		params.put("componentId", getId());
		return templateManager
				.mergeTemplate("ajax/replaceWith.vm", params);
	}

	public boolean isTree()
	{
		return true;
	}

	public LyTree getTree()
	{
		return _tree;
	}
	
	@Override
	public void writeHtml(LyWebPageWriter pw)
	{
		LyTemplatesUtilsBean	templateManager = _viewManager.getVeloTemplatesBean();
		Map<String, Object>		params = new HashMap<String, Object>();
		
		params.put("lyTree", _tree);
		
		String	result = templateManager.mergeTemplate("tree/lyTreeTemplate.vm", params);
		
		pw.append(result);
	}

}