/* 
 * Lyria-W4 - afficheur_web2
 * LyExceptionController.java
 * Copyright (c) 2000-2009, Lyria-W4
 * All rights reserved.
 */
package leon.view.web.jquery.controller;

import java.io.*;

import javax.servlet.http.*;

import leon.view.web.jquery.*;
import leon.view.web.jquery.common.*;

import org.springframework.web.servlet.*;
import org.springframework.web.servlet.handler.*;

/**
 * Type : leon.view.web.web2.exception.LyExceptionController
 * @version $Revision: 12M $
 * @author ychaari, last modified by $Author: (local) $
 */
public class LyExceptionController extends SimpleMappingExceptionResolver
{
	protected static String	EXCEPTION_MSG_PARAM			= "exceptionMessage";
	
	protected static String	EXCEPTION_CAUSE_PARAM		= "exceptionCause";
	
	protected static final String EXCEPTION_TEMPLATE    = "exception/lyExceptionDialogTemplate";
	
	protected static final String AJAX_PARAM    		= "forAjaxCall";


	/**
	 * Getting exception text and calls LyExceptionDialog template
	 */
	public ModelAndView resolveException(HttpServletRequest req, HttpServletResponse res,
			Object handler, Exception ex)
	{
		String	exceptionMessage, exceptionDetails;
		Object	error = req.getAttribute("leonardi.exception");
		
		if (error != null)
		{
			exceptionMessage = "An error has occured";
			exceptionDetails = error.toString();
		}
		else
		{
			ByteArrayOutputStream	byteArrayOutputStream = new ByteArrayOutputStream();
			PrintStream				printStream = new PrintStream(byteArrayOutputStream);
			
			ex.printStackTrace(printStream);
			printStream.close();
			exceptionMessage = ex.toString();
			exceptionDetails = byteArrayOutputStream.toString();
		}
	
		String isAjaxMode = req.getParameter(LyJQConstants.AJAX_MODE);
		String tableId = req.getParameter("_tableId");

		ModelAndView	modelAndView = getModelAndView(EXCEPTION_TEMPLATE, ex, req);
		
		// In ajax mode we generate pure Javascript (without <script> tags), except for the case
		// of a table loading whose response will be directly inserted in the HTML body.
		if (((tableId == null) || (tableId.length() == 0))
				&& (isAjaxMode != null) && isAjaxMode.equals("true"))
			modelAndView.addObject(AJAX_PARAM, true);

		modelAndView.addObject(EXCEPTION_CAUSE_PARAM, TemplateUtils.getFormattedJs(exceptionMessage));
		modelAndView.addObject(EXCEPTION_MSG_PARAM, TemplateUtils.getFormattedJs(exceptionDetails));

		return modelAndView;
	}
}