package leon.view.web.jquery.controller;

import javax.servlet.http.*;

import leon.app.*;
import leon.view.web.*;
import leon.view.web.jquery.*;

import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.*;

/**
 * Audit page controller
 * @author atalbi
 */
public class LyJQAuditController extends LyJQController
{
	public LyJQAuditController()
	{
		super();
	}

	@SuppressWarnings("deprecation")
	@RequestMapping("/audit")
	public ModelAndView handleRequest(HttpServletRequest request, HttpServletResponse response)
			throws Exception
	{
		if (checkSession(request))
		{
			LySession		session = getSession();
			LyJQViewManager	viewManager = getViewManager(session);

			beginHandleRequest(viewManager);

			getApplicationId(request);

			LyApplication application = LyApplication.getApplication(_applicationId);
			
			if (application == null)
				application = LyJQController.createApplication(_applicationId, _applicationContext.getConfigFile(), request.getRealPath("/"));

			request.setAttribute(LyWebConstants.RA_LY_APP_NAME, _applicationId);
			request.setAttribute("viewManager", viewManager);

			// forward to audit page
			String auditPage = application.getEnvironment().getUrl("LY_JQUERY_AUDIT_PAGE");

			System.gc();
			auditPage = getContextRelativePath(request, auditPage);
			request.getSession().getServletContext().getRequestDispatcher(auditPage).forward(request, response);
			endHandleRequest(viewManager);
		}
		else
			return redirectToPage(request, null, LyJQConstants.PATH_ACTION_HOME);
		
		return null;
	}
}
