/**
 * 
 */
package leon.view.web.jquery.controller;

import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

import leon.app.LySession;
import leon.control.LyController;
import leon.view.LyChart;
import leon.view.web.LyWebConstants;
import leon.view.web.jquery.LyJQViewManager;
import leon.view.web.jquery.common.TemplateUtils;
import leon.view.web.jquery.component.chart.LyJQChart;

/**
 * @author slachihe
 * 
 *	LyJQChartController
 */
public class LyJQChartController extends LyJQController
{
	@RequestMapping("/chart.htm")
	public ModelAndView handleRequest(HttpServletRequest request, HttpServletResponse response)
			throws Exception
	{
		if (checkSession(request))
		{
			LySession				session = getSession();
			LyJQViewManager			viewManager = getViewManager(session);
			String					chartId = getParameter(request, "_chartId");
			String					controllerId = getParameter(request, LyWebConstants.CONTROLLER);
			LyController			controller = session.getController(controllerId);
			LyTemplatesUtilsBean	templateManager = viewManager.getVeloTemplatesBean();
			
			if (controller == null)
				return null;
			
			try
			{
				session.getSoftLock();

				LyChart					lyChart = (LyChart)controller.getComponent().getComponent(chartId);
				LyJQChart				jqChart = (LyJQChart)lyChart.getInternalView();
				String					charthtml = jqChart.generateChartImage();
				
				charthtml = TemplateUtils.getFormattedJs(charthtml);
				
				Map<String, Object>		params = new HashMap<String, Object>();
				
				params.put("content", charthtml);
				params.put("componentId", jqChart.getId());
				viewManager.addToUpdateScript(templateManager.mergeTemplate("ajax/replaceWith.vm", params));			
				writeUpdateScripts(response, viewManager);
			}
			finally
			{
				session.releaseSoftLock();
			}
		}

		return null;
	}
}
