/* 
 * Lyria-W4 - afficheur_web2
 * LyJQLoginController.java
 * Copyright (c) 2000-2009, Lyria-W4
 * All rights reserved.
 */
package leon.view.web.jquery.controller;

import javax.servlet.http.*;

import leon.app.*;
import leon.control.*;
import leon.misc.*;
import leon.view.event.*;
import leon.view.web.*;
import leon.view.web.jquery.*;

import org.springframework.stereotype.*;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.*;

/**
 * LyJQLoginController
 * @version $Revision$
 * @author slachiheb, last modified by $Author$
 */
@Controller
public class LyJQLoginController extends LyJQController
{

	public final static String	MSG_PARAM					= "msg";

	public final static String	DIALOG_TITLE_PARAM			= "dialogTitle";

	public final static String	VELO_TEMPLATES_UTILS_BEAN	= "veloTemplates";

	public final static String	SHOW_DIALOG_TEMPLATE		= "ajax/showDialogBox.vm";

	/**
	 * handleRequest
	 * @see org.springframework.web.servlet.mvc.Controller#handleRequest(javax.servlet.http.HttpServletRequest,
	 * javax.servlet.http.HttpServletResponse)
	 */
	@RequestMapping("/login")
	public ModelAndView handleRequest(HttpServletRequest request, HttpServletResponse response)
			throws Exception
	{
		LyJQViewManager	viewManager = null;

		if (checkSession(request))
		{
			LySession	session = getSession();

			if (!checkSessionValidity(session))
			{
				endHandleRequest(viewManager);

				return redirectToPage(request, null, LyJQConstants.PATH_ACTION_HOME);
			}
			
			// if session is not valid
			LyEnvironment	environment = getEnvironment();
			
			viewManager = getViewManager(session);
			LyWebViewManager	sessionViewManager = (LyWebViewManager)session.getViewManager();
			
			if (viewManager == null)
			{
				endHandleRequest(viewManager);
				session.close();
				return null;
			}

			try
			{
				session.getSoftLock();

				/** Get some request parameters **/
				String source = getParameter(request, LyWebConstants.SOURCE);
				String value = getParameter(request, LyWebConstants.VALUE);
				String controller = getParameter(request, LyWebConstants.CONTROLLER);
	
				// Manage null controller
				if ((controller == null) || (session.getController(controller) == null))
				{
					 LyController rootController = session.getController(0);
					 
					 if (rootController!=null)
						 controller = rootController.getId();
				}
				
				/** Transmit the action demand **/
				if (source != null)
				{
					LyActionDemand demand = new LyActionDemand(LyActionDemand.TYPE_ACTION, source);
	
					demand.setValue(value);
					demand.setParameterValues(new LyWebParameterValues(request, environment.getString()));
					sessionViewManager.processDemand(controller, demand);
				}
	
				session = getSession();
				
				if (!session.isValid())
				{
					String	errorMessage = viewManager.getMessage();
	
					if (errorMessage != null)
						writeUpdateScripts(response, viewManager);
					else
					{
						endHandleRequest(viewManager);
	
						return redirectToPage(request, viewManager, LyJQConstants.PATH_ACTION_HOME);
					}
					
					endHandleRequest(viewManager);
	
					return null;
				}
	
				viewManager.getUpdateScripts(true);
				endHandleRequest(viewManager);
			}
			finally
			{
				session.releaseSoftLock();
			}
		}
		else
		{
			return redirectToPage(request, viewManager, LyJQConstants.PATH_ACTION_HOME);
		}
		
		return redirectToPage(request, viewManager, LyJQConstants.PATH_ACTION_HOME);
	}

	@Override
	public LyDemand getDemand(HttpServletRequest request, LyEnvironment environment)
	{
		return null;
	}
}