package leon.view.web.jquery.controller;

import java.io.*;
import java.util.*;

import javax.servlet.http.*;

import leon.app.*;
import leon.control.*;
import leon.misc.*;
import leon.view.*;
import leon.view.web.jquery.*;
import leon.view.web.jquery.component.form.field.text.*;

import org.springframework.stereotype.*;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.*;

@Controller
public class LyJQRichTextController extends LyJQController
{
	@RequestMapping("/richtext.htm")
	public ModelAndView handleRequest(HttpServletRequest request, HttpServletResponse response)
			throws Exception
	{
		if (checkSession(request))
		{
			LySession		session = getSession();
			LyJQViewManager	viewManager = getViewManager(session);
			String			textId = getParameter(request, "textId");
			String			textName = getParameter(request, "textName");
			String			textWidth = getParameter(request, "textWidth");
			String			textHeight = getParameter(request, "textHeight");
			String			controllerId = getParameter(request, "controllerId");
			LyController	controller = session.getController(controllerId);
			
			if (controller == null)
				return null;
			
			LyFormField		formField = (LyFormField)controller.getComponent().getComponent(textName);
			LyText			text = (LyText)formField.getFieldItem();
			LyJQText		jqText = (LyJQText)text.getInternalView();
			StringBuffer	buffer = new StringBuffer();
			String			formattedLabel = jqText.getFormattedRichText(text.getLabel());
			
			buffer.append("<html>");
			buffer.append("<head>");
			buffer.append("<script type='text/javascript' src='./leon/scripts/jquery/jquery/jquery.min.js'></script>");
			buffer.append("<script type='text/javascript' src='./leon/scripts/jquery/jquery/ajax/eventsUtils.js'></script>");
			buffer.append("<script type='text/javascript' src='./leon/scripts/LyUtilsScript.js'></script>");
			buffer.append("<script type='text/javascript' src='./leon/scripts/jquery/LyJQUtils.js'></script>");
			buffer.append("<script type='text/javascript' src='./leon/scripts/jquery/jquery/form/text/ckeditor/ckeditor.js'></script>");
			buffer.append("</head> ");
			buffer.append("<body style='overflow:hidden;margin:0;padding:0;background:transparent;border:0px;'>\n");
			buffer.append("<div id='container_" + textId + "' class='text_editor_container'>\n");
			buffer.append("<div id='" + textId + "' name='" + textName + "' style='visibility:hidden;width:" + textWidth +
					"px;height:" + textHeight + "px;' class='cke_textArea'>");
			
			if (formattedLabel != null)
				buffer.append(formattedLabel);
			
			buffer.append("</div>\n");
			buffer.append("</div>\n");
			buffer.append("<script type='text/javascript'>jQuery(document).ready(function() {\n");
			
			LyTemplatesUtilsBean	templateManager = viewManager.getVeloTemplatesBean();
			Map<String, Object>		params = new HashMap<String, Object>();

			params.put("textIdCode", textId);
			params.put("language", session.getEnvironment().getLocale().getLanguage());
			params.put("textWidth", textWidth);
			params.put("textHeight", (Integer.parseInt(textHeight) - 30));
			
			String richTextConfig = templateManager.mergeTemplate("form/field/text/lyRichTextConfigTemplate.vm", params);
			
			buffer.append(richTextConfig);
			buffer.append("CKEDITOR.instances['" + textId + "'].on( 'blur', function() {\n");
			buffer.append("    onChangeField('" + controllerId + "', this.getData() , '" +
					jqText.getJSWithoutTranslateString(formField.getInternalId()) + "',null,true);\n");
			buffer.append("});\n");
			
			// Remove border around CKEditor, decrease margin in edition area and show the iframe
			buffer.append("CKEDITOR.instances['" + textId + "'].on('instanceReady', function() {\n");
			buffer.append("    jQuery('#container_" + textId + " span:first').css('border','none').css('padding','0px');");
			buffer.append("    jQuery('#container_" + textId + " span:first').find('.cke_contents').find('iframe').contents().find('.cke_show_borders').css('margin','3px');");
			
			// Resize frame when opening toolbar to be sure there is enough place
			if (Integer.parseInt(textHeight) <= 365)
			{
				buffer.append("    jQuery('#container_" + textId + " span:first').find('.cke_toolbox_collapser').click(function() {");
				buffer.append("            var isMin = jQuery(this).hasClass('cke_toolbox_collapser_min');resizeCKEditorFrame('" + textId + "','" + textHeight + "',isMin);");
				buffer.append("        });");
			}
			
			buffer.append("    getLeonardiTopFrame().document.getElementById('ckeditor_frame_" + textId + "').style.visibility = 'visible';");
			buffer.append("    getLeonardiTopFrame().CheckCKEditorFocus('" + textId + "');");
			buffer.append("});\n");
			
			buffer.append("});</script>\n");
			buffer.append("</body>\n");
			buffer.append("</html>\n");

			response.setContentType("text/html; charset=" + LyString.DEFAULT_CHARSET);
			
			PrintWriter	pw = response.getWriter();

			pw.print(buffer);
			pw.close();
			getViewManager(session).setPrintMode(false);
			response.setHeader("Content-Length", buffer.length() + "");
		}

		return null;
	}
}
