package leon.view.web.jquery.controller;

import java.util.*;

import javax.servlet.http.*;

import leon.misc.*;
import leon.view.event.*;
import leon.view.web.*;

import org.springframework.stereotype.*;

/**
 * Selection event spring controller
 * @author atalbi
 */

@Controller
public class LyJQSelectionController extends LyJQController
{
	public LyJQSelectionController()
	{
		super();
	}

	/**
	 * @see leon.view.web.jquery.controller.LyJQController#getDemand(javax.servlet.http.HttpServletRequest,
	 * leon.misc.LyEnvironment)
	 */
	public LyDemand getDemand(HttpServletRequest request, LyEnvironment environment)
	{
		// prepare a selection demand
		LySelectionDemand selectionDemand = null;

		// get the source component
		String source = getParameter(request, LyWebConstants.SOURCE);

		source = ((source == null) ? "" : source.intern());

		// get the extend parameter
		String extend = getParameter(request, LyWebConstants.EXTEND);
		String value = getParameter(request, LyWebConstants.VALUE);

		// Use the same separator as used in the getSelectionIds() function in
		// LyUtilsScript.js
		Vector<String> selectionIds = new Vector<String>();
		String[] ids = LyString.stringToList(value, "__|__");

		if ((ids != null) && (ids.length > 0))
		{
			for (int i = 0; i < ids.length; i++)
			{
				if ((ids[i] != null) && (ids[i].length() > 0))
					selectionIds.addElement(ids[i]);
			}
		}

		int i, nSelections = selectionIds.size();

		// create the demand depending on the source component
		if (LyWebConstants.SELECT_ITEM == source || LyWebConstants.UNSELECT_ITEM.equals(source))
		{
			if (LyWebConstants.SELECT_ITEM == source)
				selectionDemand = new LySelectionDemand(LySelectionDemand.TYPE_SELECT, null);
			else
				selectionDemand = new LySelectionDemand(LySelectionDemand.TYPE_UNSELECT, null);

			// set the extend property
			selectionDemand.setExtend("true".equals(extend));

			// set the selected items
			for (i = 0; i < nSelections; i++)
				selectionDemand.addSelectionId(selectionIds.elementAt(i));
		}
		else if (LyWebConstants.SELECT_ALL.equals(source))
			selectionDemand = new LySelectionDemand(LySelectionDemand.TYPE_SELECT_ALL, null);
		else if (LyWebConstants.UNSELECT_ALL.equals(source))
			selectionDemand = new LySelectionDemand(LySelectionDemand.TYPE_UNSELECT_ALL, null);

		String positionX = getParameter(request, LyWebConstants.POSITION_X);
		String positionY = getParameter(request, LyWebConstants.POSITION_Y);
		
		if ((positionX != null) && (positionX.trim().length() > 0))
			selectionDemand.setAttribute("x", positionX);
		
		if ((positionY != null) && (positionY.trim().length() > 0))
			selectionDemand.setAttribute("y", positionY);

		return selectionDemand;
	} // end method getDemand

}
