package leon.view.web.jquery.controller;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import leon.app.LySession;
import leon.control.LyController;
import leon.control.LyViewController;
import leon.misc.LyEnvironment;
import leon.misc.LyString;
import leon.view.LyComponent;
import leon.view.event.LyDemand;
import leon.view.web.LyWebConstants;
import leon.view.web.LyWebPageWriter;
import leon.view.web.jquery.LyJQConstants;
import leon.view.web.jquery.LyJQViewManager;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.servlet.ModelAndView;

@Controller
public class LyJQTableController extends LyJQController
{
	@Override
	public LyDemand getDemand(HttpServletRequest request, LyEnvironment environment)
	{
		return null;
	}
	
	@RequestMapping("/table.htm")
	public ModelAndView handleRequest(HttpServletRequest request, HttpServletResponse response)
			throws Exception
	{
		if (checkSession(request))
		{
			LySession		session = getSession();
			LyJQViewManager	viewManager = getViewManager(session);
			String			requestRootUrl = getRootUrlFromRequest(request);
			
			try
			{
				session.getSoftLock();

				response.setContentType("text/plain;charset=" + LyString.DEFAULT_CHARSET);
				response.setHeader("Content-Type", "text/plain;charset=" + LyString.DEFAULT_CHARSET);
				
				if (!checkSessionValidity(session))
					response.getWriter().write(requestRootUrl + "/" + LyJQConstants.PATH_ACTION_HOME);
		
				beginHandleRequest(viewManager);
				
				String componentId = getParameter(request, "_tableId");
				String controllerId = getParameter(request, LyWebConstants.CONTROLLER);
				
				if ((controllerId != null) && (controllerId.length() > 0))
				{	
					LyController lyController = session.getController(controllerId);		
					
					if (lyController!=null)
					{
						LyComponent component = lyController.getComponent();
						
						if ((component != null) && (componentId != null) && (componentId.length() > 0))
						{
							LyComponent tableComponent = component.getComponent(componentId);
			
							if (tableComponent == null)
							{
								LyViewController lastView = session.getLastViewController(0);	
			
								if (lastView != null)
								{
									component = lastView.getComponent();
			
									if (component != null)
										tableComponent = component.getComponent(componentId);
								}			
							}
							
							ModelAndView modelAndView = new ModelAndView("table/lyTableTemplate");
							modelAndView.addObject("table",tableComponent);
							endHandleRequest(viewManager);
	
							return modelAndView;
						}
					}
				}
				else			
				{			
					LyViewController lastView = session.getLastViewController(0);	
	
					if (lastView != null)
					{
						LyComponent component = lastView.getComponent();
						
						if (component != null)
						{
							LyComponent		tableComponent = component.getComponent(componentId);
							ModelAndView	modelAndView = new ModelAndView("table/lyTableTemplate");
							
							modelAndView.addObject("table",tableComponent);				
							endHandleRequest(viewManager);
	
							return modelAndView;
						}
					}
				}
				
				writeUpdateScripts(response, viewManager);
				endHandleRequest(viewManager);
			}
			finally
			{
				session.releaseSoftLock();
			}
		}
		
		return null;
	}
	
	/**
	 * Searches the controller concerned by the printing.
	 *
	 * @param  request     Current HTTP request that contains information about the controller.
	 * @param  session     Current Leonardi session.
	 * @param  viewManager Current view manager.
	 * @return the controller involved in the request.
	 */
	protected LyController getController(HttpServletRequest request, LySession session,
		LyJQViewManager viewManager)
	{
		LyController controller = null;
		String		 pageId = getParameter(request, LyWebConstants.PAGE);
		String		 controllerId = getParameter(request, LyWebConstants.CONTROLLER);

		if (pageId != null)
		{
			LyWebPageWriter pw = viewManager.getPageWriter(pageId);

			if (pw != null)
			{
				LyComponent component = pw.getViewComponent();

				controllerId = component.getRootController();
			}
		}

		if (controllerId != null)
			controller = session.getController(controllerId);

		return controller;
	}
}
