package leon.view.web.jquery.controller;

import javax.servlet.http.*;

import leon.app.*;
import leon.misc.*;
import leon.view.event.*;
import leon.view.web.jquery.*;

import org.springframework.stereotype.*;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.servlet.*;

@Controller
public class LyJQUpFrameController extends LyJQController
{
	@Override
	public LyDemand getDemand(HttpServletRequest request, LyEnvironment environment)
	{
		return null;
	}
	
	@RequestMapping("/upFrame.htm")
	public ModelAndView handleRequest(HttpServletRequest request, HttpServletResponse response)
			throws Exception
	{
		if (checkSession(request))
		{
			// Get the LY_UP_PAGE ressource
			LySession		session = getSession();
			LyJQViewManager	viewManager = getViewManager(session);
			LyEnvironment	environment = getEnvironment();	
			String			upPage = environment.getUrl("LY_JQUERY_UP_PAGE");
			
			try
			{
				session.getSoftLock();

				if ((upPage != null) && !upPage.equals("LY_JQUERY_UP_PAGE"))
				{
					// get the path relative to the context
					upPage = getContextRelativePath(request, upPage);
					setRequestAttributes(request, session);
					request.getSession(false).getServletContext().getRequestDispatcher(upPage).forward(request, response);
					endHandleRequest(viewManager);
				}
			}
			finally
			{
				session.releaseSoftLock();
			}
		}
		else
			return redirectToPage(request, null, LyJQConstants.PATH_ACTION_HOME);

		return null;
	}
}
