<%@ page import="java.util.*,leon.app.*,leon.data.*,leon.info.*,leon.control.*,leon.misc.*,leon.view.*,leon.view.web.*,leon.view.web.jquery.*"%>

<%!
	public String getDisplayTime(LyDataSession session)
	{
		long time = session.getCreationTime();

		return LyDateFormatter.format(new Date(time), "MM/dd HH:mm:ss");
	}

	public String getObjects(LyApplication application, LyClassInfo classInfo)
	{
		LyObjectSource source = application.getObjectSource(classInfo);
		LyFilter filter = new LyFilter();
		LyResponse response = source.getObjects(null, null, filter, -1, true, null);
		LyObjectList objects = response.getObjects();

		if (objects.getSize() == 0)
			return null;

		return "Class '" + application.getEnvironment().translate(classInfo.getName()) + "': " + objects.getSize();
	}
%>

<%

	System.gc();

	String			appName = (String)request.getAttribute(LyWebConstants.RA_LY_APP_NAME);
	Properties		properties = System.getProperties();
	String[]		propertyNames = new String[] {"java.runtime.name", "java.vm.version"};
	Vector<LyApplication>	applications = LyApplication.getApplications();
	LyJQViewManager		viewManager = (LyJQViewManager)request.getAttribute("viewManager");
	LyEnvironment		environment = viewManager.getEnvironment();
	String  		skin = environment.getSkin();
	String			cookieTheme = viewManager.getCookieTheme(request);
	String			cssFile = environment.getUrl("LY_JQUERY_CSS_FILE");
	
	if (cookieTheme != null)
		skin = cookieTheme;
%>

<html>
<head>
	<script type="text/javascript" src="./leon/scripts/jquery/jquery/jquery.min.js"></script> 
	<script type="text/javascript" src="./leon/scripts/jquery/jquery/ui/jquery-ui.min.js"></script> 
	<link type="text/css" rel="stylesheet" href="<%=cssFile%>"/>
	<link rel="stylesheet" type="text/css" href="./leon/css/jquery-ui/themes/<%=skin%>/jquery-ui.css">
	<link type="text/css" rel="stylesheet" href="http://jqueryui.com/themes/base/ui.all.css" />
	<link rel="stylesheet" type="text/css" href="./leon/scripts/jquery/jquery/panel/mbContainer/css/mbContainer.css"></link>

	<script type="text/javascript" src="./leon/scripts/jquery/jquery/panel/mbContainer/inc/jquery.metadata.js"></script>
	<script type="text/javascript" src="./leon/scripts/jquery/jquery/panel/mbContainer/inc/mbContainer.js"></script>
	
<title>Audit page</title>

	<script>

		function ShowDiv(divId)
		{
			var div = document.getElementById(divId);

			div.style.display = (div.style.display == "none" ? "block" : "none");
		}
		
		$().ready(function(){
			 $(".jtable tr").each(function(){
			 
			  $(this).addClass("ui-state-default");
			 
			  });
			 $(".jtable td").each(function(){
			  $(this).addClass("ui-widget-content");
			  });
			 $(".jtable tr").hover(
			     function()
			     {
			      $(this).children("td").addClass("ui-state-hover");
			     },
			     function()
			     {
			      $(this).children("td").removeClass("ui-state-hover");
			     }
			    );
			}); 

	</script>
</head>

<body class='ly-body'>

<div class="ui-layout-center ui-widget-content " style="height:100%;">

<div id="switcher"></div>

<table border='0' align='center' class="jtable" >

 <th class='ui-widget-header ui-corner-all' colspan='3' align='center' nowrap='yes'>
  	Audit for <%=appName%> application
 
 </th>


 <%
 	for (int i = 0; i < propertyNames.length; i++)
 	{
 %>
 <tr>
  <td>
  	<strong><%=propertyNames[i]%> :</strong>
  </td>
  <td class='lbl' align='right' nowrap='yes'>
  	<%=properties.get(propertyNames[i])%>
  </td>
  <td>
  	&nbsp;
  </td>
 </tr>
 <%
 	}
 %>

 <tr>
  <td height='20' colspan='3'>
  	&nbsp;
  </td>
 </tr>
 <tr>
  <td>
  	<strong>LyApplication instances :</strong>
  </td>
  <td class='lbl' align='right'>
  	<%=applications.size()%>
  </td>
  <td>
  	<a class='toolLabel' href="javascript:ShowDiv('applicationDetailDiv');">Detail</a>
  </td>
 </tr>
 <tr>
  <td colspan='3'>
  	<div id='applicationDetailDiv' style='display:none;'>

  		<table border='0' width="100%">
		 <%
			for (int i = 0; i < applications.size(); i++)
			{
		 %>
  			<tr>
  				<td class='lbl' width='30'><span class="ui-icon ui-icon-play"></span></td>
  				<td class='lbl' nowrap='yes'>
  					<%=(i + 1) + ". " + applications.elementAt(i).getId()%>, valid: <%=applications.elementAt(i).isValid()%>, sleeping: <%=applications.elementAt(i).isSleeping()%>
  				</td>
  			</tr>
		 <%
			}
		 %>
  		</table>

  	</div>
  </td>
 </tr>
 <tr>
  <td class='lblObl'>
  	LySession instances :
  </td>
  <td class='lbl' align='right'>
  	<%=LySession._nbSessions%>
  </td>
  <td>
  	<a class='toolLabel' href="javascript:ShowDiv('sessionDetailDiv');">Detail</a>
  </td>
 </tr>
 <tr>
  <td colspan='3'>
  	<div id='sessionDetailDiv' style='display:none;'>

  		<table border='0' width="100%">
		 <%
			for (int i = 0; i < applications.size(); i++)
			{
				LyApplication leonApplication = applications.elementAt(i);
				Vector<LyDataSession> sessions = leonApplication.getSessions();

				for (int j = 0; j < sessions.size(); j++)
				{
		 %>
  			<tr>
  				<td class='lbl' width='30'><span class="ui-icon ui-icon-play"></span></td>
  				<td class='lbl' nowrap='yes'>
  					<%=(j + 1)%>. user: <%=sessions.elementAt(j).getUser()%>, state: <%=sessions.elementAt(j).getState()%>, creation date: <%=getDisplayTime(sessions.elementAt(j))%>
  				</td>
  			</tr>
		 <%
				}
			}
		 %>
  		</table>

  	</div>

  </td>
 </tr>
 <tr>
  <td class='lblObl'>
  	LyObject instances :
  </td>
  <td class='lbl' align='right'>
  	<%=LyObject._nbObjects%>
  </td>
  <td>
  	<a class='toolLabel' href="javascript:ShowDiv('objectDetailDiv');">Detail</a>
  </td>
 </tr>
 <tr>
  <td colspan='3'>
  	<div id='objectDetailDiv' style='display:none;'>

  		<table border='0' width="100%">
		 <%
		    LyApplication leonApplication = null;
			for (int i = 0; i < applications.size(); i++)
			{
				leonApplication = applications.elementAt(i);
				
				LyInfoList<LyClassInfo> classes = leonApplication.getClassInfos();
				int count = 0;

				for (int j = 0; j < classes.getSize(); j++)
				{
					String objects = getObjects(leonApplication, classes.getInfo(j));

					if (objects != null)
					{
						count++;
		 %>
  			<tr>
  				<td class='lbl' width='30'><span class="ui-icon ui-icon-play"></span></td>
  				<td class='lbl' nowrap='yes'>
  					<%=count + ". " + objects%>
  				</td>
  			</tr>
		 <%
		 			}
				}
			}
		 %>
  		</table>

  	</div>
  </td>
 </tr>
 <tr>
  <td class='lblObl'>
  	LyController instances :
  </td>
  <td class='lbl' align='right'>
  	<%=LyController._nbControllers%>
  </td>
  <td>
  	&nbsp;
  </td>
 </tr>
 <tr>
  <td>
  </td>
  <td colspan='2'>
  </td>
 </tr>
 <tr>
  <td class='lblObl'>
  	LyView instances :
  </td>
  <td class='lbl' align='right'>
  	<%=LyView._nbViews%>
  </td>
  <td>
  	&nbsp;
  </td>
 </tr>
 <tr>
  <td>
  </td>
  <td colspan='2'>
  </td>
 </tr>
 <tr>
  <td class='lblObl'>
  	LyComponent instances :
  </td>
  <td class='lbl' align='right'>
  	<%=LyComponent._nbComponents%>
  </td>
  <td>
  	&nbsp;
  </td>
 </tr>
</table>

</div>


</body>
</html>
