<%@ page import="leon.app.*, leon.misc.*, java.util.*, leon.view.web.*, leon.view.web.jquery.*, leon.view.web.jquery.common.*"%>
<%
	// Current user session
	LySession		leonardiSession = (LySession)request.getAttribute(LyWebConstants.RA_LY_SESSION);
	LyEnvironment		environment = leonardiSession.getEnvironment();
	LyJQViewManager		viewManager = (LyJQViewManager)environment.getViewManager();
	boolean 		isRtlMode = viewManager.isRtlMode();
	String			targetCode = viewManager.getTargetCode();
	String			appName = environment.translate("LY_APPLICATION");
	String			title = environment.translate("LY_LOGIN_TITLE");
	String			favicon = environment.getImageUrl("LY_WEB_FAVICON");
	String			waitIcon = environment.getImageUrl("LY_JQUERY_ANIMATED_WAIT_ICON");
	String  		skin = environment.getSkin();
	LyApplication		leonardiApplication = leonardiSession.getApplication();
	String[][]		languages = leonardiApplication.getSupportedLanguages();
	String			cookieTheme = viewManager.getCookieTheme(request);
	String			cssFile = environment.getUrl("LY_JQUERY_CSS_FILE");
	String			loginFormContent = (String)request.getAttribute("loginFormContent");
	String			leftImage = environment.getImageUrl("LY_LOGIN_PAGE_LEFT_IMAGE");
	String			versionString = "?_version=" + environment.translate("LY_PRODUCT_VERSION");
	String			direction = "";
	
	if (isRtlMode)
		direction = "rtl";
	
	if (cookieTheme != null)
		skin = cookieTheme;
	
	appName = TemplateUtils.getConvertedHTML(appName);
%>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html dir="<%=direction%>" xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<title><%=title%> <%=appName%></title>
		<%
			if ((favicon != null) && (favicon.length() > 0))
			{
		%>
		<link rel="shortcut icon" href="<%=favicon%>"/>
		<%
			}
		%>
    	
		<script type="text/javascript">
		    var targetParam = '<%=targetCode%>';
		</script>

		<script type="text/javascript" src="./leon/scripts/jquery/jquery/jquery.min.js<%=versionString%>"></script> 
		<script type="text/javascript" src="./leon/scripts/jquery/jquery/ajax/eventsUtils.js<%=versionString%>"></script> 
		<script type="text/javascript" src="./leon/scripts/jquery/jquery/ui/jquery-ui.min.js<%=versionString%>"></script>
		<script type="text/javascript" src="./leon/scripts/jquery/LyJQUtils.js<%=versionString%>"></script>  
		<script type="text/javascript" src="./leon/scripts/jquery/jquery/ui.themeselect/ui.themeselect.js<%=versionString%>"></script>
		<script type="text/javascript" src="./leon/scripts/jquery/jquery/ajaxloader/jquery.ajaxloader.1.5.0.min.js<%=versionString%>"></script>
		<script type="text/javascript" src="./leon/scripts/jquery/jquery/glob.js<%=versionString%>"></script> 
		<script type="text/javascript" src="./leon/scripts/jquery/jquery/glob.de-DE.js<%=versionString%>"></script>  
		<script type="text/javascript" src="./leon/scripts/jquery/jquery/form/field/number/ui.spinner.js<%=versionString%>"></script>
		<link rel="stylesheet" type="text/css" href="<%=cssFile%>"/>
		<link rel="stylesheet" type="text/css" href="./leon/css/login/login-style.css" media="all"/> 
		<link rel="stylesheet" type="text/css" href="./leon/css/jquery-ui/themes/<%=skin%>/jquery-ui.css"/>
		<link rel="stylesheet" type="text/css" href="./leon/css/form/field/number/ui.spinner.css">
		
		<style>
		.tata-ajax-loader{z-index:999999999 !important;background-color:transparent !important;opacity: 1 !important;}
		</style>
		
		<script type="text/javascript">
		
		var addValidateOnEnter = function(event, ui) {
			if ($(event.target).find(':input').length > 0) {
				$(event.target).find(':input').each(function(index, elem) {
				
					if ( $(elem).not('button') && $(elem).not(':hidden') && !$(elem).attr('readonly') && !$(elem).attr('disabled')) {
						$(elem).focus();
						return false;
					}
				});
			}
			var validateButton = $(event.target).find('button.commands-button[onclick*="_validate"]');
			if (validateButton && validateButton.length == 1) {
				$(event.target).keyup(function(event) {
					if (event.keyCode == 13) {
						validateButton.click(function() {
							return false;							
						});
						validateButton.trigger('click');
					}
				});
			}
		};
		
	        $(document).ready(function() {
	        	setTimeout("showLoginForm()", 500);
		});
		
		function showLoginForm()
		{
			initLoader("<%=waitIcon%>");
			$("#loginform").dialog({
				width:'auto',
				show: "fade",
				closeOnEscape: false,
				draggable: false,
				resizable: false,
				position : 'center',
				open : addValidateOnEnter,
				autoOpen : false
			});

			if (jQuery.browser.msie)
			{
				if (jQuery.browser.version < 7.9999)
				{
					var $headerSel = $("#loginform").parent().find('.ui-dialog-titlebar:first');
					
					$headerSel .outerWidth($("#loginform").closest('.ui-dialog').width());
				}
			}

			$("#loginform").parent().removeClass("ui-widget");
			$("#loginform").parent().find(".ui-dialog-titlebar-close").remove();
			$("#loginform").dialog("open");
		}
		
		</script>
	</head>
	
	<body class='ly-body'>
	
	<div id='leftImageDiv' style='z-index:1000;position:absolute;top:20px;<%if(isRtlMode) {%>right<% } %><%if(!isRtlMode){%>left<% } %>:20px;'>
		<center><img id='leftImage' src='<%=leftImage%>' /></center>
	</div>
	<div id='themeselector' style='display:none;'></div>
	<div id="cont" style="visibility:hidden;">
		<div id="loginform" title='<%=appName%>'>
			<%=loginFormContent%>
			<script>initThemeRoller(false,"");</script>
		</div>
	</div>

	<div id="bg" class='ui-widget-header'>
		<div>
			<table cellspacing="0" cellpadding="0">
				<tr>
					<td><img src="./leon/css/images/login/bg.png" alt=""/> </td>
				</tr>
			</table>
		</div>
	</div>
	
	<div id="dialog" title="Basic dialog" hidden="true"></div>
	<div id="dialogsContainer"></div>


<%
if (environment.testResource("LY_WEB_PUSH_MODE") || environment.testEnv("LY_REPLAY"))
{
%>
	<iframe src='./leon/pages/push_page.jsp' name='push_frame' id='push_frame'
		style="position:absolute;top:0px;left:0px;width:1px;height:1px;visibility:hidden;"></iframe>
<%
}
%>

	<div style="position:absolute; top: 20px; <%if(isRtlMode) {%>left<% } %><%if(!isRtlMode){%>right<% } %>: 20px; z-index: 100;">										
<%
if ((languages != null) && (languages.length > 1))
{
	for (int i = 0; i < languages.length; i++)
	{
		String	flag = "";		
		if ("en".equals(languages[i][0]))
			flag = "LY_ENGLISH_FLAG";
		else if ("fr".equals(languages[i][0]))
			flag = "LY_FRENCH_FLAG";
		else if ("es".equals(languages[i][0]))
			flag = "LY_SPANISH_FLAG";
		else if ("ar".equals(languages[i][0]))
			flag = "LY_ARABIC_FLAG";
%>
		<span style='padding:10px;'><a href="<%=LyJQConstants.PATH_ACTION_HOME%>?_language=<%=languages[i][0]%>"><img border="0" title="<%=environment.translate(languages[i][1])%>" src="<%=environment.getImageUrl(flag)%>" /></a></span>
<%
	}
}
%>
	</div>

	</body>
</html>
