jQuery.bind = function(object, method) {
	var args = Array.prototype.slice.call(arguments, 2);
	return function() {
		var args2 = [ this ].concat(args, jQuery.makeArray(arguments));
		return method.apply(object, args2);
	};
};

jQuery.fn.delay = function(time, func) {
	return this.each(function() {
		setTimeout(func, time);
	});
};

jQuery.fn.extend( {
	$chain : [],
	chain : function(fn) {
		this.$chain.push(fn);
		return this;
	},
	callChain : function(context) {
		return (this.$chain.length) ? this.$chain.pop().apply(context,
				arguments) : false;
	},
	clearChain : function() {
		this.$chain.empty();
		return this;
	}
});

(function($) {

	ErrorDialog = {
		getOptions : function() {
			return {
				name : 'AlertBox',
				zIndex : 65555,
				onReturn : false,
				onReturnFunction : function(e) {
				},
				BoxStyles : {
					'width' : 500
				},
				OverlayStyles : {
					'backgroundColor' : '#000',
					'opacity' : 0.7
				},
				showDuration : 200,
				closeDuration : 100,
				moveDuration : 500,
				onCloseComplete : jQuery.bind(this, function() {
					this.options.onReturnFunction(this.options.onReturn);
				})
			};
		},

		initialize : function(options) {
			this.i = 0;
			this.options = jQuery.extend(this.getOptions(), options);
			jQuery('body')
					.append(
							'<div id="BoxOverlay"></div><div id="'
									+ this.options.name
									+ '-Box"><div id="'
									+ this.options.name
									+ '-InBox"><div id="'
									+ this.options.name
									+ '-BoxContent"><div id="'
									+ this.options.name
									+ '-BoxContenedor"></div></div><div id="detailsDivContainer"><div id="detailsDiv">'
									+ jQuery("#exceptionField").val()
									+ '</div></div></div></div>');

			jQuery('#detailsDiv').hide();

			this.Content = jQuery('#' + this.options.name + '-BoxContenedor');
			this.Contenedor = jQuery('#' + this.options.name + '-BoxContent');
			this.InBox = jQuery('#' + this.options.name + '-InBox');
			this.Box = jQuery('#' + this.options.name + '-Box');

			jQuery('#BoxOverlay').css( {
				position : 'absolute',
				top : 0,
				left : 0,
				opacity : this.options.OverlayStyles.opacity,
				backgroundColor : this.options.OverlayStyles.backgroundColor,
				'z-index' : this.options.zIndex,
				height : jQuery(document).height(),
				width : jQuery(document).width()
			}).hide();

			this.Box.css( {
				display : 'none',
				position : 'absolute',
				top : 0,
				left : 0,
				'z-index' : this.options.zIndex + 2,
				width : this.options.BoxStyles.width + 'px'
			});

//			this.preloadImages();

			jQuery(window).bind('resize', jQuery.bind(this, function() {
				if (this.options.display == 1) {
					jQuery('#BoxOverlay').css( {
						height : 0,
						width : 0
					});
					jQuery('#BoxOverlay').css( {
						height : jQuery(document).height(),
						width : jQuery(document).width()
					});
					this.replaceBox();
				}
			}));

			this.Box.bind('keydown', jQuery.bind(this, function(obj, event) {
				if (event.keyCode == 27) {
					this.options.onReturn = false;
					this.display(0);
				}
			}));

			jQuery(window).bind('scroll', jQuery.bind(this, function() {
				this.replaceBox();
			}));

		},

		replaceBox : function() {
			if (this.options.display == 1) {

				this.Box.stop();

				this.Box
						.animate(
								{
									left : ((jQuery(document).width() - this.options.BoxStyles.width) / 2),
									top : (jQuery(document).scrollTop() + (jQuery(window)
											.height() - this.Box.outerHeight()) / 2)
								}, {
									duration : this.options.moveDuration,
									easing : 'easeOutBack'
								});

				jQuery(this).delay(this.options.moveDuration,
						jQuery.bind(this, function() {
							jQuery('#BoxAlertBtnOk').focus();
							jQuery('#BoxPromptInput').focus();
							jQuery('#BoxConfirmBtnOk').focus();
						}));
			}
		},

		display : function(option) {
			if (this.options.display == 0 && option != 0 || option == 1) {

				if (!jQuery.support.maxHeight) { // IE6
					jQuery('embed, object, select').css( {
						'visibility' : 'hidden'
					});
				}

				this.togFlashObjects('hidden');

				this.options.display = 1;

				jQuery('#BoxOverlay').stop();
				jQuery('#BoxOverlay')
						.fadeIn(
								this.options.showDuration,
								$
										.bind(
												this,
												function() {
													this.Box
															.css( {
																display : 'block',
																left : ((jQuery(
																		document)
																		.width() - this.options.BoxStyles.width) / 2)
															});
													this.replaceBox();
												}));

			} else {

				this.Box.css( {
					display : 'none',
					top : 0
				});

				this.options.display = 0;

				jQuery(this).delay(500, jQuery.bind(this, this.queue));

				jQuery(this.Content).empty();
				this.Content.removeClass();

				if (this.i == 1) {
					jQuery('#BoxOverlay').stop();
					jQuery('#BoxOverlay').fadeOut(this.options.closeDuration,
							jQuery.bind(this, function() {
								jQuery('#BoxOverlay').hide();
								if (!jQuery.support.maxHeight) { // IE6
										jQuery('embed, object, select').css( {
											'visibility' : 'visible'
										});
									}

									this.togFlashObjects('visible');

									this.options.onCloseComplete.call();
								}));
				}
			}
		},

		messageBox : function(type, message, properties, input) {

			jQuery(this)
					.chain(
							function() {

								properties = jQuery.extend( {
									'textBoxBtnOk' : 'Ok',
									'textBoxBtnDetails' : 'Details >>',
									'textBoxBtnCancel' : 'Cancelar',
									'textBoxInputPrompt' : null,
									'password' : false,
									'onComplete' : function(e) {
									}
								}, properties || {});

								this.options.onReturnFunction = properties.onComplete;

								this.Content
										.append('<div id="' + this.options.name + '-Buttons"></div>');
								if (type == 'alert' || type == 'info'
										|| type == 'error') {
									jQuery('#' + this.options.name + '-Buttons')
											.append(
													'<input id="BoxAlertBtnOk" type="submit" />');

									jQuery('#BoxAlertBtnOk').val(
											properties.textBoxBtnOk).css( {
										'width' : 70
									});

									jQuery('#BoxAlertBtnOk').bind('click',
											jQuery.bind(this, function() {
												this.options.onReturn = true;
												this.display(0);
											}));

									jQuery('#' + this.options.name + '-Buttons')
											.append(
													'<input id="BoxAlertBtnDetails" type="submit" />');

									jQuery('#BoxAlertBtnDetails').val(
											properties.textBoxBtnDetails).css( {
										'width' : 70
									});

									jQuery("#BoxAlertBtnDetails").click(function() {
										if (jQuery("#detailsDiv").is(":hidden")) {
											jQuery("#detailsDiv").slideDown("slow");
										} else {
											jQuery("#detailsDiv").hide();
										}
									});

									if (type == 'alert') {
										clase = 'BoxAlert';
									} else if (type == 'error') {
										clase = 'BoxError';
									} else if (type == 'info') {
										clase = 'BoxInfo';
									}

									this.Content.addClass(clase).prepend(
											message);
									this.display(1);

								} else if (type == 'confirm') {

									jQuery('#' + this.options.name + '-Buttons')
											.append(
													'<input id="BoxConfirmBtnOk" type="submit" /> <input id="BoxConfirmBtnCancel" type="submit" />');
									jQuery('#BoxConfirmBtnOk').val(
											properties.textBoxBtnOk).css( {
										'width' : 70
									});
									jQuery('#BoxConfirmBtnCancel').val(
											properties.textBoxBtnCancel).css( {
										'width' : 70
									});

									jQuery('#BoxConfirmBtnOk').bind('click',
											jQuery.bind(this, function() {
												this.options.onReturn = true;
												this.display(0);
											}));

									jQuery('#BoxConfirmBtnCancel').bind('click',
											jQuery.bind(this, function() {
												this.options.onReturn = false;
												this.display(0);
											}));

									this.Content.addClass('BoxConfirm')
											.prepend(message);
									this.display(1);
								} else if (type == 'prompt') {

									jQuery('#' + this.options.name + '-Buttons')
											.append(
													'<input id="BoxPromptBtnOk" type="submit" /> <input id="BoxPromptBtnCancel" type="submit" />');
									jQuery('#BoxPromptBtnOk').val(
											properties.textBoxBtnOk).css( {
										'width' : 70
									});
									jQuery('#BoxPromptBtnCancel').val(
											properties.textBoxBtnCancel).css( {
										'width' : 70
									});

									type = properties.password ? 'password'
											: 'text';

									this.Content
											.prepend('<input id="BoxPromptInput" type="' + type + '" />');
									jQuery('#BoxPromptInput').val(properties.input);
									jQuery('#BoxPromptInput').css( {
										'width' : 250
									});

									jQuery('#BoxPromptBtnOk').bind(
											'click',
											jQuery.bind(this, function() {
												this.options.onReturn = jQuery(
														'#BoxPromptInput')
														.val();
												this.display(0);
											}));

									jQuery('#BoxPromptBtnCancel').bind('click',
											jQuery.bind(this, function() {
												this.options.onReturn = false;
												this.display(0);
											}));

									this.Content.addClass('BoxPrompt').prepend(
											message + '<br />');
									this.display(1);
								} else {
									this.options.onReturn = false;
									this.display(0);
								}

							});

			this.i++;

			if (this.i == 1) {
				jQuery(this).callChain(this);
			}
		},

		queue : function() {
			this.i--;
			jQuery(this).callChain(this);
		},

		chk : function(obj) {
			return !!(obj || obj === 0);
		},

		togFlashObjects : function(state) {
			var hideobj = new Array("embed", "iframe", "object");
			for (y = 0; y < hideobj.length; y++) {
				var objs = document.getElementsByTagName(hideobj[y]);
				for (i = 0; i < objs.length; i++) {
					objs[i].style.visibility = state;
				}
			}
		},

		preloadImages : function() {
			var img = new Array(2);
			img[0] = new Image();
			img[1] = new Image();
			img[2] = new Image();
			img[0].src = this.Box.css('background-image').replace(
					new RegExp("url\\('?([^']*)'?\\)", 'gi'), "$1");
			img[1].src = this.InBox.css('background-image').replace(
					new RegExp("url\\('?([^']*)'?\\)", 'gi'), "$1");
			img[2].src = this.Contenedor.css('background-image').replace(
					new RegExp("url\\('?([^']*)'?\\)", 'gi'), "$1");
		},

		/*
		 * Property: alert Shortcut for alert
		 *
		 * Argument: properties - see Options in messageBox
		 */
		alert : function(message, properties) {
			this.messageBox('alert', message, properties);
		},

		/*
		 * Property: info Shortcut for alert info
		 *
		 * Argument: properties - see Options in messageBox
		 */
		info : function(message, properties) {
			this.messageBox('info', message, properties);
		},

		/*
		 * Property: error Shortcut for alert error
		 *
		 * Argument: properties - see Options in messageBox
		 */
		error : function(message, properties) {
			this.messageBox('error', message, properties);
		},

		/*
		 * Property: confirm Shortcut for confirm
		 *
		 * Argument: properties - see Options in messageBox
		 */
		confirm : function(message, properties) {
			this.messageBox('confirm', message, properties);
		},

		/*
		 * Property: prompt Shortcut for prompt
		 *
		 * Argument: properties - see Options in messageBox
		 */
		prompt : function(message, input, properties) {
			this.messageBox('prompt', message, properties, input);
		}

	};

})(jQuery);