(function( $ ) {
		$.widget( "custom.dictionary", {
			options: {
			  	disabled: false,
			  	dictionaryId: ''
			},
			_create: function() {

				// Variables initialization
				var self = this,
					tree = this.element.hide();

				// Containers creation
				var container = this.container = jQuery( "<div id='idContainer' class='container'></div>" );

				// Containers attachment
				this.container.insertBefore( tree );

				// Components (input, button and ul) creation and manipulation
				var input = this.input = jQuery( "<input></input>" )
					.attr( "readonly", this.options.disabled )
					.attr( "id", "input_"+this.options.dictionaryId )
					.addClass( "" )
					.css( "width", "180px" )
					.css( "margin-right", "1px" )
					.appendTo(this.container);

				var button = this.button = jQuery( "<button type='button'>&nbsp;</button>" )
					.attr( "tabIndex", -1 )
					.attr( "disabled", this.options.disabled )
					.attr( "style", "width: 20px;height: 20px;" )
					.insertAfter( input )
					.button({
						icons: {
							primary: "ui-icon-triangle-1-s"
						},
						text: false
					})
					.removeClass( "ui-corner-all" )
					.addClass( "ui-button-icon" )
					.appendTo( this.container )
					.click(function() {
						// close if already visible
						if ( tree.is( ":visible" ) ) {
							tree.hide();
							return;
						} else {
							tree.addClass('ui-autocomplete ui-menu ui-widget-content ui-corner-all');
							tree.css("width", self.input.width());
							tree.css("max-width", self.input.width());
							tree.css("left", self.input.offset().left);
							tree.css("top", self.input.offset().top + self.input.outerHeight());
							tree.show();
							return;
						}
					});

			},

			// Component destruction
			destroy: function() {
				this.input.remove();
				this.button.remove();
				this.element.show();
				$.Widget.prototype.destroy.call( this );
			}
	});
})( jQuery );
