(function( $ ) {
	$.widget( "ui.combobox",{options : {
				disabled: false,
				disabledAuto: false,
				size: 10,
				appendTo: "body"
			},
		_create: function() {
			var self = this,
				select = this.element.hide(),
				selected = select.children( ":selected" ),
				firstTime = true,
				value = selected.val() ? selected.text() : "";
			var input = this.input = jQuery( "<input></input>" )
				.insertAfter( select )
				.val( value )
				.attr( "disabled", this.options.disabled)
				.attr( "readonly", this.options.disabledAuto)
				.attr( "size", this.options.size )
				.attr( "style", "height: 16px;" )
				.autocomplete({
					delay: 0,
					minLength: 0,
					appendTo: this.options.appendTo,
					source: function( request, response ) {
						var matcher = new RegExp( $.ui.autocomplete.escapeRegex(request.term), "i" );
						response( select.children( "option" ).map(function() {
							var text = jQuery( this ).text();
							if ( this.value && ( !request.term || matcher.test(text) ) )
								return {
									label: text.replace(
										new RegExp(
											"(?![^&;]+;)(?!<[^<>]*)(" +
											$.ui.autocomplete.escapeRegex(request.term) +
											")(?![^<>]*>)(?![^&;]+;)", "gi"
										), "<strong>$1</strong>" ),
									value: text,
									image: jQuery( this ).attr('image'),
									option: this
								};
						}) );
					},
					select: function( event, ui ) {
						ui.item.option.selected = true;
						onChangeField(select.attr('controller'), jQuery(ui.item.option).val(), select.attr('name'));
						self._trigger( "selected", event, {
							item: ui.item.option
						});
					},
					change: function( event, ui ) {
						if ( !ui.item ) {
							var matcher = new RegExp( "^" + $.ui.autocomplete.escapeRegex( jQuery(this).val() ) + "$", "i" ),
								valid = false;
							select.children( "option" ).each(function() {
								if ( jQuery( this ).text().match( matcher ) ) {
									this.selected = valid = true;
									return false;
								}
							});
							if ( !valid ) {
								// remove invalid value, as it didn't match anything
								jQuery( this ).val( "" );
								select.val( "" );
								input.data( "autocomplete" ).term = "";
								return false;
							}
						}
					}
				})
				.addClass( "ui-widget ui-widget-content ui-corner-left" );

			input.data( "autocomplete" )._renderItem = function( ul, item ) {
				var str = "<a>";
					if(item.image)
						str = str + '<img width="16" height="16" style="border: 0px none; position: relative; top: 4px; padding-right: 2px;" src="'
						+item.image+'">';
					str = str + item.label + "</a>";
					
				return jQuery( "<li></li>" )
					.data( "item.autocomplete", item )
					.append( str )
					.appendTo( ul );
			};

			this.button = jQuery( "<button type='button'>&nbsp;</button>" )
				.attr( "tabIndex", -1 )
				.attr( "title", "Show All Items" )
				.insertAfter( input )
				.button({
					icons: {
						primary: "ui-icon-triangle-1-s"
					},
					text: false,
					disabled : this.options.disabled
				})
				.removeClass( "ui-corner-all" )
				.addClass( "ui-corner-right ui-button-icon" )
				.attr( "style", "height: 20px; width: 20px;" )
				.click(function() {
					// close if already visible
					if ( input.autocomplete( "widget" ).is( ":visible" ) ) {
						input.autocomplete( "close" );
						return;
					}

					// pass empty string as value to search for, displaying all results
					input.autocomplete( "search", "" );
					input.focus();
					input.autocomplete( "widget" ).width(input.autocomplete( "widget" ).width() + 19);
				});
		},

		destroy: function() {
			this.input.remove();
			this.button.remove();
			this.element.show();
			$.Widget.prototype.destroy.call( this );
		}
	});
})( jQuery );