/*
 * jQuery kiketable.colsizable plugin
 * Version 1.1 (20-MAR-2009)
 * @requires jQuery v1.3.2 or later (http://jquery.com)
 * @requires jquery.event.drag-1.4.js (http://blog.threedubmedia.com/2008/08/eventspecialdrag.html)
 *
 * Examples at: http://www.ita.es/jquery/jquery.kiketable.colsizable.htm
 * Copyright (c) 2007-2009 Enrique MelÃƒÆ’Ã‚Â©ndez Estrada
 * Dual licensed under the MIT and GPL licenses:
 * http://www.opensource.org/licenses/mit-license.php
 * http://www.gnu.org/licenses/gpl.html
 *
 * Modified by bsmichet version 1.1.2 (06-FEV-2011)
 */
(function($){

	$.fn.kiketable_colsizable = function(o) {
		// default parameters, properties or settings
		o = $.extend({}, $.fn.kiketable_colsizable.defaults, o);
		o.dragProxy = (o.dragProxy === "line" ) ? false : true;
		this
			.filter("table:not(."+o.namespace+")") // only for "virgin" html table(s)
			.addClass(o.namespace)
			.each(function(index){
				o.renderTime = new Date().getTime();
				//
				// global variables
				//
				var oTable =	this,
					$Table =	jQuery(this),
					_Cols =		$Table.find("col:not(.noresize)");
					;
				var columnsSize = "";
				
				var kiketableThWidthStyle;
				
				_Cols.length && jQuery(o.dragCells,this)
					.each(function(index){
						if (!jQuery(this).hasClass('kiketable-th'))
							{
							jQuery(this).addClass('kiketable-th').each(function(){
								
								kiketableThWidthStyle='';
								if(jQuery(this).attr('index'))
								{
								kiketableThWidthStyle = parseInt($Table.find('col').eq(jQuery(this).attr('index'))[0].style.width.replace('px', ''));								
								kiketableThWidthStyle='width:'+kiketableThWidthStyle+'px;';	
								}								
								jQuery(this).wrapInner("<div style='"+kiketableThWidthStyle+"' class='kiketable-th-text'></div>");
								var headersWidth=0;
								var currentHeaderId = jQuery(this).attr('parentHeader');
								$Table.find("th[parentHeader='"+currentHeaderId+"']").each(function(){
									headersWidth=headersWidth+jQuery(this).find(".kiketable-th-text, .cellSpan").width();
								});										
								jQuery('#'+jQuery(this).attr('parentHeader')).find(".kiketable-th-text, .cellSpan").css("width" , headersWidth +"px");

					});
					}
						if(!jQuery(this).hasClass('emptyCol'))
						{
						jQuery('<div class="'+o.classHandler+'" title="'+ o.title+'"></div>')
							.prependTo(this)
							.each(function(){
								//
								// global properties
								//
								this.td =	this.parentNode; // alias for TD / CELL of this, if jerarchy changes in future, only depends on this var
								this.$td =	jQuery(this.td);
								this.col = document.getElementById(this.td.id + '_col');
							})
							.dblclick( function() {
								var currentIndex= jQuery(this).parent().attr('index');
								$Table.find('td[colnum="'+currentIndex+'"]').find('div').width('auto');
								$Table.find('col[index="'+currentIndex+'"]').width('auto');
								$Table.find('th[index="'+currentIndex+'"]').find('.kiketable-th-text').width('auto');
								var currentParentHeaderId = jQuery(this).parent().attr('parentHeader');
								var headersWidth=0;
								jQuery("#"+currentParentHeaderId).find('.kiketable-th-text').width('auto');
								$Table.find('td[colnum="'+currentIndex+'"]').find('div').width($Table.find('td[colnum="'+currentIndex+'"]').find('div').width());
								$Table.find('col[index="'+currentIndex+'"]').width($Table.find('td[colnum="'+currentIndex+'"]').find('div').width()-11);														
								
								if(isChrome())
								{
									$Table.find('th[index="'+currentIndex+'"]').find('.kiketable-th-text').width($Table.find('th[index="'+currentIndex+'"]').find('.kiketable-th-text').width()+6);
								}else
								{
									$Table.find('th[index="'+currentIndex+'"]').find('.kiketable-th-text').width($Table.find('th[index="'+currentIndex+'"]').find('.kiketable-th-text').width());
								}
								$Table.find("th[parentHeader='"+currentParentHeaderId+"']").each(function(){
									headersWidth=headersWidth+jQuery(this).find(".kiketable-th-text, .cellSpan").width();
								});											
								jQuery('#'+currentParentHeaderId).find(".kiketable-th-text, .cellSpan").css("width" , headersWidth +"px");
							
								columnsSize = "";
								$Table.find("th&.header&:[controller]").each(function (index) {
									if(!jQuery(this).hasClass('statusCol'))
										{
									if (columnsSize != "")
										columnsSize += "##";
										columnsSize +=  (($Table.find('td[colnum="'+index+'"]:first').width()-11) / 8);
										}
									});

								resizeTableColumn(jQuery(this).parent().attr("controller"), columnsSize);
							})
							//
							// bind a dragstart event, return the proxy element
							//
							.bind( 'dragstart', function(e){
								this.col_minWidth =	((this.col.style.minWidth).split("px"))[0];
								this.cell_width =	((this.col.style.width).split("px"))[0];
								this.table_width =	$Table.outerWidth(true);
								var xPosition = e.offsetX;
								if(isRtlMode())
									xPosition = document.body.clientWidth -	xPosition;
								this.left0 =xPosition;
								AAA = this.left0;
								this.d1 = this.cell_width - this.left0; // precalc for drag event
								this.d2 = this.col_minWidth - this.d1; // precalc for drag event

								return jQuery(this)
										.clone()
										.appendTo(this.td)
										.css("opacity",o.dragOpacity)
										.css((o.dragProxy)?{
											top:	this.$td.offset().top,
											left:	this.$td.offset().left,
											width:	this.cell_width
											}:{
											top:	this.$td.offset().top,
											left:	e.offsetX
											})
										.removeClass(o.classHandler)
										.addClass(	(o.dragProxy)? o.classDragArea :	o.classDragLine)
										// commented to avoid scrollbar when start draging
										// .height($Table.innerHeight());
										
							})
							//
							// bind a drag event, update proxy position
							//
							.bind( 'drag', (o.dragMove || o.dragProxy)? function(e){
									var xPosition = e.offsetX;
									if(isRtlMode())
										xPosition = document.body.clientWidth -	xPosition;
									var w = xPosition + this.d1;
									if(w - this.d2 - this.d1 >= 8){
								
										e.dragProxy.style.width = w + "px"; //jQuery(e.dragProxy).css({width: w}) ;
										if (o.dragMove){
											this.col.style.width = w +"px"; // cell width
											jQuery(this).parent().find(".kiketable-th-text, .cellSpan").css("width" , w +"px"); // cell header div width
											jQuery(oTable).find("tr>td[colnum='"+jQuery(this).parent().attr("index")+"']>div").css("width" , w +"px");
											var headersWidth=0;
											var currentHeaderId = jQuery(this).parent().attr('parentHeader');
											jQuery("*[parentHeader='"+currentHeaderId+"']").each(function(){
												headersWidth=headersWidth+jQuery(this).find(".kiketable-th-text, .cellSpan").width();
											});											
											jQuery('#'+jQuery(this).parent().attr('parentHeader')).find(".kiketable-th-text, .cellSpan").css("width" , headersWidth +"px");
										};
									}
								}: function(e){
									})
							//
							// bind a dragend event, remove proxy
							//
							.bind( 'dragend', function(e){
								if (!o.dragMove){
									var delta = parseInt(e.dragProxy.style.left) - this.left0;
									this.col.style.width = (o.dragProxy) ? e.dragProxy.style.width : (this.cell_width + delta)+"px"; // cell width
									jQuery(this.col).find(".kiketable-th-text, .cellSpan").css("width" , (o.dragProxy) ? e.dragProxy.style.width-20 : (this.cell_width + delta - 22)+"px"); // cell width
									// change table width (if not fixed)
									if(isChrome() && !o.fixWidth)
										oTable.style.width = ((o.dragProxy) ? this.table_width - this.cell_width + parseInt(e.dragProxy.style.width) : this.table_width + delta)+"px";
								}
								jQuery(e.dragProxy)[o.fxHide](o.fxSpeed, function(){jQuery(this).remove()});
								jQuery(this).trigger('minimized');

								// Retrieve columns except status
								columnsSize = "";
								var columns = jQuery(this).parent().parent().parent().find("th&.header&:[controller]").each(function (index) {
									if(!jQuery(this).hasClass('statusCol'))
										{
									if (columnsSize != "")
										columnsSize += "##";	
										columnsSize +=  (parseInt($Table.find('col').eq(index)[0].style.width.replace('px', '')) / 8);
										}
									});

								resizeTableColumn(jQuery(this).parent().attr("controller"), columnsSize);
							})
							.bind('minimized', function(e){
								jQuery(this.col)[(parseInt(this.col.style.width) <= o.minWidth) ? "addClass":"removeClass"](o.classMinimized)
							});
						}
						});
				o.renderTime = new Date().getTime() - o.renderTime;
				o.onLoad();
				});
		return this;
	};
	$.fn.kiketable_colsizable.defaults = {
		dragCells :		"tr:first > *",// cells for allocating column sizing handlers (by default: all cells of first row)
		dragMove :		true,		// see column moving its width? (true/false)
		dragProxy :		"line",		// Shape of dragging ghost ("line"/"area")
		dragOpacity :	.3,			// Opacity for dragging ghost (0 - 1)
		minWidth :		8,			// width for minimized column (px)
		fixWidth :		false,		// table with fixed width? (true/false)
		fxHide :		"fadeOut",	// effect for hiding (fadeOut/hide/slideUp)
		fxSpeed:		200,		// speed for hiding (miliseconds)
		namespace :		"kiketable-colsizable",
		classHandler :	"kiketable-colsizable-handler",
		classDragLine :	"kiketable-colsizable-dragLine",
		classDragArea :	"kiketable-colsizable-dragArea",
		classMinimized: "kiketable-colsizable-minimized",
		title :			'Expand/Collapse this column',
		renderTime :	0,
		onLoad : function(){}
	};
}) (jQuery);