var click = 0;
var dblClick = 0;

var backgroundClick = false;
var backgroundDblClick = false;

var movementStarted = false;
var clickStart = 0;
var draggingStart = 0;

// co-ordinates of the starting point of the selection.
var startx = 0;
var starty = 0;
// co-ordinates of the ending point of the selection.
var endx = 0;
var endy = 0;

var browser = new Browser()
var dragObj = new Object();

dragObj.zIndex = 0;


/***************************
 *     Mouse functions     *
 ***************************/


function InvokeMapClick(elementId, controllerId, mapId, path, event)
{
	click = (new Date()).getTime();

	var ctrlKey = false;

	if ((typeof event == "undefined") || (event == null) || !event.ctrlKey)
	{
		clearSelectionIds(mapId);
		addSelectionId(mapId, elementId);
	}
	else
	{
		ctrlKey = true;

		if (hasSelectionId(mapId, elementId))
			removeSelectionId(mapId, elementId);
		else
			addSelectionId(mapId, elementId);
	}

	UpdateMapElementsStyle(mapId, null);

	var selected = hasSelectionId(mapId, elementId);

	//InvokeSelection((selected ? "_select" : "_unselect"), elementId, controllerId, (event.ctrlKey ? "true" : "false"), path);

	sendMapSelectionDemand((selected ? "_select" : "_unselect"), elementId, controllerId, "", (ctrlKey ? "true" : "false"), "", "");

	return false;
}

function InvokeMapDblClick(elementId, controllerId, mapId, path)
{
	dblClick = (new Date()).getTime();

	//InvokeAction(mapId, path, '', controllerId, elementId);
	onDbClickEvent(elementId, controllerId, mapId, false, '', '');
}

function InvokeBackgroundClick(mapId, controllerId, path)
{
	if (backgroundClick == true)
	{
		backgroundClick = false;
		return;
	}

	backgroundClick = true;
	backgroundDblClick = false;

	var method = "callBackgroundFunction('" + mapId + "','" + controllerId + "','" + path + "')";

	setTimeout(method, 100);
}

function InvokeBackgroundDblCLick(mapId, controllerId, path)
{
	var dblClickTime = (new Date()).getTime() - dblClick;

	if (dblClickTime < 1000)
	{
		return;
	}

	backgroundDblClick = true;
	InvokeMapEvent(controllerId,mapId,'');
}

function AreaDblClick(elementId, mapId, controllerId, path)
{
	backgroundDblClick = true;
	//InvokeAction(mapId, path, '', controllerId, elementId);
	onDbClickEvent(elementId, controllerId, mapId, false, '', '');

	window.event.cancelBubble = true;
}

function callBackgroundFunction(mapId, controllerId, path)
{
	backgroundClick = false;

	if (!backgroundDblClick)
	{
		backgroundDblClick = false;

		var date = new Date();
		var time = date.getTime() - clickStart;
		var elementTime = date.getTime() - click;

		if (time > 500)
			return;

		if (elementTime < 200)
			return;

		clearSelectionIds(mapId);
		UpdateMapElementsStyle(mapId, null);
		//InvokeSelection("_select", '', controllerId, "false", path);
		sendMapSelectionDemand("_select", "", controllerId, "", "false", "", "");
	}
}

// Called when a contextual menu is performed on the map
function InvokeMapPopup(elementId, regionId, controllerId, htmlMapId, mapId, path, selectionPath, event)
{
	var selected = hasSelectionId(htmlMapId, elementId);

	// Try to select map region (for treemap layout only)
	try
	{
		var doc = window.document;
		var region = doc.getElementById(regionId);

		selected = (region.style.borderWidth.substring(0, 1) != '0' && region.style.borderWidth.substring(0, 1) != '');

		if (!selected)
			TreemapSelection(elementId, true);
	}
	catch (ex)
	{
	}

	if (!selected)
	{
		InvokeMapClick(elementId, controllerId, htmlMapId, selectionPath, event);

		// Send the popup demand
		var methodParam = ReplaceString(elementId, "\\", "\\\\");

		setTimeout("sendPopupMenuDemand('" + methodParam + "','" + controllerId + "','" + mapId + "'," +
			event.ctrlKey + "," + event.clientX + "," + event.clientY + ",'" + methodParam + "');", 300);
	}
	else
		sendPopupMenuDemand(elementId, controllerId, mapId, event.ctrlKey,
							event.clientX, event.clientY, elementId);

		//InvokePopup(mapId, elementId, path, controllerId, event.ctrlKey, event.clientX, event.clientY);

}

// Graphical select a node
// return true if changed
function selectMapNode(id)
{
	needUpdate = false;
	divObject = document.getElementById(id);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeSelectedImage')
		{
			divObject.className = 'nodeSelectedImage';
			needUpdate = true;
		}
	}

	// compute label id
	i = id.indexOf("_node");
	currentId = id.substring(0, i);

	var labelId = currentId +"_label";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeSelectedLabel')
		{
			divObject.className = 'nodeSelectedLabel';
			needUpdate = true;
		}
	}

	labelId = currentId +"_leftLabel";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeSelectedLabel')
		{
			divObject.className = 'nodeSelectedLabel';
			needUpdate = true;
		}
	}

	labelId = currentId +"_rightLabel";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeSelectedLabel')
		{
			divObject.className = 'nodeSelectedLabel';
			needUpdate = true;
		}
	}

	labelId = currentId +"_topLabel";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeSelectedLabel')
		{
			divObject.className = 'nodeSelectedLabel';
			needUpdate = true;
		}
	}

	labelId = currentId +"_bottomLabel";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeSelectedLabel')
		{
			divObject.className = 'nodeSelectedLabel';
			needUpdate = true;
		}
	}

	return needUpdate;
}

// Graphical unselect a node
// return true if changed
function unselectMapNode(id)
{
	needUpdate = false;
	divObject = document.getElementById(id);
	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeImage')
		{
			divObject.className = 'nodeImage';
			needUpdate = true;
		}
	}

	// compute label id
	i = id.indexOf("_node");
	currentId = id.substring(0, i);

	var labelId = currentId +"_label";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeLabel')
		{
			divObject.className = 'nodeLabel';
			needUpdate = true;
		}
	}

	labelId = currentId +"_leftLabel";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeLabel')
		{
			divObject.className = 'nodeLabel';
			needUpdate = true;
		}
	}

	labelId = currentId +"_rightLabel";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeLabel')
		{
			divObject.className = 'nodeLabel';
			needUpdate = true;
		}
	}

	labelId = currentId +"_topLabel";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeLabel')
		{
			divObject.className = 'nodeLabel';
			needUpdate = true;
		}
	}

	labelId = currentId +"_bottomLabel";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeLabel')
		{
			divObject.className = 'nodeLabel';
			needUpdate = true;
		}
	}

	return needUpdate;
}

function UpdateMapElementsStyle(mapId, frameId)
{
	var ie= (navigator.appName == "Microsoft Internet Explorer")?1:0;
	var doc = document;

	var map = doc.getElementById(mapId);

	if ((map == null) || ((typeof map) == "undefined"))
		return;

	var divs = doc.getElementsByTagName('div');

	for (var i = 0; i < divs.length; i++)
	{
		divObject = divs[i];
		currentId = divObject.id;

		if ( (currentId == null) || (currentId == "undefined") || (currentId == ""))
			continue;

		if ((typeof id != "undefined") && (id != null) && (currentId == id) )
			continue;

		if (endsWith(currentId, "_node") )
		{
			var isSelected = hasSelectionId(mapId, divObject.getAttribute("nodeId"));

			if (isSelected)
				selectMapNode(currentId);
			else
				unselectMapNode(currentId);
		}
	}
}

// unselect all node except id
function unselectAllNodes(id)
{
	var needUpdate = false;
	var divs = document.getElementsByTagName('div');

	for (var i = 0; i < divs.length; i++)
	{
		divObject = divs[i];
		currentId = divObject.id;

		if ( (currentId == null) || (currentId == "undefined") || (currentId == ""))
			continue;

		if ((typeof id != "undefined") && (id != null) && (currentId == id) )
			continue;

		if ( endsWith(currentId, "_node") )
		{
			if (unselectMapNode(currentId))
				needUpdate = true;
		}
	}
	return needUpdate;
}

function unselectAll(url)
{
	date = new Date();
	time = date.getTime() - clickStart;

	if (time > 500)
		return;

	unselectAllNodes();
	InvokeMapSelection(url);
}


/***********************************
 *     Drag and drop functions     *
 ***********************************/

var dragStopCallback = null;
var parentNodes = null;
var dragChildrenNodes = null;

function setParentMapNode(nodeId, parentNodeId)
{
	if (parentNodes == null)
		parentNodes = new Array();

	parentNodes[nodeId] = parentNodeId;
}

function getChildrenMapNodes(parentNodeId)
{
	if (parentNodes == null)
		return null;

	var result = null;

	for (var nodeId in parentNodes)
	{
		if (parentNodes[nodeId] == parentNodeId)
		{
			if (result == null)
				result = new Array();

			var dragChildrenNode = new Object();

			dragChildrenNode.elNode = document.getElementById(nodeId);

			if (dragChildrenNode.elNode != null)
			{
				dragChildrenNode.elNodeStartLeft  = parseInt(dragChildrenNode.elNode.style.left, 10);
				dragChildrenNode.elNodeStartTop   = parseInt(dragChildrenNode.elNode.style.top,  10);
				if (isNaN(dragChildrenNode.elNodeStartLeft))
					dragChildrenNode.elNodeStartLeft = 0;
				if (isNaN(dragChildrenNode.elNodeStartTop))
					dragChildrenNode.elNodeStartTop  = 0;

				result[result.length] = dragChildrenNode;
			}
		}
	}

	return result;
}

function dragStart(event, id, nodeId, mapId, htmlMapId, mapDivId, mapContentId, controllerId, path, selectionPath)
{
  var el;
  var x, y;

  // If an element id was given, find it. Otherwise use the element being
  // clicked on.
  date = new Date();

  draggingStart = date.getTime();

  if (id)
  {
	  dragObj.nodeId = nodeId;
	  dragObj.elNode = document.getElementById(id);
	  dragChildrenNodes = getChildrenMapNodes(id);
  }

  // Get cursor position with respect to the page.
  if (browser.isIE)
  {
    x = window.event.clientX + document.documentElement.scrollLeft
      + document.body.scrollLeft;
    y = window.event.clientY + document.documentElement.scrollTop
      + document.body.scrollTop;
  }
  if (browser.isFirefox)
  {
    x = event.clientX + window.scrollX;
    y = event.clientY + window.scrollY;
    startx = x;
    starty = y;
  }
  else if (browser.isNS)
  {
    x = event.clientX + window.scrollX;
    y = event.clientY + window.scrollY;
  }

  // Save starting positions of cursor and element.
  dragObj.cursorStartX = x;
  dragObj.cursorStartY = y;

  if (dragObj.elNode != null)
  {
	dragObj.elNodeStartLeft  = parseInt(dragObj.elNode.style.left, 10);
  	dragObj.elNodeStartTop   = parseInt(dragObj.elNode.style.top,  10);
  	if (isNaN(dragObj.elNodeStartLeft))
  		dragObj.elNodeStartLeft = 0;
  	if (isNaN(dragObj.elNodeStartTop))
  		dragObj.elNodeStartTop  = 0;
  }

  // Capture mousemove and mouseup events on the page.
	dragStopCallback = function()
	{
		dragStop(mapId, htmlMapId, mapDivId, mapContentId, controllerId, path, selectionPath);
	}

  if (browser.isIE) {
    document.attachEvent("onmousemove", dragGo);
    document.attachEvent("onmouseup",   dragStopCallback);
    window.event.cancelBubble = true;
    window.event.returnValue = false;
  }
  if (browser.isNS) {
    document.addEventListener("mousemove", dragGo,   true);
    document.addEventListener("mouseup",   dragStopCallback, true);
    event.preventDefault();
  }
}

function dragGo(event) {

  var x, y;

  // Get cursor position with respect to the page.
  draggingStart -= 500;

  if (browser.isIE) {
    x = window.event.clientX + document.documentElement.scrollLeft
      + document.body.scrollLeft;
    y = window.event.clientY + document.documentElement.scrollTop
      + document.body.scrollTop;
  }
  if (browser.isNS) {
    x = event.clientX + window.scrollX;
    y = event.clientY + window.scrollY;
  }

  // Move drag element by the same amount the cursor has moved.

	if (dragObj.elNode != null)
	{
		dragObj.elNode.style.left = (dragObj.elNodeStartLeft + x - dragObj.cursorStartX) + "px";
		dragObj.elNode.style.top  = (dragObj.elNodeStartTop  + y - dragObj.cursorStartY) + "px";

		if (dragChildrenNodes != null)
		{
			var dragChildrenNode;

			for (var i = 0; i < dragChildrenNodes.length; i++)
			{
				dragChildrenNodes[i].elNode.style.left = (dragChildrenNodes[i].elNodeStartLeft + x - dragObj.cursorStartX) + "px";
				dragChildrenNodes[i].elNode.style.top  = (dragChildrenNodes[i].elNodeStartTop  + y - dragObj.cursorStartY) + "px";
			}
		}
	}

  if (browser.isIE) {
    window.event.cancelBubble = true;
    window.event.returnValue = false;
  }
  if (browser.isNS)
    event.preventDefault();
}

function dragStop(mapId, htmlMapId, mapDivId, mapContentId, controllerId, path, selectionPath)
{
	// Stop capturing mousemove and mouseup events.
	if (browser.isIE)
	{
		document.detachEvent("onmousemove", dragGo);
		document.detachEvent("onmouseup",   dragStopCallback);
		dragStopCallback = null;
	}
	if (browser.isNS)
	{
		document.removeEventListener("mousemove", dragGo,   true);
		document.removeEventListener("mouseup",   dragStopCallback, true);
		dragStopCallback = null;
	}

	var dragNode = dragObj.elNode;

	date = new Date();
	time = date.getTime() - draggingStart;
	dragObj.elNode = null;
	dragChildrenNodes = null;

	if (time < 500 )
		return;

	if (dragNode != null)
	{
		var mapContent = this.document.getElementById(mapContentId);

		x = parseInt(dragNode.style.left,10);
		y = parseInt(dragNode.style.top,10);
		id = ReplaceString(dragObj.nodeId,"\\","\\\\");

		var selected = hasSelectionId(htmlMapId, dragObj.nodeId);
		var mapSelection = getSelectionIds(htmlMapId);
		var methodParam = pageParam + '=' + mapId + '&' + sourceParam + '=moveElements' +
				'&' + controllerParam + '=' + controllerId +
				'&' + valueParam + '=' + id + '&' + indexParam + '=' + x + "|" + y;

		if (!selected || (mapSelection != dragObj.nodeId))
		{
			InvokeMapClick(dragObj.nodeId, controllerId, htmlMapId, selectionPath, null);

			setTimeout("sendMapDemand('" + methodParam + "');", 300);
		}
		else
			sendMapDemand(methodParam);
	}
}


/***********************************
 *     Miscellaneous functions     *
 ***********************************/


function Browser()
{

  var ua, s, i;

  this.isIE    = false;
  this.isNS    = false;
  this.isFirefox = false;
  this.version = null;

  ua = navigator.userAgent;

  s = "MSIE";
  if ((i = ua.indexOf(s)) >= 0) {
    this.isIE = true;
    this.version = parseFloat(ua.substr(i + s.length));
    return;
  }


  s = "Firefox";
    if ((i = ua.indexOf(s)) >= 0) {
      this.isFirefox = true;
      this.isNS = true; // As long has everything is not migrated
      this.version = parseFloat(ua.substr(i + s.length));;
      return;
    }

  s = "Netscape6/";
  if ((i = ua.indexOf(s)) >= 0) {
    this.isNS = true;
    this.version = parseFloat(ua.substr(i + s.length));
    return;
  }

  // Treat any other "Gecko" browser as NS 6.1.

  s = "Gecko";
  if ((i = ua.indexOf(s)) >= 0) {
    this.isNS = true;
    this.version = 6.1;
    return;
  }
}

function getMapDocument()
{
	return window.document;
}

// return true if the given source string endsWith pattern
function endsWith(source, pattern)
{
	n = pattern.length;
	m = source.length;

	temp = source.substring(m-n);

	if (temp == pattern)
		return true;
	else
		return false;
}


/***********************************
 *     Management of tree maps     *
 ***********************************/


var mapWidth = 0;
var mapHeight = 0;
var mapDelta = 10;
var mapInitialized = false;

function mouseOverRegion(regionId, over, isSmallImage, x, y, width, height, borderWidth)
{
	var doc = getMapDocument();
	var newValue = (over ? 'visible' : 'hidden');
	var selectBorder = doc.getElementById("_select_border_up");

	selectBorder.style.visibility = newValue;

	if (over)
	{
		selectBorder.style.width = width + "px";
		selectBorder.style.height = selectBorderWidth + "px";
		selectBorder.style.left = x + "px";
		selectBorder.style.top = y + "px";
	}

	selectBorder = doc.getElementById("_select_border_right");
	selectBorder.style.visibility = newValue;

	if (over)
	{
		selectBorder.style.width = selectBorderWidth + "px";
		selectBorder.style.height = height + "px";
		selectBorder.style.left = (x+ (width - selectBorderWidth)) + "px";
		selectBorder.style.top = y+"px";
	}

	selectBorder = doc.getElementById("_select_border_down");
	selectBorder.style.visibility = newValue;

	if (over)
	{
		selectBorder.style.width = (width - selectBorderWidth )+ "px";
		selectBorder.style.height = selectBorderWidth + "px";
		selectBorder.style.left = (x+ selectBorderWidth) + "px";
		selectBorder.style.top = (y+ (height - selectBorderWidth)) + "px";
	}

	selectBorder = doc.getElementById("_select_border_left");
	selectBorder.style.visibility = newValue;

	if (over)
	{
		selectBorder.style.width = selectBorderWidth + "px";
		selectBorder.style.height = height + "px";
		selectBorder.style.left = x + "px";
		selectBorder.style.top = y+  "px";
	}

	var tooltipId = (isSmallImage ? "_smallimage_tooltip" : "_tooltip");
	var regionTooltip = doc.getElementById(regionId + tooltipId);

	if (regionTooltip != null)
	{
		regionTooltip.style.visibility = newValue;
	}
}

function ReinitMap()
{
	mapWidth = 0;
	mapHeight = 0;
	mapDelta = 10;
	mapInitialized = false;
}

function InitResizeMap(frameName, pageId, bottomDivId, path)
{
	setTimeout("ResizeMap('" + frameName + "','" + pageId + "','" + bottomDivId + "','" + path + "','true')", 50);
}

function ResizeMap(frameName, pageId, bottomDivId, path, initialization)
{
	if (mapInitialized && (initialization == 'true'))
		return;

	var parentIframes = this.document.getElementsByTagName('iframe');
	var frame = this.frames[frameName];
	var iframe = parentIframes[frameName];

	if (frame == null || frame.document == null || frame.document.body == null)
	{
		this.location.reload();
		return;
	}

	// For performances reasons, only update url when size change significantly
	var  width = frame.document.body.clientWidth;
	var  height = frame.document.body.clientHeight;

	if ((mapWidth > width + mapDelta)
		|| (mapWidth < width - mapDelta)
		|| (mapHeight > height + mapDelta)
		|| (mapHeight < height - mapDelta))
	{
		mapWidth = width;
		mapHeight = height;

		iframe.style.height = "0px";

		var totalHeight = this.document.body.clientHeight;
		var scrollHeight = this.document.body.scrollHeight;
		var messageDiv = this.document.getElementById(bottomDivId);
		var newHeight = totalHeight;

		if (messageDiv != null)
			newHeight = cmGetY(messageDiv) - cmGetY(iframe);
		else
			newHeight = totalHeight - cmGetY(iframe);

		iframe.style.height = (newHeight - 2)+'px';

		if (initialization == 'true')
			mapInitialized = true;

		var  newUrl = _rootUrl + path;
		var  date = new Date();

		newUrl = newUrl + '?_reload=' + date.getTime() + '&_ajax=false' + '&_page=' + pageId +
			'&_frame=' + frame.name + cmGetWidth(iframe) + '*' + cmGetHeight(iframe);

		frame.location.href = newUrl;
	}
}


/****************************************
 *     Management of rubber banding     *
 ****************************************/

var rubberMapObject = null;
var rubberContentObject = null;
var rubberMovingObject = null;
var rubberObject = null;
var useRubber = new Array();
var leftContentOffset = 0;
var topContentOffset = 0;
var stopUpdateLoadedImages;
var selectCursor = "crosshair";
var moveCursor;
var movingCursor;

/**
 * Sets or unsets the rubber mode.
 **/
function setMapRubberMode(frameName, mapId, rubber, selectCellId, moveCellId)
{
	setUseRubber(frameName, mapId, rubber);

	var selectCell = document.getElementById(selectCellId);
	var moveCell = document.getElementById(moveCellId);

	if (rubber)
	{
		selectCell.className = "pressedTool";
		moveCell.className = "";
	}
	else
	{
		selectCell.className = "";
		moveCell.className = "pressedTool";
	}
}

/**
 * Sets the move map cursors.
 **/
function setMoveMapCursors(frameName, moveCursorUrl, movingCursorUrl)
{
	moveCursor = moveCursorUrl;
	movingCursor = movingCursorUrl;
}

/**
 * Set or Unset the document has a rubberband listener.
 * doc is the reference to the document.
 **/
function setRubberBandListener(rubberId, set, mapId, mapDivId, mapContentDivId, controllerId, mapComponentId,
	actionPath, selectionPath)
{
	if (movementStarted)
		return;

	var doc = window.document;
	var path = (isUseRubber(mapComponentId) ? selectionPath : actionPath);

	if (set == true)
	{
		var startMovementCallback = function(e)
		{
			startMovement(e, mapComponentId, controllerId, path);
			return false;
		}

		var movementCallback = function(e)
		{
			movement(e, mapComponentId, controllerId, path);
			return false;
		}

		var stopMovementCallback = function()
		{
			stopMovement(mapId, mapComponentId, controllerId, path);
		}

		doc.onmousemove = movementCallback;
		doc.onmousedown = startMovementCallback;
		doc.onmouseup = stopMovementCallback;
		rubberObject = doc.getElementById(rubberId);
		rubberMovingObject = doc.getElementById(rubberId + "_moving");
		rubberMapObject = doc.getElementById(mapDivId);
		rubberContentObject = doc.getElementById(mapContentDivId);
	}
	else if (set == false)
	{
		doc.onmousemove = "";
		doc.onmousedown = "";
		doc.onmouseup = "";
	}
	else
		return true;

	if (rubberMovingObject != null)
		rubberMovingObject.style.cursor = (isUseRubber(mapComponentId) ? selectCursor : moveCursor);

	if (rubberContentObject != null)
		rubberContentObject.style.cursor = (isUseRubber(mapComponentId) ? selectCursor : moveCursor);
}

/**
 * This method defines the starting point of a rectangle for
 * the selection of an area over the map.
 * It is called when the mouse is pressed over the map.
 * doc : the reference of the document
 **/
function startMovement(e, mapComponentId, controllerId, path)
{
	if (zoomMoving || viewerMoving || translatingViewer)
		return;

	if ((dragObj.elNode != null) && (typeof dragObj.elNode != "undefined"))
		return;

	// Prevent right click to start rubber banding
	if ((e && (e.button == 2)) || (window.event && (window.event.button == 2)))
		return;

	date = new Date();
	clickStart = date.getTime();

	if (!movementStarted)
	{
		var doc = getMapDocument();

		movementStarted = true;

		if (e)
		{
			var parent = e.target;

			startx = e.layerX + parseInt(rubberContentObject.style.left);
			starty = e.layerY + parseInt(rubberContentObject.style.top);

			while (parent && (parent != rubberContentObject))
			{
				startx += parent.offsetLeft;
				starty += parent.offsetTop;
				parent = parent.offsetParent;
			}
		}
		else
		{
			startx = window.event.x;
			starty = window.event.y;
		}


		endx = startx;
		endy = starty;

		if (!isUseRubber(mapComponentId))
		{
			rubberMovingObject.style.cursor = movingCursor;
			rubberContentObject.style.cursor = movingCursor;
			leftContentOffset = parseInt(rubberContentObject.style.left);
			topContentOffset = parseInt(rubberContentObject.style.top);

			stopUpdateLoadedImages = false;
			updateLoadedImagesTimeout(mapComponentId, controllerId, path);
		}
	}

	return false; // very important, do not remove!
}

/**
 * This method draws a rectangle for the selection of an area over the map.
 * It is drawn each time the user moves the mouse while pressed over the map.
 **/
function movement(e, mapComponentId, controllerId, path)
{
	if (movementStarted)
	{
		if (rubberObject.style.visibility != "visible")
		{
			if (isUseRubber(mapComponentId))
			{
				// initialise layer.
				rubberObject.style.left = startx + "px";
				rubberObject.style.top = starty + "px";
				rubberObject.style.width = "0px";
				rubberObject.style.height = "0px";
				rubberObject.style.visibility = "visible";
			}

			rubberMovingObject.style.left = "0px";
			rubberMovingObject.style.top = "0px";
			rubberMovingObject.style.width = cmGetWidth(rubberMapObject) + 'px';
			rubberMovingObject.style.height = cmGetHeight(rubberMapObject) + 'px';
			rubberMovingObject.style.visibility = "visible";
		}

		var newEvent = e;
		var target = null;

		if (!e)
			newEvent = window.event;

		if (newEvent.target)
			target = newEvent.target;
		else if (newEvent.srcElement)
			target = newEvent.srcElement;

		if (target != rubberMovingObject)
			return false;

		if (e)
		{
			endx = e.layerX;
			endy = e.layerY;
		}
		else
		{
			endx = window.event.x;
			endy = window.event.y;
		}

		if (!isUseRubber(mapComponentId))
		{
			rubberContentObject.style.left = (leftContentOffset + (endx - startx)) + 'px';
			rubberContentObject.style.top = (topContentOffset + (endy - starty)) + 'px';
		}
		else
		{
			var doc = getMapDocument();
			var posx = Math.min(endx, startx);
			var posy = Math.min(endy, starty);
			var w = Math.abs(endx-startx);
			var h = Math.abs(endy-starty);

			rubberObject.style.width = w + "px";
			rubberObject.style.height = h + "px";
			rubberObject.style.left = posx + "px";
			rubberObject.style.top = posy + "px";
		}

		return false;
	}
	else
	{
		// The event is routed in order to let the tooltip
		// function going on.
		if (document.layers)
		{
			var doc = getMapDocument();
			doc.routeEvent(e);
		}
		return true;
	}
}

/**
 * This method stops drawing the rectangle and capture
 * the coordinates of the upper left and bottom right corners.
 **/
function stopMovement(mapId, mapComponentId, controllerId, path)
{
	if (movementStarted)
	{
		movementStarted = false;
		stopUpdateLoadedImages = true;
		rubberObject.style.visibility = "hidden";
		rubberMovingObject.style.visibility = "hidden";

		date = new Date();
		time =  date.getTime() - clickStart;

		if (isUseRubber(mapComponentId))
		{
			corner1x = Math.min(startx, endx);
			corner1y = Math.min(starty, endy);
			corner2x = Math.max(startx, endx);
			corner2y = Math.max(starty, endy);

			selectMapNodes(corner1x ,corner1y ,corner2x, corner2y, mapId, controllerId, path);
		}
		else
		{
			updateLoadedImages(mapComponentId, controllerId, path);

			sendMapDemand(pageParam + '=' + mapComponentId + '&' + sourceParam + '=translateMap' +
				'&' + valueParam + '=' + (endx - startx) + "_" + (endy - starty) + '&' + controllerParam + '=' + controllerId);
		}
	}

	rubberMovingObject.style.cursor = (isUseRubber(mapComponentId) ? selectCursor : moveCursor);
	rubberContentObject.style.cursor = (isUseRubber(mapComponentId) ? selectCursor : moveCursor);

	return true;
}

/**
 * This method updates all the images that area visible and not loaded with a timeout.
 */
function updateLoadedImagesTimeout(mapComponentId, controllerId, path)
{
	if (stopUpdateLoadedImages)
		return;

	setTimeout("updateLoadedImages('" + mapComponentId + "', '" + controllerId + "', '" + path + "')", 200);
}

/**
 * This method updates all the images that area visible and not loaded.
 */
function updateLoadedImages(mapComponentId, controllerId, path)
{
	// Load parts that were not loaded
	var mapWidth = parseInt(rubberMapObject.style.width);
	var mapHeight = parseInt(rubberMapObject.style.height);
	var contentx = parseInt(rubberContentObject.style.left);
	var contenty = parseInt(rubberContentObject.style.top);
	var preloadOffset = 60;
	var startTime1 = new Date().getTime();
	var contentAll = rubberContentObject.getElementsByTagName("*");
	var length = contentAll.length;
	var divIds = "";
	var optimizeRequests = true;

	for (var i = 0; i < length; i++)
	{
		var divObject = contentAll[i];

		if (divObject.className != "MIE")
			continue;

		var divx1 = parseInt(divObject.style.left) + contentx;
		var divx2 = divx1 + parseInt(divObject.style.width);
		var divy1 = parseInt(divObject.style.top) + contenty;
		var divy2 = divy1 + parseInt(divObject.style.height);

		if (((divx1 >= -preloadOffset && divx1 <= mapWidth + preloadOffset)
					|| (divx2 >= -preloadOffset && divx2 <= mapWidth + preloadOffset))
				&& ((divy1 >= -preloadOffset && divy1 <= mapHeight + preloadOffset)
						|| (divy2 >= -preloadOffset && divy2 <= mapHeight + preloadOffset)))
		{
			divObject.className = "MI";

			if (divIds != "")
				divIds += "*";

			divIds += divObject.id;

			if (!optimizeRequests)
				sendMapDemand(pageParam + '=' + mapComponentId + '&' + sourceParam + '=loadImage' +
					'&' + valueParam + '=' + divObject.id + '&' + controllerParam + '=' + controllerId);

				/*
				SendAjaxRequestParams(_rootUrl + path, pageParam + '=' + mapComponentId + '&' + sourceParam + '=loadImage' +
									'&' + valueParam + '=' + divObject.id + '&' + controllerParam + '=' + controllerId, 'false');
				*/
		}
	}

	if (optimizeRequests && (divIds != ""))
		sendMapDemand(pageParam + '=' + mapComponentId + '&' + sourceParam + '=loadImage' +
			'&' + valueParam + '=' + divIds + '&' + controllerParam + '=' + controllerId);

		/*
		SendAjaxRequestParams(_rootUrl + path, pageParam + '=' + mapComponentId + '&' + sourceParam + '=loadImage' +
					'&' + valueParam + '=' + divIds + '&' + controllerParam + '=' + controllerId, 'false');
		*/

	updateLoadedImagesTimeout(mapComponentId, controllerId, path);
}

/**
 * This method selects the map nodes contained in the given box and
 * sends a selection event to the server.
 **/
function selectMapNodes(startX, startY, endX, endY, mapId, controllerId, path)
{
	clearSelectionIds(mapId);
	unselectAllNodes();

	var contentAll = rubberContentObject.getElementsByTagName("*");

	for (var i = 0; i < contentAll.length; i++)
	{
		var divObject = contentAll[i];

		currentId = divObject.id;

		if ((currentId == null) || (currentId == "undefined"))
			continue;

		if (endsWith(currentId, "_node"))
		{
			var x = 0, y = 0;
			var obj = divObject;

			do
			{
				x += obj.offsetLeft;
				y += obj.offsetTop;
				obj = obj.offsetParent;
			}
			while (obj && obj != rubberMapObject);

			if ((startX <= x ) && (x <= endX) && (startY <= y) && (y <= endY))
			{
				n = currentId.indexOf("_node");
				nodeId = currentId.substring(0, n);
				addSelectionId(mapId, divObject.getAttribute("nodeId"));
				selectMapNode(currentId);
			}
		}
	}

	// Call InvokeSelection
	var selectedIds = getSelectionIds(mapId);

	//InvokeSelection("_select", selectedIds, controllerId, "false", path);
	sendMapSelectionDemand("_select", selectedIds, controllerId, "", "false", "", "");

}


/**************************************
 *     Management of zoom widgets     *
 **************************************/


var viewerXPos = null;
var viewerYPos = null;
var viewerMoving = false;
var zoomYPos = null;
var zoomMoving = false;
var translatingViewer = false;
var currentScale = new Array();

function switchMapWidgetState(actionId, path, mapId, toolDivId, controller)
{
	backgroundDblClick = true;

	var toolDiv = this.document.getElementById(toolDivId);
	var open = (toolDiv == null ? false : toolDiv.style.display == 'none');

	if ((controller != null) && (controller != '') && (typeof controller != "undefined"))
		sendMapDemand(pageParam + '=' + mapId + '&' + sourceParam + '=' + actionId +
			'&' + valueParam + '=' + open + '&' + controllerParam + '=' + controller);
		/*
		SendAjaxRequestParams(_rootUrl + path, pageParam + '=' + mapId + '&' + sourceParam + '=' + actionId +
					'&' + valueParam + '=' + open + '&' + controllerParam + '=' + controller, 'false');
		*/
}

function setMapWidgetState(open, toolDivId, switchImgId, image, tooltip)
{
	var toolDiv = this.document.getElementById(toolDivId);
	var viewerSwitchImg = this.document.getElementById(switchImgId);

	if (toolDiv != null)
	{
		if (open)
			toolDiv.style.display = 'block';
		else
			toolDiv.style.display = 'none';
	}

	if (viewerSwitchImg != null)
	{
		viewerSwitchImg.src = image;
		SetImageTooltip(switchImgId, tooltip);
	}
}

function getCurrentScaleValue(frameName, mapId)
{
		return currentScale[mapId];
}

function setCurrentScaleValue(frameName, mapId, scale)
{
	currentScale[mapId] = scale;
}

function isUseRubber(mapId)
{
	var result = useRubber[mapId];

	if ((typeof result == "undefined") || (result == null))
		return true;

	return result;
}

function setUseRubber(frameName, mapId, useRubberValue)
{
		useRubber[mapId] = useRubberValue;
}

function setMapZoomScale(scale, path, mapId, mapZoomId, xTranslation, yTranslation, controller)
{
	backgroundDblClick = true;

	var mapZoomDiv = document.getElementById(mapZoomId);
	var scaleDiv = document.getElementById(mapZoomId + '_scale' + scale);

	if ((scaleDiv == null) || (typeof scaleDiv == "undefined"))
		return;

	var zoomCursorDiv = document.getElementById(mapZoomId + '_cursor');
	var zoomCursorMovingDiv = document.getElementById(mapZoomId + '_cursor_moving');
	var x = cmGetXAt(scaleDiv, mapZoomDiv);
	var y = cmGetYAt(scaleDiv, mapZoomDiv);

	zoomCursorDiv.style.left = (x + 1)+'px';
	zoomCursorDiv.style.top = (y + 1)+'px';
	zoomCursorDiv.style.visibility = "visible";
	currentScale[mapId] = scale;
	zoomCursorMovingDiv.style.visibility = "hidden";

	if ((mapId != null) && (mapId != ''))
	{
		var params = pageParam + '=' + mapId + '&' + sourceParam + '=setMapZoomScale' +
			'&' + valueParam + '=' + scale;

		if ((xTranslation != null) && (typeof xTranslation != "undefined")
				&& (yTranslation != null) && (typeof yTranslation != "undefined"))
			params += '_' + xTranslation + '_' + yTranslation;

		if ((typeof controller != "undefined") && (controller != null) && (controller != ''))
			params += '&' + controllerParam + '=' + controller;

		//SendAjaxRequestParams(_rootUrl + path, params, 'false');
		sendMapDemand(params);
	}
}

function prepareMovingZoom(evt, mapId, mapZoomId)
{
	var zoomDiv = this.document.getElementById(mapZoomId + '_cursor');
	var zoomCursorMovingDiv = this.document.getElementById(mapZoomId + '_cursor_moving');
	var mapDiv = this.document.getElementById(mapId);

	zoomCursorMovingDiv.style.left = (cmGetXAt(zoomDiv, mapDiv))+'px';
	zoomCursorMovingDiv.style.top = (cmGetYAt(zoomDiv, mapDiv))+'px';
	zoomCursorMovingDiv.style.width = (cmGetWidth(zoomDiv))+'px';
	zoomCursorMovingDiv.style.height = (cmGetHeight(zoomDiv))+'px';
	zoomCursorMovingDiv.style.visibility = "visible";
}

function startMovingZoom(mapId, mapZoomId)
{
	var mapDiv = this.document.getElementById(mapId);
	var zoomCursorMovingDiv = this.document.getElementById(mapZoomId + '_cursor_moving');

	zoomCursorMovingDiv.style.left = "0px";
	zoomCursorMovingDiv.style.top = "0px";
	zoomCursorMovingDiv.style.width = (cmGetWidth(mapDiv))+'px';
	zoomCursorMovingDiv.style.height = (cmGetHeight(mapDiv))+'px';
	zoomMoving = true;
}

function moveZoom(evt, mapId, mapZoomId)
{
	var zoomCursorDiv = this.document.getElementById(mapZoomId + '_cursor');

	if (!zoomMoving)
	{
		zoomYPos = evt.clientY;

		return;
	}

	if (document.getElementById && !(document.all))
	{
		// Firefox
		// Nothing to do
	}
	else if(document.all)
	{
		// IE
		evt = event;
	}

	if (zoomYPos == null)
	{
		zoomYPos = evt.clientY;
	}

	var diffY = evt.clientY - zoomYPos;
	var newY = parseInt(zoomCursorDiv.style.top) + diffY;
	var mapZoomDiv = this.document.getElementById(mapZoomId);
	var mapDiv = this.document.getElementById(mapId);
	var zoomScaleDiv = this.document.getElementById(mapZoomId + '_scale');
	var yTotal = cmGetYAt(mapZoomDiv, mapDiv) + newY;
	var yMin = cmGetYAt(zoomScaleDiv, mapDiv);
	var yMax = yMin + cmGetHeight(zoomScaleDiv);

	if (yTotal < yMin + 1)
	{
		newY = yMin - cmGetYAt(mapZoomDiv, mapDiv) + 1;
		zoomCursorDiv.style.top = newY + "px";
		return;
	}

	if (yTotal > yMax - 8)
	{
		newY = yMax - cmGetYAt(mapZoomDiv, mapDiv) - 8;
		zoomCursorDiv.style.top = newY + "px";
		return;
	}

	zoomYPos = evt.clientY;
	zoomCursorDiv.style.top = newY + "px";
}

function endMovingZoom(path, mapId, mapZoomId, minScale, controller)
{
	var zoomDiv = this.document.getElementById(mapZoomId);
	var zoomCursorDiv = this.document.getElementById(mapZoomId + '_cursor');
	var zoomCursorMovingDiv = this.document.getElementById(mapZoomId + '_cursor_moving');
	var zoomCursorY = cmGetYAt(zoomCursorDiv, zoomDiv);
	var scale = minScale;
	var scaleDiv = null;

	while (zoomMoving
		&& ((scaleDiv = document.getElementById(mapZoomId + '_scale' + scale)) != null)
		&& (typeof scaleDiv != "undefined"))
	{
		if (cmGetYAt(scaleDiv, zoomDiv) < zoomCursorY - (-4))
		{
			setMapZoomScale(scale, path, mapId, mapZoomId, null, null, controller);
			break;
		}

		scale++;
	}

	zoomCursorMovingDiv.style.visibility = "hidden";
	zoomYPos = null;
	zoomMoving = false;
}

function prepareMovingViewer(mapDivId, mapViewerDivId, mapViewerTranslateId, mapViewerMovingId)
{
	var viewerDiv = this.document.getElementById(mapViewerDivId);
	var viewerTranslateDiv = this.document.getElementById(mapViewerTranslateId);
	var viewerMovingDiv = this.document.getElementById(mapViewerMovingId);
	var mapDiv = this.document.getElementById(mapDivId);

	viewerMovingDiv.style.left = (cmGetXAt(viewerDiv, mapDiv))+'px';
	viewerMovingDiv.style.top = (cmGetYAt(viewerDiv, mapDiv))+'px';
	viewerMovingDiv.style.width = (cmGetWidth(viewerDiv))+'px';
	viewerMovingDiv.style.height = (cmGetHeight(viewerDiv))+'px';
	viewerMovingDiv.style.visibility = "visible";
	viewerTranslateDiv.style.left = (cmGetXAt(viewerDiv, mapDiv) + 5)+'px';
	viewerTranslateDiv.style.top = (cmGetYAt(viewerDiv, mapDiv) + 5)+'px';
	viewerTranslateDiv.style.width = (cmGetWidth(viewerDiv) - 10)+'px';
	viewerTranslateDiv.style.height = (cmGetHeight(viewerDiv) - 10)+'px';
	viewerTranslateDiv.style.visibility = "visible";

}

function startMovingViewer(mapDivId, mapViewerTranslateId, mapViewerMovingId)
{
	var mapDiv = this.document.getElementById(mapDivId);
	var viewerTranslateDiv = this.document.getElementById(mapViewerTranslateId);
	var viewerMovingDiv = this.document.getElementById(mapViewerMovingId);

	viewerTranslateDiv.style.visibility = "hidden";
	viewerMovingDiv.style.left = "0px";
	viewerMovingDiv.style.top = "0px";
	viewerMovingDiv.style.width = (cmGetWidth(mapDiv))+'px';
	viewerMovingDiv.style.height = (cmGetHeight(mapDiv))+'px';
	viewerMoving = true;
}

function moveViewer(evt, mapDivId, mapViewerDivId, mapViewerImgId, mapViewerSwitchId)
{
	var viewerDiv = this.document.getElementById(mapViewerDivId);
	var mapDiv = this.document.getElementById(mapDivId);
	var viewerImgDiv = this.document.getElementById(mapViewerImgId);
	var viewerSwitchDiv = this.document.getElementById(mapViewerSwitchId);

	if (!viewerMoving)
	{
		viewerXPos = evt.clientX;
		viewerYPos = evt.clientY;

		return;
	}

	if (document.getElementById && !(document.all))
	{
		// Firefox
		// Nothing to do
	}
	else if(document.all)
	{
		// IE
		evt = event;
	}

	if (viewerXPos == null)
	{
		viewerXPos = evt.clientX;
		viewerYPos = evt.clientY;
	}

	var diffX = evt.clientX - viewerXPos;
	var diffY = evt.clientY - viewerYPos;
	var newX = parseInt(viewerDiv.style.left) + diffX;
	var newY = parseInt(viewerDiv.style.top) + diffY;
	var yTotal = cmGetYAt(viewerDiv, mapDiv) + newY;
	var xMax = cmGetWidth(mapDiv) - cmGetWidth(viewerImgDiv);
	var yMax = cmGetHeight(mapDiv) - cmGetHeight(viewerImgDiv);
	var setXPos = true;
	var setYPos = true;

	if (newX < 2)
	{
		newX = 2;
		setXPos = false;
	}

	if (newY < 2)
	{
		newY = 2;
		setYPos = false;
	}

	if (newX > xMax - 5)
	{
		newX = (xMax - 5);
		setXPos = false;
	}

	if (newY > yMax - 5)
	{
		newY = (yMax - 5);
		setYPos = false;
	}

	if (setXPos)
		viewerXPos = evt.clientX;

	if (setYPos)
		viewerYPos = evt.clientY;

	viewerDiv.style.left = newX + "px";
	viewerDiv.style.top = newY + "px";

	if (viewerSwitchDiv != null)
	{
		viewerSwitchDiv.style.left = (newX + 2) + "px";
		viewerSwitchDiv.style.top = (newY + 2) + "px";
	}
}

function endMovingViewer(mapDivId, mapViewerDivId, mapViewerTranslateId, mapViewerMovingId, path, mapId, controller)
{
	var viewerDiv = this.document.getElementById(mapViewerDivId);

	prepareMovingViewer(mapDivId, mapViewerDivId, mapViewerTranslateId, mapViewerMovingId);
	viewerXPos = null;
	viewerYPos = null;

	var viewerX = viewerDiv.style.left;
	var viewerY = viewerDiv.style.top;

	if (viewerMoving && (controller != null) && (controller != '') && (typeof controller != "undefined"))
		sendMapDemand(pageParam + '=' + mapId + '&' + sourceParam + '=moveViewer' +
			'&' + valueParam + '=' + viewerX + "_" + viewerY + '&' + controllerParam + '=' + controller);
		/*SendAjaxRequestParams(_rootUrl + path, pageParam + '=' + mapId + '&' + sourceParam + '=moveViewer' +
			'&' + valueParam + '=' + viewerX + "_" + viewerY + '&' + controllerParam + '=' + controller, 'false');*/

	viewerMoving = false;
}

function translateViewer(evt, path, mapId, mapViewerDivId, controller)
{
	translatingViewer = true;

	if (document.getElementById && !(document.all))
	{
		// Firefox
		// Nothing to do
	}
	else if(document.all)
	{
		// IE
		evt = event;
	}

	var viewerDiv = this.document.getElementById(mapViewerDivId);
	var x = evt.clientX - cmGetX(viewerDiv);
	var y = evt.clientY - cmGetY(viewerDiv);

	/*SendAjaxRequestParams(_rootUrl + path, pageParam + '=' + mapId + '&' + sourceParam + '=translateViewer' +
		'&' + valueParam + '=' + x + "_" + y + '&' + controllerParam + '=' + controller, 'false');*/

	sendMapDemand(pageParam + '=' + mapId + '&' + sourceParam + '=translateViewer' +
		'&' + valueParam + '=' + x + "_" + y + '&' + controllerParam + '=' + controller);

	setTimeout("translatingViewer = false;", 500);
}

function translateMap(path, direction, mapId, mapDivId, mapContentDivId, backgroundImagesId, emptyImagePath, controller)
{
	backgroundDblClick = true;

	rubberMapObject = document.getElementById(mapDivId);
	rubberContentObject = document.getElementById(mapContentDivId);

	var xoffset = parseInt(rubberMapObject.style.width) * 0.2;
	var yoffset = parseInt(rubberMapObject.style.height) * 0.2;
	var offset = Math.min(xoffset, yoffset);

	if (direction == "CENTER")
	{
		var globalWidth = parseInt(rubberContentObject.style.width);
		var globalHeight = parseInt(rubberContentObject.style.height);
		var visibleWidth = parseInt(rubberMapObject.style.width);
		var visibleHeight = parseInt(rubberMapObject.style.height);

		setMapOffset(mapContentDivId, (visibleWidth - globalWidth) / 2, (visibleHeight - globalHeight) / 2);
	}
	else
	{
		if (direction == "NORTH")
		{
			xoffset = 0;
			yoffset = offset;
		}
		else if (direction == "SOUTH")
		{
			xoffset = 0;
			yoffset = -offset;
		}
		else if (direction == "WEST")
		{
			xoffset = offset;
			yoffset = 0;
		}
		else if (direction == "EAST")
		{
			xoffset = -offset;
			yoffset = 0;
		}

		setMapOffset(mapContentDivId, parseInt(rubberContentObject.style.left) + xoffset, parseInt(rubberContentObject.style.top) + yoffset);
	}

	updateLoadedImages(mapId, controller, path);

	/*
	SendAjaxRequestParams(_rootUrl + path, pageParam + '=' + mapId + '&' + sourceParam + '=translateMap' +
			'&' + valueParam + '=' + (direction == "CENTER" ? "reset" : xoffset + "_" + yoffset) + '&' + controllerParam + '=' + controller, 'false');
	*/
	sendMapDemand(pageParam + '=' + mapId + '&' + sourceParam + '=translateMap' +
		'&' + valueParam + '=' + (direction == "CENTER" ? "reset" : xoffset + "_" + yoffset) + '&' + controllerParam + '=' + controller);
}

function setMapOffset(mapContentDivId, xoffset, yoffset)
{
	var mapComponent = document.getElementById(mapContentDivId);

	mapComponent.style.left = xoffset + "px";
	mapComponent.style.top = yoffset + "px";
}

function addFirefoxWheelEvent(path, mapDivId, mapContentId, mapZoomId, mapId, controller)
{
	var mapZoomDiv = document.getElementById(mapDivId);

	var firefoxWheelMoved = function(event)
	{
		wheelMoved(event, path, mapDivId, mapContentId, mapZoomId, mapId, controller);
	}

	mapZoomDiv.addEventListener('DOMMouseScroll', firefoxWheelMoved, false);
}

function wheelMoved(event, path, mapDivId, mapContentId, mapZoomId, mapId, controller)
{
	var zoomIn = true;

	if (event.wheelDelta)
		zoomIn = (event.wheelDelta > 0);
	else if (event.detail)
		zoomIn = (event.detail < 0);

	var mapContent = document.getElementById(mapContentId);
	var x = event.clientX - cmGetX(mapContent) - (cmGetWidth(mapContent) / 2);
	var y = event.clientY - cmGetY(mapContent) - (cmGetHeight(mapContent) / 2);

	if (zoomIn)
		setMapZoomScale(currentScale[mapId] + 1, path, mapId, mapZoomId, x, y, controller);
	else
		setMapZoomScale(currentScale[mapId] - 1, path, mapId, mapZoomId, x, y, controller);

	if (browser.isIE)
	{
		window.event.cancelBubble = true;
		window.event.returnValue = false;
	}
	else if (browser.isNS)
		event.preventDefault();
}


// Enables or disables the selection in HTML page
function SetSelectionStartMode(enableSelection)
{
	if (enableSelection)
	{
		if (typeof document.onselectstart != 'undefined')
			document.onselectstart = function() {return true};
		else if (typeof document.body.style.MozUserSelect != 'undefined')
			document.body.style.MozUserSelect = null;
	}
	else
	{
		if (typeof document.onselectstart != 'undefined')
			document.onselectstart = function() {return false};
		else if (typeof document.body.style.MozUserSelect != 'undefined')
			document.body.style.MozUserSelect = 'none';
	}
}

//
// returns the object baring the id
//
function cmGetObject (id)
{
	if (document.all)
		return document.all[id];
	return document.getElementById (id);
}

//
// functions that obtain the width of an HTML element.
//
function cmGetWidth (obj)
{
	var width = obj.offsetWidth;
	if (width > 0 || !cmIsTRNode (obj))
		return width;
	if (!obj.firstChild)
		return 0;
	// use TABLE's length can cause an extra pixel gap
	//return obj.parentNode.parentNode.offsetWidth;

	// use the left and right child instead
	return obj.lastChild.offsetLeft - obj.firstChild.offsetLeft + cmGetWidth (obj.lastChild);
}

//
// functions that obtain the height of an HTML element.
//
function cmGetHeight (obj)
{
	var height = obj.offsetHeight;
	if (height > 0 || !cmIsTRNode (obj))
		return height;
	if (!obj.firstChild)
		return 0;
	// use the first child's height
	return obj.firstChild.offsetHeight;
}

//
// functions that obtain the coordinates of an HTML element
//
function cmGetX (obj)
{
	if (!obj)
		return 0;
	var x = 0;

	do
	{
		x += obj.offsetLeft;
		obj = obj.offsetParent;
	}
	while (obj);
	return x;
}

function cmGetXAt (obj, elm)
{
	var x = 0;

	while (obj && obj != elm)
	{
		x += obj.offsetLeft;
		obj = obj.offsetParent;
	}
	if (obj == elm)
		return x;
	return x - cmGetX (elm);
}

function cmGetY (obj)
{
	if (!obj)
		return 0;
	var y = 0;
	do
	{
		y += obj.offsetTop;
		obj = obj.offsetParent;
	}
	while (obj);
	return y;
}

function cmIsTRNode (obj)
{
	var tagName = obj.tagName;
	return tagName == "TR" || tagName == "tr" || tagName == "Tr" || tagName == "tR";
}

//
// get the Y position of the object.  In case of TR element though,
// we attempt to adjust the value.
//
function cmGetYAt (obj, elm)
{
	var y = 0;

	if (!obj.offsetHeight && cmIsTRNode (obj))
	{
		var firstTR = obj.parentNode.firstChild;
		obj = obj.firstChild;
		y -= firstTR.firstChild.offsetTop;
	}

	while (obj && obj != elm)
	{
		y += obj.offsetTop;
		obj = obj.offsetParent;
	}

	if (obj == elm)
		return y;
	return y - cmGetY (elm);
}

//
// extract description from the menu item and set the status text
//
function cmSetStatus (item)
{
	var descript = '';
	if (item.length > 4)
		descript = (item[4] != null) ? item[4] : (item[2] ? item[2] : descript);
	else if (item.length > 2)
		descript = (item[2] ? item[2] : descript);

	window.defaultStatus = descript;
}

//
// debug function, ignore :)
//
function cmGetProperties (obj)
{
	if (obj == undefined)
		return 'undefined';
	if (obj == null)
		return 'null';

	var msg = obj + ':\n';
	var i;
	for (i in obj)
		msg += i + ' = ' + obj[i] + '; ';
	return msg;
}