/*
 * LyStrutsDrawingArea.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.web.struts;

import java.awt.*;
import leon.misc.*;
import leon.view.*;


/**
 * This class implements a drawing area (map, chart, ...) for web viewer.
 *
 * @version $Id: LyStrutsDrawingArea.java 16172 2009-01-06 11:04:44Z jls $
 * @author  Lyria
 */
public abstract class LyStrutsDrawingArea extends LyStrutsPanel
{
	public static final String __VERSION =
		"$Id: LyStrutsDrawingArea.java 16172 2009-01-06 11:04:44Z jls $";

	/** Default frame. */
	protected static Frame     _frame;

	/**
	 * Gets the default frame.
	 *
	 * @return The default frame.
	 */
	public static Frame getDefaultFrame()
	{
		if (_frame == null)
		{
			_frame = new Frame();
			// ensure that the peer is ready.
			// a peer is required for some methods such as createImage()
			// see also : LyEnvironment.getImage()
			if (LyEnvironment.isOperatingSystem(LyEnvironment.OS_WINDOWS))
				_frame.addNotify();
		}

		return _frame;
	}

	/**
	 * Class constructor of a Drawing Area for the struts target.<br>
	 * Call the super implementation
	 *
	 * @param panel the panel component
	 */
	public LyStrutsDrawingArea(LyPanel panel)
	{
		super(panel);
	}

} // end class LyStrutsDrawingArea
