/*
 * LyStrutsListOption.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.web.struts;

import leon.view.*;
import leon.view.graphic.*;
import leon.view.web.*;


/**
 * This class implements the ListOption object (as described in the dtd) for web viewer.
 *
 * <p><b>LIST_OPTION: List Option</b><br>
 * A list option represents a possible value in an input field of List type.</p>
 *
 * @version $Id: LyStrutsListOption.java 23300 2009-12-17 13:56:41Z jlsaouli $
 * @author  Lyria
 * @see     LyListOption
 */
public class LyStrutsListOption extends LyWebObject
	implements LyGraphicalListOption
{
	public static final String __VERSION =
		"$Id: LyStrutsListOption.java 23300 2009-12-17 13:56:41Z jlsaouli $";

	/** The list option generic component. */
	protected LyListOption     _option;

	/**
	 * Class constructor of a List Option object for the struts target.
	 *
	 * @param option the generic List Option defined for every type of view targets
	 */
	public LyStrutsListOption(LyListOption option)
	{
		super(option);
		_option = option;
	}

	/*
	 * (non-Javadoc)
	 * @see leon.view.web.LyWebComponent#writeHtml(leon.view.web.LyWebPageWriter)
	 */
	public void writeHtml(LyWebPageWriter pw)
	{
	    pw.startComponent(this);
	    
		String label = _option.getLabel();

		label = getHtmlString(label);
		String optionId = getHtmlEntitiesString(_option.getId());
		
		pw.append("\n<option value='" + optionId + "'");
		if (_option.isSelected())
			pw.append(" selected='true'");
		pw.append(">" + label + "</option>");
		
		pw.endComponent(this);
	}

	/*
	 * (non-Javadoc)
	 * @see leon.view.setinterface.LySetSelectedInterface#setSelected(boolean)
	 */
	public void setSelected(boolean selected)
	{
		refresh();
	}
} // end class LyStrutsListOption
