/*
 * LyWebParameterValues.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.web.struts;

import javax.servlet.http.*;

import leon.misc.*;
import leon.view.*;
import leon.view.web.*;


/**
 * Submit data from one or several forms.
 *
 * @version $Id: LyStrutsParameterValues.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public class LyStrutsParameterValues extends LyWebParameterValues
{
	public static final String   __VERSION =
		"$Id: LyStrutsParameterValues.java 28422 2010-11-03 12:03:38Z ehelmste $";


	/**
	 * Constructor.
	 *
	 * @param request the HTTP request
	 * @param string  the reference to the LyString
	 */
	public LyStrutsParameterValues(HttpServletRequest request, LyString string)
	{
		super(request, string);
	}

	/*
	 * (non-Javadoc)
	 * @see leon.view.web.LyWebParameterValues#needFileUpdate(leon.view.LyFile)
	 */
    protected LyFile needFileUpdate(LyFile file)
    {
    	if (file.getAttachmentHandler() != null)
    	{
    		// If upload is being processed, return standard result. Otherwise, return null because file
    		// component has already been updated by the upload process.
        	String	upload = getParameter(LyWebConstants.UPLOAD);
        	
        	if (upload != null)
        		upload = upload.intern();
        	
        	if (upload != "true")
        		return null;
    	}
    	
    	return super.needFileUpdate(file);
    }
} // end class LyStrutsParameterValues
