/*
 * LyStrutsPolygon.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.web.struts;

import leon.view.*;
import leon.view.graphic.*;
import leon.view.web.*;


/**
 * This class implements the Polygon object (as described in the dtd) for web viewer.
 *
 * <p><b>POLYGON: polygon</b><br>
 * A polygon allows to define a set of points used to describe a map region.</p>
 *
 * @version $Id: LyStrutsPolygon.java 16172 2009-01-06 11:04:44Z jls $
 * @author  Lyria
 * @see     leon.view.LyPolygon
 */
public class LyStrutsPolygon extends LyWebObject
	implements LyGraphicalPolygon
{
	public static final String __VERSION =
		"$Id: LyStrutsPolygon.java 16172 2009-01-06 11:04:44Z jls $";

	/** The icon generic component. */
	protected LyPolygon		   _polygon;

	/**
	 * Class constructor of an Idon object for the struts target.
	 *
	 * @param icon the generic Icon defined for every type of view targets
	 */
	public LyStrutsPolygon(LyPolygon polygon)
	{
		super(polygon);
		_polygon = polygon;
	}

	/*
	 * (non-Javadoc)
	 * @see leon.view.web.LyWebComponent#writeHtml(leon.view.web.LyWebPageWriter)
	 */
	public void writeHtml(LyWebPageWriter pw)
	{
	}

	/*
	 * (non-Javadoc)
	 * @see leon.view.setinterface.LySetColorInterface#setColor(java.lang.String)
	 */
	public void setColor(String color)
	{
		LyMapRegion		 mapRegion = (LyMapRegion)_polygon.getParent();
		LyStrutsMapRegion webMapRegion = (LyStrutsMapRegion)mapRegion.getInternalView();

		webMapRegion.refresh();
	}
} // end class LyStrutsPolygon
