/*
 * LyStrutsAuditAction.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */
package leon.view.web.struts.action;

import javax.servlet.*;
import javax.servlet.http.*;

import leon.app.*;
import leon.view.web.*;

import org.apache.struts.action.*;


/**
 * Type : leon.view.web.struts.action.LyStrutsAboutAction<br>
 * This action just handles the audit action.
 *
 * @version $Id: LyStrutsAuditAction.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria S.A.
 */
public class LyStrutsAuditAction extends LyStrutsLeonardiAction
{
	public static final String __VERSION =
		"$Id: LyStrutsAuditAction.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Default constructor without parameters.<br>
	 * This constructor should be kept for Java reflection.
	 */
	public LyStrutsAuditAction()
	{
	}

	/**
	 * This action displays a pop-up with the about message.
	 *
	 * @param  mappings - The ActionMapping used to select this instance
	 * @param  bean     - The optional ActionForm bean for this request (if any)
	 * @param  request  - The HTTP request we are processing
	 * @param  response - The HTTP response we are creating
	 * @return null : an empty action forward while the action has written the response.
	 */
	public ActionForward execute(ActionMapping mappings, ActionForm bean,
		HttpServletRequest request, HttpServletResponse response)
		throws Exception
	{
		HttpSession				httpSession = request.getSession();
		ServletContext			context = httpSession.getServletContext();
		LyStrutsLeonardiPlugin	plugin = LyStrutsLeonardiPlugin.getPlugin(context);
		String					applicationId = plugin.getInitName();
		LyApplication			application = LyApplication.getApplication(applicationId);

		// If no application is loaded, create one in order to access to its environment
		if (application == null)
			application = LyStrutsLeonardiPlugin.createApplication(context);

		// set no cache
		setNoCacheHeaders(response, 0);
		
		request.setAttribute(LyWebConstants.RA_LY_APP_NAME, applicationId);
		request.setAttribute(LyWebConstants.RA_LY_SKIN_URL, application.getEnvironment().getUrl("LY_CSS_FILE"));

		// Get the LY_HOME_PAGE ressource
		String homePage = application.getEnvironment().getUrl("LY_AUDIT_PAGE");

		// get the path relative to the context
		homePage = getContextReativePath(request, homePage);

		return new ActionForward(homePage);
	} // end method execute

} // end class LyStrutsAboutAction
