/*
 * LySwingChart.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.win.swing;

import leon.view.*;
import leon.view.graphic.*;


/**
 * This class implements the common behavior of the CHART object (as described in the dtd) for win &
 * Swing viewer.
 *
 * <p>A chart allows to display a graph representing statistics on data.</p>
 *
 * @version $Id: LySwingChart.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 * @see     LyRelation
 */
public abstract class LySwingChart extends LySwingPanel
	implements LyGraphicalChart
{
	public static final String __VERSION =
		"$Id: LySwingChart.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/** The view independent chart description. */
	protected LyChart		   _chart;

	/**
	 * Class constructor of a chart object for the Swing target.
	 *
	 * @param chart a CHART component defined for every type of view targets. This chart is
	 *              initialized specificaly for the Swing view.
	 */
	protected LySwingChart(LyChart chart)
	{
		super(chart);
	}

	/**
	 * This method is not implemented. Nothing is done.
	 *
	 * @see LyGraphicalChart#addColumn(LyColumn, int)
	 */
	public void addColumn(LyColumn column, int pos)
	{
		// XXX Not implemented
	}

	/**
	 * This method is not implemented. Nothing is done.
	 *
	 * @see LyGraphicalChart#removeColumn(LyColumn)
	 */
	public void removeColumn(LyColumn column)
	{
		// XXX Not implemented
	}
} // end class LySwingChart
