/*
 * LySwingLink.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.win.swing;

import leon.view.*;
import leon.view.graphic.*;


/**
 * This class implements the LyLink object. XXX implemented only to recurse setHeader call on
 * parent. To be removed
 *
 * <p>A link represents a possible value in an input field of Relation type.</p>
 *
 * @version $Id: LySwingLink.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 * @see     LyLink
 */
public class LySwingLink extends LySwingObject
	implements LyGraphicalLink
{
	public static final String __VERSION =
		"$Id: LySwingLink.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/** The view independent link description. */
	protected LyLink		   _link;

	/**
	 * Class constructor of a Link object for the Swing target.
	 *
	 * @param link a LINK component defined for every type of view targets
	 */
	public LySwingLink(LyLink link)
	{
		super(link);
		_link = link;
	}

	/**
	 * Sets the selected flag for the parent relation of this link.
	 *
	 * @param selected the new selected value for this link
	 * @see   leon.view.setinterface.LySetSelectedInterface#setSelected(boolean)
	 */
	public void setSelected(boolean selected)
	{
		LyRelation relation = (LyRelation)_link.getParent();

		((LySwingRelation)relation.getInternalView()).setSelected(_link, selected);
	}

} // end class LySwingLink
