/*
 * LySwingList.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.win.swing;

import leon.view.*;
import leon.view.graphic.*;


/**
 * This class implements the List option object (as described in the dtd) for swing viewer.
 */
public class LySwingListOption extends LySwingObject
    implements LyGraphicalListOption
{
    /** The list option generic component. */
    protected LyListOption     _option;

    /**
     * Class constructor of a List Option object for the Swing target.
     *
     * @param option the generic List Option defined for every type of view targets
     */
    public LySwingListOption(LyListOption option)
    {
        super(option);
        _option = option;
    }

    /*
     * (non-Javadoc)
     * @see leon.view.setinterface.LySetSelectedInterface#setSelected(boolean)
     */
    public void setSelected(boolean selected)
    {
        if (_option.getParent() instanceof LyList)
        {
            LySwingList list = (LySwingList)_option.getParent().getInternalView();
            
            list.selectOption(_option, selected);
        }
    }
} // end class LySwingListption
