/*
 * LyJCellCustomizedScrollable.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.win.swing.table;

import java.awt.*;


/**
 * The components that implements this interface can specify a customized preferred size used to
 * layout in a LyJTableScrollPane.
 *
 * <p>In Leonardi Swing Viewer, it is used to ignore the last column of a table during layout
 * process.</p>
 *
 * @version $Id: LyJCustomizedScrollable.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public interface LyJCustomizedScrollable
{
	String __VERSION = "$Id: LyJCustomizedScrollable.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Gets this component's preferred size for scrolling.
	 *
	 * @return the dimensions of the customized scrollable area
	 */
	Dimension getCustomizedScrollablePreferredSize();
}