/*
 * LyJBadFormatException.java
 * Copyright (c) 2000-2009, Lyria-W4.
 * All rights reserved.
 */

package leon.view.win.swing.text;

/**
 * This class defines exception that can be throw using LyJFormattedInput.
 *
 * @version $Id: LyJBadFormatException.java 28422 2010-11-03 12:03:38Z ehelmste $
 * @author  Lyria
 */
public class LyJBadFormatException extends Exception
{
	private static final long  serialVersionUID = -7598955288408372415L;

	public static final String __VERSION =
		"$Id: LyJBadFormatException.java 28422 2010-11-03 12:03:38Z ehelmste $";

	/**
	 * Constructor. Builds a new LyBadFormatException with the given level, the position of the
	 * error and the format where the error occur.
	 *
	 * @param level    the error level
	 * @param format   the bad format
	 * @param errorPos the positin of the error
	 */
	public LyJBadFormatException(String level, String format, int errorPos)
	{
		super(level + " : " + "Error at pos " + errorPos + " in String " + format);
	}
}