// LyActionScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyActionScript.js 35294 2012-04-19 08:12:42Z nhamon $

var parameters = 'scrollbars=yes,resizable=yes';
var size = 'width=640,height=480';
var smallSize = 'width=360,height=280';
var defaultDialogName = 'dialog';
var sourceParam = '_source';
var commandParam = '_command';
var hiddenParam = '_hidden';
var frameParam = '_frame';
var controllerParam = '_controller';
var pageParam = '_page';
var valueParam = '_value';
var typeParam = '_type';
var indexParam = '_index';
var extendParam = '_extend';
var submittedParam = '_submitted';
var targetControllerIdParam = '_target_controller';
var ajaxParam = '_ajax';
var positionX = '_positionX';
var positionY = '_positionY';

// This function invokes a command.
function InvokeCommand(actionId, url, noResult, isCheckField, submitMessage, fileErrorMessage, controllerId)
{
	var value;
	var targetForm;
	var mySelectionForm = findForm(null, controllerId);

	// If no form was found, try to get the first one in the current frame.
	// May happen if several controllers are used in the same frame.
	if ((mySelectionForm == null)
			&& (typeof window.document.forms[0] != "undefined"))
		mySelectionForm = window.document.forms[0];

	if ((mySelectionForm != null) && (typeof mySelectionForm.elements != "undefined") )
	{
		if ((submitMessage != null) && (mySelectionForm.elements[submittedParam] != null))
		{
			if (mySelectionForm.elements[submittedParam].value == "submitted")
			{
				alert(submitMessage);
				return;
			}
			else
			 	mySelectionForm.elements[submittedParam].value = "submitted";

		}

		// set the form action URL : usefull for struts (url may vary)
		if ((typeof url != "undefined") && (url != null) && (url != ""))
		{
			var actionUrl = "";
			if (((typeof _rootUrl) != "undefined") && (_rootUrl != null))
				actionUrl = _rootUrl;

			actionUrl += url;
			actionUrl = ReplaceString(actionUrl, "&#38;","&");

			mySelectionForm.action=actionUrl;
		}

		// Set the actionId input in the form
		if (mySelectionForm.elements[sourceParam] != null)
			mySelectionForm.elements[sourceParam].value = actionId;

		// Set the actionId input in the form
		if (mySelectionForm.elements[commandParam] != null)
			mySelectionForm.elements[commandParam].value = actionId;

		// Set the actionId input in the form
		if (mySelectionForm.elements[commandParam] != null)
			mySelectionForm.elements[controllerParam].value = controllerId;

		// Set the use of the hiddenFrame
		if (mySelectionForm.elements[hiddenParam] != null)
			mySelectionForm.elements[hiddenParam].value = "true";

		// Cancel any type param that has been set
		if (mySelectionForm.elements[typeParam] != null)
			mySelectionForm.elements[typeParam].value = "";

		if (IsAjaxMode(mySelectionForm))
		{
			// Target is reload frames (LyServlet manages frames to be reloaded)
			if (mySelectionForm.elements[frameParam] != null)
				mySelectionForm.elements[frameParam].value = targetFrameName;

			SendAjaxRequest(mySelectionForm, url);
		}
		else
		{
			try
			{
				// And we submit the form
				mySelectionForm.submit();
			}
			catch (ex)
			{
				// When a file input is displayed in the HTML form, the submit of form may
				// launch an error. Display a message asking the user to check values of
				// file inputs.
				if ((submitMessage != null) && (mySelectionForm.elements[submittedParam] != null))
				{
					mySelectionForm.elements[submittedParam].value = "";
				}

				alert(fileErrorMessage);
			}
		}
	}
	else
	{
		var date = new Date();
		// If no form was found, just call the given link
		InvokeLink(url+ "&reload=" + date.getTime(), targetFrameName,"true");
	}

	// If close or cancel command in a popup which has no Leonardi main frame, close the popup
	if ((actionId == "_close") || (actionId == "_cancel"))
	{
		var hasMainFrame = hasLeonardiMainFrame();

		if (!hasMainFrame)
		{
			var topFrame = getLeonardiTopFrame();

			if ((typeof topFrame.opener) != "undefined")
				topFrame.setTimeout("close()", 1000);
		}
	}
}

function InvokeSelection(actionId, valeur, controllerId, extend, path)
{
	var selectionForm = null;
	var oldController = null;

	// For a selection, form is in the current view
	if (typeof window.document.forms[0] != "undefined")
	{
		selectionForm = window.document.forms[0];

		if (typeof selectionForm.elements[controllerParam] != "undefined")
		{
			oldController = selectionForm.elements[controllerParam].value;

			if ((typeof controllerId == "undefined") || (controllerId.length == 0))
				selectionForm.elements[controllerParam].value = _controllerId;
			else
				selectionForm.elements[controllerParam].value = controllerId;
		}
	}
	else
		selectionForm = findForm(null,_controllerId);

	if (selectionForm != null)
	{
		// Set the actionId input in the form
		if( (typeof selectionForm.elements[sourceParam] != "undefined") && (selectionForm.elements[sourceParam] != null) )
			selectionForm.elements[sourceParam].value = actionId

		if (typeof valeur!="undefined")
			selectionForm.elements[valueParam].value = valeur;

		if ((typeof extend!="undefined") && (extend.length > 0))
			selectionForm.elements[extendParam].value = extend;

		if ((typeof notify!="undefined") && (notify == true))
			selectionForm.elements[frameParam].value = context.name;

		// Cancel any type param that has been set
		if (selectionForm.elements[typeParam] != null)
			selectionForm.elements[typeParam].value = "";

		if (IsAjaxMode(selectionForm))
		{
			SendAjaxRequest(selectionForm, path);
		}
		else
		{
			// If a form was found, submit !
			selectionForm.submit();
		}

		if (oldController != null)
			selectionForm.elements[controllerParam].value = oldController;
	}
}

// This function invokes a popup demand.
function InvokePopup(sourceId, index, url, controllerId, extend, xPos, yPos)
{
	if ( (typeof controllerId == "undefined") ||
		(controllerId == ""))
		controllerId = _controllerId;

	var selectionForm = findForm(null,controllerId);
	var oldController = null;

	if (selectionForm == null)
		selectionForm = findForm(null, null);

	// If no form was found, try to get the first one in the current frame.
	// May happen if several controllers are used in the same frame.
	if ((selectionForm == null)
		&& (typeof window.document.forms[0] != "undefined"))
	{
			selectionForm = window.document.forms[0];
	}

	if ((selectionForm != null) && (typeof selectionForm.elements != "undefined") )
	{
		// set the form action URL : usefull for struts (url may vary)
		if (IsAjaxMode(selectionForm) && (typeof url != "undefined") && (url != null) && (url != ""))
		{
			var actionUrl = "";
			if (((typeof _rootUrl) != "undefined") && (_rootUrl != null))
				actionUrl = _rootUrl;

			actionUrl += url;
			actionUrl = ReplaceString(actionUrl, "&#38;","&");

			selectionForm.action=actionUrl;
		}

		if (controllerId != null)
		{
			oldController = selectionForm.elements[controllerParam].value;

			if ((typeof selectionForm.elements[controllerParam] != "undefined")
					&& (selectionForm.elements[controllerParam] != null))
				selectionForm.elements[controllerParam].value = controllerId
		}

		// Set the source input in the form as _popupMenu
		if (selectionForm.elements[sourceParam] != null)
		{
			if (extend)
				selectionForm.elements[sourceParam].value = "_popupMenuExtend";
			else
				selectionForm.elements[sourceParam].value = "_popupMenu";
		}

		// Set the value input in the form
		if (selectionForm.elements[valueParam] != null)
			selectionForm.elements[valueParam].value = sourceId;

		// Set the index input in the form
		if (selectionForm.elements[indexParam] != null)
			selectionForm.elements[indexParam].value = index;

		// Set the use of the hiddenFrame
		if (selectionForm.elements[hiddenParam] != null)
			selectionForm.elements[hiddenParam].value = "true";

		// Set the position of popup menu
		if (selectionForm.elements[positionX] != null)
			selectionForm.elements[positionX].value = xPos;

		if (selectionForm.elements[positionY] != null)
			selectionForm.elements[positionY].value = yPos;

		// We want to use the hidden frame
		selectionForm.elements[hiddenParam].value = "true";

		// Cancel any type param that has been set
		if (selectionForm.elements[typeParam] != null)
			selectionForm.elements[typeParam].value = "";

		if (IsAjaxMode(selectionForm))
		{
			// Change the popup position to ensure popup will be displayed at the right position
			popupLeftOffset = xPos;
			popupTopOffset = yPos;

			var topFrame = getLeonardiTopFrame();
			var popupFrame = topFrame.frames[upFrameName];

			if (popupFrame != null)
				popupTopOffset = yPos + popupFrame.document.body.scrollHeight;

			SendAjaxRequest(selectionForm, url);
		}
		else
		{
			// And we submit the form
			selectionForm.submit();
		}

		if (oldController != null)
			selectionForm.elements[controllerParam].value = oldController;
	}
	else
	{
		var date = new Date();
		// If no form was found, just call the given link
		InvokeLink(url+ "&reload=" + date.getTime(), targetFrameName,"true");
	}
}

function InvokeStatus(url, value)
{
	InvokeAction('_status',url,'reload_frames',_controllerId,value);
}

// This function invokes an action.
function InvokeAction(actionId, url, target, controllerId, value, type)
{
	if ( (typeof controllerId == "undefined") ||
		(controllerId == ""))
		controllerId = _controllerId;

	if (controllerId.indexOf("_CONTROLLER_CHANGED_ID") > 0)
	{
		controllerId = controllerId.substring(0, controllerId.length -
			"_CONTROLLER_CHANGED_ID".length);
	}

	var selectionForm = null;
	var currentForm = this.document.forms[0];

	if ((currentForm != null)
		&& (currentForm.elements[controllerParam] != null)
		&& ((currentForm.elements[controllerParam].value == controllerId)
				|| (controllerId == null))
		&& (currentForm.elements[sourceParam] != null))
	{
			currentForm.elements[frameParam].value = this.name;
			selectionForm = currentForm;
	}

	if (selectionForm == null)
		selectionForm = findForm(null,controllerId);

	// If no form was found, try to get the first one in the current frame.
	// May happen if several controllers are used in the same frame.
	if ((selectionForm == null)
		&& (typeof window.document.forms[0] != "undefined"))
	{
			selectionForm = window.document.forms[0];
	}

	if (selectionForm == null)
		selectionForm = findForm(null, null);

	var oldControllerId = null;

	if (selectionForm != null)
	{
		if (controllerId != null)
		{
			if ((typeof selectionForm.elements[controllerParam] != "undefined")
					&& (selectionForm.elements[controllerParam] != null))
			{
				oldControllerId = selectionForm.elements[controllerParam].value;
				selectionForm.elements[controllerParam].value = controllerId;
			}
		}

		// Cancel any value param that has been set
		if ((typeof selectionForm.elements[valueParam] != "undefined")
				&& (selectionForm.elements[valueParam] != null))
			selectionForm.elements[valueParam].value = "";

		// Cancel any source param that has been set
		if ((typeof selectionForm.elements[sourceParam] != "undefined")
				&& (selectionForm.elements[sourceParam] != null))
			selectionForm.elements[sourceParam].value = "";

		// Cancel any type param that has been set
		if (selectionForm.elements[typeParam] != null)
			selectionForm.elements[typeParam].value = "";

		// If a value is given set the value input in the form
		if((value != null) && (typeof value != "undefined")
				&& (typeof selectionForm.elements[valueParam] != "undefined")
				&& (selectionForm.elements[valueParam] != null))
			selectionForm.elements[valueParam].value = value;

		// If a type is given set the value input in the form
		if((type != null) && (typeof type != "undefined")
				&& (typeof selectionForm.elements[typeParam] != "undefined")
				&& (selectionForm.elements[typeParam] != null))
			selectionForm.elements[typeParam].value = type;

		// Set the index if a close tab action is called
		if (((type == 'closeTab')
					|| (type == 'sort')
					|| (type == 'extendSort'))
				&& (selectionForm.elements[indexParam] != null))
			selectionForm.elements[indexParam].value = value;

		// Set the actionId input in the form
		if((typeof selectionForm.elements[sourceParam] != "undefined")
				&& (selectionForm.elements[sourceParam] != null))
			selectionForm.elements[sourceParam].value = actionId;

		// If no target is specified, use the step frame
		selectionForm.elements[hiddenParam].value = "true";
		selectionForm.elements[frameParam].value = target;

		if (IsAjaxMode(selectionForm))
		{
			SendAjaxRequest(selectionForm, url);
		}
		else
		{
			selectionForm.submit();
		}

		// Reset old controller id
		if (oldControllerId != null)
			selectionForm.elements[controllerParam].value = oldControllerId;
	}
	else
	{
		var date = new Date();
		// If no form was found, just call the given link
		InvokeLink(url+ "&reload=" + date.getTime(), target,"true");
	}
}

function InvokeDef(url)
{
	InvokeLink(url,'reload_frame','true');
}

function InvokeHref(url)
{
	InvokeLink(url,'','true');
}


// This function opens a link in a given target
function InvokeLink(url, target, hiddenFrame, newSize)
{
	var newUrl = "";
	var isRootUrl = false;

	if (newSize != null)
	{
		if (newSize == 'small')
			size = smallSize;
	}

	if (target.length == 0)
		target = targetFrameName;



	if (url != null && url != "")
	{
		if (url.indexOf("http:"))
			isRootUrl = true;
	}

	if (((typeof _rootUrl) != "undefined") && (_rootUrl != null)
		&& isRootUrl)
	{
		// Compute the partial rootUrl: i.e.  the part of the url from the beginning to ?
		var pos = _rootUrl.indexOf("?");
		var root = _rootUrl;
		if (pos >= 0)
		{
			root = _rootUrl.substring(0, pos);
		}

		if (url.indexOf(root) != 0)
		{
			newUrl = _rootUrl;
		}
	}


	newUrl += url;
	newUrl = ReplaceString(newUrl, "&#38;","&");
	var finalTarget;

	if ( ((typeof hiddenFrame) != "undefined") && (hiddenFrame=="true") )
	{
	}
	else
	{
		// We are in the hiddenFrame
		// the target frame must get its page
		finalTarget = findTarget(null, target);

		// first we have to find main_frame or target_frame
		if (finalTarget == null)
		{
			finalTarget = findTarget(null, targetFrameName);
			/*if (target=='popup_view')
			{
				//If popup not exist create a iframe
				var tempTarget = findTargetByContent(null, 'savePopUp');
				var myScript = tempTarget.addIframe;

				replaceDivInnerHtml(tempTarget.name,'savePopUp',myScript);
				tempTarget = findTarget(tempTarget, target);

				if (tempTarget != null)
					finalTarget = tempTarget;
			}*/
		}

		// if main_frame or target_frame are undefined, we have to construct main_frame
		// else the target is certainly target_frame
		if (finalTarget == null)
		{
			finalTarget = findTarget(null,mainFrameName);
			// We need to rebuild MainFrame structure (frameset)
			if (finalTarget != null)
				newUrl += "&_source=" + finalTarget.name;
		}
		else
		{
			newUrl += "&_frame=" + finalTarget.name;
		}
	}

	if (finalTarget != null)
		finalTarget.location.replace(newUrl);
	else if (AJAX_MODE == 'force')
		SendAjaxRequest(null, newUrl);

	return;
}

// This function invokes a print job
function InvokePrint(url, target, areaId, actionId)
{
	var newUrl ='';

	newUrl += ReplaceString(url, "&#38;","&");
	newUrl += "&" + hiddenParam + "=true";

	// Add area id in source
	var toolbar = "";

	newUrl = ReplaceString(newUrl, actionId, "_print");

	if (((typeof areaId) != "undefined") && (areaId != null))
		newUrl = ReplaceString(newUrl, "_print","_print" + areaId);

	if (this.print == "undefined")
		toolbar = ",toolbar=yes";

	open(newUrl, null, parameters + toolbar + ',width=600,height=500');
}

// This function opens a print job in a new window
function OpenPrintPopup(url, popupMessage)
{
	var toolbar = "";

	if (this.print == "undefined")
		toolbar = ",toolbar=yes";

	var printWindow = open(url, null, parameters + toolbar + ',width=600,height=500');

	if (printWindow == null)
	{
		alert(popupMessage);
		SendAjaxRequestParams(url + '&_cancel=true', '', 'false')
	}
}

// This function returns a valid name for a new Window
function GetWindowName(newUrl)
{
	var targetName;

	targetName = ReplaceString(newUrl, ':', '_');
	targetName = ReplaceString(targetName, '\\', '_');
	targetName = ReplaceString(targetName, '\/', '_');
	targetName = ReplaceString(targetName, '?', '_');
	targetName = ReplaceString(targetName, '&', '_');
	targetName = ReplaceString(targetName, '.', '_');
	targetName = ReplaceString(targetName, '=', '_');

	return targetName;
}

// This function selects a tab in a tabs view
function SelectTab(url, index, controllerId, pageId, frameName, targetFormId, targetControllerId, type)
{
	var targetForm;
	var mySelectionForm;
	var oldController = null;

	mySelectionForm = findForm(null, controllerId);

	if ((mySelectionForm != null) && (typeof mySelectionForm.elements != "undefined"))
		targetForm = findTarget(null, mySelectionForm.elements[frameParam].value);

	// If no form was found, try to get the first one in the current frame.
	// May happen if several controllers are used in the same frame.
	if ((mySelectionForm == null)
		&& (typeof window.document.forms[0] != "undefined"))
	{
			mySelectionForm = window.document.forms[0];

			if (typeof mySelectionForm.elements[controllerParam] != "undefined")
			{
				oldController = mySelectionForm.elements[controllerParam].value;

				if ((typeof controllerId == "undefined") || (controllerId.length == 0))
					mySelectionForm.elements[controllerParam].value = _controllerId;
				else
					mySelectionForm.elements[controllerParam].value = controllerId;
			}
	}

//	if (mySelectionForm == null)
//		mySelectionForm = findForm(null, null);

	if ((mySelectionForm != null) && (typeof mySelectionForm.elements != "undefined") )
	{
		// Set the actionId input in the form
		if (mySelectionForm.elements[sourceParam] != null)
			mySelectionForm.elements[sourceParam].value = "_tabs";

		// set the form action URL : usefull for struts (url may vary)
		if ((typeof url != "undefined") && (url != null) && (url != ""))
		{
			var actionUrl = "";
			if (((typeof _rootUrl) != "undefined") && (_rootUrl != null))
				actionUrl = _rootUrl;

			actionUrl += url;
			actionUrl = ReplaceString(actionUrl, "&#38;","&");

			mySelectionForm.action=actionUrl;
		}

		// Reset any value param that has been set
		if (mySelectionForm.elements[valueParam] != null)
			mySelectionForm.elements[valueParam].value = "";

		// Set the target
		if (mySelectionForm.elements[pageParam] != null)
			mySelectionForm.elements[pageParam].value = pageId;

		// Set the target
		if (mySelectionForm.elements[indexParam] != null)
			mySelectionForm.elements[indexParam].value = index;

		// Set the target
		if ((targetControllerId != null) && (mySelectionForm.elements[targetControllerIdParam] != "undefined"))
			mySelectionForm.elements[targetControllerIdParam].value = targetControllerId;

		// Cancel any type param that has been set
		if (mySelectionForm.elements[typeParam] != null)
			mySelectionForm.elements[typeParam].value = type;

		if (IsAjaxMode(mySelectionForm))
		{
			SendAjaxRequest(mySelectionForm, url);
		}
		else
		{
			// And we submit the form
			mySelectionForm.submit();
		}

		if (oldController != null)
			mySelectionForm.elements[controllerParam].value = oldController;
	}
	else
	{
		// If no form was found, just call the given link
		var date = new Date();

		if (AJAX_MODE)
		{
			SendAjaxRequest(null, url + "&" + typeParam + "=" + type + "&reload=" + date.getTime());
		}
		else
		{
			InvokeLink(url + "&reload=" + date.getTime(), frameName, "true");
		}
	}
}

// This function opens or closes a toolbar
function OpenToolbar(url)
{
	var newUrl = _rootUrl + url;
	var date = new Date();

	newUrl = ReplaceString(newUrl , "&#38;" , "&");
	newUrl = newUrl + "&reload=" + date.getTime() + "&_frame=" + this.name;

	this.location.href = newUrl;
}

//Those functions set Image backgrounds of a command button whether the mouse is over it or not
function rollover(img, path, source) {
	img.src = path + source;
}

function rollout(img, path, source) {
	img.src = path + source;
}

function changeLineBg(line, path, source)
{
	line.style.background = "url(" + path + source + ")";
}// LyDateScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyDateScript.js 35339 2012-04-23 14:46:31Z smaupin $

var dateForm;
var field;
var dateField;
var timeField;
var initialDay;
var initialMonth;
var initialYear;
var currentDate;
var yearLeftImage;
var monthLeftImage;
var monthRightImage;
var yearRightImage;
var dateLang;
var dateType;
var previousValues;
var calendarFrameId;
var dateSelectorEvent = false;

var yearTmp;

// This function displays the date selector
// @param form the form containing the date field
// @param field the date/time hidden field name
// @param fieldDate the date field name
// @param fieldTime the time field name
// @param form the language
// @param form the image path for year decrement
// @param form the image path for month decrement
// @param form the image path for month increment
// @param form the image path for year increment
// @param type the type of the date field : it's an integer and must be the same
// as constants defined in LyDate.java.
function ShowDateSelector(frameId, scriptPath, form, fieldName, fieldDateName,
	fieldTimeName, lang, yearLeft, monthLeft, monthRight, yearRight, type)
{
	if (typeof form == "undefined")
		form = this.document.forms[0];

	// Initialize values
	yearLeftImage = yearLeft;
	monthLeftImage = monthLeft;
	monthRightImage = monthRight;
	yearRightImage = yearRight;
	dateLang = lang;
	dateForm = form;
	field = fieldName;
	dateField = fieldDateName;
	timeField = fieldTimeName;
	dateType = type;
	yearTmp = null;
	calendarFrameId = frameId;

	var value = form.elements[dateField].value;

	// If not english, swap day and month
//	if (dateLang != "en_US" && dateLang != "en_EN")
//		value = DateLangSwapDayMonth(value);

	if (value.length <= 0)
		currentDate = new Date();
	else
	{
		currentDate = parseDate(value, form.elements[dateField]);

		if (isNaN(currentDate))
			currentDate = new Date();
	}

	initialDay = currentDate.getDate();
	initialMonth = currentDate.getMonth();
	initialYear = currentDate.getFullYear();

	SetFrameSrc(frameId, scriptPath + '/LyDateSelector.html');
	CloseLastDivShown();
	SwitchDivVisibility(frameId);
	SetDivSize(frameId, 155, 155);
}

// This function hides the date selector immediatly
function HideDateSelector()
{
	CloseLastDivShown();
	SetDivVisibility(calendarFrameId, false);
	calendarFrameId = null;
}

// This function updates the date field.
function DateSelectorEvent()
{
	dateSelectorEvent = true;

	UpdateDate(dateForm, field, dateField, timeField, dateType, dateLang, 'false', 'true', 10);
	HideDateSelector();

	dateSelectorEvent= false;
}

// This function swap the day and the month of the given value.
function DateLangSwapDayMonth(value)
{
	if (value.length <= 5)
		return value;

	var n1 = value.indexOf('/', 0);
	var n2 = value.indexOf('/', n1 + 1);

	if (n1>0 && n2 > n1+1)
	{
		var newDate = value.substring(n1 + 1, n2 + 1) + value.substring(0, n1) +
			value.substring(n2);

		value = newDate;
	}

	return value;
}

// This function add a 0 before the number if single-figure number.
function GetTwoFiguresNumber(number)
{
	if (number.length >= 2)
		return number;

	return (number < 10) ? '0' + number : number;
}

// This function converts a year for being Y2K compliant.
function ConvertY2K(number)
{
 	if (number < 20)
		number += 2000;
 	if (number < 100)
		number += 1900;

	return number;
}

function TransformCurrentDate(dateField, optional)
{
	var str = '';

	if (currentDate == null)
		currentDate = new Date();

	str = formatDate(currentDate, dateField);

//	if (dateLang == "en_US" || dateLang == "en_EN")
//		str = DateLangSwapDayMonth(str);

	if (dateField != null)
	{
		if ((dateField.value != "") ||
		    ((optional != "true") && (dateField.value == "")))
		{
			dateField.value = str;
		}
	}
}

// Format a date using a given field and its format
function formatDate(date, dateField)
{
	var dayString = GetTwoFiguresNumber(currentDate.getDate());
	var monthString = GetTwoFiguresNumber(currentDate.getMonth() + 1);
	var yearString;

	if (dateSelectorEvent)
	{
		yearString = "" + yearTmp;

		while (yearString.length < 4)
			yearString = "0" + yearString;

		yearTmp = null;
	}
	else
		yearString = currentDate.getFullYear();

	var dateFormat = dateField.getAttribute("dateFormat");
	var str = "";
	var pos;
	var currentChar;
	var daySet = false, monthSet = false, yearSet = false;

	for (pos = 0; pos < dateFormat.length; pos++)
	{
		currentChar = dateFormat.substring(pos, pos + 1);

		if (currentChar == 'd')
		{
			if (!daySet)
			{
				str = str + dayString;
				daySet = true;
			}
		}
		else if (currentChar == 'M')
		{
			if (!monthSet)
			{
				str = str + monthString;
				monthSet = true;
			}
		}
		else if (currentChar == 'y')
		{
			if (!yearSet)
			{
				str = str + yearString;
				yearSet = true;
			}
		}
		else
			str = str + currentChar;
	}

	return str;
}

// Parse a date using a given field and its format
function parseDate(value, dateField)
{
	var dateFormat = dateField.getAttribute("dateFormat");

	if ((value == null) || (typeof value == "undefined") || value.length != dateFormat.length)
		return new Date();

	var pos;
	var currentValueChar, currentFormatChar;
	var dayString = "", monthString = "", yearString = "";

	for (pos = 0; pos < value.length; pos++)
	{
		currentValueChar = value.substring(pos, pos + 1);
		currentFormatChar = dateFormat.substring(pos, pos + 1);

		if (currentFormatChar == 'd')
			dayString = dayString + currentValueChar;
		else if (currentFormatChar == 'M')
			monthString = monthString + currentValueChar;
		else if (currentFormatChar == 'y')
			yearString = yearString + currentValueChar;
	}

	return new Date(monthString + "/" + dayString + "/" + yearString);
}

// This function resets the internal date. Mandatory when this date was created
// by the popup date selector to "close" the links to the popup window.
function ResetDate()
{
	currentDate = new Date(currentDate.getYear(),
		currentDate.getMonth(), currentDate.getDate());

	if (currentDate == null
		|| isNaN(currentDate))
			currentDate = new Date();
}

function UpdateDateOnBlur(form, fieldName, dateFieldName, timeFieldName, type,
	lang, optional, format, error, updateFieldValue)
{
	if (typeof form == "undefined")
		form = this.document.forms[0];

	var dateField = form.elements[dateFieldName];
	var timeField = form.elements[timeFieldName];
	var check = CheckFormatField(form, dateFieldName, format, error, 'true');
	var updateField = (typeof updateFieldValue == "undefined") || (updateFieldValue != false);

	if (check == "false")
	{
		// update the date field with the previous value
		var previousValue = GetPreviousValue(dateFieldName);

		if (previousValue != "")
		{
			if (updateField)
				dateField.value = previousValue;

			UpdateDate(form, fieldName, dateFieldName, timeFieldName, type, lang, optional, "false", null, updateField);
		}
		else if (optional == "true")
		{
			if (updateField)
				dateField.value = "";

			UpdateDate(form, fieldName, dateFieldName, timeFieldName, type, lang, optional, "false", null, updateField);
		}
		else 	// update the date with transformation of the current date
			UpdateDate(form, fieldName, dateFieldName, timeFieldName, type, lang, "false", "true", null, updateField);
	}
	else
	{
		var transform = "false";

		// if the new value is null and the field not optional : revert to previous value
		//var dateField = form.elements[dateFieldName];
		if ((optional != "true") && (dateField.value == ""))
			dateField.value = GetPreviousValue(dateFieldName);
		else
			StorePreviousValue(dateField); // update the previous value

		// if is optional and the date is null, set time field to null

		if ((optional == "true") && (timeField != null))
		{
			if (updateField)
			{
				if (dateField.value == "")
					timeField.value = "";
				else if (timeField.value == "")
					timeField.value = GetDefaultTime(type);
			}
		}
		else if ((optional != "true") && (timeField != null))
		{
		 	if (updateField && (timeField.value == "") && (dateField.value != "") )
		 	{
				timeField.value = GetDefaultTime(type);
			}
		}

		var length = dateField.value.length;

		// update the date
		UpdateDate(form, fieldName, dateFieldName, timeFieldName, type, lang, optional, transform, length, updateField);
	}
}

function UpdateTimeOnBlur(form, fieldName, dateFieldName, timeFieldName, type,
	lang, optional, format, error, updateFieldValue)
{
	var timeField = form.elements[timeFieldName];
	var dateField = form.elements[dateFieldName];
	var updateField = (typeof updateFieldValue == "undefined") || (updateFieldValue != false);

	if (CheckFormatField(form, timeFieldName, format, error, 'true') == "false")
	{
		// update the date field with the previous value
		var previousValue = GetPreviousValue(timeFieldName);

		var transform = "false";

		if (previousValue != "")
		{
			if (updateField)
				timeField.value = previousValue;
		}
		else if (optional == "true")
		{
			if (updateField)
				timeField.value = "";
		}
		else 	// update the date with transformation of the current date
		{
//			timeField.value = GetCurrentTime(type);
			transform = "true";
		}

		UpdateDate(form, fieldName, dateFieldName, timeFieldName, type, lang, optional, transform, null, updateField);
	}
	else
	{
		var transform = "false";

		if ((optional != "true") && (timeField.value == "") && updateField)
			timeField.value = GetPreviousValue(timeFieldName);
		else
			StorePreviousValue(timeField); // update the previous value


		// if the field is optional if the time value is empty : empty the date.
		if ( (optional == "true") && (dateField != null) )
		{

			if (timeField.value == "")
			{
				if (updateField)
					dateField.value = "";
			}
			else
			{
				if ((dateField != null) && (dateField.value == ""))
				{
					optional = "false";
					transform = "true";
				}
			}
		}
		else if (timeField.value != null)
		{
			// Obligatory: if the timeField is not null, the date field should not be null!
		 	if ( (dateField != null) && (dateField.value == "") && (timeField.value.length != 0))
		 		transform = "true";
		}
		UpdateDate(form, fieldName, dateFieldName, timeFieldName, type, lang, optional, transform, null, updateField);
	}
}

// This function updates a field with a date field and a time field.
function UpdateDate(form, fieldName, dateFieldName, timeFieldName, type, lang, optional, transform, length, updateField)
{
	var field = form.elements[fieldName];
	var dateField = form.elements[dateFieldName];
	var timeField = form.elements[timeFieldName];
	var timeAmPmField = form.elements[timeFieldName + "_ampm"];
	var value = "";

	if (currentDate == null)
		currentDate = new Date();
	dateLang = lang;

	if (typeof updateField == "undefined")
		updateField = true;

	if ((transform != "false") && updateField)
		TransformCurrentDate(dateField, optional);

	// check if the value of the date is Y2K compliant
	// and modify it if needed.
	if ((dateField != null) && updateField)
	{
		var dateValue = dateField.value;
		if (dateValue != null)
		{
			var yearStr = dateValue.substring(dateValue.lastIndexOf("/") + 1);
			var d = new Date("01/01/" + yearStr);

			yearStr = removeLeadingZeros(yearStr);
			var year = parseInt(yearStr);

			if ((year < 1000) && (length != null) && (length < 10)) // case of a date lower than 1000
			{
				// If lower than 30 consider it is 20xx
				if (year < 10)
					year = "200" + year;
				else if (year < 30)
					year = "20" + year;
				// If lower than 100 but greater than 10 it is 19xx
				else if (year < 100)
					year = "19" + year;
				// If lower than 1000 it is 0xxx
				else if (year < 1000)
					year = "0" + year;

				// create the new value for the field
				var str = dateValue.substring(0,dateValue.lastIndexOf("/"));
				str = str+"/"+year;
				dateField.value = str;
				StorePreviousValue(dateField);
			}
		}
	}

	if ((transform == "true") && updateField)
	{
		if ((timeField != null) && (timeField.value == "")) {
			if ((timeAmPmField != null) && (typeof timeAmPmField != "undefined")) {
				timeField.value = GetAmPmDefaultTime(type);
				setSelectedIndex(timeAmPmField, isAmPm());
			} else {
				timeField.value = GetDefaultTime(type);
			}
		}
	}


	if (field != null)
	{
		if (dateField != null)
			value = dateField.value;

		if (timeField != null)
		{
			// If date and time are not null, add a space between the values
			if ((value.length != 0) && (timeField.value.length != 0))
				value += " ";

			value += timeField.value;

			if ((timeAmPmField != null) && (typeof timeAmPmField != "undefined") && timeField.value) {
				value += " " + isAmPm();
				setSelectedIndex(timeAmPmField, isAmPm());
			}
				

			if (!updateField && (optional != "true"))
			{
				if ((value.length != 0) && (timeField.value.length != 0))
					value += " ";
				if ((timeAmPmField != null) && (typeof timeAmPmField != "undefined")) {
					value += GetAmPmDefaultTime(type) + " " + isAmPm();
					setSelectedIndex(timeAmPmField, isAmPm());
				} else {
					value += GetDefaultTime(type);
				}
			}
		}
	}

	// Notify new value only if it has changed
	field.value = value;

	var checkDateField = form.elements['_checkDate' + fieldName];

	if ((checkDateField != null) && updateField)
	{
		var checkDateValue = checkDateField.value;

		FieldChange(form, field, checkDateValue);
	}
}

function setSelectedIndex(selectField, value) {
	if (selectField) {
		for (var i = 0; i< selectField.options.length; i++) { 
			if (selectField.options[i].value == value) {
				selectField.options[i].selected = true;
				break;
			}
		}
	}
	return;
}


// This function returns the current time
function GetCurrentTime(type)
{
	var date = new Date();
	var hours;
	var minutes;
	var seconds;
	var result;

	hours = date.getHours();
	minutes = date.getMinutes();
	seconds = date.getSeconds();

	if (hours < 10)
		hours = '0' + hours;
	if (minutes < 10)
		minutes = '0' + minutes;
	if (seconds < 10)
		seconds = '0' + seconds;

	if ((type == "DATE_TIME") || (type == "TIME"))
		// DATE_TIME or TIME
		result = hours + ":" + minutes + ":" + seconds;
	else if ((type == "DATE_HOUR_MIN") || (type == "HOUR_MIN"))
		// DATE_HOUR_MIN or HOUR_MIN
		result = hours + ":" + minutes;
	else
		// HOUR
		result = hours;

	return result;
}


function isAmPm() {
	var now = new Date();
	var hour = now.getHours();
	var ap = "AM";
	if (hour > 12) {
		ap = "PM";
	}
	return ap;
}

function GetAmPmDefaultTime(type) {
	var now = new Date();
	var hour = now.getHours();
	var minute = now.getMinutes();
	var second = now.getSeconds();
	var ap = "AM";
	if (hour > 11) {
		ap = "PM";
	}
	if (hour > 12) {
		hour = hour - 12;
	}
	if (hour == 0) {
		hour = 12;
	}
	if (hour < 10) {
		hour = "0" + hour;
	}
	if (minute < 10) {
		minute = "0" + minute;
	}
	if (second < 10) {
		second = "0" + second;
	}

	if ((type == "DATE_TIME") || (type == "TIME"))
		// DATE_TIME or TIME
		result = hour + ":" + minute + ":" + second + " " + ap;
	else if ((type == "DATE_HOUR_MIN") || (type == "HOUR_MIN"))
		// DATE_HOUR_MIN or HOUR_MIN
		result = hour + ":" + minute + " " + ap;
	else
		// HOUR
		result = hour + " " + ap;
	return result;
}


// This function returns the current time
function GetDefaultTime(type)
{
	var date = new Date();
	var hours;
	var minutes;
	var seconds;
	var result;

	hours = date.getHours();
	minutes = date.getMinutes();
	seconds = date.getSeconds();

	if (hours < 10)
		hours = "0" + hours;

	if (minutes < 10)
		minutes = "0" + minutes;

	if (seconds < 10)
		seconds = "0" + seconds;

	if ((type == "DATE_TIME") || (type == "TIME"))
		// DATE_TIME or TIME
		result = hours + ":" + minutes + ":" + seconds;
	else if ((type == "DATE_HOUR_MIN") || (type == "HOUR_MIN"))
		// DATE_HOUR_MIN or HOUR_MIN
		result = hours + ":" + minutes;
	else
		// HOUR
		result = hours;

	return result;
}

// This function stores the previous value of a date input
function StorePreviousValue(dateInput)
{
	if (typeof previousValues == "undefined")
		previousValues = new Array();
	previousValues[dateInput.name] = dateInput.value;
}

// retrieves the previous value for a given date field
function GetPreviousValue(dateInputName)
{
	return previousValues[dateInputName];
}
// LyStringScript.js
// Copyright (c) 2000, Lyria.
// All rights reserved.
// @version	$Id: LyDictionaryScript.js 36403 2012-07-31 09:33:16Z nhamon $

// The root node of the dictionary
var dictionaryRoot;
// The selection mode : 0 if none, 1 if single, 2 if multiple
var selectionMode;
// The current selection
var selectedNode;
// The number of values before children in the array representing the nodes
var varBeforeChildren = 6;

var parent_form;
var parent_field_name;
var hidden_field_name;

var sep;
var visibleSep;
var is_popup;
var root_window;

var last_node_open;
var last_node_closed;
var node_open;
var node_closed;
var last_node;
var blank_node;
var vertical_line_node;
var simple_node;
var empty_checkbox;
var checked_checkbox;
var disabled_checkbox;

// The frame name where dictionary shall be written
var dictionaryTagName;

// This function creates an instance of entry.
// Each entry in the dictionary is an Array with at least 6 values :
// entry[0] id of the node
// entry[1] name of the node
// entry[2] indicates if the node is open
// entry[3] indicates if the node is selected
// entry[4] icon of the node when closed
// entry[5] icon of the node when open
// entry[6]...entry[6+n] the n children nodes
// @param id id of the node
// @param name name of the node
// @param nodeClosed icon of the node when closed
// @param nodeOpen icon of the node when open
// @param open indicates if the node is open
// @param selected indicates if the node is selected

function entry(id, name, nodeClosed, nodeOpen, open, selected)
{
	var node;

	node = new Array;

	node[0] = id;
	node[1] = name;
	node[2] = open;
	node[3] = selected;
	node[4] = nodeClosed;
	node[5] = nodeOpen;

	if (selected)
		selectedNode = node;

	return node;
}

// This function returns the id of a node.
function getId(entry)
{
	return entry[0];
}

// This function returns the name of a node.
function getName(entry)
{
	if (entry[1] == "")
		return "&nbsp;&nbsp;&nbsp;&nbsp;";

	return entry[1];
}

// This function indicates whether the node is open or not.
function isOpen(entry)
{
	if (entry == dictionaryRoot)
		return true;

	return entry[2];
}

// This function indicates whether the node is selected or not.
function isSelected(entry)
{
	return entry[3];
}

// This function returns the icon of a node when closed.
function getIconClosed(entry)
{
	return entry[4];
}

// This function returns the icon of a node when open.
function getIconOpen(entry)
{
	return entry[5];
}

// This function returns the link of a node (for href).
function getLink(entry)
{
	return getId(entry);
}

// This function indicates whether the node has children or not.
function hasChildren(entry)
{
	return (entry.length > varBeforeChildren);
}

// Open or close the node.
function setOpen(entry, open)
{
	entry[2] = open;
}

// Select or unselect the node.
function setSelected(entry, selected)
{
	entry[3] = selected;
}

// Add a child to the node.
function addChild(parent, child)
{
	parent[parent.length] = child;

	return child;
}

// Write the dictionary in the given document.
function writeDictionary(updateFromHiddenField, controller)
{
	if (updateFromHiddenField == true)
	{
		var nodes;

		nodes = new Array;

		GetSelectedNodes(nodes, dictionaryRoot);

		for (var i = 0; i < nodes.length; i++)
		{
			nodeTmp = nodes[i];
			setSelected(nodeTmp, false);
		}

		var selectedNodes = StringToArray(GetHiddenValue(), sep);

		for (var i = 0; i < selectedNodes.length; i++)
		{
			selectNode(selectedNodes[i], false, null);
		}
	}

	var cell = document.getElementById(dictionaryTagName);

	cell.innerHTML = writeNode(dictionaryRoot, 0, 1, "", controller);
}

// Write the node in the given document.
function writeNode(node, level, lastNode, leftSide, controller)
{
	var j = 0;
	var i = 0;
	var celltext = "";

	celltext += "<table border=0 cellspacing=0 cellpadding=0>";
	celltext += "<tr>";
	celltext += "<td valign='middle' nowrap='true'>";
	celltext += leftSide;

	if (level > 0)
	{
		var		idNode = ReplaceString(getId(node), "\\", "\\\\");


		if (hasChildren(node))
			celltext += "<a href='javascript:openNode(\"" +
				idNode + "\",\"" + controller + "\");' onmouseover=\"window.status='';return true;\">";

		if (lastNode)
		{
			if (hasChildren(node) && isOpen(node))
				celltext += "<img src='" + last_node_open + "' width='16' height='22'";
			else if (hasChildren(node) && !isOpen(node))
				celltext += "<img src='" + last_node_closed + "' width='16' height='22'";
			else
				celltext += "<img src='" + last_node + "' width='16' height='22'";
		}
		else
		{
			if (hasChildren(node) && isOpen(node))
				celltext += "<img src='" + node_open + "' width='16' height='22'";
			else if (hasChildren(node) && !isOpen(node))
				celltext += "<img src='" + node_closed + "' width='16' height='22'";
			else
				celltext += "<img src='" + simple_node + "' width='16' height='22'";
		}

		celltext += " border='0' />";

		if (hasChildren(node))
			celltext += "</a>";

		if (lastNode)
			leftSide = leftSide + "<img src='" + blank_node + "' width='16' height='22' />";
		else
			leftSide = leftSide + "<img src='" + vertical_line_node + "' width='16' height='22' />";
	}


	celltext += "</td>";
	celltext += writeNodeCell(node, controller);
	celltext += "</tr>";
	celltext += "</table>";



	if (hasChildren(node) && isOpen(node))
	{
		level = level + 1;

		for (i = varBeforeChildren; i < node.length; i++)
		{
			if (i == node.length - 1)
				celltext += writeNode(node[i], level, 1, leftSide, controller);
			else
				celltext += writeNode(node[i], level, 0, leftSide, controller);
		}
	}


	return celltext;
}

// Write the node cell (icon + label) in the given document.
function writeNodeCell(node, controller)
{
	var	link = ReplaceString(getLink(node), "\\", "\\\\");
	var	celltext = "";

	if ((selectionMode == 2) && (node != dictionaryRoot)
		&& (!hasChildren(node) || selection_type == 1))
	{
		celltext += "<td valign='middle' nowrap='true'>&nbsp;";
		celltext += "<a href='javascript:selectNode(\"" +
			link + "\",true,\"" + controller + "\");' class='link' onmouseover=\"window.status='';return true;\">";

		if (isSelected(node))
			celltext += "<img src='" + checked_checkbox + "' border='0'/>";
		else
			celltext += "<img src='" + empty_checkbox + "' border='0'/>";

		celltext += "</a>";
		celltext += "&nbsp;</td>";
	}

	celltext += "<td valign='middle' nowrap='true'>";

	if (isOpen(node) && (getIconOpen(node) != ""))
		celltext += "<img src='" + getIconOpen(node) + "' border='0' />";
	else if (getIconClosed(node) != "")
		celltext += "<img src='" + getIconClosed(node) + "' border='0' />";

	celltext += "</td>";
	celltext += "<td>&nbsp;</td>";

	celltext += "<td valign='middle' align='left' nowrap='true'";

	if (isSelected(node) && (selectionMode == 1))
		celltext += " bgcolor='#000088'";

	celltext += ">";

	if ((selectionMode != 0)
		&& (!hasChildren(node) || selection_type == 1))
	{
		celltext += "<a href='javascript:selectNode(\"" +
			link + "\",true,\"" + controller + "\");' class='link' onmouseover=\"window.status='';return true;\">";
	}

	celltext += "<font class='label'";

	if (isSelected(node) && (selectionMode == 1))
		celltext += " color='#FFFFFF'";

	celltext += ">" + getName(node) + "</font>";

	if ((selectionMode != 0)
		&& (!hasChildren(node) || selection_type == 1))
		celltext += "</a>";

	celltext += "</td>";

	return celltext;
}

// Retrieve a node with its id.
function getNodeById(node, nodeId)
{
	var i = 0;

	if (getId(node) == nodeId)
		return node;
	else
	{
		for (i = varBeforeChildren; i < node.length; i++)
		{
			nodeTmp = getNodeById(node[i], nodeId);

			if (nodeTmp != null)
				return nodeTmp;
		}
	}

	return null;
}

// Open or close a node.
function openNode(nodeId, controller)
{
	var node = getNodeById(dictionaryRoot, nodeId);

	if (isOpen(node))
		setOpen(node, false);
	else
		setOpen(node, true);


	writeDictionary(false, controller);

}

// Select a node.
function selectNode(nodeId, mouseClick, controller)
{
	var node = getNodeById(dictionaryRoot, nodeId);

	if (selectionMode == 2)
	{
		setSelected(node, !isSelected(node));
	}
	else
	{
		if ((selectedNode != null) && (node != selectedNode))
			setSelected(selectedNode, false);

		setSelected(node, !isSelected(node));

		if (isSelected(node))
			selectedNode = node;
		else
			selectedNode = null;
	}

	if (mouseClick)
	{
		var displayable_value = ComputeDisplayableValue();
		var value = ComputeValue();

		DictionaryEvent(displayable_value, value, controller);
	}

	if (selectionMode == 1 && mouseClick && is_popup)
		root_window.CloseLastDivShown();

	writeDictionary(false, controller);
}

function DictionaryEvent(displayable_value, value, controller)
{
	var parent_field = parent_form.elements[parent_field_name];
	var hidden_field = parent_form.elements[hidden_field_name];

	parent_field.value = displayable_value;
	hidden_field.value = value;

	if ((controller != null) && (controller != "") && (controller != "undefined") && (controller != "null") && (typeof controller != "undefined"))
		root_window.FieldChange(parent_form, hidden_field_name, controller);
}

function ComputeDisplayableValue()
{
	var text = "";
	var nodes;

	nodes = new Array;

	GetSelectedNodes(nodes, dictionaryRoot);

	for (var i = 0; i < nodes.length; i++)
	{
		if (i != 0)
			text += visibleSep;

		nodeTmp = nodes[i];
		text += nodeTmp[1];
	}

	return text;
}

function ComputeValue()
{
	var text = "";
	var nodes;

	nodes = new Array;

	GetSelectedNodes(nodes, dictionaryRoot);

	for (var i = 0; i < nodes.length; i++)
	{
		if (i != 0)
			text += sep;

		nodeTmp = nodes[i];
		text += nodeTmp[0];
	}

	return text;
}

function GetHiddenValue()
{
	var hidden_field = parent_form.elements[hidden_field_name];

	return hidden_field.value;
}

function GetSelectedNodes(nodes, parent)
{
	if (hasChildren(parent))
	{
		for (var i = varBeforeChildren; i < parent.length; i++)
		{
			nodeTmp = parent[i];

			if (isSelected(nodeTmp))
				nodes[nodes.length] = nodeTmp;

			GetSelectedNodes(nodes, nodeTmp);
		}
	}
}

function OpenDictionaryPopup(frameId)
{
	CloseLastDivShown();
	SwitchDivVisibility(frameId);
}

function OnKeyPress(evt, form, fieldName, hiddenFieldName)
{
        var resetChar = /[\x00\x08]/;
        var reCarSpeciaux = /[\x00\x08\x0D]/;

        var codeDecimal  = (!document.all) ? evt.which : event.keyCode;
        var car = String.fromCharCode(codeDecimal);
        var autorisation = reCarSpeciaux.test(car);
        var reset = resetChar.test(car);

        if (reset)
        {
		//ReInit the values of imput only in Netscape
		//Because onKeyPress in Ie not detect suppression caracters
		ResetDictionary(form, fieldName, hiddenFieldName);
        }


        return autorisation;
}

function OnKeyDown(evt, form, fieldName, hiddenFieldName)
{
        if (!document.all)
        	return;

	//ReInit the values of imput only in IE
        var resetChar = /[\x2E\x08]/;

        var codeDecimal  = event.keyCode;
        var car = String.fromCharCode(codeDecimal);
        var reset = resetChar.test(car);

        if (reset)
        {
		ResetDictionary(form, fieldName, hiddenFieldName);
        }
}

function ResetDictionary(form, fieldName, hiddenFieldName)
{
	parent_form = form;
	parent_field_name = fieldName;
	hidden_field_name = hiddenFieldName;

	var parent_field = parent_form.elements[parent_field_name];
	var hidden_field = parent_form.elements[hidden_field_name];

	parent_field.value = "";
	hidden_field.value = "";
}// LyFileScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyFileScript.js 33137 2011-11-14 13:08:56Z nhamon $

// This function updates an hidden field with a file field.
function UpdateFile(form, fieldName, isDirectory)
{
	var field = form.elements[fieldName];
	var fileField = form.elements[fieldName + "File"];

	if (fileField.value != "")
	{
		var dir = fileField.value;

		// If directory field, remove file from path
		// and keep only directory path
		if (isDirectory)
		{
			var pos = dir.lastIndexOf("/");

			if (pos < 0)
				pos = dir.lastIndexOf("\\");

			if (pos > 0)
				dir = dir.substring(0, pos + 1)
		}

		field.value = dir;
	}
}

// This function set the disable state of a file input.
function DisableFileInput(form, fieldName, disable)
{
	var field = form.elements[fieldName];
	var fileField = form.elements[fieldName + "File"];

	fileField.disabled = disable;
}

// This function uploads a file to the server
function SendFile(form, controller, fieldName, frameName, fileErrorMessage, path, encoding, target)
{
	var oldTarget = form.target;
	var oldAction = form.action;
	var oldEncoding = form.encoding;

	try
	{
		var params = "_upload=true&" + controllerParam + "=" + controller + "&" + sourceParam + "=" + fieldName;

		if ((typeof target != "undefined") && (target != null) && (target != "null"))
			params += "&target_session=" + target;

		form.encoding = encoding;
		form.target = frameName;
		form.action = _rootUrl + path + "?" + params;

		// And we submit the form
		form.submit();

		form.encoding = oldEncoding;
		form.target = oldTarget;
		form.action = oldAction;
		getLeonardiTopFrame().showWaitDiv(true, true);
	}
	catch (ex)
	{
		// When a file input is displayed in the HTML form, the submit of form may
		// launch an error. Display a message asking the user to check values of
		// file inputs.
		alert(fileErrorMessage);
	}
}// LyIntegerScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyFloatScript.js 30975 2011-05-12 16:44:19Z nhamon $

var ACCURACY = 1000000;
var netscapeNavigation = (navigator.appName == "Netscape");

// This function tests if the argument is a float and return the result.
function IsFloat(str)
{
	var number = parseFloat(str);
	var result = !isNaN(number);

	if (!result)
		return false;

	var nPoints=0;
	var i;
	var car;

	for (i = 0; i < str.length && result; i++)
	{
		car = str.substring(i,i+1);

		if ((i==0) && (car == "-"))
			continue;

		if (((car >= "0") && (car <= "9"))
			|| (car == "."))
		{
			if (car == ".")
				nPoints++;
			continue;
		}
		else
			result = false;
	}

	if (nPoints >= 2)
		result = false;

	if (!result)
		return false;

	var numberString = number.toString();

	if ((numberString.substring(0,1)) == ".")
		numberString = "0" + numberString;

	if ((numberString.substring(0,2)) == "-.")
		numberString = "-0." + numberString.substring(2);

	if (numberString.indexOf('.') == -1)
		numberString = numberString + ".0";

	if ((str.substring(0,2)) == "-.")
		str = "-0." + str.substring(2);

	if ((str.substring(0,1)) == ".")
		str = "0" + str;

	if (str.indexOf('.') == -1)
		str = str + ".0";

	if (str.indexOf('.') == (str.length - 1))
		str = str + "0";

	if ((nPoints == 1) && (numberString.length < str.length))
	{
		for (i = numberString.length; i < str.length; i++)
			numberString = numberString + "0";
	}

	if (numberString == str)
		return true;
	else
		return false;
}

// This function tests if the field has a valid value.
function CheckFloatField(form, field, min, max, error, sep, decimals)
{
 	var	value = form.elements[field].value;
	var	newValue = value;

	if (typeof value == "undefined")
		return;

	// Replace the separator by a dot (for IsFloat function)
	if (sep != '.')
		newValue = newValue.replace(sep, '.');

	// Check if the value is a float
	var result = IsFloat(newValue);

 	// Check if the value is <= max and >= min
 	if (((!result) && (newValue != ''))
		|| (parseFloat(newValue) < min)
		|| (parseFloat(newValue) > max))
 	{
 		var message = ReplaceString(error, "%1", value);
		alert(message);

		// Reset field
 		form.elements[field].value = form.elements[field].defaultValue;
 	}

	// Check the number of decimals
	var valueChecked;

	if (decimals > 0)
		valueChecked = CheckDecimals(newValue, decimals);

	if (valueChecked != null)
	{
 		var message = ReplaceString(error, "%1", value);
		alert(message);

		if (sep != '.')
		{
			if (netscapeNavigation)
				valueChecked = replaceNetscape(valueChecked,'.', sep);
			else
				valueChecked = valueChecked.replace('.', sep);	
		}

		// Reset field
 		form.elements[field].value = valueChecked;
	}
}

// This function replace a char by an another char for netscape browser
// FFT00892
function replaceNetscape(initVal, sep1, sep2)
{
	var	pos1 = initVal.indexOf(sep1);
	initVal = initVal.substring(0, pos1) + sep2 + initVal.substring(pos1 +1);
	return initVal;
}

// This function tests the number of decimals of the value.
function CheckDecimals(value, decimals)
{
	if ((decimals <= 0) || (value == ''))
		return null;

	var	pos = value.indexOf('.');

	if (pos < 0)
		return null;

	if (value.length - pos - 1 > decimals)
		return value.substring(0, pos + decimals + 1);

	return null;
}

// This function increments the value of the field.
function IncrementFloatField(form, field, min, max, pitch, sep, check)
{
	var value = form.elements[field].value;
	var newValue = value;

	// Replace the separator by a dot (for IsFloat function)
	if (sep != '.')
		newValue = newValue.replace(sep,'.');

	// Check if the value is a float
	var result = IsFloat(newValue);


 	if (value == "") // case of an empty value
	{
		if ((min <= 0) && (max >= 0))
			newValue = "0";
		else if (min > 0)
			newValue = min.toString();
		else
			newValue = max.toString();
	}
 	else if ((!result) || (parseFloat(newValue) < min - pitch))
 		newValue = min.toString();
 	else if ((parseFloat(newValue) > (max - pitch)))
 		newValue = max.toString();
 	else
 	{
 		pitch *= ACCURACY;
 		var fval = parseFloat(newValue);
 		fval *= ACCURACY;

 		fval += parseFloat(pitch);

 		fval = fval / ACCURACY;

 		newValue = fval.toString();
 	}

	if (sep != '.')
	{
		if (navigator.appName == "Netscape")
			newValue = newValue.replace('\\.', sep);
		else
			newValue = newValue.replace('.', sep);
	}

	form.elements[field].value = newValue;

	if (check != "false")
	{
		var fieldInst = form.elements[field];
		FieldChange(form, fieldInst, check);
	}
}
// LyFormScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyFormScript.js 41706 2012-12-04 16:59:06Z smaupin $

var sourceParam = '_source';
var valueParam = '_value';
var typeParam = '_type';
var frameParam = '_frame';
var ajaxParam = '_ajax';
var pageParam = '_page';
var manageTabKey = false;
var sendFieldChange = true;

// This function submits the script form in order to reset the
// value field.
// field if a refence of an HTML element.
function FieldChange(form, field, controllerId, typeParamValue)
{
	if (!sendFieldChange)
		return;

	// If default form is set, use the first form in page
	if ( form == "default" || (typeof form == "undefined"))
		form=document.forms[0];

	if (typeof field == "string")
		field = form.elements[field];

	if (form.elements[sourceParam] != null)
		form.elements[sourceParam].value = field.name;

	if (form.elements[valueParam] != null)
	{
		var newValue;

		if ( (typeof field.selectedIndex != "undefined") && (typeof field.options != "undefined") )
		{
			// For combo box : on Netscape field.value == "". We must use
			// field.selectedIndex instead (works with IE too).
			if ( (typeof field != "undefined")
				&& (typeof field.options != "undefined" )
				&& (typeof field.selectedIndex != "undefined" )
				&& (typeof field.options[field.selectedIndex] != "undefined" )
				&& (typeof field.options[field.selectedIndex].value != "undefined") )
				newValue = field.options[field.selectedIndex].value;
		}
		else
		{
			if (typeof field.value != "undefined")
				newValue = field.value;
			else //case of boolean choice
				newValue = form.elements[field].value;
		}

		form.elements[valueParam].value = newValue;
	}

	if (form.elements[typeParam] != null)
	{
		if ((typeof typeParamValue != "undefined")
				&& (typeParamValue != null)
				&& (typeParamValue != ""))
			form.elements[typeParam].value = typeParamValue;
		else
			form.elements[typeParam].value = "_checkField";
	}

	if (form.elements[frameParam] != null)
		form.elements[frameParam].value = this.name;

	// If there are different controllers managing the view, update the
	// controller input value
	var oldController = form.elements['_controller'].value;

	if (controllerId != null)
		form.elements['_controller'].value = controllerId;

	form.elements['_hidden'].value = 'true';

	// USE for STRUTS : add the page parameter if defined.
	// It is added to the action URL for backward compatibility
	if (((typeof pageWriterId) != "undefined") && (pageWriterId != null))
	{
		var formAction = form.action;
		if ((formAction != null) && (formAction != ""))
		{
			var pos = formAction.indexOf('?');
			if (pos <= 0)
				formAction += '?';
			formAction += pageParam + '=' + pageWriterId
			form.action = formAction;
		}
	}

	SendAjaxRequest(form);
	form.elements['_controller'].value = oldController;
}

// This function selects an option in a select component
function SelectOption(formName, fieldName, optionValue, select)
{
	var form = findForm(null, formName, fieldName);

	if (form == null)
		return;

	var field = form.elements[fieldName];

	if ((typeof field == "undefined") || (typeof field.options == "undefined"))
		return;

	var n = field.options.length;
	var option;

	for (var i = n - 1; i >= 0; i--)
	{
		option = field.options[i];

		if (option.value == optionValue)
		{
			option.selected = select;
			break;
		}
	}
}

// This function sets the value of an HTML field
function SetFieldValue(formName, fieldName, value)
{
	var form = findForm(null, formName, fieldName);

	if (form == null)
		return;

	var field = form.elements[fieldName];

	if (typeof field == "undefined")
		return;

	field.value = value;
}

// This function adds an option to a given select component
function AddSelectOption(formName, fieldName, optionValue, optionName, pos)
{
	var form = findForm(null, formName, fieldName);

	if (form == null)
		return;

	var field = form.elements[fieldName];

	if (typeof field == "undefined")
		return;

	var option = new Option(optionName);

	option.value = optionValue;

	if (pos < 0)
		pos = field.options.length;

	// Move all the options after inserted option
	if (pos < field.options.length)
	{
		for (var i = field.options.length; i > pos; i--)
		{
			var decal_option = new Option(field.options[i - 1].text);

			decal_option.value = field.options[i - 1].value;
			field.options[i] = decal_option;
		}
	}

	field.options[pos] = option;
}

// This function removes an option from a given select component
function RemoveSelectOption(formName, fieldName, optionValue)
{
	var form = findForm(null, formName, fieldName);

	if (form == null)
		return;

	var field = form.elements[fieldName];

	if (typeof field == "undefined")
		return;

	var n = field.options.length;
	var option;

	for (var i = n - 1; i >= 0; i--)
	{
		option = field.options[i];

		if (option.value == optionValue)
		{
			field.options[i] = null;
			break;
		}
	}
}

// This function selects checkbox (or radio) component
function SelectCheckbox(formName, fieldName, optionValue, select)
{
	var form = findForm(null, formName, fieldName);

	if (form == null)
		return;

	var field = form.elements[fieldName];

	if (typeof field == "undefined")
		return;

	var n = field.length;
	var option;

	// May occurs when there is only one radio button
	if (typeof n == "undefined")
	{
		field.checked = select;
		return;
	}

	for (var i = n - 1; i >= 0; i--)
	{
		option = field[i];

		if (option.value == optionValue)
		{
			option.checked = select;
			break;
		}
	}
}

function checkTextAreaLength(textComp, maxLength, e)
{
	if (e == null)
		e = window.event;

	var appName = navigator.userAgent;

	if ((appName.indexOf("Chrome") < 0)
			&& (((e.charCode == 0) && (e.keyCode != 13))
				|| (e.keyCode == 8)
				|| (e.keyCode == 46)
				|| ((e.keyCode > 32)
						&& (e.keyCode < 41)
						&& (e.keyCode == e.charCode))))
		return true;

	if (textComp.value.length >= maxLength)
		return false;

	return true;
}

function checkTextAreaPaste(textComp, maxLength)
{
	if (textComp.value.length >= maxLength)
		return false;

	setTimeout(function()
		{
			if (textComp.value.length > maxLength) {
				textComp.value = textComp.value.substring(0, maxLength);
			}
		}, 10);

	return true;
}

function ClickOnDisabledComponent(message)
{
	alert(message);
}

// This function updates a multiple choice. The built value is send to
// to the servlet.
// default value is the value send when no option is checked. If nothing is specified
// defaultValues is ""
function UpdateMultipleChoice(form, fieldName, optName, sep, needCheck, controllerId, defaultValue)
{
	if (typeof form == "undefined")
		form = this.document.forms[0];

	var field = form.elements[fieldName];
	var opt = form.elements[optName];
	var i, n = opt.length;
	var first = true;

	// FFT00292
	// We are in a multiple choice, but if there is just one checkbox, the length properties
	// is undefined, so we must force n to 1
	if (typeof n == "undefined")
		n = 1;

	// Update the field value with the selected values
	if (defaultValue == null)
		defaultValue = "";

	field.value = defaultValue;
	if (n > 1)
	{
		for (i = 0; i < n; i++)
		{
			if (opt[i].checked == false)
				continue;

			if (!first)
				field.value += sep;

			field.value += opt[i].value;
			first = false;
		}
	}
	else
	{
		// single checkbox case
		if (opt.checked == true)
		{
			field.value = opt.value;
		}
	}

	if ( (typeof needCheck != "undefined") && (needCheck == true) )
	{
		FieldChange(form, field, controllerId);
	}
}

// This function updates a list. The built value is send to the servlet.
function UpdateList(form, fieldName, listName, sep, needCheck, controllerId)
{
	if (typeof form == "undefined")
		form = this.document.forms[0];

	var field = form.elements[fieldName];
	var list = form.elements[listName];
	var i, n = list.length;
	var first = true;

	// Update the field value with the selected values
	field.value = "";
	for (i = 0; i < n; i++)
	{
		if (list[i].selected == false)
			continue;

		if (!first)
			field.value += sep;

		field.value += list[i].value;
		first = false;
	}

	if ( (typeof needCheck != "undefined") && (needCheck == true) )
	{
		FieldChange(form, field, controllerId);
	}
}

// This function changes the state of a boolean field.
function ChangeBooleanState(form, fieldName, shownFieldName, imageName, textTag, optional,
	labelEmpty, labelFalse, labelTrue,
	imgEmpty, imgFalse, imgTrue, not)
{
	if (typeof form == "undefined")
		form = this.document.forms[0];

	var field = form.elements[fieldName];
	var shownField = form.elements[shownFieldName];

	// If shownValue is empty, the next value is always unchecked
	if (shownField.value == "EMPTY")
	{
		shownField.value = "UNCHECKED";
		field.value = (not ? "CHECKED" : "UNCHECKED");
		document.images[imageName].src = imgFalse;
		textTag.innerText = labelFalse;
	}
	// If shown value is unchecked, the next value is always checked
	else if (shownField.value == "UNCHECKED")
	{
		shownField.value = "CHECKED";
		field.value = (not ? "UNCHECKED" : "CHECKED");
		document.images[imageName].src = imgTrue;
		textTag.innerText = labelTrue;
	}
	// if shown value is checked and the field is optional, the next value is empty
	else if ((shownField.value == "CHECKED") && optional)
	{
		shownField.value = "EMPTY";
		field.value = "EMPTY";
		document.images[imageName].src = imgEmpty;
		textTag.innerText = labelEmpty;
	}
	else // if the shown value is checked and the field is not optional, the next value is unchecked
	{
		shownField.value = "UNCHECKED";
		field.value = (not ? "CHECKED" : "UNCHECKED");
		document.images[imageName].src = imgFalse;
		textTag.innerText = labelTrue;
	}
}

// This function changes the image of a boolean field.
function SwapBooleanImage(form, fieldName, imageName, imgEmpty, imgFalse, imgTrue)
{
	if (typeof form == "undefined")
		form = this.document.forms[0];

	var field = form.elements[fieldName];

	if (field.value == "UNCHECKED")
	{
		document.images[imageName].src = imgFalse;
	}
	else if (field.value == "EMPTY")
	{
		document.images[imageName].src = imgEmpty;
	}
	else
	{
		document.images[imageName].src = imgTrue;
	}
}

// This function give a full width to a cell in a table
function ExtendCellToFullWidth(cellId, tableId)
{
	var frame = findTargetByContent(null, cellId);

	if ((frame != null) && (frame != this))
	{
		frame.ExtendCellToFullWidth(cellId, tableId);
		return;
	}

	var formCell = this.document.getElementById(cellId);
	var formTable = this.document.getElementById(tableId);

	if ((formCell == null) || (formTable == null))
		return;

	var cellWidth = cmGetWidth(formCell);
	var initialTableWidth = cmGetWidth(formTable);
	var tableWidth = initialTableWidth;
	var offset = 60;
	var maxSteps = 10;

	for (var i = 0; i < maxSteps; i++)
	{
		cellWidth = cellWidth - (-offset);

		formCell.style.width = cellWidth;
		tableWidth = cmGetWidth(formTable);

		if (tableWidth - 10 > initialTableWidth)
		{
			formCell.style.width = cellWidth - offset;
			break;
		}
	}

	if (this.name == popupFrameName)
		checkSizePopupView(null, false);
}


/*************************************************
 *     Auto-completion of text and relations     *
 *************************************************/

var autoCompletionArray = new Array();

// This function registers an array of auto-completion values.
function addAutoCompletionValues(componentId, values)
{
	autoCompletionArray[componentId] = values;
}

// This function sends the value of an auto-completion component to update list
function sendAutoCompletionValue(actionUrl, controller, event, value)
{
	var key = (!document.all) ? event.which : event.keyCode;

	// Tab key : nothing to do
	if (key == 9)
		return false;

	InvokeAction(null, actionUrl, null, controller, value, 'completeValue');
}

// This function refresh the content of an auto-completion component
function refreshAutoCompletion(formName, completionName, fieldName, componentId,
	selectColor, maxValues, width, event, controller, displayAllValues, allowUnknownValues)
{
	var key = (event == null ? 0 : (!document.all) ? event.which : event.keyCode);
	var form = findForm(null, formName, fieldName);

	if (form == null)
		return;

	var autoCompletionIndex = form.elements["AutoCompletionIndex_" + completionName];
	var autoCompletionIndexValue = autoCompletionIndex.value;
	var divObj = document.getElementById('AutoCompletion_' + completionName)
	var iframeObj = document.getElementById('AutoCompletionFrame_' + completionName);

	// Manage arrow down / up to select an item
    if ((key == 40) || (key == 38))
    {
		var previousTrObj = document.getElementById(completionName + autoCompletionIndexValue);
		var diff = (key == 40 ? -1 : 1);
		var trObj = document.getElementById(completionName + (autoCompletionIndexValue - diff));

		if (previousTrObj != null)
			previousTrObj.style.background = "#FFFFFF";

		if (trObj != null)
			trObj.style.background = selectColor;

		if ((previousTrObj != null) || (trObj != null))
			autoCompletionIndex.value = autoCompletionIndex.value - diff;

		if ((trObj != null) && (typeof(divObj.scrollIntoView) != "undefined"))
			trObj.scrollIntoView(false);

    	return;
    }

	autoCompletionIndex.value = "-1";

	var idField = form.elements[fieldName];
	var field = form.elements[fieldName + "_text"];

	if (typeof field == "undefined")
		field = form.elements[fieldName];

	var startValue = field.value.toLowerCase();
	var html = "<table id=\"" + completionName + "_table\" width='" + width + "' border='0' bgColor='FFFFFF' cellspacing='0' cellpadding='3'>";
	var visibility = "hidden";
	var match = false;
	var nbValues = 0;
	var valueId, valueName, valueDisplayed;
	var rowColor;
	var matchIndex = -1;

	values = autoCompletionArray[componentId];

	for (var i = 0; i < values.length; i++)
	{
		if ((maxValues > 0) && (nbValues >= maxValues))
			break;

		valueId = values[i][0];
		valueName = values[i][1];
		valueDisplayed = values[i][2];

		// Check if value start with field value (not case sensitive)
		if (valueDisplayed
			&& ((valueName.toLowerCase().indexOf(startValue) == 0) || displayAllValues))
		{
			var jsFieldName = ReplaceString(fieldName, "\\", "\\\\");
			var displayedValue = (valueName == "" ? "&nbsp;" : valueName);
			var javascriptValueId = ReplaceString(valueId, "\\", "\\\\");
			var javascriptValueName = ReplaceString(valueName, "\\", "\\\\");

			displayedValue = ReplaceString(displayedValue, "<", "&lt;");
			displayedValue = ReplaceString(displayedValue, ">", "&gt;");

			javascriptValueId = ReplaceString(javascriptValueId, "'", "\\'");
			javascriptValueId = ReplaceString(javascriptValueId, "\"", "&quot;");
			javascriptValueName = ReplaceString(javascriptValueName, "'", "\\'");
			javascriptValueName = ReplaceString(javascriptValueName, "\"", "&quot;");

			html += "<tr id=\"" + completionName + nbValues + "\"";

			rowColor = '#FFFFFF';

			if (!allowUnknownValues && (valueId == idField.value))
			{
				rowColor = selectColor;
				autoCompletionIndex.value = nbValues;
			}

			html += " bgColor='" + rowColor + "'";
			html += " onMouseOver=\"";
			html += "resetAutoCompletionBackground('" + formName + "','" + completionName + "','" + jsFieldName + "');";
			html += "this.style.background='" + selectColor + "'\"";
			html += " onMouseOut=\"this.style.background='" + rowColor + "'\"";
			html += " onMouseDown=\"setCompletionValue('" + formName + "', '" + completionName + "','" + jsFieldName + "','" +
				javascriptValueId + "','" + javascriptValueName + "','" + controller + "');\"";
			html += " style=\"cursor:default;\">";
			html += "<td valign='top' align='left' nowrap='yes'><font class='label'>" + displayedValue + "</font></td></tr>";
			visibility = "visible";

			if (valueName.toLowerCase().indexOf(startValue) == 0)
				match = true;

			if (!displayAllValues
					&& (valueName.toLowerCase() == startValue))
				matchIndex = i;

			if ((key == 13) && (autoCompletionIndexValue == nbValues))
			{
				setCompletionValue(formName, completionName, fieldName, valueId, valueName, controller);
			}

			nbValues++;
		}
	}

	html += "</table>";

	if (key == 13)
		visibility = "hidden";

	if (!match && !allowUnknownValues)
		setCompletionValue(formName, completionName, fieldName, "", null, null);
	else if ((matchIndex >= 0) && (nbValues == 1))
	{
		if (!allowUnknownValues)
			setCompletionValue(formName, completionName, fieldName, values[matchIndex][0], values[matchIndex][1], controller);

		visibility = "hidden";
	}

	divObj.innerHTML = html;
	divObj.style.visibility = visibility;

	if (visibility == "hidden")
		lastKeyEventTime = -1;
	else
		lastKeyEventTime = new Date().getTime() + 10000000;

	// If div contains a vertical scrollbar, reduce table width to avoid a horizontal
	// scrollbar to appear.
	if (divObj.clientHeight < divObj.scrollHeight)
	{
		var tableObj = document.getElementById(completionName + '_table');

		tableObj.width -= 16;
	}

	if (iframeObj != null)
		iframeObj.style.visibility = visibility;
}

// This function reset the background color of auto-completion div
function resetAutoCompletionBackground(formName, completionName, fieldName)
{
	var form = findForm(null, formName, fieldName);

	if (form == null)
		return;

	var autoCompletionIndex = form.elements["AutoCompletionIndex_" + completionName];
	var autoCompletionIndexValue = autoCompletionIndex.value;
	var trObj = document.getElementById(fieldName + autoCompletionIndexValue);

	autoCompletionIndex.value = "-1";

	if (trObj != null)
		trObj.style.background = "#FFFFFF";
}

// This function updates a text input with an auto-completion value
function setCompletionValue(formName, completionName, fieldName, valueId, valueName, controller)
{
	var form = findForm(null, formName, fieldName);

	if (form == null)
		return;

	var idField = form.elements[fieldName];
	var nameField = form.elements[fieldName + "_text"];

	idField.value = valueId;

	if ((typeof nameField != "undefined") && (valueName != null))
		nameField.value = valueName;

	hideAutoCompletion(formName, completionName, fieldName, controller);
	setTimeout("activateAutoCompletionText('" + formName + "','" + fieldName + "')", 300);
}

// This function gives the focus to a text input with an auto-completion value
function activateAutoCompletionText(formName, fieldName)
{
	var form = findForm(null, formName, fieldName);

	if (form == null)
		return;

	var field = form.elements[fieldName + "_text"];

	if (typeof field == "undefined")
		field = form.elements[fieldName];

	try
	{
		field.focus();
		SetEndCaret(field);
	}
	catch (ex)
	{
	}
}

// This function reset the focus state of an auto-completion component
function resetAutoCompletionFocus(formName, completionName)
{
	setAutoCompletionFocus(formName, "AutoCompletionFocus_" + completionName, 'true');
	setTimeout("setAutoCompletionFocus('" + formName + "', 'AutoCompletionFocus_" + completionName + "', false)", 300);
}

// This function set the focus state of an auto-completion component
function setAutoCompletionFocus(formName, fieldName, value)
{
	var form = findForm(null, formName, fieldName);

	if (form == null)
		return;

	var autoCompletionFocus = form.elements[fieldName];

	if (typeof autoCompletionFocus != "undefined")
		autoCompletionFocus.value = value;
}

// This function switch the visibility of an auto-completion component
function switchAutoCompletion(formName, completionName, fieldName, values,
	selectColor, maxValues, width, event, controller)
{
	var divObj = document.getElementById('AutoCompletion_' + completionName)

	if (divObj.style.visibility == "hidden")
	{
		refreshAutoCompletion(formName, completionName, fieldName, values, selectColor, maxValues, width, event, controller,
			true, false);
	}
	else
		hideAutoCompletion(formName, completionName, fieldName);

	activateAutoCompletionText(formName, fieldName);
}

// This function hides an auto-completion component with a timeout
function hideAutoCompletionTimeout(formName, completionName, fieldName, controller)
{
	setTimeout("hideAutoCompletion('" + formName + "', '" + completionName + "','" + fieldName + "', '" + controller + "')", 150);
}

var changedField = null;

// This function hides an auto-completion component immediatly
function hideAutoCompletion(formName, completionName, fieldName, controller)
{
	var form = findForm(null, formName, fieldName);

	if (form == null)
		return;

	var autoCompletionFocus = form.elements["AutoCompletionFocus_" + completionName];

	if ((typeof autoCompletionFocus != "undefined") && (autoCompletionFocus.value != "true"))
	{
		var divObj = document.getElementById('AutoCompletion_' + completionName)
		var iframeObj = document.getElementById('AutoCompletionFrame_' + completionName);

		divObj.style.visibility = 'hidden';
		lastKeyEventTime = -1;

		if (iframeObj != null)
			iframeObj.style.visibility = 'hidden';

		if ((controller != null) && (controller != "") && (controller != "undefined") && (controller != "null") && (typeof controller != "undefined"))
		{
			var field = form.elements[fieldName];

			// If a FieldChange is being sent, do not authorize modification of this field
			// but reset this value after 3 seconds.
			changedField = fieldName;
			setTimeout("changedField = null", 3000);

			FieldChange(form, field, controller);
		}
	}
}

var lastKeyEventTime = -1;
var keyHandlerTopFrame = null;

// This function captures return key on input fields and prevent return
function keyHandler (evt)
{
	var elem;

	if (!document.all)
		elem = (evt.target) ? evt.target : evt.srcElement;
	else
		elem = (event.target) ? event.target : event.srcElement;

	var key = (!document.all) ? evt.which : event.keyCode;
	var actionId = "";

	// If a FieldChange is being sent, do not authorize modification of this field
	if ((changedField != null)
			&& (elem != null)
			&& (elem.name == changedField)
			&& (key != 9))
		return false;

	// Firefox may send two events at the same time.
	// W4/FFT03621 don't do that for enter key
	if (key != 13 && (new Date().getTime() - lastKeyEventTime < 50))
		return true;

	lastKeyEventTime = new Date().getTime();

    if (key == 13)
    {
		// Redirect return on text fields to the first command button.
		if ((elem.tagName == "INPUT")
			|| (elem.type == "text")
			|| (elem.type == "select-one"))
		{
			elem.blur();
			setTimeout(function() {
				FieldChange('default', elem , '', '_validateField')
			}, 300);
			return false;
      	}
   	}
   	// Manage tab key
   	else if ((key == 9) && manageTabKey)
   	{
   		var parent = elem;

   		while (parent != null)
   		{
	   		parent = parent.parentNode;

	   		if ((parent != null)
	   			&& (parent.tagName == "DIV")
	   			&& (parent.getAttribute("manageTabKey") != null))
	   		{
				if (!document.all)
					actionId = (evt.shiftKey) ? "_tabPrevious" : "_tabNext";
				else
					actionId = (event.shiftKey) ? "_tabPrevious" : "_tabNext";

		   		break;
			}
	   	}
   	}
   	// Manage alt + arrow up, down, left and right keys and alt + add key
   	else if (((key == 37) || (key == 38) || (key == 39) || (key == 40) || (key == 107) || ((key == 187) && window.event.shiftKey))
   			&& window.event.altKey
   			&& manageTabKey)
   	{
		if (key == 37)
			actionId = "_altLeft";
		else if (key == 38)
			actionId = "_altUp";
		else if (key == 39)
			actionId = "_altRight";
		else if (key == 40)
			actionId = "_altDown";
		else if ((key == 107) || (key == 187))
			actionId = "_altAdd";
	}
   	else if (key == 8)
   	{
   		// Manage Backspace key : disable when key is not pressed in an input field
   		// to avoid returning to previous page.
		var elem;

		if (!document.all)
    			elem = (evt.target) ? evt.target : evt.srcElement;
    		else
    			elem = (event.target) ? event.target : event.srcElement;

   		if (((elem.type == "text") || (elem.type == "textarea") || (elem.type == "password") || (elem.type == "file"))
   				&& !elem.disabled
				&& !elem.readOnly)
	   		return true;
	   	else
	   		return false;
   	}
   	else
   	{
		// Specific process
		if (keyHandlerTopFrame == null)
			keyHandlerTopFrame = getLeonardiTopFrame();

		if (keyHandlerTopFrame.specificKeyHandler)
			return keyHandlerTopFrame.specificKeyHandler((!document.all) ? evt : event);

     		return true;
	}

	if (actionId != "")
	{
   		// Manage tab key for editable tables
		var elem;

		if (!document.all)
    			elem = (evt.target) ? evt.target : evt.srcElement;
    		else
    			elem = (event.target) ? event.target : event.srcElement;

		if ((elem.tagName == "INPUT") || (elem.tagName == "SELECT") || (elem.tagName == "TEXTAREA"))
		{
			// Use a timeout to leave enough time to the valueChanged
			// event to be sent.
			var jsFieldName = ReplaceString(elem.name, "\\", "\\\\");

			setTimeout("FieldChange('default', '" + jsFieldName + "', '', '" + actionId + "')", 300);
		}

		return false;
	}
}
// Activate key capture for keyHandler
if (!document.all)
  document.captureEvents(Event.KEYDOWN);
document.onkeydown = keyHandler;
// LyFormatScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyFormatScript.js 33851 2012-01-17 16:42:40Z nhamon $

// This function tests if the field has a valid value.
function CheckFormatField(form, fieldName, format, error, isDate)
{
	var value = form.elements[fieldName].value;
	var initialValue = value;
	var n0 = 0, n2 = 0, n3 = 0;
	var formatTmp;
	var valueTmp;
	var fixTmp;
	var result;
	var checked = true;
	var last = false;
	var changed = false;

	var finalValue="";

	if ((typeof value == "undefined") || (value.length == 0))
		return;

	do
	{
		n0 = format.indexOf('[', 0);
//		n1 = format.indexOf(':', 0);
		n2 = format.indexOf(']', 0);

		fixTmp = "";
		// If fixed string starting
		if (n0 > 0)
		{
			fixTmp = format.substring(1, n0 - 1);
			format = format.substring(n0);

			n0 = value.indexOf(fixTmp);

			if (n0 == 0)
				value = value.substring(fixTmp.length);
			else
			{
				checked = false;
				break;
			}

			continue;
		}

//		if ((n1 >= 0) && (n1 < n2))
//			n3 = n1;
//		else
			n3 = n2;

		formatTmp = format.substring(n0 + 1, n3);

		// If there is still something after this format
		if ((format.length != 0) && (n2 < format.length - 1))
		{
			// Retrieve the next '['
			n0 = format.indexOf('[', 1);

			// If no next, it means there is a fix string at the end
			if (n0 < 0)
			{
				n0 = format.length;
				last = true;
			}

			fixTmp="";

			//FFT00532
			if (n2 == (n0-1))
				fixTmp="";
			else
				fixTmp = format.substring(n2 + 2, n0 - 1);



			valueLength = getValueLength(formatTmp);
			n4 = value.indexOf(fixTmp, 0);

			if (   ( (fixTmp.length > 0) && (valueLength < n4) )
				|| (fixTmp.length == 0) )
				n4 = valueLength;



			if (last)
			{
				// If too many characters
				if ((value.length - n4) > fixTmp.length)
					n4 = -1;
			}

			if (n4 < 0)
			{
				checked = false;
				break;
			}
			else
			{
				valueTmp = value.substring(0, n4);
				value = value.substring(n4 + fixTmp.length);
			}

			// FFT00098 : error on validation with format
//			format = format.substring(n2 + 3 + fixTmp.length);
			format = format.substring(n2 + 1 + fixTmp.length);
		}
		else if (formatTmp.length != 0)
		{
			valueTmp = value;
			format = format.substring(n2 + 4);
		}

		result = CheckFormat(formatTmp, valueTmp);

		if (result == "")
		{
			checked = false;
			break;
		}
		else if (result != valueTmp)
		{
			changed = true;
			finalValue += result+fixTmp;
		}
		else
		{
			finalValue += valueTmp+fixTmp;
		}
	}
	while (format.length != 0)

	if ( changed && checked)
	{
		if (isDate != "true")
			form.elements[fieldName].value = finalValue;
	}
	else if (!checked)
	{
		if (error != null)
		{
			var message = ReplaceString(error, "%1", initialValue);
			alert(message);
		}

		// Reset field
		if (isDate == "true")
		{
			if (error != null)
				form.elements[fieldName].value = '';

			return "false";
		}
//FFT00533
//		else
//			form.elements[fieldName].value = form.elements[fieldName].defaultValue;
	}
}

// This function compute the length of a value from a format
function getValueLength(format)
{
	var n = format.indexOf('-', 0);
	var min = format.substring(0, n);
	var max = format.substring(n + 1);

	if(max.length >= min.length)
		return max.length;
	else
		return min.length;

}

// This function tests if a value is valid for the given format.
// @return the value if correct, a new value if modifications needed, a
// blank string if wrong.
function CheckFormat(format, value)
{
	var n = format.indexOf('-', 0);
	var min = format.substring(0, n);
	var max = format.substring(n + 1);

	if (IsInteger(min) && IsInteger(max))
	{
		if (!IsInteger(value))
			return "";

		var minInt = parseInt(min);
		var maxInt = parseInt(max);

		// Remove leading '0'
		value = removeLeadingZeros(value);
		var valueInt = parseInt(value);

		maxLength = max.length;
		if ( (minInt < 0) && ( (min.length-1) > max.length) )
		{
			maxLength = min.length-1;
		}

		while (value.length < max.length)
		{
			value = "0"+value;
		}

		if ((valueInt < minInt) || (valueInt > maxInt))
			return "";
		else
			return value;
	}
	else
	{
		if ((value < min) || (value > max))
			return "";
		else
			return value;
	}
}

// This function test the number of selected characters
// inside a text area.
// return true if the number of selected characters does
// not exceeds the maxlength, false otherwise.
function CheckTextArea(maxlength, errorMessage, textArea)
{
	var value = textArea.value;

	// if the length is ok
	if (value.length <= maxlength)
		return true;

	// raise Error
	var message = ReplaceString(errorMessage, "%1", value.length + "");

	alert(message);

	return false;
}// LyGanttScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyGanttScript.js 28422 2010-11-03 12:03:38Z ehelmste $
// LyIntegerScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyIntegerScript.js 30975 2011-05-12 16:44:19Z nhamon $

// This function tests if the argument is an integer and return the result.
function IsExactInteger(str)
{
	var number = parseInt(str);
	result = isNaN(number);

	if (result)
		return false;

	// Return true only if number equals str (because parseInt('15h')=15).
	if (number.toString() == str)
		return true;
	else
		return false;
}

// This function tests if the argument is an integer and return the result
// (ignoring 0 at the beginning of the number)
function IsInteger(str)
{
	str = removeLeadingZeros(str);

	var number = parseInt(str);
	result = isNaN(number);

	if (result)
		return false;

	if (number.toString() == str)
		return true;
	else
		return false;
}

// This function remove leading '0' from the given string
// Doesn't work for negative numbers.
function removeLeadingZeros(str)
{
	// If more than 1 character try to remove the starting 0
	if (str.length > 1)
	{
		for (; str.charAt(0) == '0';)
			str = str.substring(1);

		// If the string was something like '000'
		if (str.length == 0)
			str= '0';
	}

	return str;
}

// This function tests if the field has a valid value.
function CheckIntegerField(form, fieldName, min, max, error)
{
	var value = form.elements[fieldName].value;

	if (typeof value == "undefined")
		return;

	// Check if the value is an integer
	var result = IsExactInteger(value);

 	// Check if the value is <= max and >= min
	if (((!result) && (value != '')) || (parseInt(value) < min) || (parseInt(value) > max))
	{
		var message = ReplaceString(error, "%1", value);
		alert(message);

		// Reset field
		form.elements[fieldName].value = form.elements[fieldName].defaultValue;
	}
}

// This function increments the value of the field.
function IncrementIntegerField(form, fieldName, min, max, pitch, check)
{
	var field = form.elements[fieldName];
	// Check if the value is an integer
	var result = IsExactInteger(field.value);

	if (field.value == "") // case of an empty value
	{
		if ((min <= 0) && (max >= 0))
			form.elements[fieldName].value = 0;
		else if (min > 0)
			form.elements[fieldName].value = min;
		else
			form.elements[fieldName].value = max;
	}
	else if ((!result) || (parseInt(field.value) < min - pitch))
		form.elements[fieldName].value = min;
	else if ((parseInt(field.value) > max - pitch))
		form.elements[fieldName].value = max;
	else
		form.elements[fieldName].value=(parseInt(field.value) + parseInt(pitch)).toString();

	if (check != "false")
		FieldChange(form, field, check);
}
var click = 0;
var dblClick = 0;

var backgroundClick = false;
var backgroundDblClick = false;

var movementStarted = false;
var clickStart = 0;
var draggingStart = 0;

// co-ordinates of the starting point of the selection.
var startx = 0;
var starty = 0;
// co-ordinates of the ending point of the selection.
var endx = 0;
var endy = 0;

var browser = new Browser();
var dragObj = new Object();

var formTargetParam = "target_session";

dragObj.zIndex = 0;


/***************************
 *     Mouse functions     *
 ***************************/


function InvokeMapClick(elementId, controllerId, mapId, path, event)
{
	click = (new Date()).getTime();

	if (!event.ctrlKey)
	{
		clearSelectionIds(mapId);
		addSelectionId(mapId, elementId);
	}
	else
	{
		if (hasSelectionId(mapId, elementId))
			removeSelectionId(mapId, elementId);
		else
			addSelectionId(mapId, elementId);
	}

	UpdateMapElementsStyle(mapId, null);

	var selected = hasSelectionId(mapId, elementId);

	InvokeSelection((selected ? "_select" : "_unselect"), elementId, controllerId, (event.ctrlKey ? "true" : "false"), path);

	return false;
}

function InvokeMapDblClick(elementId, controllerId, mapId, path)
{
	dblClick = (new Date()).getTime();

	InvokeAction(mapId, path, '', controllerId, elementId);
}

function InvokeBackgroundClick(mapId, controllerId, path)
{
	if (backgroundClick == true)
	{
		backgroundClick = false;
		return;
	}

	backgroundClick = true;
	backgroundDblClick = false;

	var method = "callBackgroundFunction('" + mapId + "','" + controllerId + "','" + path + "')";

	setTimeout(method, 100);
}

function InvokeBackgroundDblCLick(mapId, controllerId, path)
{
	var dblClickTime = (new Date()).getTime() - dblClick;

	if (dblClickTime < 1000)
	{
		return;
	}

	backgroundDblClick = true;
	InvokeAction(mapId, path, '', controllerId, '');
}

function AreaDblClick(elementId, mapId, controllerId, path)
{
	backgroundDblClick = true;
	InvokeAction(mapId, path, '', controllerId, elementId);

	window.event.cancelBubble = true;
}

function callBackgroundFunction(mapId, controllerId, path)
{
	backgroundClick = false;

	if (!backgroundDblClick)
	{
		backgroundDblClick = false;

		var date = new Date();
		var time = date.getTime() - clickStart;
		var elementTime = date.getTime() - click;

		if (time > 500)
			return;

		if (elementTime < 200)
			return;

		clearSelectionIds(mapId);
		UpdateMapElementsStyle(mapId, null);
		InvokeSelection("_select", '', controllerId, "false", path);
	}
}

// Called when a contextual menu is performed on the map
function InvokeMapPopup(elementId, regionId, controllerId, htmlMapId, mapId, path, selectionPath, event)
{
	var selected = hasSelectionId(htmlMapId, elementId);

	// Try to select map region (for treemap layout only)
	try
	{
		var doc = window.document;
		var region = doc.getElementById(regionId);

		selected = (region.style.borderWidth.substring(0, 1) != '0' && region.style.borderWidth.substring(0, 1) != '');

		if (!selected)
			TreemapSelection(elementId, true);
	}
	catch (ex)
	{
	}

	if (!selected)
	{
		InvokeMapClick(elementId, controllerId, htmlMapId, selectionPath, event);

		// Send the popup demand
		var methodParam = ReplaceString(elementId, "\\", "\\\\");

		setTimeout("InvokePopup('" + mapId + "','" + methodParam + "','" + path + "','" +
			controllerId + "'," + event.ctrlKey + "," +
			event.clientX + "," + event.clientY + ")", 300);
	}
	else
		InvokePopup(mapId, elementId, path, controllerId, event.ctrlKey, event.clientX, event.clientY);
}

// Graphical select a node
// return true if changed
function selectMapNode(id)
{
	needUpdate = false;
	divObject = document.getElementById(id);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeSelectedImage')
		{
			divObject.className = 'nodeSelectedImage';
			needUpdate = true;
		}
	}

	// compute label id
	i = id.indexOf("_node");
	currentId = id.substring(0, i);

	var labelId = currentId +"_label";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeSelectedLabel')
		{
			divObject.className = 'nodeSelectedLabel';
			needUpdate = true;
		}
	}

	labelId = currentId +"_leftLabel";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeSelectedLabel')
		{
			divObject.className = 'nodeSelectedLabel';
			needUpdate = true;
		}
	}

	labelId = currentId +"_rightLabel";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeSelectedLabel')
		{
			divObject.className = 'nodeSelectedLabel';
			needUpdate = true;
		}
	}

	labelId = currentId +"_topLabel";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeSelectedLabel')
		{
			divObject.className = 'nodeSelectedLabel';
			needUpdate = true;
		}
	}

	labelId = currentId +"_bottomLabel";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeSelectedLabel')
		{
			divObject.className = 'nodeSelectedLabel';
			needUpdate = true;
		}
	}

	return needUpdate;
}

// Graphical unselect a node
// return true if changed
function unselectMapNode(id)
{
	needUpdate = false;
	divObject = document.getElementById(id);
	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeImage')
		{
			divObject.className = 'nodeImage';
			needUpdate = true;
		}
	}

	// compute label id
	i = id.indexOf("_node");
	currentId = id.substring(0, i);

	var labelId = currentId +"_label";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeLabel')
		{
			divObject.className = 'nodeLabel';
			needUpdate = true;
		}
	}

	labelId = currentId +"_leftLabel";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeLabel')
		{
			divObject.className = 'nodeLabel';
			needUpdate = true;
		}
	}

	labelId = currentId +"_rightLabel";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeLabel')
		{
			divObject.className = 'nodeLabel';
			needUpdate = true;
		}
	}

	labelId = currentId +"_topLabel";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeLabel')
		{
			divObject.className = 'nodeLabel';
			needUpdate = true;
		}
	}

	labelId = currentId +"_bottomLabel";
	divObject = document.getElementById(labelId);

	if ( (divObject != null) && (divObject != "undefined") )
	{
		if (divObject.className != 'nodeLabel')
		{
			divObject.className = 'nodeLabel';
			needUpdate = true;
		}
	}

	return needUpdate;
}

function UpdateMapElementsStyle(mapId, frameId)
{
	var ie= (navigator.appName == "Microsoft Internet Explorer")?1:0;
	var doc = document;

	if (frameId != null)
	{
		var frame = findTarget(null, frameId, null);

		if (frame != null)
			doc = frame.document;
	}

	var map = doc.getElementById(mapId);

	if ((map == null) || ((typeof map) == "undefined"))
		return;

	var divs = doc.getElementsByTagName('div');

	for (var i = 0; i < divs.length; i++)
	{
		divObject = divs[i];
		currentId = divObject.id;

		if ( (currentId == null) || (currentId == "undefined") || (currentId == ""))
			continue;

		if ((typeof id != "undefined") && (id != null) && (currentId == id) )
			continue;

		if (endsWith(currentId, "_node") )
		{
			var isSelected = hasSelectionId(mapId, divObject.getAttribute("nodeId"));

			if (isSelected)
				selectMapNode(currentId);
			else
				unselectMapNode(currentId);
		}
	}
}

// unselect all node except id
function unselectAllNodes(id)
{
	var needUpdate = false;
	var divs = document.getElementsByTagName('div');

	for (var i = 0; i < divs.length; i++)
	{
		divObject = divs[i];
		currentId = divObject.id;

		if ( (currentId == null) || (currentId == "undefined") || (currentId == ""))
			continue;

		if ((typeof id != "undefined") && (id != null) && (currentId == id) )
			continue;

		if ( endsWith(currentId, "_node") )
		{
			if (unselectMapNode(currentId))
				needUpdate = true;
		}
	}
	return needUpdate;
}

function unselectAll(url)
{
	date = new Date();
	time = date.getTime() - clickStart;

	if (time > 500)
		return;

	unselectAllNodes();
	InvokeMapSelection(url);
}


/***********************************
 *     Drag and drop functions     *
 ***********************************/

var dragStopCallback = null;

function dragStart(event, id, nodeId, mapId, mapDivId, mapContentId, controllerId, path)
{
  var el;
  var x, y;

  // If an element id was given, find it. Otherwise use the element being
  // clicked on.
  date = new Date();

  draggingStart = date.getTime();

  if (id)
  {
	  dragObj.nodeId = nodeId;
	  dragObj.elNode = document.getElementById(id);
  }

  // Get cursor position with respect to the page.
  if (browser.isIE)
  {
    x = window.event.clientX + document.documentElement.scrollLeft
      + document.body.scrollLeft;
    y = window.event.clientY + document.documentElement.scrollTop
      + document.body.scrollTop;
  }
  if (browser.isFirefox)
  {
    x = event.clientX + window.scrollX;
    y = event.clientY + window.scrollY;
    startx = x;
    starty = y;
  }
  else if (browser.isNS)
  {
    x = event.clientX + window.scrollX;
    y = event.clientY + window.scrollY;
  }

  // Save starting positions of cursor and element.
  dragObj.cursorStartX = x;
  dragObj.cursorStartY = y;

  if (dragObj.elNode != null)
  {
	dragObj.elNodeStartLeft  = parseInt(dragObj.elNode.style.left, 10);
  	dragObj.elNodeStartTop   = parseInt(dragObj.elNode.style.top,  10);
  	if (isNaN(dragObj.elNodeStartLeft))
  		dragObj.elNodeStartLeft = 0;
  	if (isNaN(dragObj.elNodeStartTop))
  		dragObj.elNodeStartTop  = 0;
  }

  // Capture mousemove and mouseup events on the page.
	dragStopCallback = function()
	{
		dragStop(mapId, mapDivId, mapContentId, controllerId, path);
	}

  if (browser.isIE) {
    document.attachEvent("onmousemove", dragGo);
    document.attachEvent("onmouseup",   dragStopCallback);
    window.event.cancelBubble = true;
    window.event.returnValue = false;
  }
  if (browser.isNS) {
    document.addEventListener("mousemove", dragGo,   true);
    document.addEventListener("mouseup",   dragStopCallback, true);
    event.preventDefault();
  }
}

function dragGo(event) {

  var x, y;

  // Get cursor position with respect to the page.
  draggingStart -= 500;

  if (browser.isIE) {
    x = window.event.clientX + document.documentElement.scrollLeft
      + document.body.scrollLeft;
    y = window.event.clientY + document.documentElement.scrollTop
      + document.body.scrollTop;
  }
  if (browser.isNS) {
    x = event.clientX + window.scrollX;
    y = event.clientY + window.scrollY;
  }

  // Move drag element by the same amount the cursor has moved.

	if (dragObj.elNode != null)
	{
		dragObj.elNode.style.left = (dragObj.elNodeStartLeft + x - dragObj.cursorStartX) + "px";
		dragObj.elNode.style.top  = (dragObj.elNodeStartTop  + y - dragObj.cursorStartY) + "px";
	}

  if (browser.isIE) {
    window.event.cancelBubble = true;
    window.event.returnValue = false;
  }
  if (browser.isNS)
    event.preventDefault();
}

function dragStop(mapId, mapDivId, mapContentId, controllerId, path)
{
	// Stop capturing mousemove and mouseup events.
	if (browser.isIE)
	{
		document.detachEvent("onmousemove", dragGo);
		document.detachEvent("onmouseup",   dragStopCallback);
		dragStopCallback = null;
	}
	if (browser.isNS)
	{
		document.removeEventListener("mousemove", dragGo,   true);
		document.removeEventListener("mouseup",   dragStopCallback, true);
		dragStopCallback = null;
	}

	var dragNode = dragObj.elNode;

	date = new Date();
	time = date.getTime() - draggingStart;
	dragObj.elNode = null;

	if (time < 500 )
		return;

	if (dragNode != null)
	{
		var mapContent = this.document.getElementById(mapContentId);

		x = parseInt(dragNode.style.left,10);
		y = parseInt(dragNode.style.top,10);
		id = ReplaceString(dragObj.nodeId,"\\","\\\\");

		var params = pageParam + '=' + mapId + '&' + sourceParam + '=moveElements' +
			'&' + controllerParam + '=' + controllerId +
			'&' + valueParam + '=' + id + '&' + indexParam + '=' + x + "|" + y;

		if ((document.forms[0].elements[formTargetParam] != null)
				&& (typeof document.forms[0].elements[formTargetParam] != "undefined")
				&& (typeof document.forms[0].elements[formTargetParam].value != "undefined"))
			params += '&target_session=' + document.forms[0].elements[formTargetParam].value;

		SendAjaxRequestParams(_rootUrl + path, params, 'false');
	}
}


/***********************************
 *     Miscellaneous functions     *
 ***********************************/


function Browser()
{

  var ua, s, i;

  this.isIE    = false;
  this.isNS    = false;
  this.isFirefox = false;
  this.version = null;

  ua = navigator.userAgent;

  s = "MSIE";
  if ((i = ua.indexOf(s)) >= 0) {
    this.isIE = true;
    this.version = parseFloat(ua.substr(i + s.length));
    return;
  }


  s = "Firefox";
    if ((i = ua.indexOf(s)) >= 0) {
      this.isFirefox = true;
      this.isNS = true; // As long has everything is not migrated
      this.version = parseFloat(ua.substr(i + s.length));;
      return;
    }

  s = "Netscape6/";
  if ((i = ua.indexOf(s)) >= 0) {
    this.isNS = true;
    this.version = parseFloat(ua.substr(i + s.length));
    return;
  }

  // Treat any other "Gecko" browser as NS 6.1.

  s = "Gecko";
  if ((i = ua.indexOf(s)) >= 0) {
    this.isNS = true;
    this.version = 6.1;
    return;
  }
}

function getMapDocument()
{
	return window.document;
}

// return true if the given source string endsWith pattern
function endsWith(source, pattern)
{
	n = pattern.length;
	m = source.length;

	temp = source.substring(m-n);

	if (temp == pattern)
		return true;
	else
		return false;
}


/***********************************
 *     Management of tree maps     *
 ***********************************/


var mapWidth = 0;
var mapHeight = 0;
var mapDelta = 10;
var mapInitialized = false;

function mouseOverRegion(regionId, over, isSmallImage, x, y, width, height, borderWidth)
{
	var doc = getMapDocument();
	var newValue = (over ? 'visible' : 'hidden');
	var selectBorder = doc.getElementById("_select_border_up");

	selectBorder.style.visibility = newValue;

	if (over)
	{
		selectBorder.style.width = width;
		selectBorder.style.height = selectBorderWidth;
		selectBorder.style.left = x + "px";
		selectBorder.style.top = y + "px";
	}

	selectBorder = doc.getElementById("_select_border_right");
	selectBorder.style.visibility = newValue;

	if (over)
	{
		selectBorder.style.width = selectBorderWidth;
		selectBorder.style.height = height;
		selectBorder.style.left = (width - selectBorderWidth) + "px";
		selectBorder.style.top = "0px";
	}

	selectBorder = doc.getElementById("_select_border_down");
	selectBorder.style.visibility = newValue;

	if (over)
	{
		selectBorder.style.width = width;
		selectBorder.style.height = selectBorderWidth;
		selectBorder.style.left = (selectBorderWidth - width) + "px";
		selectBorder.style.top = (height - selectBorderWidth) + "px";
	}

	selectBorder = doc.getElementById("_select_border_left");
	selectBorder.style.visibility = newValue;

	if (over)
	{
		selectBorder.style.width = selectBorderWidth;
		selectBorder.style.height = height;
		selectBorder.style.left = "0px";
		selectBorder.style.top = (selectBorderWidth - height) + "px";
	}

	var tooltipId = (isSmallImage ? "_smallimage_tooltip" : "_tooltip");
	var regionTooltip = doc.getElementById(regionId + tooltipId);

	if (regionTooltip != null)
	{
		regionTooltip.style.visibility = newValue;
	}
}

function ReinitMap()
{
	mapWidth = 0;
	mapHeight = 0;
	mapDelta = 10;
	mapInitialized = false;
}

function InitResizeMap(frameName, pageId, bottomDivId, path)
{
	setTimeout("ResizeMap('" + frameName + "','" + pageId + "','" + bottomDivId + "','" + path + "','true')", 500);
}

function ResizeMap(frameName, pageId, bottomDivId, path, initialization)
{
	if (mapInitialized && (initialization == 'true'))
		return;

	var parentIframes = this.document.getElementsByTagName('iframe');
	var frame = this.frames[frameName];
	var iframe = null;

	for (var i = 0; i < parentIframes.length; i++)
	{
		if (parentIframes[i].name == frameName)
		{
			iframe = parentIframes[i];
			break;
		}
	}

	if (frame == null || frame.document == null || frame.document.body == null || iframe == null)
	{
		this.location.reload();
		return;
	}

	// For performances reasons, only update url when size change significantly
	var  width = frame.document.body.clientWidth;
	var  height = frame.document.body.clientHeight;

	if ((mapWidth > width + mapDelta)
		|| (mapWidth < width - mapDelta)
		|| (mapHeight > height + mapDelta)
		|| (mapHeight < height - mapDelta))
	{
		mapWidth = width;
		mapHeight = height;

		iframe.style.height = 0;

		var totalHeight = this.document.body.clientHeight;
		var scrollHeight = this.document.body.scrollHeight;
		var messageDiv = this.document.getElementById(bottomDivId);
		var newHeight = totalHeight;

		if (messageDiv != null)
			newHeight = cmGetY(messageDiv) - cmGetY(iframe);
		else
			newHeight = totalHeight - cmGetY(iframe);

		iframe.style.height = newHeight - 2;

		if (initialization == 'true')
			mapInitialized = true;

		var  newUrl = _rootUrl + path;
		var  date = new Date();

		newUrl = newUrl + '?_reload=' + date.getTime() + '&_ajax=false' + '&_page=' + pageId +
			'&_frame=' + frame.name + cmGetWidth(iframe) + '*' + cmGetHeight(iframe);

		frame.location.href = newUrl;
	}
}


/****************************************
 *     Management of rubber banding     *
 ****************************************/

var rubberMapObject = null;
var rubberContentObject = null;
var rubberMovingObject = null;
var rubberObject = null;
var useRubber = new Array();
var leftContentOffset = 0;
var topContentOffset = 0;
var stopUpdateLoadedImages;
var selectCursor = "crosshair";
var moveCursor;
var movingCursor;

/**
 * Sets or unsets the rubber mode.
 **/
function setMapRubberMode(frameName, mapId, rubber, selectCellId, moveCellId)
{
	setUseRubber(frameName, mapId, rubber);

	var selectCell = document.getElementById(selectCellId);
	var moveCell = document.getElementById(moveCellId);

	if (rubber)
	{
		selectCell.className = "pressedTool";
		moveCell.className = "";
	}
	else
	{
		selectCell.className = "";
		moveCell.className = "pressedTool";
	}
}

/**
 * Sets the move map cursors.
 **/
function setMoveMapCursors(frameName, moveCursorUrl, movingCursorUrl)
{
	var frame = findTarget(null, frameName);

	if (frame != null)
	{
		frame.moveCursor = moveCursorUrl;
		frame.movingCursor = movingCursorUrl;
	}
}

/**
 * Set or Unset the document has a rubberband listener.
 * doc is the reference to the document.
 **/
function setRubberBandListener(rubberId, set, mapId, mapDivId, mapContentDivId, controllerId, mapComponentId,
	actionPath, selectionPath)
{
	if (movementStarted)
		return;

	var doc = window.document;
	var path = (isUseRubber(mapComponentId) ? selectionPath : actionPath);

	if (set == true)
	{
		var startMovementCallback = function(e)
		{
			startMovement(e, mapComponentId, controllerId, path);
			return false;
		}

		var movementCallback = function(e)
		{
			movement(e, mapComponentId, controllerId, path);
			return false;
		}

		var stopMovementCallback = function()
		{
			stopMovement(mapId, mapComponentId, controllerId, path);
		}

		doc.onmousemove = movementCallback;
		doc.onmousedown = startMovementCallback;
		doc.onmouseup = stopMovementCallback;
		rubberObject = doc.getElementById(rubberId);
		rubberMovingObject = doc.getElementById(rubberId + "_moving");
		rubberMapObject = doc.getElementById(mapDivId);
		rubberContentObject = doc.getElementById(mapContentDivId);
	}
	else if (set == false)
	{
		doc.onmousemove = "";
		doc.onmousedown = "";
		doc.onmouseup = "";
	}
	else
		return true;

	if (rubberMovingObject != null)
		rubberMovingObject.style.cursor = (isUseRubber(mapComponentId) ? selectCursor : moveCursor);

	if (rubberContentObject != null)
		rubberContentObject.style.cursor = (isUseRubber(mapComponentId) ? selectCursor : moveCursor);
}

/**
 * This method defines the starting point of a rectangle for
 * the selection of an area over the map.
 * It is called when the mouse is pressed over the map.
 * doc : the reference of the document
 **/
function startMovement(e, mapComponentId, controllerId, path)
{
	if (zoomMoving || viewerMoving || translatingViewer)
		return;

	if ((dragObj.elNode != null) && (typeof dragObj.elNode != "undefined"))
		return;

	// Prevent right click to start rubber banding
	if ((e && (e.button == 2)) || (window.event && (window.event.button == 2)))
		return;

	date = new Date();
	clickStart = date.getTime();

	if (!movementStarted)
	{
		var doc = getMapDocument();

		movementStarted = true;

		if (e)
		{
			var parent = e.target;

			startx = e.layerX + parseInt(rubberContentObject.style.left);
			starty = e.layerY + parseInt(rubberContentObject.style.top);

			while (parent && (parent != rubberContentObject))
			{
				startx += parent.offsetLeft;
				starty += parent.offsetTop;
				parent = parent.offsetParent;
			}
		}
		else
		{
			startx = window.event.x;
			starty = window.event.y;
		}

		endx = startx;
		endy = starty;

		if (!isUseRubber(mapComponentId))
		{
			rubberMovingObject.style.cursor = movingCursor;
			rubberContentObject.style.cursor = movingCursor;
			leftContentOffset = parseInt(rubberContentObject.style.left);
			topContentOffset = parseInt(rubberContentObject.style.top);

			stopUpdateLoadedImages = false;
			updateLoadedImagesTimeout(mapComponentId, controllerId, path);
		}
	}

	return false; // very important, do not remove!
}

/**
 * This method draws a rectangle for the selection of an area over the map.
 * It is drawn each time the user moves the mouse while pressed over the map.
 **/
function movement(e, mapComponentId, controllerId, path)
{
	if (movementStarted)
	{
		if (rubberObject.style.visibility != "visible")
		{
			if (isUseRubber(mapComponentId))
			{
				// initialise layer.
				rubberObject.style.left = startx + "px";
				rubberObject.style.top = starty + "px";
				rubberObject.style.width = "0px";
				rubberObject.style.height = "0px";
				rubberObject.style.visibility = "visible";
			}

			rubberMovingObject.style.left = "0px";
			rubberMovingObject.style.top = "0px";
			rubberMovingObject.style.width = cmGetWidth(rubberMapObject);
			rubberMovingObject.style.height = cmGetHeight(rubberMapObject);
			rubberMovingObject.style.visibility = "visible";
		}

		var newEvent = e;
		var target = null;

		if (!e)
			newEvent = window.event;

		if (newEvent.target)
			target = newEvent.target;
		else if (newEvent.srcElement)
			target = newEvent.srcElement;

		if (target != rubberMovingObject)
			return false;

		if (e)
		{
			endx = e.layerX;
			endy = e.layerY;
		}
		else
		{
			endx = window.event.x;
			endy = window.event.y;
		}

		if (!isUseRubber(mapComponentId))
		{
			rubberContentObject.style.left = leftContentOffset + (endx - startx);
			rubberContentObject.style.top = topContentOffset + (endy - starty);
		}
		else
		{
			var doc = getMapDocument();
			var posx = Math.min(endx, startx);
			var posy = Math.min(endy, starty);
			var w = Math.abs(endx-startx);
			var h = Math.abs(endy-starty);

			rubberObject.style.width = w + "px";
			rubberObject.style.height = h + "px";
			rubberObject.style.left = posx + "px";
			rubberObject.style.top = posy + "px";
		}

		return false;
	}
	else
	{
		// The event is routed in order to let the tooltip
		// function going on.
		if (document.layers)
		{
			var doc = getMapDocument();
			doc.routeEvent(e);
		}
		return true;
	}
}

/**
 * This method stops drawing the rectangle and capture
 * the coordinates of the upper left and bottom right corners.
 **/
function stopMovement(mapId, mapComponentId, controllerId, path)
{
	if (movementStarted)
	{
		movementStarted = false;
		stopUpdateLoadedImages = true;
		rubberObject.style.visibility = "hidden";
		rubberMovingObject.style.visibility = "hidden";

		date = new Date();
		time =  date.getTime() - clickStart;

		if (isUseRubber(mapComponentId))
		{
			corner1x = Math.min(startx, endx);
			corner1y = Math.min(starty, endy);
			corner2x = Math.max(startx, endx);
			corner2y = Math.max(starty, endy);

			selectMapNodes(corner1x ,corner1y ,corner2x, corner2y, mapId, controllerId, path);
		}
		else
		{
			updateLoadedImages(mapComponentId, controllerId, path);

			var params = pageParam + '=' + mapComponentId + '&' + sourceParam + '=translateMap' +
				'&' + valueParam + '=' + (endx - startx) + "_" + (endy - starty) + '&' + controllerParam + '=' + controllerId;

			if ((document.forms[0].elements[formTargetParam] != null)
					&& (typeof document.forms[0].elements[formTargetParam] != "undefined")
					&& (typeof document.forms[0].elements[formTargetParam].value != "undefined"))
				params += '&target_session=' + document.forms[0].elements[formTargetParam].value;

			SendAjaxRequestParams(_rootUrl + path, params, 'false');
		}
	}

	rubberMovingObject.style.cursor = (isUseRubber(mapComponentId) ? selectCursor : moveCursor);
	rubberContentObject.style.cursor = (isUseRubber(mapComponentId) ? selectCursor : moveCursor);

	return true;
}

/**
 * This method updates all the images that area visible and not loaded with a timeout.
 */
function updateLoadedImagesTimeout(mapComponentId, controllerId, path)
{
	if (stopUpdateLoadedImages)
		return;

	setTimeout("updateLoadedImages('" + mapComponentId + "', '" + controllerId + "', '" + path + "')", 200);
}

/**
 * This method updates all the images that area visible and not loaded.
 */
function updateLoadedImages(mapComponentId, controllerId, path)
{
	// Load parts that were not loaded
	var mapWidth = parseInt(rubberMapObject.style.width);
	var mapHeight = parseInt(rubberMapObject.style.height);
	var contentx = parseInt(rubberContentObject.style.left);
	var contenty = parseInt(rubberContentObject.style.top);
	var preloadOffset = 60;
	var startTime1 = new Date().getTime();
	var contentAll = rubberContentObject.getElementsByTagName("*");
	var length = contentAll.length;
	var divIds = "";
	var optimizeRequests = true;

	for (var i = 0; i < length; i++)
	{
		var divObject = contentAll[i];

		if (divObject.className != "MIE")
			continue;

		var divx1 = parseInt(divObject.style.left) + contentx;
		var divx2 = divx1 + parseInt(divObject.style.width);
		var divy1 = parseInt(divObject.style.top) + contenty;
		var divy2 = divy1 + parseInt(divObject.style.height);

		if (((divx1 >= -preloadOffset && divx1 <= mapWidth + preloadOffset)
					|| (divx2 >= -preloadOffset && divx2 <= mapWidth + preloadOffset))
				&& ((divy1 >= -preloadOffset && divy1 <= mapHeight + preloadOffset)
						|| (divy2 >= -preloadOffset && divy2 <= mapHeight + preloadOffset)))
		{
			divObject.className = "MI";

			if (divIds != "")
				divIds += "*";

			divIds += divObject.id;

			if (!optimizeRequests)
			{
				var params = pageParam + '=' + mapComponentId + '&' + sourceParam + '=loadImage' +
					'&' + valueParam + '=' + divObject.id + '&' + controllerParam + '=' + controllerId;

				if ((document.forms[0].elements[formTargetParam] != null)
						&& (typeof document.forms[0].elements[formTargetParam] != "undefined")
						&& (typeof document.forms[0].elements[formTargetParam].value != "undefined"))
					params += '&target_session=' + document.forms[0].elements[formTargetParam].value;

				SendAjaxRequestParams(_rootUrl + path, params, 'false');
			}
		}
	}

	if (optimizeRequests && (divIds != ""))
	{
		var params = pageParam + '=' + mapComponentId + '&' + sourceParam + '=loadImage' +
			'&' + valueParam + '=' + divIds + '&' + controllerParam + '=' + controllerId;

		if ((document.forms[0].elements[formTargetParam] != null)
				&& (typeof document.forms[0].elements[formTargetParam] != "undefined")
				&& (typeof document.forms[0].elements[formTargetParam].value != "undefined"))
			params += '&target_session=' + document.forms[0].elements[formTargetParam].value;

		SendAjaxRequestParams(_rootUrl + path, params, 'false');
	}

	updateLoadedImagesTimeout(mapComponentId, controllerId, path);
}

/**
 * This method selects the map nodes contained in the given box and
 * sends a selection event to the server.
 **/
function selectMapNodes(startX, startY, endX, endY, mapId, controllerId, path)
{
	clearSelectionIds(mapId);
	unselectAllNodes();

	var contentAll = rubberContentObject.getElementsByTagName("*");

	for (var i = 0; i < contentAll.length; i++)
	{
		var divObject = contentAll[i];

		currentId = divObject.id;

		if ((currentId == null) || (currentId == "undefined"))
			continue;

		if (endsWith(currentId, "_node"))
		{
			var x = 0, y = 0;
			var obj = divObject;

			do
			{
				x += obj.offsetLeft;
				y += obj.offsetTop;
				obj = obj.offsetParent;
			}
			while (obj && obj != rubberMapObject);

			if ((startX <= x ) && (x <= endX) && (startY <= y) && (y <= endY))
			{
				n = currentId.indexOf("_node");
				nodeId = currentId.substring(0, n);
				addSelectionId(mapId, divObject.getAttribute("nodeId"));
				selectMapNode(currentId);
			}
		}
	}

	// Call InvokeSelection
	var selectedIds = getSelectionIds(mapId);

	InvokeSelection("_select", selectedIds, controllerId, "false", path);
}


/**************************************
 *     Management of zoom widgets     *
 **************************************/


var viewerXPos = null;
var viewerYPos = null;
var viewerMoving = false;
var zoomYPos = null;
var zoomMoving = false;
var translatingViewer = false;
var currentScale = new Array();

function switchMapWidgetState(actionId, path, mapId, toolDivId, controller)
{
	var parentFrame = findTargetByContent(null, toolDivId);

	if (parentFrame == null)
		return;

	backgroundDblClick = true;

	var toolDiv = parentFrame.document.getElementById(toolDivId);
	var open = (toolDiv == null ? false : toolDiv.style.display == 'none');

	if ((controller != null) && (controller != '') && (typeof controller != "undefined"))
	{
		var params = pageParam + '=' + mapId + '&' + sourceParam + '=' + actionId +
			'&' + valueParam + '=' + open + '&' + controllerParam + '=' + controller;

		if ((document.forms[0].elements[formTargetParam] != null)
				&& (typeof document.forms[0].elements[formTargetParam] != "undefined")
				&& (typeof document.forms[0].elements[formTargetParam].value != "undefined"))
			params += '&target_session=' + document.forms[0].elements[formTargetParam].value;

		SendAjaxRequestParams(_rootUrl + path, params, 'false');
	}
}

function setMapWidgetState(open, toolDivId, switchImgId, image, tooltip)
{
	var parentFrame = findTargetByContent(null, toolDivId);

	if (parentFrame == null)
		return;

	var toolDiv = parentFrame.document.getElementById(toolDivId);
	var viewerSwitchImg = parentFrame.document.getElementById(switchImgId);

	if (toolDiv != null)
	{
		if (open)
			toolDiv.style.display = 'block';
		else
			toolDiv.style.display = 'none';
	}

	if (viewerSwitchImg != null)
	{
		viewerSwitchImg.src = image;
		SetImageTooltip(switchImgId, tooltip);
	}
}

function getCurrentScaleValue(frameName, mapId)
{
	var frame = findTarget(null, frameName);

	if (frame != null)
		return frame.currentScale[mapId];
}

function setCurrentScaleValue(frameName, mapId, scale)
{
	var frame = findTarget(null, frameName);

	if (frame != null)
		frame.currentScale[mapId] = scale;
}

function isUseRubber(mapId)
{
	var result = useRubber[mapId];

	if ((typeof result == "undefined") || (result == null))
		return true;

	return result;
}

function setUseRubber(frameName, mapId, useRubberValue)
{
	var frame = findTarget(null, frameName);

	if (frame != null)
		frame.useRubber[mapId] = useRubberValue;
}

function setMapZoomScale(scale, path, mapId, mapZoomId, xTranslation, yTranslation, controller)
{
	backgroundDblClick = true;

	var parentFrame = findTargetByContent(null, mapZoomId);

	if (parentFrame == null)
		return;

	var mapZoomDiv = parentFrame.document.getElementById(mapZoomId);
	var scaleDiv = parentFrame.document.getElementById(mapZoomId + '_scale' + scale);

	if ((scaleDiv == null) || (typeof scaleDiv == "undefined"))
		return;

	var zoomCursorDiv = parentFrame.document.getElementById(mapZoomId + '_cursor');
	var zoomCursorMovingDiv = parentFrame.document.getElementById(mapZoomId + '_cursor_moving');
	var x = cmGetXAt(scaleDiv, mapZoomDiv);
	var y = cmGetYAt(scaleDiv, mapZoomDiv);

	zoomCursorDiv.style.left = x + 1;
	zoomCursorDiv.style.top = y + 1;
	zoomCursorDiv.style.visibility = "visible";
	parentFrame.currentScale[mapId] = scale;
	zoomCursorMovingDiv.style.visibility = "hidden";

	if ((mapId != null) && (mapId != ''))
	{
		var params = pageParam + '=' + mapId + '&' + sourceParam + '=setMapZoomScale' +
			'&' + valueParam + '=' + scale;

		if ((xTranslation != null) && (typeof xTranslation != "undefined")
				&& (yTranslation != null) && (typeof yTranslation != "undefined"))
			params += '_' + xTranslation + '_' + yTranslation;

		if ((typeof controller != "undefined") && (controller != null) && (controller != ''))
			params += '&' + controllerParam + '=' + controller;

		if ((document.forms[0].elements[formTargetParam] != null)
				&& (typeof document.forms[0].elements[formTargetParam] != "undefined")
				&& (typeof document.forms[0].elements[formTargetParam].value != "undefined"))
			params += '&target_session=' + document.forms[0].elements[formTargetParam].value;

		SendAjaxRequestParams(_rootUrl + path, params, 'false');
	}
}

function prepareMovingZoom(evt, mapId, mapZoomId)
{
	var zoomDiv = this.document.getElementById(mapZoomId + '_cursor');
	var zoomCursorMovingDiv = this.document.getElementById(mapZoomId + '_cursor_moving');
	var mapDiv = this.document.getElementById(mapId);

	zoomCursorMovingDiv.style.left = cmGetXAt(zoomDiv, mapDiv);
	zoomCursorMovingDiv.style.top = cmGetYAt(zoomDiv, mapDiv);
	zoomCursorMovingDiv.style.width = cmGetWidth(zoomDiv);
	zoomCursorMovingDiv.style.height = cmGetHeight(zoomDiv);
	zoomCursorMovingDiv.style.visibility = "visible";
}

function startMovingZoom(mapId, mapZoomId)
{
	var mapDiv = this.document.getElementById(mapId);
	var zoomCursorMovingDiv = this.document.getElementById(mapZoomId + '_cursor_moving');

	zoomCursorMovingDiv.style.left = "0px";
	zoomCursorMovingDiv.style.top = "0px";
	zoomCursorMovingDiv.style.width = cmGetWidth(mapDiv);
	zoomCursorMovingDiv.style.height = cmGetHeight(mapDiv);
	zoomMoving = true;
}

function moveZoom(evt, mapId, mapZoomId)
{
	var zoomCursorDiv = this.document.getElementById(mapZoomId + '_cursor');

	if (!zoomMoving)
	{
		zoomYPos = evt.clientY;

		return;
	}

	if (document.getElementById && !(document.all))
	{
		// Firefox
		// Nothing to do
	}
	else if(document.all)
	{
		// IE
		evt = event;
	}

	if (zoomYPos == null)
	{
		zoomYPos = evt.clientY;
	}

	var diffY = evt.clientY - zoomYPos;
	var newY = parseInt(zoomCursorDiv.style.top) + diffY;
	var mapZoomDiv = this.document.getElementById(mapZoomId);
	var mapDiv = this.document.getElementById(mapId);
	var zoomScaleDiv = this.document.getElementById(mapZoomId + '_scale');
	var yTotal = cmGetYAt(mapZoomDiv, mapDiv) + newY;
	var yMin = cmGetYAt(zoomScaleDiv, mapDiv);
	var yMax = yMin + cmGetHeight(zoomScaleDiv);

	if (yTotal < yMin + 1)
	{
		newY = yMin - cmGetYAt(mapZoomDiv, mapDiv) + 1;
		zoomCursorDiv.style.top = newY + "px";
		return;
	}

	if (yTotal > yMax - 8)
	{
		newY = yMax - cmGetYAt(mapZoomDiv, mapDiv) - 8;
		zoomCursorDiv.style.top = newY + "px";
		return;
	}

	zoomYPos = evt.clientY;
	zoomCursorDiv.style.top = newY + "px";
}

function endMovingZoom(path, mapId, mapZoomId, minScale, controller)
{
	var zoomDiv = this.document.getElementById(mapZoomId);
	var zoomCursorDiv = this.document.getElementById(mapZoomId + '_cursor');
	var zoomCursorMovingDiv = this.document.getElementById(mapZoomId + '_cursor_moving');
	var zoomCursorY = cmGetYAt(zoomCursorDiv, zoomDiv);
	var scale = minScale;
	var scaleDiv = null;

	while (zoomMoving
		&& ((scaleDiv = document.getElementById(mapZoomId + '_scale' + scale)) != null)
		&& (typeof scaleDiv != "undefined"))
	{
		if (cmGetYAt(scaleDiv, zoomDiv) < zoomCursorY - (-4))
		{
			setMapZoomScale(scale, path, mapId, mapZoomId, null, null, controller);
			break;
		}

		scale++;
	}

	zoomCursorMovingDiv.style.visibility = "hidden";
	zoomYPos = null;
	zoomMoving = false;
}

function prepareMovingViewer(mapDivId, mapViewerDivId, mapViewerTranslateId, mapViewerMovingId)
{
	var viewerDiv = this.document.getElementById(mapViewerDivId);
	var viewerTranslateDiv = this.document.getElementById(mapViewerTranslateId);
	var viewerMovingDiv = this.document.getElementById(mapViewerMovingId);
	var mapDiv = this.document.getElementById(mapDivId);

	viewerMovingDiv.style.left = cmGetXAt(viewerDiv, mapDiv);
	viewerMovingDiv.style.top = cmGetYAt(viewerDiv, mapDiv);
	viewerMovingDiv.style.width = cmGetWidth(viewerDiv);
	viewerMovingDiv.style.height = cmGetHeight(viewerDiv);
	viewerMovingDiv.style.visibility = "visible";
	viewerTranslateDiv.style.left = cmGetXAt(viewerDiv, mapDiv) + 5;
	viewerTranslateDiv.style.top = cmGetYAt(viewerDiv, mapDiv) + 5;
	viewerTranslateDiv.style.width = cmGetWidth(viewerDiv) - 10;
	viewerTranslateDiv.style.height = cmGetHeight(viewerDiv) - 10;
	viewerTranslateDiv.style.visibility = "visible";
}

function startMovingViewer(mapDivId, mapViewerTranslateId, mapViewerMovingId)
{
	var mapDiv = this.document.getElementById(mapDivId);
	var viewerTranslateDiv = this.document.getElementById(mapViewerTranslateId);
	var viewerMovingDiv = this.document.getElementById(mapViewerMovingId);

	viewerTranslateDiv.style.visibility = "hidden";
	viewerMovingDiv.style.left = "0px";
	viewerMovingDiv.style.top = "0px";
	viewerMovingDiv.style.width = cmGetWidth(mapDiv);
	viewerMovingDiv.style.height = cmGetHeight(mapDiv);
	viewerMoving = true;
}

function moveViewer(evt, mapDivId, mapViewerDivId, mapViewerImgId, mapViewerSwitchId)
{
	var viewerDiv = this.document.getElementById(mapViewerDivId);
	var mapDiv = this.document.getElementById(mapDivId);
	var viewerImgDiv = this.document.getElementById(mapViewerImgId);
	var viewerSwitchDiv = this.document.getElementById(mapViewerSwitchId);

	if (!viewerMoving)
	{
		viewerXPos = evt.clientX;
		viewerYPos = evt.clientY;

		return;
	}

	if (document.getElementById && !(document.all))
	{
		// Firefox
		// Nothing to do
	}
	else if(document.all)
	{
		// IE
		evt = event;
	}

	if (viewerXPos == null)
	{
		viewerXPos = evt.clientX;
		viewerYPos = evt.clientY;
	}

	var diffX = evt.clientX - viewerXPos;
	var diffY = evt.clientY - viewerYPos;
	var newX = parseInt(viewerDiv.style.left) + diffX;
	var newY = parseInt(viewerDiv.style.top) + diffY;
	var yTotal = cmGetYAt(viewerDiv, mapDiv) + newY;
	var xMax = cmGetWidth(mapDiv) - cmGetWidth(viewerImgDiv);
	var yMax = cmGetHeight(mapDiv) - cmGetHeight(viewerImgDiv);
	var setXPos = true;
	var setYPos = true;

	if (newX < 2)
	{
		newX = 2;
		setXPos = false;
	}

	if (newY < 2)
	{
		newY = 2;
		setYPos = false;
	}

	if (newX > xMax - 5)
	{
		newX = (xMax - 5);
		setXPos = false;
	}

	if (newY > yMax - 5)
	{
		newY = (yMax - 5);
		setYPos = false;
	}

	if (setXPos)
		viewerXPos = evt.clientX;

	if (setYPos)
		viewerYPos = evt.clientY;

	viewerDiv.style.left = newX + "px";
	viewerDiv.style.top = newY + "px";

	if (viewerSwitchDiv != null)
	{
		viewerSwitchDiv.style.left = (newX + 2) + "px";
		viewerSwitchDiv.style.top = (newY + 2) + "px";
	}
}

function endMovingViewer(mapDivId, mapViewerDivId, mapViewerTranslateId, mapViewerMovingId, path, mapId, controller)
{
	var viewerDiv = this.document.getElementById(mapViewerDivId);

	prepareMovingViewer(mapDivId, mapViewerDivId, mapViewerTranslateId, mapViewerMovingId);
	viewerXPos = null;
	viewerYPos = null;

	var viewerX = viewerDiv.style.left;
	var viewerY = viewerDiv.style.top;

	if (viewerMoving && (controller != null) && (controller != '') && (typeof controller != "undefined"))
	{
		var params = pageParam + '=' + mapId + '&' + sourceParam + '=moveViewer' +
			'&' + valueParam + '=' + viewerX + "_" + viewerY + '&' + controllerParam + '=' + controller;

		if ((document.forms[0].elements[formTargetParam] != null)
				&& (typeof document.forms[0].elements[formTargetParam] != "undefined")
				&& (typeof document.forms[0].elements[formTargetParam].value != "undefined"))
			params += '&target_session=' + document.forms[0].elements[formTargetParam].value;

		SendAjaxRequestParams(_rootUrl + path, params, 'false');
	}

	viewerMoving = false;
}

function translateViewer(evt, path, mapId, mapViewerDivId, controller)
{
	translatingViewer = true;

	if (document.getElementById && !(document.all))
	{
		// Firefox
		// Nothing to do
	}
	else if(document.all)
	{
		// IE
		evt = event;
	}

	var viewerDiv = this.document.getElementById(mapViewerDivId);
	var x = evt.clientX - cmGetX(viewerDiv);
	var y = evt.clientY - cmGetY(viewerDiv);
	var params = pageParam + '=' + mapId + '&' + sourceParam + '=translateViewer' +
		'&' + valueParam + '=' + x + "_" + y + '&' + controllerParam + '=' + controller;

	if ((document.forms[0].elements[formTargetParam] != null)
			&& (typeof document.forms[0].elements[formTargetParam] != "undefined")
			&& (typeof document.forms[0].elements[formTargetParam].value != "undefined"))
		params += '&target_session=' + document.forms[0].elements[formTargetParam].value;

	SendAjaxRequestParams(_rootUrl + path, params, 'false');

	setTimeout("translatingViewer = false;", 500);
}

function translateMap(path, direction, mapId, mapDivId, mapContentDivId, backgroundImagesId, emptyImagePath, controller)
{
	backgroundDblClick = true;

	rubberMapObject = document.getElementById(mapDivId);
	rubberContentObject = document.getElementById(mapContentDivId);

	var xoffset = parseInt(rubberMapObject.style.width) * 0.2;
	var yoffset = parseInt(rubberMapObject.style.height) * 0.2;
	var offset = Math.min(xoffset, yoffset);

	if (direction == "CENTER")
	{
		var globalWidth = parseInt(rubberContentObject.style.width);
		var globalHeight = parseInt(rubberContentObject.style.height);
		var visibleWidth = parseInt(rubberMapObject.style.width);
		var visibleHeight = parseInt(rubberMapObject.style.height);

		setMapOffset(mapContentDivId, (visibleWidth - globalWidth) / 2, (visibleHeight - globalHeight) / 2);
	}
	else
	{
		if (direction == "NORTH")
		{
			xoffset = 0;
			yoffset = offset;
		}
		else if (direction == "SOUTH")
		{
			xoffset = 0;
			yoffset = -offset;
		}
		else if (direction == "WEST")
		{
			xoffset = offset;
			yoffset = 0;
		}
		else if (direction == "EAST")
		{
			xoffset = -offset;
			yoffset = 0;
		}

		setMapOffset(mapContentDivId, parseInt(rubberContentObject.style.left) + xoffset, parseInt(rubberContentObject.style.top) + yoffset);
	}

	updateLoadedImages(mapId, controller, path);

	var params = pageParam + '=' + mapId + '&' + sourceParam + '=translateMap' +
		'&' + valueParam + '=' + (direction == "CENTER" ? "reset" : xoffset + "_" + yoffset) + '&' + controllerParam + '=' + controller;

	if ((document.forms[0].elements[formTargetParam] != null)
			&& (typeof document.forms[0].elements[formTargetParam] != "undefined")
			&& (typeof document.forms[0].elements[formTargetParam].value != "undefined"))
		params += '&target_session=' + document.forms[0].elements[formTargetParam].value;

	SendAjaxRequestParams(_rootUrl + path, params, 'false');
}

function setMapOffset(mapContentDivId, xoffset, yoffset)
{
	var mapComponent = document.getElementById(mapContentDivId);

	mapComponent.style.left = xoffset;
	mapComponent.style.top = yoffset;
}

var firefoxWheelMovedCallback = null;

function addFirefoxWheelEvent(path, mapDivId, mapContentId, mapZoomId, mapId, controller)
{
	var parentFrame = findTargetByContent(null, mapDivId);

	if (parentFrame == null)
		return;

	var mapZoomDiv = parentFrame.document.getElementById(mapDivId);

	if (firefoxWheelMovedCallback != null)
		mapZoomDiv.removeEventListener('DOMMouseScroll', firefoxWheelMovedCallback, true);

	firefoxWheelMovedCallback = function(event)
	{
		parentFrame.wheelMoved(event, path, mapDivId, mapContentId, mapZoomId, mapId, controller);
	}

	mapZoomDiv.addEventListener('DOMMouseScroll', firefoxWheelMovedCallback, true);
}

function wheelMoved(event, path, mapDivId, mapContentId, mapZoomId, mapId, controller)
{
	var zoomIn = true;

	if (event.wheelDelta)
		zoomIn = (event.wheelDelta > 0);
	else if (event.detail)
		zoomIn = (event.detail < 0);

	var mapContent = this.document.getElementById(mapContentId);
	var x = event.clientX - cmGetX(mapContent) - (cmGetWidth(mapContent) / 2);
	var y = event.clientY - cmGetY(mapContent) - (cmGetHeight(mapContent) / 2);

	if (zoomIn)
		setMapZoomScale(currentScale[mapId] + 1, path, mapId, mapZoomId, x, y, controller);
	else
		setMapZoomScale(currentScale[mapId] - 1, path, mapId, mapZoomId, x, y, controller);

	if (browser.isIE)
	{
		window.event.cancelBubble = true;
		window.event.returnValue = false;
	}
	else if (browser.isNS)
		event.preventDefault();
}
/*
	JSCookMenu Effect (c) Copyright 2002-2006 by Heng Yuan

	http://jscook.sourceforge.net/JSCookMenu/

	Permission is hereby granted, free of charge, to any person obtaining a
	copy of this software and associated documentation files (the "Software"),
	to deal in the Software without restriction, including without limitation
	the rights to use, copy, modify, merge, publish, distribute, sublicense,
	and/or sell copies of the Software, and to permit persons to whom the
	Software is furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included
	in all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	ITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
	FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
	DEALINGS IN THE SOFTWARE.
*/
//
// utiltity object to simplify common tasks in effects.
//
function CMSpecialEffectInstance (effect, menu)
{
	effect.show = true;
	effect.menu = menu;
	menu.cmEffect = effect;
	this.effect = effect;
}

CMSpecialEffectInstance.prototype.canShow = function (changed)
{
	if (changed)
	{
		if (this.effect.show)
			return false;
		this.effect.show = true;
	}
	else if (!this.effect.show)
		return false;
	return true;
}

CMSpecialEffectInstance.prototype.canHide = function (changed)
{
	var effect = this.effect;
	if (changed)
	{
		if (!effect.show)
			return false;
		effect.show = false;
	}
	else if (effect.show)
		return false;
	return true;
}

//
// public function to be called to initate the display of the
// menu.
//
CMSpecialEffectInstance.prototype.startShowing = function ()
{
	var menu = this.effect.menu;
	menu.style.visibility = 'visible';
	/*@cc_on
		@if (@_jscript_version >= 5.5)
			if (menu.cmFrameObj)
			{
				var frameObj = menu.cmFrameObj;
				frameObj.style.display = 'block';
			}
		@end
	@*/
}

//
// public function to be called after showing effect is finished.
//
CMSpecialEffectInstance.prototype.finishShowing = function ()
{
}

//
// clean up after finish hiding effect.
//
CMSpecialEffectInstance.prototype.finishHiding = function ()
{
	var menu = this.effect.menu;
	menu.style.visibility = 'hidden';
	menu.style.top = '0px';
	menu.style.left = '0px';
	/*@cc_on
		@if (@_jscript_version >= 5.5)
			if (menu.cmFrameObj)
			{
				var frameObj = menu.cmFrameObj;
				frameObj.style.display = 'none';
				frameObj.style.top = '0px';
				frameObj.style.left = '0px';
				menu.cmFrameObj = null;
				cmFreeFrame (frameObj);
			}
		@end
	@*/
	menu.cmEffect = null;
	menu.cmOrient = null;
	this.effect.menu = null;
}

//
// this is the internal class to perform the sliding effect
//
function CMSlidingEffectInstance (menu, orient, speed)
{
	this.base = new CMSpecialEffectInstance (this, menu);

	menu.style.overflow = 'hidden';

	this.x = menu.offsetLeft;
	this.y = menu.offsetTop;

	if (orient.charAt (0) == 'h')
	{
		this.slideOrient = 'h';
		this.slideDir = orient.charAt (1);
	}
	else
	{
		this.slideOrient = 'v';
		this.slideDir = orient.charAt (2);
	}

	this.speed = speed;
	this.fullWidth = menu.offsetWidth;
	this.fullHeight = menu.offsetHeight;
	this.percent = 0;
	/*@cc_on
		@if (@_jscript_version >= 5.5)
			if (menu.cmFrameObj)
			{
				var frameObj = menu.cmFrameObj;
				this.frameX = frameObj.offsetLeft;
				this.frameY = frameObj.offsetTop;
				this.frameWidth = frameObj.offsetWidth;
				this.frameHeight = frameObj.offsetHeight;
			}
		@end
	@*/
}
	// public function to show the menu
CMSlidingEffectInstance.prototype.showEffect = function (changed)
{
	if (!this.base.canShow (changed))
		return;

	var percent = this.percent;
	if (this.slideOrient == 'h')
		this.slideMenuV ();
	else
		this.slideMenuH ();

	if (percent == 0)
	{
		this.base.startShowing ();
	}

	if (percent < 100)
	{
		this.percent += this.speed;
		cmTimeEffect (this.menu.id, this.show, 10);
	}
	else if (this.show)
	{
		this.base.finishShowing ();
	}
}

// public function to hide the menu
CMSlidingEffectInstance.prototype.hideEffect = function (changed)
{
	if (!this.base.canHide (changed))
		return;

	var percent = this.percent;
	if (this.slideOrient == 'h')
		this.slideMenuV ();
	else
		this.slideMenuH ();

	if (percent > 0)
	{
		this.percent -= this.speed;
		cmTimeEffect (this.menu.id, this.show, 10);
	}
	else if (!this.show)
	{
		this.menu.style.clip = 'auto';
		this.base.finishHiding ();
	}
}

// internal function to scroll a menu left/right
CMSlidingEffectInstance.prototype.slideMenuH = function ()
{
	var percent = this.percent;
	if (percent < 0)
		percent = 0;
	if (percent > 100)
		percent = 100;
	var fullWidth = this.fullWidth;
	var fullHeight = this.fullHeight;
	var x = this.x;
	var space = percent * fullWidth / 100;
	var menu = this.menu;

	if (this.slideDir == 'l')
	{
		menu.style.left = (x + fullWidth - space) + 'px';
		menu.style.clip = 'rect(0px ' + space + 'px ' + fullHeight + 'px 0px)';
	}
	else
	{
		menu.style.left = (x - fullWidth + space) + 'px';
		menu.style.clip = 'rect(0px ' + fullWidth + 'px ' + fullHeight + 'px ' + (fullWidth - space) + 'px)';
	}
	/*@cc_on
		@if (@_jscript_version >= 5.5)
			if (menu.cmFrameObj)
			{
				var frameObj = menu.cmFrameObj;
				if (this.slideDir == 'l')
					frameObj.style.left = (this.frameX + fullWidth - space) + 'px';
				frameObj.style.width = space + 'px';
			}
		@end
	@*/
}

// internal function to scroll a menu up/down
CMSlidingEffectInstance.prototype.slideMenuV = function ()
{
	var percent = this.percent;
	if (percent < 0)
		percent = 0;
	if (percent > 100)
		percent = 100;
	var fullWidth = this.fullWidth;
	var fullHeight = this.fullHeight;
	var y = this.y;
	var space = percent * fullHeight / 100;
	var menu = this.menu;

	if (this.slideDir == 'b')
	{
		menu.style.top = (y - fullHeight + space) + 'px';
		menu.style.clip = 'rect(' + (fullHeight - space) + 'px ' + fullWidth + 'px ' + fullHeight + 'px 0px)';
	}
	else
	{
		menu.style.top = (y + fullHeight - space) + 'px';
		menu.style.clip = 'rect(0px ' + fullWidth + 'px ' + space + 'px 0px)';
	}
	/*@cc_on
		@if (@_jscript_version >= 5.5)
			if (menu.cmFrameObj)
			{
				var frameObj = menu.cmFrameObj;
				if (this.slideDir == 'u')
					frameObj.style.top = (this.frameX - space) + 'px';
				frameObj.style.height = space + 'px';
			}
		@end
	@*/
}

//
// call
//		new CMSlidingEffect (speed)
// to create a new effect object.
//
function CMSlidingEffect (speed)
{
	if (!speed)
		speed = 10;
	else if (speed <= 0)
		speed = 10;
	else if (speed >= 100)
		speed = 100;
	this.speed = speed;
}

CMSlidingEffect.prototype.getInstance = function (menu, orient)
{
	return new CMSlidingEffectInstance (menu, orient, this.speed);
}

//
// this is the internal class to perform the sliding effect
//
function CMFadingEffectInstance (menu, showSpeed, hideSpeed)
{
	this.base = new CMSpecialEffectInstance (this, menu);

	menu.style.overflow = 'hidden';

	this.showSpeed = showSpeed;
	this.hideSpeed = hideSpeed;

	this.opacity = 0;
}

// public function to show the menu
CMFadingEffectInstance.prototype.showEffect = function (changed)
{
	if (!this.base.canShow (changed))
		return;

	var menu = this.menu;
	var opacity = this.opacity;

	this.setOpacity ();

	if (opacity == 0)
	{
		this.base.startShowing ();
	}

	if (opacity < 100)
	{
		this.opacity += 10;
		cmTimeEffect (menu.id, this.show, this.showSpeed);
	}
	else if (this.show)
	{
		this.base.finishShowing ();
	}
}

// public function to hide the menu
CMFadingEffectInstance.prototype.hideEffect = function (changed)
{
	if (!this.base.canHide (changed))
		return;

	var menu = this.menu;
	var opacity = this.opacity;

	this.setOpacity ();

	if (this.opacity > 0)
	{
		this.opacity -= 10;
		cmTimeEffect (menu.id, this.show, this.hideSpeed);
	}
	else if (!this.show)
	{
		this.base.finishHiding ();
	}
}

// internal functions
CMFadingEffectInstance.prototype.setOpacity = function ()
{
	this.menu.style.opacity = this.opacity / 100;
	/*@cc_on
		this.menu.style.filter = 'alpha(opacity=' + this.opacity + ')';
		//this.menu.style.filter = 'progid:DXImageTransform.Microsoft.Alpha(opacity=' + this.opacity + ')';
	@*/
}

function CMFadingEffect (showSpeed, hideSpeed)
{
	this.showSpeed = showSpeed;
	this.hideSpeed = hideSpeed;
}

CMFadingEffect.prototype.getInstance = function (menu, orient)
{
	return new CMFadingEffectInstance (menu, this.showSpeed, this.hideSpeed);
}
/*
	JSCookMenu v2.0.3 (c) Copyright 2002-2006 by Heng Yuan

	http://jscook.sourceforge.net/JSCookMenu/

	Permission is hereby granted, free of charge, to any person obtaining a
	copy of this software and associated documentation files (the "Software"),
	to deal in the Software without restriction, including without limitation
	the rights to use, copy, modify, merge, publish, distribute, sublicense,
	and/or sell copies of the Software, and to permit persons to whom the
	Software is furnished to do so, subject to the following conditions:

	The above copyright notice and this permission notice shall be included
	in all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
	OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
	ITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
	AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
	LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
	FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER
	DEALINGS IN THE SOFTWARE.
*/

// Globals
var _cmIDCount = 0;
var _cmIDName = 'cmSubMenuID';		// for creating submenu id

var _cmTimeOut = null;				// how long the menu would stay
var _cmCurrentItem = null;			// the current menu item being selected;

var _cmNoAction = new Object ();	// indicate that the item cannot be hovered.
var _cmNoClick = new Object ();		// similar to _cmNoAction but does not respond to mouseup/mousedown events
var _cmSplit = new Object ();		// indicate that the item is a menu split

var _cmMenuList = new Array ();		// a list of the current menus
var _cmItemList = new Array ();		// a simple list of items

var _cmFrameList = new Array ();	// a pool of reusable iframes
var _cmFrameListSize = 0;			// keep track of the actual size
var _cmFrameIDCount = 0;			// keep track of the frame id
var _cmFrameMasking = true;			// use the frame masking

// directory of where all the images are
var cmLeonardiBase = './';
var cmLeonardiLastPopupMenuId = _cmIDCount;

var cmLeonardi =
{
  	mainFolderRight: '&nbsp;',
	mainItemRight: '&nbsp;',
	itemRight: '&nbsp;',
	mainSpacing: 0,
	subSpacing: 0,
	delay: 200
};

var cmLeonardiPopup =
{
  	mainFolderRight: '&nbsp;',
	mainItemRight: '&nbsp;',
	itemRight: '&nbsp;',
	mainSpacing: 0,
	subSpacing: 0,
	delay: 200
};

// default node properties
var _cmNodeProperties =
{
	// theme prefix
	prefix:	'',

  	// main menu display attributes
  	//
  	// Note.  When the menu bar is horizontal,
  	// mainFolderLeft and mainFolderRight are
  	// put in <span></span>.  When the menu
  	// bar is vertical, they would be put in
  	// a separate TD cell.

  	// HTML code to the left of the folder item
  	mainFolderLeft: '',
  	// HTML code to the right of the folder item
  	mainFolderRight: '',
	// HTML code to the left of the regular item
	mainItemLeft: '',
	// HTML code to the right of the regular item
	mainItemRight:	'',

	// sub menu display attributes

	// HTML code to the left of the folder item
	folderLeft:		'',
	// HTML code to the right of the folder item
	folderRight:	'',
	// HTML code to the left of the regular item
	itemLeft:		'',
	// HTML code to the right of the regular item
	itemRight:		'',
	// cell spacing for main menu
	mainSpacing:	0,
	// cell spacing for sub menus
	subSpacing:		0,

	// optional settings
	// If not set, use the default

	// auto disappear time for submenus in milli-seconds
	delay:			500,

	// 1st layer sub menu starting index
	zIndexStart:	1000,
	// z-index incremental step for subsequent layers
	zIndexInc:		5,

	// sub menu header appears before the sub menu table
	subMenuHeader:	null,
	// sub menu header appears after the sub menu table
	subMenuFooter:	null,

	// submenu location adjustments
	//
	// offsetHMainAdjust for adjusting the first submenu
	// 		of a 'hbr' menu.
	// offsetVMainAdjust for adjusting the first submenu
	//		of a 'vbr' menu.
	// offsetSubAdjust for subsequent level of submenus
	//
	offsetHMainAdjust:	[0, 0],
	offsetVMainAdjust:	[0, 0],
	offsetSubAdjust:	[0, 0],

	// act on click to open sub menu
	// not yet implemented
	// 0 : use default behavior
	// 1 : hover open in all cases
	// 2 : click on main, hover on sub
	// 3 : click open in all cases (illegal as of 1.5)
	clickOpen:		2,

	// special effects on open/closing a sub menu
	effect:			null
};

// for horizontal menu split
var cmLeonardiHSplit = [_cmNoClick, '<td class="LeonardiMenuItemLeft"></td><td colspan="2"><div class="LeonardiMenuSplit"></div></td>'];
var cmLeonardiMainHSplit = [_cmNoClick, '<td class="LeonardiMainItemLeft"></td><td colspan="2"><div class="LeonardiMenuSplit"></div></td>'];

// disable iframe masking for IE7
/*@cc_on
	@if (@_jscript_version >= 5.6)
		if (_cmFrameMasking)
		{
			var v = navigator.appVersion;
			var i = v.indexOf ("MSIE ");
			if (i >= 0)
			{
				if (parseInt (navigator.appVersion.substring (i + 5)) >= 7)
					_cmFrameMasking = false;
			}
		}
	@end
@*/

var _cmClicked = false;				// for onClick

// flag for turning on off hiding objects
//
// 0: automatic
// 1: hiding
// 2: no hiding
var _cmHideObjects = 0;

// Utility function to do a shallow copy a node property
function cmClone (nodeProperties)
{
	var returnVal = new Object ();
	for (v in nodeProperties)
		returnVal[v] = nodeProperties[v];
	return returnVal;
}

//
// store the new menu information into a structure to retrieve it later
//
function cmAllocMenu (id, menu, orient, nodeProperties, prefix)
{
	var info = new Object ();
	info.div = id;
	info.menu = menu;
	info.orient = orient;
	info.nodeProperties = nodeProperties;
	info.prefix = prefix;
	var menuID = _cmMenuList.length;
	_cmMenuList[menuID] = info;
	return menuID;
}

//
// request a frame
//
function cmAllocFrame ()
{
	if (_cmFrameListSize > 0)
		return cmGetObject (_cmFrameList[--_cmFrameListSize]);
	var frameObj = document.createElement ('iframe');
	var id = _cmFrameIDCount++;
	frameObj.id = 'cmFrame' + id;
	frameObj.frameBorder = '0';
	frameObj.style.display = 'none';
	frameObj.src = 'javascript:false';
	document.body.appendChild (frameObj);
	frameObj.style.filter = 'alpha(opacity=0)';
	frameObj.style.zIndex = 99;
	frameObj.style.position = 'absolute';
	frameObj.style.border = '0';
	frameObj.scrolling = 'no';
	return frameObj;
}

//
// make a frame resuable later
//
function cmFreeFrame (frameObj)
{
	_cmFrameList[_cmFrameListSize++] = frameObj.id;
}

//////////////////////////////////////////////////////////////////////
//
// Drawing Functions and Utility Functions
//
//////////////////////////////////////////////////////////////////////

//
// produce a new unique id
//
function cmNewID ()
{
	return _cmIDName + (++_cmIDCount);
}

//
// return the property string for the menu item
//
function cmActionItem (item, isMain, idSub, menuInfo, menuID)
{
	_cmItemList[_cmItemList.length] = item;
	var index = _cmItemList.length - 1;
	idSub = (!idSub) ? 'null' : ('\'' + idSub + '\'');

	var clickOpen = menuInfo.nodeProperties.clickOpen;
	var onClick = (clickOpen == 3) || (clickOpen == 2 && isMain);

	var param = 'this,' + isMain + ',' + idSub + ',' + menuID + ',' + index;

	var returnStr;
	if (onClick)
		returnStr = ' onmouseover="cmItemMouseOver(' + param + ',false)" onmousedown="cmItemMouseDownOpenSub (' + param + ')"';
	else
		returnStr = ' onmouseover="cmItemMouseOverOpenSub (' + param + ')" onmousedown="cmItemMouseDown (' + param + ')"';
	return returnStr + ' onmouseout="cmItemMouseOut (' + param + ')" onmouseup="cmItemMouseUp (' + param + ')"';
}

//
// this one is used by _cmNoClick to only take care of onmouseover and onmouseout
// events which are associated with menu but not actions associated with menu clicking/closing
//
function cmNoClickItem (item, isMain, idSub, menuInfo, menuID)
{
	// var index = _cmItemList.push (item) - 1;
	_cmItemList[_cmItemList.length] = item;
	var index = _cmItemList.length - 1;
	idSub = (!idSub) ? 'null' : ('\'' + idSub + '\'');

	var param = 'this,' + isMain + ',' + idSub + ',' + menuID + ',' + index;

	return ' onmouseover="cmItemMouseOver (' + param + ')" onmouseout="cmItemMouseOut (' + param + ')"';
}

function cmNoActionItem (item)
{
	return item[1];
}

function cmSplitItem (prefix, isMain, vertical)
{
	var classStr = 'cm' + prefix;
	if (isMain)
	{
		classStr += 'Main';
		if (vertical)
			classStr += 'HSplit';
		else
			classStr += 'VSplit';
	}
	else
		classStr += 'HSplit';
	return eval (classStr);
}

//
// draw the sub menu recursively
//
function cmDrawSubMenu (subMenu, prefix, id, nodeProperties, zIndexStart, menuInfo, menuID)
{
	var str = '<div class="' + prefix + 'SubMenu" id="' + id + '" style="z-index: ' + zIndexStart + ';position: absolute; top: -400px; left: -400px;">';
	if (nodeProperties.subMenuHeader)
		str += nodeProperties.subMenuHeader;

	str += '<table summary="sub menu" id="' + id + 'Table" cellspacing="' + nodeProperties.subSpacing + '" class="' + prefix + 'SubMenuTable">';

	var strSub = '';

	var item;
	var idSub;
	var hasChild;

	var i;

	var classStr;

	for (i = 5; i < subMenu.length; ++i)
	{
		item = subMenu[i];
		if (!item)
			continue;

		if (item == _cmSplit)
			item = cmSplitItem (prefix, 0, true);
		item.parentItem = subMenu;
		item.subMenuID = id;

		hasChild = (item.length > 5);
		idSub = hasChild ? cmNewID () : null;

		str += '<tr class="' + prefix + 'MenuItem"';
		if (item[0] != _cmNoClick)
			str += cmActionItem (item, 0, idSub, menuInfo, menuID);
		else
			str += cmNoClickItem (item, 0, idSub, menuInfo, menuID);
		str += '>'

		if (item[0] == _cmNoAction || item[0] == _cmNoClick)
		{
			str += cmNoActionItem (item);
			str += '</tr>';
			continue;
		}

		classStr = prefix + 'Menu';
		classStr += hasChild ? 'Folder' : 'Item';

		str += '<td class="' + classStr + 'Left">';

		if (item[0] != null)
			str += item[0];
		else
			str += hasChild ? nodeProperties.folderLeft : nodeProperties.itemLeft;

		str += '</td><td class="' + classStr + 'Text">' + item[1];

		str += '</td><td class="' + classStr + 'Right">';

		if (hasChild)
		{
			str += nodeProperties.folderRight;
			strSub += cmDrawSubMenu (item, prefix, idSub, nodeProperties, zIndexStart + nodeProperties.zIndexInc, menuInfo, menuID);
		}
		else
			str += nodeProperties.itemRight;
		str += '</td></tr>';
	}

	str += '</table>';

	if (nodeProperties.subMenuFooter)
		str += nodeProperties.subMenuFooter;
	str += '</div>' + strSub;
	return str;
}

//
// The function that builds the menu inside the specified element id.
//
// id				id of the element
// orient			orientation of the menu in [hv][ub][lr] format
// menu				the menu object to be drawn
// nodeProperties	properties for the theme
// prefix			prefix of the theme
//
function cmDraw (id, menu, orient, nodeProperties, prefix)
{
	var obj = cmGetObject (id);

	if (!prefix)
		prefix = nodeProperties.prefix;
	if (!prefix)
		prefix = '';
	if (!nodeProperties)
		nodeProperties = _cmNodeProperties;
	if (!orient)
		orient = 'hbr';

	var menuID = cmAllocMenu (id, menu, orient, nodeProperties, prefix);
	var menuInfo = _cmMenuList[menuID];

	// setup potentially missing properties
	if (!nodeProperties.delay)
		nodeProperties.delay = _cmNodeProperties.delay;
	if (!nodeProperties.clickOpen)
		nodeProperties.clickOpen = _cmNodeProperties.clickOpen;
	if (!nodeProperties.zIndexStart)
		nodeProperties.zIndexStart = _cmNodeProperties.zIndexStart;
	if (!nodeProperties.zIndexInc)
		nodeProperties.zIndexInc = _cmNodeProperties.zIndexInc;
	if (!nodeProperties.offsetHMainAdjust)
		nodeProperties.offsetHMainAdjust = _cmNodeProperties.offsetHMainAdjust;
	if (!nodeProperties.offsetVMainAdjust)
		nodeProperties.offsetVMainAdjust = _cmNodeProperties.offsetVMainAdjust;
	if (!nodeProperties.offsetSubAdjust)
		nodeProperties.offsetSubAdjust = _cmNodeProperties.offsetSubAdjust;
	// save user setting on frame masking
	menuInfo.cmFrameMasking = _cmFrameMasking;

	var str = '<table summary="main menu" class="' + prefix + 'Menu" cellspacing="' + nodeProperties.mainSpacing + '">';
	var strSub = '';

	var vertical;

	// draw the main menu items
	if (orient.charAt (0) == 'h')
	{
		str += '<tr>';
		vertical = false;
	}
	else
	{
		vertical = true;
	}

	var i;
	var item;
	var idSub;
	var hasChild;

	var classStr;

	for (i = 0; i < menu.length; ++i)
	{
		item = menu[i];

		if (!item)
			continue;

		item.menu = menu;
		item.subMenuID = id;

		str += vertical ? '<tr' : '<td';
		str += ' class="' + prefix + 'MainItem"';
		str += ' id="' + prefix + 'MainItem' + i + '"';

		hasChild = (item.length > 5);
		idSub = hasChild ? cmNewID () : null;

		str += cmActionItem (item, 1, idSub, menuInfo, menuID) + '>';

		if (item == _cmSplit)
			item = cmSplitItem (prefix, 1, vertical);

		if (item[0] == _cmNoAction || item[0] == _cmNoClick)
		{
			str += cmNoActionItem (item);
			str += vertical? '</tr>' : '</td>';
			continue;
		}

		classStr = prefix + 'Main' + (hasChild ? 'Folder' : 'Item');

		str += vertical ? '<td' : '<span';
		str += ' class="' + classStr + 'Left">';

		str += (item[0] == null) ? (hasChild ? nodeProperties.mainFolderLeft : nodeProperties.mainItemLeft)
					 : item[0];
		str += vertical ? '</td>' : '</span>';

		str += vertical ? '<td' : '<span';
		str += ' class="' + classStr + 'Text">';
		str += item[1];

		str += vertical ? '</td>' : '</span>';

		str += vertical ? '<td' : '<span';
		str += ' class="' + classStr + 'Right">';

		str += hasChild ? nodeProperties.mainFolderRight : nodeProperties.mainItemRight;

		str += vertical ? '</td>' : '</span>';

		str += vertical ? '</tr>' : '</td>';

		if (hasChild)
			strSub += cmDrawSubMenu (item, prefix, idSub, nodeProperties, nodeProperties.zIndexStart, menuInfo, menuID);
	}
	if (!vertical)
		str += '</tr>';
	str += '</table>' + strSub;

	if (obj != null)
		obj.innerHTML = str;
}

//
// The function builds the menu inside the specified element id.
//
// This function is similar to cmDraw except that menu is taken from HTML node
// rather a javascript tree.  This feature allows links to be scanned by search
// bots.
//
// This function basically converts HTML node to a javascript tree, and then calls
// cmDraw to draw the actual menu, replacing the hidden menu tree.
//
// Format:
//	<div id="menu">
//		<ul style="visibility: hidden">
//			<li><span>icon</span><a href="link" title="description">main menu text</a>
//				<ul>
//					<li><span>icon</span><a href="link" title="description">submenu item</a>
//					</li>
//				</ul>
//			</li>
//		</ul>
//	</div>
//
function cmDrawFromText (id, orient, nodeProperties, prefix)
{
	var domMenu = cmGetObject (id);
	var menu = null;
	for (var currentDomItem = domMenu.firstChild; currentDomItem; currentDomItem = currentDomItem.nextSibling)
	{
		if (!currentDomItem.tagName)
			continue;
		var tag = currentDomItem.tagName.toLowerCase ();
		if (tag != 'ul' && tag != 'ol')
			continue;
		menu = cmDrawFromTextSubMenu (currentDomItem);
		break;
	}
	if (menu)
		cmDraw (id, menu, orient, nodeProperties, prefix);
}

//
// a recursive function that build menu tree structure
//
function cmDrawFromTextSubMenu (domMenu)
{
	var items = new Array ();
	for (var currentDomItem = domMenu.firstChild; currentDomItem; currentDomItem = currentDomItem.nextSibling)
	{
		if (!currentDomItem.tagName || currentDomItem.tagName.toLowerCase () != 'li')
			continue;
		if (currentDomItem.firstChild == null)
		{
			items[items.length] = _cmSplit;
			continue;
		}
		var item = new Array ();
		var currentItem = currentDomItem.firstChild;
		var hasAction = false;
		for (; currentItem; currentItem = currentItem.nextSibling)
		{
			// scan for span or div tag
			if (!currentItem.tagName)
				continue;
			if (currentItem.className == 'cmNoClick')
			{
				item[0] = _cmNoClick;
				item[1] = getActionHTML (currentItem);
				hasAction = true;
				break;
			}
			if (currentItem.className == 'cmNoAction')
			{
				item[0] = _cmNoAction;
				item[1] = getActionHTML (currentItem);
				hasAction = true;
				break;
			}
			var tag = currentItem.tagName.toLowerCase ();
			if (tag != 'span')
				continue;
			if (!currentItem.firstChild)
				item[0] = null;
			else
				item[0] = currentItem.innerHTML;
			currentItem = currentItem.nextSibling;
			break;
		}
		if (hasAction)
		{
			items[items.length] = item;
			continue;
		}
		if (!currentItem)
			continue;
		for (; currentItem; currentItem = currentItem.nextSibling)
		{
			if (!currentItem.tagName)
				continue;
			var tag = currentItem.tagName.toLowerCase ();
			if (tag == 'a')
			{
				item[1] = currentItem.innerHTML;
				item[2] = currentItem.href;
				item[3] = currentItem.target;
				item[4] = currentItem.title;
				if (item[4] == '')
					item[4] = null;
			}
			else if (tag == 'span' || tag == 'div')
			{
				item[1] = currentItem.innerHTML;
				item[2] = null;
				item[3] = null;
				item[4] = null;
			}
			break;
		}

		for (; currentItem; currentItem = currentItem.nextSibling)
		{
			// scan for span tag
			if (!currentItem.tagName)
				continue;
			var tag = currentItem.tagName.toLowerCase ();
			if (tag != 'ul' && tag != 'ol')
				continue;
			var subMenuItems = cmDrawFromTextSubMenu (currentItem);
			for (i = 0; i < subMenuItems.length; ++i)
				item[i + 5] = subMenuItems[i];
			break;
		}
		items[items.length] = item;
	}
	return items;
}

//
// obtain the actual action item's action, which is inside a
// table.  The first row should be it
//
function getActionHTML (htmlNode)
{
	var returnVal = '<td></td><td></td><td></td>';
	var currentDomItem;
	// find the table first
	for (currentDomItem = htmlNode.firstChild; currentDomItem; currentDomItem = currentDomItem.nextSibling)
	{
		if (currentDomItem.tagName && currentDomItem.tagName.toLowerCase () == 'table')
			break;
	}
	if (!currentDomItem)
		return returnVal;
	// skip over tbody
	for (currentDomItem = currentDomItem.firstChild; currentDomItem; currentDomItem = currentDomItem.nextSibling)
	{
		if (currentDomItem.tagName && currentDomItem.tagName.toLowerCase () == 'tbody')
			break;
	}
	if (!currentDomItem)
		return returnVal;
	// get the first tr
	for (currentDomItem = currentDomItem.firstChild; currentDomItem; currentDomItem = currentDomItem.nextSibling)
	{
		if (currentDomItem.tagName && currentDomItem.tagName.toLowerCase () == 'tr')
			break;
	}
	if (!currentDomItem)
		return returnVal;
	return currentDomItem.innerHTML;
}

//
// get the DOM object associated with the item
//
function cmGetMenuItem (item)
{
	if (!item.subMenuID)
		return null;
	var subMenu = cmGetObject (item.subMenuID);
	// we are dealing with a main menu item
	if (item.menu)
	{
		var menu = item.menu;
		// skip over table, tbody, tr, reach td
		subMenu = subMenu.firstChild.firstChild.firstChild.firstChild;
		var i;
		for (i = 0; i < menu.length; ++i)
		{
			if (menu[i] == item)
				return subMenu;
			subMenu = subMenu.nextSibling;
		}
	}
	else if (item.parentItem) // sub menu item
	{
		var menu = item.parentItem;
		var table = cmGetObject (item.subMenuID + 'Table');
		if (!table)
			return null;
		// skip over table, tbody, reach tr
		subMenu = table.firstChild.firstChild;
		var i;
		for (i = 5; i < menu.length; ++i)
		{
			if (menu[i] == item)
				return subMenu;
			subMenu = subMenu.nextSibling;
		}
	}
	return null;
}

//
// disable a menu item
//
function cmDisableItem (item, prefix)
{
	if (!item)
		return;
	var menuItem = cmGetMenuItem (item);
	if (!menuItem)
		return;
	if (item.menu)
		menuItem.className = prefix + 'MainItemDisabled';
	else
		menuItem.className = prefix + 'MenuItemDisabled';
	item.isDisabled = true;
}

//
// enable a menu item
//
function cmEnableItem (item, prefix)
{
	if (!item)
		return;
	var menuItem = cmGetMenuItem (item);
	if (!menuItem)
		return;
	if (item.menu)
		menu.className = prefix + 'MainItem';
	else
		menu.className = prefix + 'MenuItem';
	item.isDisabled = true;
}

//////////////////////////////////////////////////////////////////////
//
// Mouse Event Handling Functions
//
//////////////////////////////////////////////////////////////////////

//
// action should be taken for mouse moving in to the menu item
//
// Here we just do things concerning this menu item, w/o opening sub menus.
//
function cmItemMouseOver (obj, isMain, idSub, menuID, index, calledByOpenSub)
{
	if (!calledByOpenSub && _cmClicked)
	{
		cmItemMouseOverOpenSub (obj, isMain, idSub, menuID, index);
		return;
	}

	clearTimeout (_cmTimeOut);

	if (_cmItemList[index].isDisabled)
		return;

	var prefix = _cmMenuList[menuID].prefix;

	if (!obj.cmMenuID)
	{
		obj.cmMenuID = menuID;
		obj.cmIsMain = isMain;
	}

	var thisMenu = cmGetThisMenu (obj, prefix);

	// insert obj into cmItems if cmItems doesn't have obj
	if (!thisMenu.cmItems)
		thisMenu.cmItems = new Array ();
	var i;
	for (i = 0; i < thisMenu.cmItems.length; ++i)
	{
		if (thisMenu.cmItems[i] == obj)
			break;
	}
	if (i == thisMenu.cmItems.length)
	{
		//thisMenu.cmItems.push (obj);
		thisMenu.cmItems[i] = obj;
	}

	// hide the previous submenu that is not this branch
	if (_cmCurrentItem)
	{
		// occationally, we get this case when user
		// move the mouse slowly to the border
		if (_cmCurrentItem == obj || _cmCurrentItem == thisMenu)
		{
			var item = _cmItemList[index];
			cmSetStatus (item);
			return;
		}

		var thatMenuInfo = _cmMenuList[_cmCurrentItem.cmMenuID];
		var thatPrefix = thatMenuInfo.prefix;
		var thatMenu = cmGetThisMenu (_cmCurrentItem, thatPrefix);

		if (thatMenu != thisMenu.cmParentMenu)
		{
			if (_cmCurrentItem.cmIsMain)
				_cmCurrentItem.className = thatPrefix + 'MainItem';
			else
				_cmCurrentItem.className = thatPrefix + 'MenuItem';
			if (thatMenu.id != idSub)
				cmHideMenu (thatMenu, thisMenu, thatMenuInfo);
		}
	}

	// okay, set the current menu to this obj
	_cmCurrentItem = obj;

	// just in case, reset all items in this menu to MenuItem
	cmResetMenu (thisMenu, prefix);

	var item = _cmItemList[index];
	var isDefaultItem = cmIsDefaultItem (item);

	if (isDefaultItem)
	{
		if (isMain)
			obj.className = prefix + 'MainItemHover';
		else
			obj.className = prefix + 'MenuItemHover';
	}

	cmSetStatus (item);
}

//
// action should be taken for mouse moving in to the menu item
//
// This function also opens sub menu
//
function cmItemMouseOverOpenSub (obj, isMain, idSub, menuID, index)
{
	clearTimeout (_cmTimeOut);

	if (_cmItemList[index].isDisabled)
		return;

	cmItemMouseOver (obj, isMain, idSub, menuID, index, true);

	if (idSub)
	{
		var subMenu = cmGetObject (idSub);
		var menuInfo = _cmMenuList[menuID];
		var orient = menuInfo.orient;
		var prefix = menuInfo.prefix;
		cmShowSubMenu (obj, isMain, subMenu, menuInfo);
	}
}

//
// action should be taken for mouse moving out of the menu item
//
function cmItemMouseOut (obj, isMain, idSub, menuID, index)
{
	var delayTime = _cmMenuList[menuID].nodeProperties.delay;
	_cmTimeOut = window.setTimeout ('cmHideMenuTime ()', delayTime);
	window.defaultStatus = '';
}

//
// action should be taken for mouse button down at a menu item
//
function cmItemMouseDown (obj, isMain, idSub, menuID, index)
{
	if (_cmItemList[index].isDisabled)
		return;

	if (cmIsDefaultItem (_cmItemList[index]))
	{
		var prefix = _cmMenuList[menuID].prefix;
		if (obj.cmIsMain)
			obj.className = prefix + 'MainItemActive';
		else
			obj.className = prefix + 'MenuItemActive';
	}
}

//
// action should be taken for mouse button down at a menu item
// this is one also opens submenu if needed
//
function cmItemMouseDownOpenSub (obj, isMain, idSub, menuID, index)
{
	if (_cmItemList[index].isDisabled)
		return;

	_cmClicked = true;
	cmItemMouseDown (obj, isMain, idSub, menuID, index);

	if (idSub)
	{
		var subMenu = cmGetObject (idSub);
		var menuInfo = _cmMenuList[menuID];
		cmShowSubMenu (obj, isMain, subMenu, menuInfo);
	}
}

//
// action should be taken for mouse button up at a menu item
//
function cmItemMouseUp (obj, isMain, idSub, menuID, index)
{
	if (_cmItemList[index].isDisabled)
		return;

	var item = _cmItemList[index];

	var link = null, target = '_self';

	if (item.length > 2)
		link = item[2];
	if (item.length > 3 && item[3])
		target = item[3];

	if (link != null)
	{
		_cmClicked = false;
		window.open (link, target);
	}

	var menuInfo = _cmMenuList[menuID];
	var prefix = menuInfo.prefix;
	var thisMenu = cmGetThisMenu (obj, prefix);

	var hasChild = (item.length > 5);
	if (!hasChild)
	{
		if (cmIsDefaultItem (item))
		{
			if (obj.cmIsMain)
				obj.className = prefix + 'MainItem';
			else
				obj.className = prefix + 'MenuItem';
		}
		cmHideMenu (thisMenu, null, menuInfo);
	}
	else
	{
		if (cmIsDefaultItem (item))
		{
			if (obj.cmIsMain)
				obj.className = prefix + 'MainItemHover';
			else
				obj.className = prefix + 'MenuItemHover';
		}
	}
}

//////////////////////////////////////////////////////////////////////
//
// Mouse Event Support Utility Functions
//
//////////////////////////////////////////////////////////////////////

//
// move submenu to the appropriate location
//
function cmMoveSubMenu (obj, isMain, subMenu, menuInfo)
{
	var orient = menuInfo.orient;

	var offsetAdjust;

	if (isMain)
	{
		if (orient.charAt (0) == 'h')
			offsetAdjust = menuInfo.nodeProperties.offsetHMainAdjust;
		else
			offsetAdjust = menuInfo.nodeProperties.offsetVMainAdjust;
	}
	else
		offsetAdjust = menuInfo.nodeProperties.offsetSubAdjust;

	if (!isMain && orient.charAt (0) == 'h')
		orient = 'v' + orient.charAt (1) + orient.charAt (2);

	var mode = String (orient);
	var p = subMenu.offsetParent;
	var subMenuWidth = cmGetWidth (subMenu);
	var horiz = cmGetHorizontalAlign (obj, mode, p, subMenuWidth);
	if (mode.charAt (0) == 'h')
	{
		if (mode.charAt (1) == 'b')
			subMenu.style.top = (cmGetYAt (obj, p) + cmGetHeight (obj) + offsetAdjust[1]) + 'px';
		else
			subMenu.style.top = (cmGetYAt (obj, p) - cmGetHeight (subMenu) - offsetAdjust[1]) + 'px';
		if (horiz == 'r')
			subMenu.style.left = (cmGetXAt (obj, p) + offsetAdjust[0]) + 'px';
		else
			subMenu.style.left = (cmGetXAt (obj, p) + cmGetWidth (obj) - subMenuWidth - offsetAdjust[0]) + 'px';
	}
	else
	{
		if (horiz == 'r')
			subMenu.style.left = (cmGetXAt (obj, p) + cmGetWidth (obj) + offsetAdjust[0]) + 'px';
		else
			subMenu.style.left = (cmGetXAt (obj, p) - subMenuWidth - offsetAdjust[0]) + 'px';
		if (mode.charAt (1) == 'b')
			subMenu.style.top = (cmGetYAt (obj, p) + offsetAdjust[1]) + 'px';
		else
			subMenu.style.top = (cmGetYAt (obj, p) + cmGetHeight (obj) - cmGetHeight (subMenu) + offsetAdjust[1]) + 'px';
	}

	// IE specific iframe masking method
	/*@cc_on
		@if (@_jscript_version >= 5.5)
			if (menuInfo.cmFrameMasking)
			{
				if (!subMenu.cmFrameObj)
				{
					var frameObj = cmAllocFrame ();
					subMenu.cmFrameObj = frameObj;
				}

				var frameObj = subMenu.cmFrameObj;
				frameObj.style.zIndex = subMenu.style.zIndex - 1;
				frameObj.style.left = (cmGetX (subMenu) - cmGetX (frameObj.offsetParent)) + 'px';
				frameObj.style.top = (cmGetY (subMenu)  - cmGetY (frameObj.offsetParent)) + 'px';
				frameObj.style.width = cmGetWidth (subMenu) + 'px';
				frameObj.style.height = cmGetHeight (subMenu) + 'px';
				frameObj.style.display = 'block';
			}
		@end
	@*/
	if (horiz != orient.charAt (2))
		orient = orient.charAt (0) + orient.charAt (1) + horiz;
	return orient;
}

//
// automatically re-adjust the menu position based on available screen size.
//
function cmGetHorizontalAlign (obj, mode, p, subMenuWidth)
{
	var horiz = mode.charAt (2);
	if (!(document.body))
		return horiz;
	var body = document.body;
	var browserLeft;
	var browserRight;
	if (window.innerWidth)
	{
		// DOM window attributes
		browserLeft = window.pageXOffset;
		browserRight = window.innerWidth + browserLeft;
	}
	else if (body.clientWidth)
	{
		// IE attributes
		browserLeft = body.clientLeft;
		browserRight = body.clientWidth + browserLeft;
	}
	else
		return horiz;

	if (mode.charAt (0) == 'h')
	{
		if (horiz == 'r' && (cmGetXAt (obj) + subMenuWidth) > browserRight)
			horiz = 'l';
		if (horiz == 'l' && (cmGetXAt (obj) + cmGetWidth (obj) - subMenuWidth) < browserLeft)
			horiz = 'r';
		return horiz;
	}
	else
	{
		if (horiz == 'r' && (cmGetX (obj) + cmGetWidth (obj) + subMenuWidth) > browserRight)
			horiz = 'l';
		if (horiz == 'l' && (cmGetX (obj) - subMenuWidth) < browserLeft)
			horiz = 'r';
		return horiz;
	}
}

//
// show the subMenu w/ specified orientation
// also move it to the correct coordinates
//
function cmShowSubMenu (obj, isMain, subMenu, menuInfo)
{
	var prefix = menuInfo.prefix;

	if (!subMenu.cmParentMenu)
	{
		// establish the tree w/ back edge
		var thisMenu = cmGetThisMenu (obj, prefix);
		subMenu.cmParentMenu = thisMenu;
		if (!thisMenu.cmSubMenu)
			thisMenu.cmSubMenu = new Array ();
		thisMenu.cmSubMenu[thisMenu.cmSubMenu.length] = subMenu;
	}

	var effectInstance = subMenu.cmEffect;

	if (effectInstance)
		effectInstance.showEffect (true);
	else
	{
		// position the sub menu only if we are not already showing the submenu
		var orient = cmMoveSubMenu (obj, isMain, subMenu, menuInfo);
		subMenu.cmOrient = orient;

		var forceShow = false;
		if (subMenu.style.visibility != 'visible' && menuInfo.nodeProperties.effect)
		{
			try
			{
				effectInstance = menuInfo.nodeProperties.effect.getInstance (subMenu, orient);
				effectInstance.showEffect (false);
			}
			catch (e)
			{
				forceShow = true;
				subMenu.cmEffect = null;
			}
		}
		else
			forceShow = true;

		if (forceShow)
		{
			subMenu.style.visibility = 'visible';
			/*@cc_on
				@if (@_jscript_version >= 5.5)
					if (subMenu.cmFrameObj)
						subMenu.cmFrameObj.style.display = 'block';
				@end
			@*/
		}
	}

	if (!_cmHideObjects)
	{
		_cmHideObjects = 2;	// default = not hide, may change behavior later
		try
		{
			if (window.opera)
			{
				if (parseInt (navigator.appVersion) < 9)
					_cmHideObjects = 1;
			}
		}
		catch (e)
		{
		}
	}

	if (_cmHideObjects == 1)
	{
		if (!subMenu.cmOverlap)
			subMenu.cmOverlap = new Array ();
		cmHideControl ("IFRAME", subMenu);
		cmHideControl ("OBJECT", subMenu);
	}

	if (!effectInstance)
	{
		// Check if the popup menu will be entirely displayed in its parent frame.
		var frameHeight = this.document.body.clientHeight;
		var parentVScroll = this.document.body.scrollTop;
		var menuHeight = cmGetHeight (subMenu);
		var menuY = cmGetY (subMenu);

		if (menuHeight + menuY - parentVScroll > frameHeight)
		{
			var oldTop = subMenu.style.top;

			oldTop = oldTop.replace("px", "");
			subMenu.style.top = oldTop - ((menuHeight + menuY - parentVScroll) - frameHeight);
		}
	}
}

//
// reset all the menu items to class MenuItem in thisMenu
//
function cmResetMenu (thisMenu, prefix)
{
	if (thisMenu.cmItems)
	{
		var i;
		var str;
		var items = thisMenu.cmItems;
		for (i = 0; i < items.length; ++i)
		{
			if (items[i].cmIsMain)
			{
				if (items[i].className == (prefix + 'MainItemDisabled'))
					continue;
			}
			else
			{
				if (items[i].className == (prefix + 'MenuItemDisabled'))
					continue;
			}
			if (items[i].cmIsMain)
				str = prefix + 'MainItem';
			else
				str = prefix + 'MenuItem';
			if (items[i].className != str)
				items[i].className = str;
		}
	}
}

//
// called by the timer to hide the menu
//
function cmHideMenuTime ()
{
	_cmClicked = false;
	if (_cmCurrentItem)
	{
		var menuInfo = _cmMenuList[_cmCurrentItem.cmMenuID];
		var prefix = menuInfo.prefix;
		cmHideMenu (cmGetThisMenu (_cmCurrentItem, prefix), null, menuInfo);
		_cmCurrentItem = null;
	}
}

//
// Only hides this menu
//
function cmHideThisMenu (thisMenu, menuInfo)
{
	var effectInstance = thisMenu.cmEffect;
	if (effectInstance)
		effectInstance.hideEffect (true);
	else
	{
		thisMenu.style.visibility = 'hidden';
		thisMenu.cmOrient = null;
		/*@cc_on
			@if (@_jscript_version >= 5.5)
				if (thisMenu.cmFrameObj)
				{
					var frameObj = thisMenu.cmFrameObj;
					frameObj.style.display = 'none';
					frameObj.style.width = '1px';
					frameObj.style.height = '1px';
					thisMenu.cmFrameObj = null;
					cmFreeFrame (frameObj);
				}
			@end
		@*/
	}

	cmShowControl (thisMenu);
	thisMenu.cmItems = null;
}

//
// hide thisMenu, children of thisMenu, as well as the ancestor
// of thisMenu until currentMenu is encountered.  currentMenu
// will not be hidden
//
function cmHideMenu (thisMenu, currentMenu, menuInfo)
{
	var prefix = menuInfo.prefix;
	var str = prefix + 'SubMenu';

	// hide the down stream menus
	if ((thisMenu != null) && thisMenu.cmSubMenu)
	{
		var i;
		for (i = 0; i < thisMenu.cmSubMenu.length; ++i)
		{
			cmHideSubMenu (thisMenu.cmSubMenu[i], menuInfo);
		}
	}

	// hide the upstream menus
	while (thisMenu && thisMenu != currentMenu)
	{
		cmResetMenu (thisMenu, prefix);
		if (thisMenu.className == str)
		{
			cmHideThisMenu (thisMenu, menuInfo);
		}
		else
			break;
		thisMenu = cmGetThisMenu (thisMenu.cmParentMenu, prefix);
	}
}

//
// hide thisMenu as well as its sub menus if thisMenu is not
// already hidden
//
function cmHideSubMenu (thisMenu, menuInfo)
{
	if (thisMenu.style.visibility == 'hidden')
		return;
	if (thisMenu.cmSubMenu)
	{
		var i;
		for (i = 0; i < thisMenu.cmSubMenu.length; ++i)
		{
			cmHideSubMenu (thisMenu.cmSubMenu[i], menuInfo);
		}
	}
	var prefix = menuInfo.prefix;
	cmResetMenu (thisMenu, prefix);
	cmHideThisMenu (thisMenu, menuInfo);
}

//
// hide a control such as IFRAME
//
function cmHideControl (tagName, subMenu)
{
	var x = cmGetX (subMenu);
	var y = cmGetY (subMenu);
	var w = subMenu.offsetWidth;
	var h = subMenu.offsetHeight;

	var i;
	for (i = 0; i < document.all.tags(tagName).length; ++i)
	{
		var obj = document.all.tags(tagName)[i];
		if (!obj || !obj.offsetParent)
			continue;

		// check if the object and the subMenu overlap

		var ox = cmGetX (obj);
		var oy = cmGetY (obj);
		var ow = obj.offsetWidth;
		var oh = obj.offsetHeight;

		if (ox > (x + w) || (ox + ow) < x)
			continue;
		if (oy > (y + h) || (oy + oh) < y)
			continue;

		// if object is already made hidden by a different
		// submenu then we dont want to put it on overlap list of
		// of a submenu a second time.
		// - bug fixed by Felix Zaslavskiy
		if(obj.style.visibility == 'hidden')
			continue;

		//subMenu.cmOverlap.push (obj);
		subMenu.cmOverlap[subMenu.cmOverlap.length] = obj;
		obj.style.visibility = 'hidden';
	}
}

//
// show the control hidden by the subMenu
//
function cmShowControl (subMenu)
{
	if (subMenu.cmOverlap)
	{
		var i;
		for (i = 0; i < subMenu.cmOverlap.length; ++i)
			subMenu.cmOverlap[i].style.visibility = "";
	}
	subMenu.cmOverlap = null;
}

//
// returns the main menu or the submenu table where this obj (menu item)
// is in
//
function cmGetThisMenu (obj, prefix)
{
	var str1 = prefix + 'SubMenu';
	var str2 = prefix + 'Menu';
	while (obj)
	{
		if (obj.className == str1 || obj.className == str2)
			return obj;
		obj = obj.parentNode;
	}
	return null;
}

//
// A special effect function to hook the menu which contains
// special effect object to the timer.
//
function cmTimeEffect (menuID, show, delayTime)
{
	window.setTimeout ('cmCallEffect("' + menuID + '",' + show + ')', delayTime);
}

//
// A special effect function.  Called by timer.
//
function cmCallEffect (menuID, show)
{
	var menu = cmGetObject (menuID);
	if (!menu || !menu.cmEffect)
		return;
	try
	{
		if (show)
			menu.cmEffect.showEffect (false);
		else
			menu.cmEffect.hideEffect (false);
	}
	catch (e)
	{
	}
}

//
// return true if this item is handled using default handlers
//
function cmIsDefaultItem (item)
{
	if (item == _cmSplit || item[0] == _cmNoAction || item[0] == _cmNoClick)
		return false;
	return true;
}

//
// returns the object baring the id
//
function cmGetObject (id)
{
	if (document.all)
		return document.all[id];
	return document.getElementById (id);
}

//
// functions that obtain the width of an HTML element.
//
function cmGetWidth (obj)
{
	var width = obj.offsetWidth;
	if (width > 0 || !cmIsTRNode (obj))
		return width;
	if (!obj.firstChild)
		return 0;
	// use TABLE's length can cause an extra pixel gap
	//return obj.parentNode.parentNode.offsetWidth;

	// use the left and right child instead
	return obj.lastChild.offsetLeft - obj.firstChild.offsetLeft + cmGetWidth (obj.lastChild);
}

//
// functions that obtain the height of an HTML element.
//
function cmGetHeight (obj)
{
	var height = obj.offsetHeight;
	if (height > 0 || !cmIsTRNode (obj))
		return height;
	if (!obj.firstChild)
		return 0;
	// use the first child's height
	return obj.firstChild.offsetHeight;
}

//
// functions that obtain the coordinates of an HTML element
//
function cmGetX (obj)
{
	if (!obj)
		return 0;
	var x = 0;

	do
	{
		x += obj.offsetLeft;
		obj = obj.offsetParent;
	}
	while (obj);
	return x;
}

function cmGetXAt (obj, elm)
{
	var x = 0;

	while (obj && obj != elm)
	{
		x += obj.offsetLeft;
		obj = obj.offsetParent;
	}
	if (obj == elm)
		return x;
	return x - cmGetX (elm);
}

function cmGetY (obj)
{
	if (!obj)
		return 0;
	var y = 0;
	do
	{
		y += obj.offsetTop;
		obj = obj.offsetParent;
	}
	while (obj);
	return y;
}

function cmIsTRNode (obj)
{
	var tagName = obj.tagName;
	return tagName == "TR" || tagName == "tr" || tagName == "Tr" || tagName == "tR";
}

//
// get the Y position of the object.  In case of TR element though,
// we attempt to adjust the value.
//
function cmGetYAt (obj, elm)
{
	var y = 0;

	if (!obj.offsetHeight && cmIsTRNode (obj))
	{
		var firstTR = obj.parentNode.firstChild;
		obj = obj.firstChild;
		y -= firstTR.firstChild.offsetTop;
	}

	while (obj && obj != elm)
	{
		y += obj.offsetTop;
		obj = obj.offsetParent;
	}

	if (obj == elm)
		return y;
	return y - cmGetY (elm);
}

//
// extract description from the menu item and set the status text
//
function cmSetStatus (item)
{
	var descript = '';
	if (item.length > 4)
		descript = (item[4] != null) ? item[4] : (item[2] ? item[2] : descript);
	else if (item.length > 2)
		descript = (item[2] ? item[2] : descript);

	window.defaultStatus = descript;
}

//
// debug function, ignore :)
//
function cmGetProperties (obj)
{
	if (obj == undefined)
		return 'undefined';
	if (obj == null)
		return 'null';

	var msg = obj + ':\n';
	var i;
	for (i in obj)
		msg += i + ' = ' + obj[i] + '; ';
	return msg;
}

/* v2.0.3			1. Fix an issue with IE6 displaying menu over HTTPS connection.
						Thanks to Paul Horton for reporting the bug and testing
						possible solutions. */
/* v2.0.2			1. Minor clean up and some attempts to reduce memory leak in IE. */
/* v2.0.1			1. Disable iframe masking for IE7 since it is no longer necessary. */
/* v2.0				1. improves the way handling flash/iframe/select boxes in IE
						and firefox and Opera 9.  Hiding these elements is no
						longer necessary.  For older versions of Opera, flash/iframe
						still need to be hidden.
					2. Improves cmDrawFromText ().  Also allows custom actions.
					3. Improves clickOpen behavior.  Now once a submenu is opened,
						opening other sub menus no longer requires clicking.
					4. Special Effects.  This version has hooks that allow people
						to install special effects to various themes.
					5. For a given menu item, cmGetMenuitem(item) provides the ability
						to find the corresponding DOM element.
					6. Disable API.  If you know which item to disable, you can call
						cmDisableItem(item, themePrefix) and cmEnableItem(item, themePrefix).
						However, you will have to provide your own CSS for the item.
						For purposes other than to disable an item, cmGetMenuItem (item)
						is provided for locating HTML DOM element of the menu item in concern.
					7. Better z-index.  Now you can specify in the theme property the
						starting z-index and incremental step for submenus.
					8. Allow themes to insert additional elements before and after
						the sub menu table.
					9. Improved themes.  More organized and easier to customize.
					10. Add a flag to control hiding/nohiding objects/iframes.  By default,
						only Opera before 9 hides objects.
					11. Add new property options to control submenu positions to fine tune
						the look.
					12. It is no longer necessary to specify the theme name while calling
						cmDraw and cmDrawFromText.  Currently it still accepts it, but it
						will not in the future.
*/
/* v1.4.4			1. a quick fix for a bug for _cmSplit checking.  reported by
						Son Nguyen.
*/
/* v1.4.3			1. changed how _cmSplit is handled a bit so that _cmNoClick can work
						properly.  All splits in predefined themes are changed to use
						_cmNoClick instead of _cmNoAction.
*/
/* v1.4.2			1. fixed _cmNoClick mouse hoover bug.
					2. fixed a statusbar text problem that cause text to disappear when
						hoovering mouse within the same menu item.
					3. changed the behavior of cmDrawFromText s.t. if the title of the
						of a link is empty, the actual url is used as text.  To clear
						this link information, title needs to be ' '.
*/
/* v1.4.1			1. fixed a problem introduced in 1.4 where re-entering a main menu
						item which doesn't have a child can disable its hover setting.
						Apparently I deleted an extra line of code when I was doing
						cleaning up.  Reported by David Maliachi and a few others.
*/
/* JSCookMenu v1.4	1. fixed a minor td cell closure problem.  Thanks to Georg Lorenz
					   <georg@lonux.de> for discovering that.
					2. added clickOpen to nodeProperties.  See _cmNodeProperties for
						description.  Basically menus can be opened on click only.
					3. added an ability to draw menu from an html node instead of a javascript
						tree, making this script search bot friendly (I hope?).
*/
/* JSCookMenu v1.31 1. fix a bug on IE with causes submenus to display at the top
					   left corner due to doctype.  The fix was provided by
					   Burton Strauss <Burton@ntopsupport.com>.
*/
/* JSCookMenu v1.3	1. automatically realign (left and right) the submenu when
					   client space is not enough.
					2. add _cmNoClick to get rid of menu closing behavior
					   on the particular menu item, to make it possible for things
					   such as search box to be inside the menu.
*/
/* JSCookMenu v1.25	1. fix Safari positioning issue.  The problem is that all TR elements are located
					   at the top left corner.  Thus, need to obtain the "virtual"
					   position of these element could be at.
*/
/* JSCookMenu v1.24	1. fix window based control hiding bug
					   thanks to Felix Zaslavskiy <felix@bebinary.com> for the fix.
*/
/* JSCookMenu v1.23	1. correct a position bug when the container is positioned.
					  thanks to Andre <anders@netspace.net.au> for narrowing down
					  the problem.
*/
/* JSCookMenu v1.22	1. change Array.push (obj) call to Array[length] = obj.
					   Suggestion from Dick van der Kaaden <dick@netrex.nl> to
					   make the script compatible with IE 5.0
					2. Changed theme files a little to add z-index: 100 for sub
					   menus.  This change is necessary for Netscape to avoid
					   a display problem.
					3. some changes to the DOM structure to make this menu working
					   on Netscape 6.0 (tested).  The main reason is that NN6 does
					   not do absolute positioning with tables.  Therefore an extra
					   div layer must be put around the table.
*/
/* JSCookMenu v1.21	1. fixed a bug that didn't add 'px' as part of coordinates.
					   JSCookMenu should be XHTML validator friendly now.
					2. removed unnecessary display attribute and corresponding
					   theme entry to fix a problem that Netscape sometimes
					   render Office theme incorrectly
*/
/* JSCookMenu v1.2.	1. fix the problem of showing status in Netscape
					2. changed the handler parameters a bit to allow
					   string literals to be passed to javascript based
					   links
					3. having null in target field would cause the link
					   to be opened in the current window, but this behavior
					   could change in the future releases
*/
/* JSCookMenu v1.1.		added ability to hide controls in IE to show submenus properly */
/* JSCookMenu v1.01.	cmDraw generates XHTML code */
/* JSCookMenu v1.0.		(c) Copyright 2002 by Heng Yuan */
// LyMessageScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyMessageScript.js 33137 2011-11-14 13:08:56Z nhamon $

var frameParam = '_frame';
var messageWindowName = 'message_window';
var messageWindowTitleName = 'message_window_td';
var messageWindowIconName = 'message_window_icon_td';
var messageWindowTextName = 'message_window_text_td';
var messageWindowCommandsName = 'message_window_commands_td';
var messageWindowShadowName = 'message_window_shadow';
var lastUrl = '';
var lastInfoId = '';
var messageWindowDisplayed = null;
var messagesToDisplay = new Array();


// Show a message window
function ShowMessageWindow(title, icon, text, valueArray, labelArray, imageArray, infoId, url,
	leftImage, leftOverImage, rightImage, rightOverImage, target, align)
{
	var topFrame = getLeonardiTopFrame();

	if ((topFrame != null) && (this != topFrame))
	{
		topFrame.ShowMessageWindow(title, icon, text, valueArray, labelArray, imageArray, infoId, url, leftImage, leftOverImage, rightImage, rightOverImage, target, align);
		return;
	}

	// If a message is already displayed, register this one as the next one
	if (messageWindowDisplayed != null)
	{
		// If two messages with the same infoId reach at this point, display only one
		if (messageWindowDisplayed != infoId)
		{
			var newMessageToDisplay = new Array();

			newMessageToDisplay[0] = title;
			newMessageToDisplay[1] = icon;
			newMessageToDisplay[2] = text;
			newMessageToDisplay[3] = valueArray;
			newMessageToDisplay[4] = labelArray;
			newMessageToDisplay[5] = imageArray;
			newMessageToDisplay[6] = infoId;
			newMessageToDisplay[7] = url;
			newMessageToDisplay[8] = leftImage;
			newMessageToDisplay[9] = leftOverImage;
			newMessageToDisplay[10] = rightImage;
			newMessageToDisplay[11] = rightOverImage;
			newMessageToDisplay[12] = target;
			newMessageToDisplay[13] = align;

			messagesToDisplay[messagesToDisplay.length] = newMessageToDisplay;
		}

		return;
	}

	messageWindowDisplayed = infoId;

	var messageWindow = this.document.getElementById(messageWindowName);
	var messageWindowTitle = this.document.getElementById(messageWindowTitleName);
	var messageWindowIcon = this.document.getElementById(messageWindowIconName);
	var messageWindowText = this.document.getElementById(messageWindowTextName);
	var messageWindowCommands = this.document.getElementById(messageWindowCommandsName);

	this.lastUrl = url;
	this.lastInfoId = infoId;

	messageWindowTitle.innerHTML = title;

	if (icon != "")
		messageWindowIcon.innerHTML = "<img src='" + icon + "'/>";
	else
		messageWindowIcon.innerHTML = "";

	if ((align != null) && (typeof align != "undefined"))
		messageWindowText.style.textAlign = align;
	else
		messageWindowText.style.textAlign = "center";

	messageWindowText.innerHTML = text;

	var commandsHtml = "";

	commandsHtml += "<table border='0' align='center'><tr>";

	for (var i = 0; i < valueArray.length; i++)
	{
		mouseHtml = " onMouseOver=\"rollover(document.images['imageLeft" + valueArray[i] + "'],'";
		mouseHtml += leftOverImage;
		mouseHtml += "','');rollover(document.images['imageRight" + valueArray[i] + "'],'";
		mouseHtml += rightOverImage;
		mouseHtml += "','');";
		mouseHtml += "document.getElementById('imageBg" + valueArray[i] + "').className='commandButtonOver';";
		mouseHtml += "return true;\"";

		mouseHtml += " onMouseOut=\"rollover(document.images['imageLeft" + valueArray[i] + "'],'";
		mouseHtml += leftImage;
		mouseHtml += "','');rollover(document.images['imageRight" + valueArray[i] + "'],'";
		mouseHtml += rightImage;
		mouseHtml += "','');";
		mouseHtml += "document.getElementById('imageBg" + valueArray[i] + "').className='commandButton';";
		mouseHtml += "return true;\"";

		commandsHtml += "<td><table border='0' cellspacing='0' cellpadding='0'><tr>";
		commandsHtml += "<td align='right'>";
		commandsHtml += "<a href=\"javascript:HideMessageWindow('" + valueArray[i] + "','" + target + "');\"" + mouseHtml + ">";
		commandsHtml += "<img src='" + leftImage + "' name='imageLeft" + valueArray[i] + "' border='0'/></a></td>";
		commandsHtml += "<td align='center' class='commandButton' id='imageBg" + valueArray[i] + "'>";

		if (imageArray[i] != 'null')
		{
			commandsHtml += "<table border='0' cellspacing='0' cellpadding='0'><tr><td valign='middle'>";
			commandsHtml += "<a href=\"javascript:HideMessageWindow('" + valueArray[i] + "','" + target + "');\"" + mouseHtml + ">";
			commandsHtml += "<img src='" + imageArray[i] + "' title='" + labelArray[i] + "' border='0' align='center' class='commandImage'/>";
			commandsHtml += "</a></td><td valign='middle'>";
		}

		commandsHtml += "<a id='message_button_" + valueArray[i] + "' href=\"javascript:HideMessageWindow('" + valueArray[i] + "','" + target + "');\"";
		commandsHtml += mouseHtml;
		commandsHtml += "><b><font class='commandLabel'>";

		if (imageArray[i] != 'null')
			commandsHtml += "&nbsp;";

		commandsHtml += labelArray[i];
		commandsHtml += "</font></b></a>";

		if (imageArray[i] != 'null')
			commandsHtml += "</td></tr></table>";

		commandsHtml += "</td>";
		commandsHtml += "<td align='left'>";
		commandsHtml += "<a href=\"javascript:HideMessageWindow('" + valueArray[i] + "','" + target + "');\"" + mouseHtml + ">";
		commandsHtml += "<img src='" + rightImage + "' name='imageRight" + valueArray[i] + "' border='0'/></a></td>";
		commandsHtml += "</tr></table></td>";
	}

	commandsHtml += "</tr></table>";

	messageWindowCommands.innerHTML = commandsHtml;

	// Center message window
	var totalWidth = this.document.body.clientWidth;
	var totalHeight = this.document.body.clientHeight;
	var divWidth = cmGetWidth(messageWindow);
	var divHeight = cmGetHeight(messageWindow);

	messageWindow.style.left = (totalWidth - divWidth) / 2;
	messageWindow.style.top = (totalHeight - divHeight) / 2;
	messageWindowTitle.style.width = cmGetWidth(messageWindow) - 30;
	ShowMessageWindowShadow(true);
	messageWindow.style.visibility = "visible";

	// Give focus to the first button, to manage 'Enter' key
	if (valueArray.length > 0)
	{
		var defaultButton = this.document.getElementById("message_button_" + valueArray[0]);

		try
		{
			defaultButton.focus();
		}
		catch (ex)
		{
		}
	}
}

// Show the message window shadow
function ShowMessageWindowShadow(force)
{
	var topFrame = getLeonardiTopFrame();
	var parentIframes = topFrame.document.getElementsByTagName('iframe');
	var popupShadowObject = parentIframes[messageWindowShadowName];

	if (popupShadowObject == null)
		popupShadowObject = topFrame.document.getElementById(messageWindowShadowName);

	if ((popupShadowObject != null)
		&& (force || (popupShadowObject.style.visibility == "visible")))
	{
		var totalWidth = topFrame.document.body.clientWidth;
		var totalHeight = topFrame.document.body.clientHeight;

		popupShadowObject.style.width = totalWidth;
		popupShadowObject.style.height = totalHeight;
		popupShadowObject.style.left = 0;
		popupShadowObject.style.top = 0;
		popupShadowObject.style.visibility = "visible";
	}
}

// Hide the message window shadow
function HideMessageWindow(value, target)
{
	if ((typeof value != "undefined") && (value != null))
	{
		var params = "_message=" + lastInfoId + "&_answer=" + value;

		if ((typeof target != "undefined") && (target != null) && (target != "null"))
			params += "&target_session=" + target;

		SendAjaxRequestParams(lastUrl, params);
	}

	var topFrame = getLeonardiTopFrame();
	var messageWindow = topFrame.document.getElementById(messageWindowName);
	var messageWindowTitle = topFrame.document.getElementById(messageWindowTitleName);
	var messageWindowIcon = topFrame.document.getElementById(messageWindowIconName);
	var messageWindowText = topFrame.document.getElementById(messageWindowTextName);
	var messageWindowCommands = topFrame.document.getElementById(messageWindowCommandsName);
	var parentIframes = topFrame.document.getElementsByTagName('iframe');
	var popupShadowObject = parentIframes[messageWindowShadowName];

	if (popupShadowObject == null)
		popupShadowObject = topFrame.document.getElementById(messageWindowShadowName);

	topFrame.lastUrl = '';
	topFrame.lastInfoId = '';
	messageWindowTitle.innerHTML = "";
	messageWindowIcon.innerHTML = "";
	messageWindowText.innerHTML = "";
	messageWindowCommands.innerHTML = "";
	messageWindowTitle.style.width = 20;
	messageWindow.style.visibility = "hidden";

	if (popupShadowObject != null)
	{
		popupShadowObject.style.width = 80;
		popupShadowObject.style.height = 40;
		popupShadowObject.style.visibility = "hidden";
	}

	messageWindowDisplayed = null;

	// Check if there area other messages to display
	if (messagesToDisplay.length > 0)
	{
		var reset = true;

		for (var i = 0; i < messagesToDisplay.length; i++)
		{
			var newMessageToDisplay = messagesToDisplay[i];

			if (newMessageToDisplay != null)
			{
				reset = false;
				ShowMessageWindow(newMessageToDisplay[0], newMessageToDisplay[1], newMessageToDisplay[2], newMessageToDisplay[3],
					newMessageToDisplay[4], newMessageToDisplay[5], newMessageToDisplay[6], newMessageToDisplay[7],
					newMessageToDisplay[8], newMessageToDisplay[9], newMessageToDisplay[10], newMessageToDisplay[11],
					newMessageToDisplay[12], newMessageToDisplay[13]);
			}

			messagesToDisplay[i] = null;
		}

		if (reset == true)
		{
			messagesToDisplay = new Array();
		}
	}
}

// This function shows a message.
function ShowAlert(message)
{
	alert(message);
}

// This function shows a message and try to put it in the hidden frame.
function ShowMessage(message, infoId)
{
	// If possible, message should appear in hidden_frame
	// Do *not* Loop
	var mainFrame = findTarget(null, "main_frame");
	var hiddenFrame = findTarget(null, "hidden_frame");

	if (((typeof AJAX_MODE == "undefined") || !AJAX_MODE)
		&& (mainFrame!=null) && (hiddenFrame != null))
	{
		// Redirect to pilot step if possible
		if (hiddenFrame != this)
		{
			hiddenFrame.location.href = this.location.href;

			alert("ShowMessage in LyMessageScript");

			this.history.go(-1);
		}
		else
			alert(message);
	}
	else
		alert(message);
}

// This function asks a question.
function AskQuestion(message, infoId, baseUrl)
{
	var params;

	if (confirm(message))
		params = "_message=" + infoId + "&_answer=true";
	else
		params = "_message=" + infoId + "&_answer=false";

	SendAjaxRequestParams(baseUrl, params);

	// If a question has been answered, there is no need to perform the update process since
	// servlet will be notified by the answer request.
	questionAnswered = true;

	setTimeout("questionAnswered = false;", 500);
}

function ShowLocation(url)
{
	var mainFrame = findTarget(null, "main_frame");
	var targetFrame = findTarget(null, "target_frame");

	if (targetFrame != null )//typeof top.frames["main_frame"].frames["target_frame"] != "undefined")
	{
		//top.frames["main_frame"].frames["target_frame"].location.href = url;
		targetFrame.location.href = url;
	}
	else
		this.location.href = url;
}

var newWindows = new Array();

function RegisterNewWindow(parameters)
{
	var name = parameters[0];
	var newWindow = NewWindow(parameters);

	// Check if window is already registered
	for (var i = 0; i < newWindows.length; i++)
	{
		if (newWindows[i][0] == name)
			return;
	}

	newWindows[newWindows.length] = new Array(name, newWindow);
}

function CloseWindow(windowName)
{
	for (var i = 0; i < newWindows.length; i++)
	{
		if (newWindows[i][0] == windowName)
		{
			newWindows[i][1].close();
			break;
		}
	}
}

function CloseAllWindows()
{
	for (var i = 0; i < newWindows.length; i++)
	{
		newWindows[i][1].close();
	}
}

// Opens a new window with an array of parameters.
// The list of parameters must be :
//  - parameters[0] : name
//  - parameters[1] : url
//  - parameters[2] : parameters
//  - parameters[3] : x
//  - parameters[4] : y
//  - parameters[5] : width
//  - parameters[6] : height
//  - parameters[7] : fullscreen
function NewWindow(parameters)
{
	var name = parameters[0];
	var url = parameters[1];
	var windowParameters = parameters[2];
	var x = parameters[3];
	var y = parameters[4];
	var width = parameters[5];
	var height = parameters[6];
	var fullscreen = parameters[7];

	if (fullscreen == "true")
	{
		width = (screen.width - 5) + "";
		height = (screen.height - 30) + "";
	}

	if (x != '')
		windowParameters += ',left=' + x;

	if (y != '')
		windowParameters += ',top=' + y;

	if (width != '')
		windowParameters += ',width=' + width;

	if (height != '')
		windowParameters += ',height=' + height;

	return window.open(url, name, windowParameters);
}

function ShowFile(file, title, message, click, alternate)
{
	var newWin = window.open("_download","Download", 'width=500,height=100,menubar=yes,resizable=yes');

	// If the window was already open, give him the focus and clear the current document
	// Clear document
	newWin.document.clear();
	newWin.focus();
	newWin.document.writeln("<HTML>");
	newWin.document.writeln("<HEAD>");
	newWin.document.writeln("<TITLE>");
	newWin.document.writeln(title);
	newWin.document.writeln("</TITLE><SCRIPT LANGUAGE='JavaScript1.1'>function saveAs(sFilename){  if(document.queryCommandSupported && document.queryCommandSupported('SaveAs')){    var win = self.open((event.srcElement.href || location.href), '', 'top=1000,left=300,width=1000,height=100');    win.document.execCommand('SaveAs', true, sFilename);    win.close();    } return false  }</SCRIPT>");
	newWin.document.writeln("</HEAD>");
	newWin.document.writeln("<BODY>");
	newWin.document.writeln(message);
	newWin.document.writeln("<A href=\""+file+"\">");
	newWin.document.writeln(click);
	newWin.document.writeln("</A>");

	if (alternate != null && alternate != "")
	{
		newWin.document.writeln("<BR/>");
		newWin.document.writeln(alternate);
		newWin.document.writeln("<A href=\""+file+"\" onclick='return saveAs()'>");
		newWin.document.writeln(click);
		newWin.document.writeln("</A>");
	}
	newWin.document.writeln("</BODY>");
	newWin.document.writeln("</HTML>");
}
// LyMultiSelectorScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyMultiSelectorScript.js 28422 2010-11-03 12:03:38Z ehelmste $

// Take the selected options from the first field and add them to
// the second field.
// if ignoreOrder is set to true, field are added at the end of the listbox
function SelectOptions(form, fieldFromName, fieldToName, fieldResultName,
	fieldName, sep, linkCrSep, needChange, ignoreOrder)
{
	var index, value, id, newOption, indexFrom, indexTo;
	var fieldFrom = form.elements[fieldFromName];
	var fieldTo = form.elements[fieldToName];
	var fieldResult = form.elements[fieldResultName];
	var field = form.elements[fieldName];
	var indexToSelected = -1;

	if (typeof ignoreOrder == "undefined")
		ignoreOrder = false;

	index = fieldFrom.options.selectedIndex;

	if (index == -1)
		return;

	if (!ignoreOrder)
		indexToSelected = fieldTo.options.selectedIndex;

	var first_idx = index;
	i = first_idx;

	do
	{
		if (fieldFrom.options[i].selected == true)
		{
			value = fieldFrom.options[i].text;
			id = fieldFrom.options[i].value;
			fieldFrom.options[i]=null;
			newOption = new Option(value);
			newOption.value = id;
			index = fieldTo.options.length;

			if (ignoreOrder)
			{
				for (j = 0; j < fieldTo.length; j++)
				{
					if (value < fieldTo.options[j].text)
					{
						indexToSelected = j;
						break;
					}
				}
			}

			if (indexToSelected > -1)
			{
				TranslateList(fieldTo, indexToSelected);
				fieldTo.options[indexToSelected] = newOption;
				indexToSelected = fieldTo.options.selectedIndex;
			}
			else
				fieldTo.options[index] = newOption;

			i--;
		}

		i++;
	}
	while (i < fieldFrom.length)

	// Update the field value with the selected values
	index = fieldResult.length;
	field.value = "";

	for (i = 0; i < index; i++)
	{
		if (i != 0)
			field.value += sep;

		field.value += ReplaceString(fieldResult.options[i].value, "\\n", linkCrSep);
	}

	UpdateTools(form, fieldName);

	if (needChange != "false")
		FieldChange(form, field, needChange);
	else if (isInPopUp == 'true')
		setTimeout("checkSizePopupView()", 50);
	else
		setTimeout("checkSizeMainView()", 50);
}

// Take all the options from the first field and add them to the second field.
function SelectAllOptions(form, fieldFromName, fieldToName, fieldResultName,
	fieldName, sep, linkCrSep, needChange)
{
	// Select all the options and call the select function
	for (j = 0; j < form.elements[fieldFromName].length; j++)
		form.elements[fieldFromName].options[j].selected = true;

	SelectOptions(form, fieldFromName, fieldToName, fieldResultName,
		fieldName, sep, linkCrSep, needChange);
}

// Translate the options of the list by one line (starting at begin)
function TranslateList(field, begin)
{
	n = field.length;

	for (k = n; k > begin; k--)
	{
		field.options[k] = new Option(field.options[k-1].text);
		field.options[k].value = field.options[k-1].value;
		field.options[k].selected = field.options[k-1].selected;
	}
}

// Take all the selected options from a list and move them up.
function MoveUpOptions(form, listName, fieldName, sep, linkCrSep, needChange)
{
	var list = form.elements[listName];
	var field = form.elements[fieldName];
	var index = list.length;
	var firstSelection = 0;

	// Check if move up is allowed
	for (i = 0; i < index; i++)
	{
		if (list.options[i].selected)
		{
			firstSelection = i;
			break;
		}
	}

	if (i <= 0)
		return;

	for (i = 0; i < index; i++)
	{
		if (list.options[i].selected)
		{
			value = list.options[i].text;
			id = list.options[i].value;
			list.options[i]=null;
			newOption = new Option(value);
			newOption.value = id;
			newOption.selected = true;
			TranslateList(list, i - 1);
			list.options[i - 1] = newOption;
		}
	}

	// Update the field value with the selected values
	field.value = "";
	index = list.length;

	for (i = 0; i < index; i++)
	{
		if (i != 0)
			field.value += sep;

		field.value += ReplaceString(list.options[i].value, "\\n", linkCrSep);
	}

	UpdateTools(form, fieldName);

	if (needChange != "false")
		FieldChange(form, field, needChange);
}

// Take all the selected options from a list and move them down.
function MoveDownOptions(form, listName, fieldName, sep, linkCrSep, needChange)
{
	var list = form.elements[listName];
	var field = form.elements[fieldName];
	var index = list.length;
	var lastSelection = 0;

	// Check if move down is allowed
	for (i = index - 1; i >= 0; i--)
	{
		if (list.options[i].selected)
		{
			lastSelection = i;
			break;
		}
	}

	if (i == index - 1)
		return;

	for (i = index - 1; i >= 0; i--)
	{
		if (list.options[i].selected)
		{
			value = list.options[i].text;
			id = list.options[i].value;
			list.options[i]=null;
			newOption = new Option(value);
			newOption.value = id;
			newOption.selected = true;
			TranslateList(list, i + 1);
			list.options[i + 1] = newOption;
		}
	}

	// Update the field value with the selected values
	field.value = "";
	index = list.length;

	for (i = 0; i < index; i++)
	{
		if (i != 0)
			field.value += sep;

		field.value += ReplaceString(list.options[i].value, "\\n", linkCrSep);
	}

	UpdateTools(form, fieldName);

	if (needChange != "false")
		FieldChange(form, field, needChange);
}

function UpdateTools(form, fieldName)
{
	if (form == null)
		return;

	var fieldFrom = form.elements[fieldName + "_from"];
	var fieldTo = form.elements[fieldName + "_to"];

	if ((fieldFrom == null) || (fieldTo == null))
		return;

	var imgSelect = this.document.getElementById(fieldName + "_select");
	var imgSelectAll = this.document.getElementById(fieldName + "_selectAll");
	var imgUnselect = this.document.getElementById(fieldName + "_unselect");
	var imgUnselectAll = this.document.getElementById(fieldName + "_unselectAll");
	var imgUp = this.document.getElementById(fieldName + "_up");
	var imgDown= this.document.getElementById(fieldName + "_down");
	var indexFrom = fieldFrom.options.selectedIndex;
	var indexTo = fieldTo.options.selectedIndex;

	// Check if move down is allowed
	var i, index = fieldTo.length;

	for (i = index - 1; i >= 0; i--)
	{
		if (fieldTo.options[i].selected)
		{
			lastSelection = i;
			break;
		}
	}

	SetMultiSelectorButtonEnabled(imgSelect, (indexFrom >= 0));
	SetMultiSelectorButtonEnabled(imgSelectAll, (fieldFrom.length > 0));
	SetMultiSelectorButtonEnabled(imgUnselect, (indexTo >= 0));
	SetMultiSelectorButtonEnabled(imgUnselectAll, (fieldTo.length > 0));
	SetMultiSelectorButtonEnabled(imgUp, (indexTo > 0));
	SetMultiSelectorButtonEnabled(imgDown, (indexTo >= 0) && (i != index - 1));
}

function SetMultiSelectorButtonEnabled(image, enabled)
{
	if (image == null)
		return;

	if (enabled)
	{
		image.className = "";
		image.style.cursor = "";
	}
	else
	{
		image.className = "disabledTool";
		image.style.cursor = "default";
	}
}

// Select an option in an auto-completion multi-selector
function AutoCompletionSelectOption(formName, textHiddenFieldName, textFieldName, listFieldName, fieldName, completionName, values, sep, controller)
{
	var form = findForm(null, formName, textHiddenFieldName);

	if (form == null)
		return;

	var textHiddenField = form.elements[textHiddenFieldName];
	var listField = form.elements[listFieldName];
	var field = form.elements[fieldName];
	var i, j;

	for (i = 0; i < values.length; i++)
	{
		valueId = values[i][0];

		if (valueId == textHiddenField.value)
		{
			var newOption = new Option(values[i][1]);

			newOption.value = values[i][0];
			listField.options[listField.options.length] = newOption;
			values[i][2] = false;

			// Select the first selectable item in the auto-completion list
			for (j = 0; j < values.length; j++)
			{
				if (values[j][2])
				{
					setCompletionValue(formName, completionName, textHiddenFieldName, values[j][0], values[j][1], null);
					break;
				}
			}

			// If no item was selected, empty the auto-completion list
			if (j == values.length)
				setCompletionValue(formName, completionName, textHiddenFieldName, "", "", null);

			break;
		}
	}

	// Update the field value with the selected values
	field.value = "";

	for (i = 0; i < listField.length; i++)
	{
		if (i != 0)
			field.value += sep;

		field.value += listField.options[i].value;
	}

	hideAutoCompletion(formName, completionName, fieldName, controller);
}

// Unselect an option in an auto-completion multi-selector
function AutoCompletionUnselectOption(formName, textHiddenFieldName, textFieldName, listFieldName, fieldName, completionName, values, sep, controller)
{
	var form = findForm(null, formName, textHiddenFieldName);

	if (form == null)
		return;

	var textHiddenField = form.elements[textHiddenFieldName];
	var listField = form.elements[listFieldName];
	var field = form.elements[fieldName];
	var i = 0, j;

	for (i = listField.length - 1; i >= 0 ; i--)
	{
		if (listField.options[i].selected)
		{
			for (j = 0; j < values.length; j++)
			{
				valueId = values[j][0];

				if (valueId == listField.options[i].value)
				{
					listField.options[i] = null;
					values[j][2] = true;

					if (textHiddenField.value == "")
						setCompletionValue(formName, completionName, textHiddenFieldName, values[j][0], values[j][1], null);

					break;
				}
			}
		}
	}

	// Update the field value with the selected values
	field.value = "";

	for (i = 0; i < listField.length; i++)
	{
		if (i != 0)
			field.value += sep;

		field.value += listField.options[i].value;
	}

	hideAutoCompletion(formName, completionName, fieldName, controller);
}
// LyPageScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyPageScript.js 28422 2010-11-03 12:03:38Z ehelmste $

// This function closes an area (close a dialog or go back).
function CloseArea(noReload)
{
	var mainFrame = findTarget(null, "main_frame");
	var targetFrame = findTarget(null, "target_frame");

	if (getLeonardiTopFrame().opener != null)
	{
		getLeonardiTopFrame().close();

		if (noReload == null)
			ReloadParent();
	}
	else
	{
		if (targetFrame == null)//(typeof top.frames["main_frame"].frames["target_frame"]) == "undefined")
			window.history.back();
		else
			//top.frames["main_frame"].frames["target_frame"].history.go(-2);
			targetFrame.history.go(-2);
	}
}

// This function reloads the parent object.
function ReloadParent()
{
	if ((getLeonardiTopFrame().opener == null) || ((typeof getLeonardiTopFrame().opener) == "undefined"))
		return;

	var mainFrame = findTarget(null, "main_frame");
	var targetFrame = findTarget(null, "target_frame");

//	if ((typeof top.opener.top.frames["main_frame"] != "undefined") &&
//		(typeof top.opener.top.frames["main_frame"].frames["target_frame"] != "undefined"))
//		top.opener.top.frames["main_frame"].frames["target_frame"].location.reload();
//	else
//		top.opener.top.location.reload();

	if ( (mainFrame != null) && (targetFrame != null))
		targetFrame.location.reload();
	else
		top.openener.top.location.reload();
}


// Extract the base URL from current location
function GetBaseUrl(baseUrl)
{
	var currentUrl = new String(baseUrl);
	var n = currentUrl.indexOf("?", 0);

	if (n > 0)
		return currentUrl.substr(0, n);
	else
		return currentUrl;
}

// This function reloads a page
function ReloadPage(close)
{
	var mainFrame = findTarget(null,"main_frame");
	var targetFrame = findTarget(null,"target_frame");

	if (getLeonardiTopFrame().opener != null)
	{
		if (close != null)
			CloseArea();
		else
			top.location.reload();
	}
	else if ((mainFrame != null) && (targetFrame != null))
	//(typeof top.frames["main_frame"] != "undefined")
	//	&& (typeof top.frames["main_frame"].frames["target_frame"] != "undefined"))
	{
		// Do *not* Loop
		if (targetFrame != this)
		//if (top.frames["main_frame"].frames["target_frame"] != this)
		{
			//top.frames["main_frame"].frames["target_frame"].location.reload();
			targetFrame.location.reload();
		}
		else
		{
			//top.frames["main_frame"].frames["target_frame"].history.go(-1);
			//targetFrame.history.go(-1);
			var hiddenFrame = findTarget(null,"hidden_frame");
			//if (typeof top.frames["hidden_frame"] != "undefined")
			if (hiddenFrame != null)
			{
				//var baseUrl = GetBaseUrl(top.frames["hidden_frame"].location);
				var baseUrl = getBaseUrl(hiddenFrame.location);
				baseUrl = baseUrl + "?_action=_reloadPage";

				//top.frames["hidden_frame"].location = baseUrl;
				hiddenFrame.location = baseUrl;
			}
		}
	}
	else
		getLeonardiTopFrame().location.reload();
}

// This function print the current page
function PrintPage(message)
{
	if (this.print != "undefined")
	{
		setTimeout("this.print()",1000);

		// Wait until data are sent to the printer
		setTimeout("this.close()", 3000);
	}
	else
	{
		if (message == null)
			alert("Printing from Javascript is not supported by this browser.\nPrint the generated page by using the printing features of your browser.");
		else
			alert(message);
	}
}
// LyDhmltSplitterScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyDhtmlSplitterScript.js 24719 2010-03-15 14:24:04Z nhamon $

var hiddenDivThickness = 8;
var divMinThickness = 40;
var firstPos = -1;
var lastPos = -1;
var movedDiv = null;
var hiddenDiv = null;
var parentPart = null;
var firstPart = null;
var secondPart = null;
var splitterCode = null;
var minPos = 0;
var maxPos = 10000;
var verticalMovement;
var hideTime = -1;
var splitterTarget = null;

// This function starts the movement of a splitter
function startMoveSplitter(event, parentPartId, firstPartId, secondPartId, hiddenDivId, movingDivId, isVertical, splitterHashcode, target)
{
	if ((new Date().getTime()) - hideTime < 1000)
	{
		hideTime = -1;
		return;
	}

	// Firefox
	if (document.getElementById && !(document.all))
		document.onmousemove = moveSplitterWithEvent;
	// IE
	else if(document.all)
		document.onmousemove = moveSplitter;

	SetSelectionStartMode(false);
	document.onmouseup = endMoveSplitter;

	parentPart = document.getElementById(parentPartId);
	firstPart = document.getElementById(firstPartId);
	secondPart = document.getElementById(secondPartId);
	hiddenDiv = document.getElementById(hiddenDivId);
	movedDiv = document.getElementById(movingDivId);
	verticalMovement = isVertical;
	splitterCode = splitterHashcode;
	splitterTarget = target;

	hiddenDiv.style.width = this.document.body.clientWidth;
	hiddenDiv.style.height = this.document.body.clientHeight;
	hiddenDiv.style.left = 0;
	hiddenDiv.style.top = 0;
	hiddenDiv.style.cursor = (isVertical ? "s-resize" : "w-resize");
	hiddenDiv.style.display = "block";

	if (isVertical)
	{
		minPos = cmGetY(parentPart);
		maxPos = cmGetY(parentPart) + cmGetHeight(parentPart);
	}
	else
	{
		minPos = cmGetX(parentPart);
		maxPos = cmGetX(parentPart) + cmGetWidth(parentPart);
	}

	if (isVertical)
	{
		firstPos = event.clientY;
		lastPos = event.clientY;

		movedDiv.style.height = hiddenDivThickness + "px";
		movedDiv.style.width = cmGetWidth(firstPart) + "px";
		movedDiv.style.top = (firstPos - (-document.body.scrollTop) - (hiddenDivThickness / 2)) + "px";
		movedDiv.style.left = cmGetX(firstPart);
	}
	else
	{
		firstPos = event.clientX;
		lastPos = event.clientX;

		movedDiv.style.width = hiddenDivThickness + "px";
		movedDiv.style.height = cmGetHeight(firstPart) + "px";
		movedDiv.style.left = (firstPos - (-document.body.scrollLeft) - (hiddenDivThickness / 2)) + "px";
		movedDiv.style.top = cmGetY(firstPart);
	}

	// Display hidden div and register events
	movedDiv.style.display = "block";
}

// This function implements the movement of a splitter
function moveSplitterWithEvent(event)
{
	moveSplitter(event);
}

// This function implements the movement of a splitter
function moveSplitter(myEvent)
{
	if (document.getElementById && !(document.all))
	{
		// Firefox
		// Nothing to do
	}
	else if(document.all)
	{
		// IE
		myEvent = event;
	}

	// Register new position and change the movedDiv position
	if (verticalMovement)
	{
		if (myEvent.clientY - minPos < divMinThickness)
			return;

		if (myEvent.clientY > document.body.clientHeight - divMinThickness)
			return;

		if (myEvent.clientY > document.body.clientHeight - (hiddenDivThickness / 2) - 5)
			return;


		var difY = myEvent.clientY - lastPos;
		var newY = parseInt(movedDiv.style.top) + difY;

		movedDiv.style.top = newY + "px";
		lastPos = myEvent.clientY;
	}
	else
	{
		if (myEvent.clientX - minPos < divMinThickness)
			return;

		if (myEvent.clientX > maxPos - divMinThickness)
			return;

		if (myEvent.clientX > maxPos - (hiddenDivThickness / 2) - 5)
			return;

		var difX = myEvent.clientX - lastPos;
		var newX = parseInt(movedDiv.style.left) + difX;

		movedDiv.style.left = newX + "px";
		lastPos = myEvent.clientX;
	}
}

// This function ends the movement of a splitter
function endMoveSplitter()
{
	// Compute the new sizes of the two parts
	var offset = lastPos - firstPos;

	// Change the sizes of the two parts
	if (verticalMovement)
	{
		var total = cmGetHeight(firstPart) + cmGetHeight(secondPart);
		var firstFrameSize = cmGetHeight(firstPart) + offset;
		var secondFrameSize = cmGetHeight(secondPart) - offset;
		var firstProp = parseInt(((firstFrameSize * 100) / total) + 0.5);

		if (firstProp < 3)
			firstProp = 3;
		else if (firstProp > 97)
			firstProp = 97;

		getLeonardiTopFrame().setSplitterSize(firstPart.id + "", firstProp, splitterCode, STRUTS_EVENT_URL, splitterTarget);
	}
	else
	{
		var total = cmGetWidth(firstPart) + cmGetWidth(secondPart);
		var firstFrameSize = cmGetWidth(firstPart) + offset;
		var secondFrameSize = cmGetWidth(secondPart) - offset;
		var firstProp = parseInt(((firstFrameSize * 100) / total) + 0.5);

		if (firstProp < 3)
			firstProp = 3;
		else if (firstProp > 97)
			firstProp = 97;

		getLeonardiTopFrame().setSplitterSize(firstPart.id + "", firstProp, splitterCode, STRUTS_EVENT_URL, splitterTarget);
	}

	// Reset default state
	minPos = 0;
	maxPos = 10000;
	hiddenDiv.style.width = 5;
	hiddenDiv.style.height = 5;
	hiddenDiv.style.left = 0;
	hiddenDiv.style.top = 0;
	hiddenDiv.style.display = "none";
	movedDiv.style.display = "none";
	parentPart = null;
	firstPart = null;
	secondPart = null;
	splitterCode = null;
	SetSelectionStartMode(true);
	document.onmousemove = null;
	document.onmouseup = null;
}

// Array of splitter ids :
//  - splitterIds[n][0] : isVertical
//  - splitterIds[n][1] : parentId
//  - splitterIds[n][2] : firstPartId
//  - splitterIds[n][3] : secondPartId
//  - splitterIds[n][4] : firstPartSize
//  - splitterIds[n][5] : set to auto overflow style of divs
var splitterIds = new Array();

function addSplitterIds(vars)
{
	var found = false;

	for (var i = splitterIds.length - 1; i >= 0; i--)
	{
		var oldVars = splitterIds[i];

		if (vars[2] == oldVars[2])
		{
			splitterIds[i] = vars;
			found = true;
		}
	}

	if (!found)
		splitterIds[splitterIds.length] = vars;
}

function setSplitterSize(firstPartId, firstPartSize, splitterHashcode, path, target)
{
	for (var i = splitterIds.length - 1; i >= 0; i--)
	{
		var vars = splitterIds[i];

		if (vars[2] == firstPartId)
		{
			vars[4] = firstPartSize + "";
		}
	}

	checkSizeMainView('true', 'false');

	// Send new splitter size to server
	for (var i = 0; i < ajaxEncodedChars.length; i++)
	{
		firstPartSize = ReplaceString(firstPartSize + "", ajaxChars[i], ajaxEncodedChars[i]);
	}

	SendAjaxRequestParams(_rootUrl + path, pageParam + '=' + splitterHashcode + '&' + sourceParam + '=setSize' +
		'&' + valueParam + '=' + firstPartSize +  '&target_session=' + target);
}

function hideSplitter(firstPartId, increase, splitterHashcode, target)
{
	hideTime = (new Date().getTime());

	for (var i = getLeonardiTopFrame().splitterIds.length - 1; i >= 0; i--)
	{
		var vars = getLeonardiTopFrame().splitterIds[i];

		if (vars[2] == firstPartId)
		{
			var newSize;

			if (increase)
			{
				if (vars[4].indexOf('0%') == 0)
					newSize = vars[4].substring(2, vars[4].length);
				else if (vars[4].indexOf('100%') == 0)
					newSize = vars[4];
				else if ((vars[4] != "") && (vars[4] != "0"))
					newSize = '100%' + vars[4];
				else
					newSize = '50';
			}
			else
			{
				if (vars[4].indexOf('100%') == 0)
					newSize = vars[4].substring(4, vars[4].length);
				else if (vars[4].indexOf('0%') == 0)
					newSize = vars[4];
				else if ((vars[4] != "") && (vars[4] != "100"))
					newSize = '0%' + vars[4];
				else
					newSize = '50';
			}

			getLeonardiTopFrame().setSplitterSize(firstPartId, newSize, splitterHashcode, STRUTS_EVENT_URL, target);
			break;
		}
	}

}// LyStringScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyStringScript.js 28422 2010-11-03 12:03:38Z ehelmste $

// This function replace a string in a text by another given string.
function ReplaceString(text, search, replace)
{
	if (text == null)
		return null;

	if (search == null)
		return text;

	var	result = "";
	var	i, j;
	var	length = text.length;
	var	sl = search.length;
	var	rl = 0;

	if (replace != null)
		rl = replace.length;

	for (i = 0, j = 0; (i < length) && ((j = text.indexOf(search, i)) >= 0); i = j + sl)
	{
		result = result + text.substring(i, j);

		if (rl > 0)
			result = result + replace;
	}

	if (i < length)
		result = result + text.substring(i, length);

	return result;
}

// This function tests if a text length is lower than the length value.
function isLongerThan(text, length)
{
	if (length < 0)
		return false;

	var textLength = text.length;

	if (textLength > length)
		return true;
	else
		return false;
}

function endsWith(source, pattern)
{
	n = pattern.length;
	m = source.length;

	temp = source.substring(m-n);

	if (temp == pattern)
		return true;
	else
		return false;
}

function StringToArray(str, sep)
{
	var words = new Array;
	var	end = false;

	while (str != "" && !end)
	{
		var index = 0;

		index = str.indexOf(sep);

		if (index < 0)
		{
			end = true;
			word = str;
		}
		else
			word = str.substring(0, index);

		words[words.length] = word;

		str = str.substring(index + sep.length, str.length);
	}

	return words;
}

// This function splits a string into an array using two separators
function SplitString(text, sep1, sep2)
{
	var scripts = new Array;
	var end = false;

	while (text != "" && !end)
	{
		var index1 = 0;
		var index2 = 0;

		index1 = text.indexOf(sep1);
		index2 = text.indexOf(sep2, index1);

		if ((index1 < 0) || (index2 < 0))
		{
			end = true;
			script = "";
		}
		else
			script = text.substring(index1 + sep1.length, index2);

		scripts[scripts.length] = script;

		text = text.substring(index2 + sep2.length, text.length);
	}
	
	return scripts;
}
// LyDhmltTableScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyDhtmlTableScript.js 24096 2010-01-20 14:42:31Z nhamon $

var click = false;
var lastCellSelected = -1;
var lastRowSelected = "";
var rowIdToRefresh = null;

// List of cells with decorations
var cellDecorations = new Array();

// called when the mouse is over a row
function callOnMouseOver(rowId, color)
{
	var ie= (navigator.appName == "Microsoft Internet Explorer")?1:0;

	if(ie)
	{
		var trObject = document.all[rowId];

		if ( (trObject != null) && (trObject != "undefined") )
		{
			var parentTag = trObject.parentElement;

			if ( (parentTag != null) && (parentTag != "undefined") )
			{
				for (var i = 0; i < parentTag.children.length; i++)
				{
					var child = parentTag.children[i];
					var tagName = child.tagName;

					if (tagName == "TR")
					{
						if ((child.id == rowId)
							|| (child.id.indexOf(rowId+"SUB_") == 0))
							child.bgColor = color;
					}
				}
			}
		}
	}
	else
	{
		var trObject = document.getElementById(rowId);

		if ( (trObject != null) && (trObject != "undefined") )
		{
			var parentTag = trObject.parentNode;

			if ( (parentTag != null) && (parentTag != "undefined") )
			{
				for (var i = 0; i < parentTag.rows.length; i++)
				{
					var child = parentTag.rows[i];
					var tagName = child.tagName;

					if (tagName == "TR")
					{
						if ((child.id == rowId)
							|| (child.id.indexOf(rowId+"SUB_") == 0))
							child.bgColor = color;
					}
				}
			}
		}
	}
}

// called when a simple click is performed on a row
function InvokeRowClick(rowId, controllerId, tableId, selectionColor, path, singleSelection, event, selectFontColor)
{
	var elem = (event.target) ? event.target : event.srcElement;
	var extend = event.ctrlKey;
	var shift = event.shiftKey;
	var selectedCheckbox = document.getElementById("checkboxSelection_row" + rowId);

	if (selectedCheckbox != null)
	{
		extend = true;
		shift = false;
	}

	if (singleSelection)
	{
		var wasSelected = hasSelectionId(tableId, rowId);

		clearSelectionIds(tableId);

		if (wasSelected && extend)
			removeSelectionId(tableId, rowId);
		else
			addSelectionId(tableId, rowId);
	}
	else if (!extend)
	{
		clearSelectionIds(tableId);

		if (shift)
			selectRows(tableId, lastRowSelected, rowId);
		else
			addSelectionId(tableId, rowId);
	}
	else
	{
		if (hasSelectionId(tableId, rowId))
			removeSelectionId(tableId, rowId);
		else
			addSelectionId(tableId, rowId);
	}

	if (selectedCheckbox == null)
		UpdateRowsColors(tableId, selectionColor, null, selectFontColor);

	lastRowSelected = rowId;

	var selectedIds = getSelectionIds(tableId);

	InvokeSelection("_select", selectedIds, controllerId, (extend ? "true" : "false"), path);
}

// Called when a dblClick is performed on a row
function InvokeRowDoubleClick(tableId, controllerId, objectId, color, column, separator, path)
{
	var methodParam = ReplaceString(objectId,"\\","\\\\");

	if (column >= 0)
		methodParam = methodParam + separator + column;

	InvokeAction(tableId, path, '', controllerId, methodParam);
}

// Called when a click is performed on the status of a row
function InvokeStatusClick(rowId, controllerId, path, e)
{
	if (window.event)
		event.cancelBubble = true; // IE
	else if (e.stopPropagation)
		e.stopPropagation(); // Firefox

	InvokeAction('_status', path, '', controllerId, rowId);
}

// Called when a click is performed on a header
function InvokeHeaderClick(controllerId, index, path, event)
{
	InvokeAction('', path, '', controllerId, index, (event.ctrlKey ? 'extendSort' : 'sort'));
}

// Called when a click is performed on a HRef
function InvokeHRefClick(objectId, controllerId, path)
{
	InvokeAction(objectId, path, '', controllerId, objectId, 'href');
}

// Called when a click is performed on an expand arrow of a row
function InvokeExpandRowClick(rowId, controllerId, path)
{
	InvokeAction(rowId, path, '', controllerId, '', 'open');
}

// Called when a contextual menu is performed on a row
function callOnContextMenu(rowId, controllerId, htmlTableId, tableId, selectionColor, path, selectionPath, event, selectFontColor)
{
	var selectedCheckbox = document.getElementById("checkboxSelection_row"+ rowId);

	if (((selectedCheckbox == null) || (typeof selectedCheckbox == "undefined"))
		&& (rowId != "") && !hasSelectionId(htmlTableId, rowId))
	{
		InvokeRowClick(rowId, controllerId, htmlTableId, selectionColor, selectionPath, false, event, selectFontColor);

		rowId = ReplaceString(rowId,"\\","\\\\");
		rowId = ReplaceString(rowId,"'","\\'");

		setTimeout("InvokePopup('" + tableId + "','" + rowId +
			"_subIndexSeparator_" + lastCellSelected + "','" + path +
			"','" + controllerId + "'," + event.ctrlKey + "," +
			event.clientX + "," + event.clientY + ")", 300);
	}
	else
		InvokePopup(tableId, rowId + "_subIndexSeparator_" + lastCellSelected, path, controllerId, event.ctrlKey,
			event.clientX, event.clientY);
}


// Starts the edition of a cell
function startCellEdition(tableId, controllerId, row, column, separator, path, event)
{
	var elem = (event.target) ? event.target : event.srcElement;

	if (elem.nodeName == "INPUT")
		return;

	if (elem.nodeName == "IMG") // Tool button
		return;

	InvokeAction(tableId, path, '', controllerId, '_cellEdition' + separator + row + separator + column);
}

// Select rows from beginIndex to endIndex
function selectRows(tableId, lastRow, newRow)
{
	var ie= (navigator.appName == "Microsoft Internet Explorer")?1:0;
	var table = document.getElementById(tableId);
	var started = false;

	if(ie)
	{
		var tbody = table.children[0];

		if ((tbody.tagName != "TBODY") && (table.children.length > 1))
			tbody = table.children[1];

		for (var i = 0; (i < tbody.children.length); i++)
		{
			if (tbody.children[i].tagName == "TR")
			{
				// Check if sub-row of existing row
				if (tbody.children[i].id.indexOf("SUB_") > 0)
					continue;

				if ((tbody.children[i].id == lastRow) || (tbody.children[i].id == newRow))
				{
					started = !started;
					addSelectionId(tableId, tbody.children[i].id);
				}
				else if (started)
					addSelectionId(tableId, tbody.children[i].id);
			}
		}
	}
	else
	{
		var tbody = table.childNodes[1];

		if ((tbody.tagName != "TBODY") && (table.childNodes.length > 2))
			tbody = table.childNodes[2];

		for (var i = 0; (i < tbody.childNodes.length); i++)
		{
			if (tbody.childNodes[i].tagName == "TR")
			{
				// Check if sub-row of existing row
				if (tbody.childNodes[i].id.indexOf("SUB_") > 0)
					continue;

				if ((tbody.childNodes[i].id == lastRow) || (tbody.childNodes[i].id == newRow))
				{
					started = !started;
					addSelectionId(tableId, tbody.childNodes[i].id);
				}
				else if (started)
					addSelectionId(tableId, tbody.childNodes[i].id);
			}
		}
	}
}

// Select a row
function selectRow(tableId, rowId, color, frameId, updateRowColors)
{
	var frame = null;

	if (frameId != null)
		frame = findTarget(null, frameId, null);

	if (frame == null)
		frame = this;

	frame.addSelectionId(tableId, rowId);
}

// Unselect a row
function  unselectRow(tableId, rowId, frameId)
{
	var frame = null;

	if (frameId != null)
		frame = findTarget(null, frameId, null);

	if (frame == null)
		frame = this;

	frame.removeSelectionId(tableId, rowId);
}

// Select all rows
function selectAll(tableId, select, color, selectFontColor)
{
	var subRowPrefix = "SUB_";
	var sectionRowPrefix = "SECTION_ROW_PREFIX";
	var footerRowPrefix = "FOOTER_ROW_PREFIX";
	var ie= (navigator.appName == "Microsoft Internet Explorer")?1:0;
	var table = document.getElementById(tableId);

	if(ie)
	{
		var tbody = table.children[0];

		if ((tbody.tagName != "TBODY") && (table.children.length > 1))
			tbody = table.children[1];

		for (var i = 0; (i < tbody.children.length); i++)
		{
			if (tbody.children[i].tagName == "TR")
			{
				// Check if sub-row of existing row
				if ((tbody.children[i].id.indexOf(subRowPrefix) > 0)
						|| (tbody.children[i].id.indexOf(sectionRowPrefix) == 0)
						|| (tbody.children[i].id.indexOf(footerRowPrefix) == 0))
					continue;

				if (select)
					addSelectionId(tableId, tbody.children[i].id);
				else
					removeSelectionId(tableId, tbody.children[i].id);
			}
		}
	}
	else
	{
		var tbody = table.childNodes[1];

		if ((tbody.tagName != "TBODY") && (table.childNodes.length > 2))
			tbody = table.childNodes[2];

		for (var i = 0; (i < tbody.childNodes.length); i++)
		{
			if (tbody.childNodes[i].tagName == "TR")
			{
				// Check if sub-row of existing row
				if ((tbody.childNodes[i].id.indexOf(subRowPrefix) > 0)
						|| (tbody.childNodes[i].id.indexOf(sectionRowPrefix) == 0)
						|| (tbody.childNodes[i].id.indexOf(footerRowPrefix) == 0))
					continue;

				if (select)
					addSelectionId(tableId, tbody.childNodes[i].id);
				else
					removeSelectionId(tableId, tbody.childNodes[i].id);
			}
		}
	}

	UpdateRowsColors(tableId, color, null, selectFontColor);
}

// permute to style of one element
function changeStyle(element, style1, style2)
{
	if (element.className == style1)
		element.className = style2;
	else
		element.className = style1;
}

// This function returns a list of sub-elements whose foreground
// color may be updated.
function GetChildrenWithForeground(object)
{
	var ie= (navigator.appName == "Microsoft Internet Explorer")?1:0;
	var result = new Array();
	var result2;

	if (ie)
	{
		for (var i = 0; (i < object.children.length); i++)
		{
			if (object.children[i].tagName == "A"
				|| object.children[i].tagName == "TD")
				result[result.length] = object.children[i];

			result2 = GetChildrenWithForeground(object.children[i]);

			for (var j = 0; (j < result2.length); j++)
				result[result.length] = result2[j];
		}
	}
	else
	{
		for (var i = 0; (i < object.childNodes.length); i++)
		{
			if (object.childNodes[i].tagName == "A"
				|| object.childNodes[i].tagName == "TD")
				result[result.length] = object.childNodes[i];

			result2 = GetChildrenWithForeground(object.childNodes[i]);

			for (var j = 0; (j < result2.length); j++)
				result[result.length] = result2[j];
		}
	}

	return result;
}

// This function change the color on a row.
function UpdateRowColor(tableId, row, selectionColor, frame, selectFontColor)
{
	var ie= (navigator.appName == "Microsoft Internet Explorer")?1:0;

	if (row != null)
	{
		var rowId = row.id;

		// Check if sub-row of existing row
		if (rowId.indexOf("SUB_") > 0)
			rowId = rowId.substring(0, rowId.indexOf("SUB_"));

		var isSelected =  frame.hasSelectionId(tableId, rowId);
		var wasSelected = !isSelected;

		if (ie)
		{
			for (var j = 0; (j < row.children.length); j++)
			{
				var className = row.children[j].className;

				if (className.indexOf("status")>=0 || className.indexOf("table")==0)
					continue;

				if ((row.children[j] != null) && (typeof row.children[j] != "undefined")
						&& (row.children[j].style != null) && (typeof row.children[j].style  != "undefined"))
				{
					wasSelected = compareColors(row.children[j].style.backgroundColor, selectionColor);
					break;
				}
			}
		}
		else
		{
			for (var j = 0; (j < row.cells.length); j++)
			{
				var className = row.cells[j].className;

				if (className.indexOf("status")>=0 || className.indexOf("table")==0)
					continue;

				if ((row.cells[j] != null) && (typeof row.cells[j] != "undefined")
						&& (row.cells[j].style != null) && (typeof row.cells[j].style  != "undefined"))
				{
					wasSelected = compareColors(row.cells[j].style.backgroundColor, selectionColor);
					break;
				}
			}
		}

		var rowIdForceRefresh = getLeonardiTopFrame().rowIdToRefresh;

		if ((isSelected == wasSelected) && (rowIdForceRefresh != row.id))
			return;

		getLeonardiTopFrame().rowIdForceRefresh = null;

		if (isSelected)
		{
			if(ie)
			{
				if(selectFontColor=='null')
					selectFontColor = "";

				for (var j = 0; (j < row.children.length); j++)
				{

					var className = row.children[j].className;


					if (className.indexOf("status")>=0 || className.indexOf("table")==0)
						continue;


					// Do not choose the highlighted color as oldcolor if ALREADY highlighted (case of Ctrl + click)
					if (row.children[j].style.backgroundColor != selectionColor)
					{

						row.children[j].style.oldColor = row.children[j].style.color;
						row.children[j].style.oldBackgroundColor = row.children[j].style.backgroundColor;
					}

					row.children[j].style.backgroundColor = selectionColor;
					row.children[j].style.color = selectFontColor;
				}
			}
			else
			{
				for (var j = 0; (j < row.cells.length); j++)
				{
					var myClassName = row.cells[j].className;

					if (myClassName.indexOf("status")>=0 || myClassName.indexOf("table")==0)
						continue;

					// Do not choose the highlighted color as oldcolor if ALREADY highlighted (case of Ctrl + click)
					if (!compareColors(row.cells[j].style.backgroundColor, selectionColor))
					{
						row.cells[j].setAttribute("oldColor", row.cells[j].style.color);
						row.cells[j].setAttribute("oldBackgroundColor", row.cells[j].style.backgroundColor);
					}

					row.cells[j].style.backgroundColor = selectionColor;
					row.cells[j].style.color = selectFontColor;

					for (var l = 0; (l < row.cells[j].childNodes.length); l++)
					{
						if (row.cells[j].childNodes[l].tagName == "A")
							row.cells[j].childNodes[l].style.color = selectFontColor;
					}
				}
			}

			// Change the foreground color of sub-elements
			var children = GetChildrenWithForeground(row);

			if (children != null)
			{
				for (var j = 0; (j < children.length); j++)
				{
					children[j].style.color = selectFontColor;
				}
			}
		}
		else
		{
			var rowColor = row.getAttribute("color");

			if (rowColor == null)
				rowColor = "";

			if (ie)
			{
				for (var j = 0; (j < row.children.length); j++)
				{
					row.children[j].style.backgroundColor = row.children[j].style.oldBackgroundColor;
					row.children[j].style.color = row.children[j].style.oldColor;
				}
			}
			else
			{
				for (var j = 0; (j < row.cells.length); j++)
				{
					row.cells[j].style.backgroundColor = row.cells[j].getAttribute("oldBackgroundColor");
					row.cells[j].style.color = row.cells[j].getAttribute("oldColor");
				}
			}

			// Change the foreground color of sub-elements
			var children = GetChildrenWithForeground(row);

			if (children != null)
			{
				for (var j = 0; (j < children.length); j++)
				{
					children[j].style.color = rowColor;
				}
			}
		}
	}
}

var updateRowsColorsCount = 0;

// To update row colors in function of selection.
function UpdateRowsColors(tableId, selectionColor, frameId, selectFontColor)
{
	var ie= (navigator.appName == "Microsoft Internet Explorer")?1:0;
	var doc = document;
	var frame = this;

	if (frameId != null)
	{
		frame = findTarget(null, frameId, null);

		if (frame != null)
			doc = frame.document;
	}

	var table = doc.getElementById(tableId);

	if ((table == null) || ((typeof table) == "undefined"))
	{
		// Retry
		updateRowsColorsCount++;

		if (updateRowsColorsCount <= 20)
		  	setTimeout("UpdateRowsColors('" + tableId + "', '" + selectionColor + "', '" + frameId + "', '" + selectFontColor + "')", 500);
		else
   			updateRowsColorsCount = 0;
		return;
	}

	if(ie)
	{
		var tbody = table.children[0];

		if ((tbody.tagName != "TBODY") && (table.children.length > 1))
			tbody = table.children[1];

		for (var i = 0; (i < tbody.children.length); i++)
		{
			if (tbody.children[i].tagName == "TR")
				UpdateRowColor(tableId, tbody.children[i], selectionColor, frame, selectFontColor);
		}
	}
	else
	{
		var tbody = table.childNodes[1];

		if ((tbody.tagName != "TBODY") && (table.childNodes.length > 2))
			tbody = table.childNodes[2];

		for (var i = 0; (i < tbody.rows.length); i++)
		{
			UpdateRowColor(tableId, tbody.rows[i], selectionColor, frame, selectFontColor);
		}
	}
}

// Update the position of the cell decoration DIV
function UpdateCellDecoration(cellPosition, register, frameId)
{
	var	frame = null;

	if (frameId != null)
		frame = findTarget(null, frameId, null);

	if (frame == null)
		frame = this;

	var	cellDeco = frame.document.getElementById('cell_' + cellPosition);
	var	divDeco = frame.document.getElementById('cellDeco_' + cellPosition);

	if ((cellDeco != null) && (typeof cellDeco !="undefined")
		&& (divDeco != null) && (typeof divDeco !="undefined"))
	{
		divDeco.style.left = getXInDiv(cellDeco);
		divDeco.style.top = getYInDiv(cellDeco)
		divDeco.style.width = cmGetWidth(cellDeco);
		divDeco.style.height = cmGetHeight(cellDeco);

		if (register)
			frame.cellDecorations[frame.cellDecorations.length] = cellPosition;
	}
}

// Gets the x position of an object in its parent DIV
function getXInDiv(obj)
{
	if (!obj)
		return 0;
	var x = 0;

	do
	{
		x += obj.offsetLeft;
		obj = obj.offsetParent;

		// If parent DIV with an auto overflow is found, position must be retrieved from this DIV
		if (obj && obj.tagName == "DIV" && obj.style.overflow == "auto")
			break;
	}
	while (obj);

	return x;
}

// Gets the y position of an object in its parent DIV
function getYInDiv(obj)
{
	if (!obj)
		return 0;
	var y = 0;

	do
	{
		y += obj.offsetTop;
		obj = obj.offsetParent;

		// If parent DIV with an auto overflow is found, position must be retrieved from this DIV
		if (obj && obj.tagName == "DIV" && obj.style.overflow == "auto")
			break;
	}
	while (obj);

	return y;
}

// Enables or disables the selection in HTML page
function SetSelectionStartMode(enableSelection)
{
	if (enableSelection)
	{
		if (typeof document.onselectstart != 'undefined')
			document.onselectstart = function() {return true};
		else if (typeof document.body.style.MozUserSelect != 'undefined')
			document.body.style.MozUserSelect = null;
	}
	else
	{
		if (typeof document.onselectstart != 'undefined')
			document.onselectstart = function() {return false};
		else if (typeof document.body.style.MozUserSelect != 'undefined')
			document.body.style.MozUserSelect = 'none';
	}
}

// This function compares if two color resources are equal
function compareColors(color1, color2)
{
	var colorObject1 = new RGBColor(color1);
	var colorObject2 = new RGBColor(color2);

	return (colorObject1.toHex() == colorObject2.toHex());
}

// This function creates a color resource from a color string such as #00ff00 or rgb(123, 234, 45)
function RGBColor(color_string)
{
    // strip any leading #
    if (color_string.charAt(0) == '#')
        color_string = color_string.substr(1,6);

    color_string = color_string.replace(/ /g,'');
    color_string = color_string.toLowerCase();

    // array of color definition objects
    var color_defs = [
        {
            re: /^rgb\((\d{1,3}),\s*(\d{1,3}),\s*(\d{1,3})\)$/,
            example: ['rgb(123, 234, 45)', 'rgb(255,234,245)'],
            process: function (bits){
                return [
                    parseInt(bits[1]),
                    parseInt(bits[2]),
                    parseInt(bits[3])
                ];
            }
        },
        {
            re: /^(\w{2})(\w{2})(\w{2})$/,
            example: ['#00ff00', '336699'],
            process: function (bits){
                return [
                    parseInt(bits[1], 16),
                    parseInt(bits[2], 16),
                    parseInt(bits[3], 16)
                ];
            }
        },
        {
            re: /^(\w{1})(\w{1})(\w{1})$/,
            example: ['#fb0', 'f0f'],
            process: function (bits){
                return [
                    parseInt(bits[1] + bits[1], 16),
                    parseInt(bits[2] + bits[2], 16),
                    parseInt(bits[3] + bits[3], 16)
                ];
            }
        }
    ];

    // search through the definitions to find a match
    for (var i = 0; i < color_defs.length; i++) {
        var re = color_defs[i].re;
        var processor = color_defs[i].process;
        var bits = re.exec(color_string);
        if (bits) {
            channels = processor(bits);
            this.r = channels[0];
            this.g = channels[1];
            this.b = channels[2];
        }
    }

    // validate/cleanup values
    this.r = (this.r < 0 || isNaN(this.r)) ? 0 : ((this.r > 255) ? 255 : this.r);
    this.g = (this.g < 0 || isNaN(this.g)) ? 0 : ((this.g > 255) ? 255 : this.g);
    this.b = (this.b < 0 || isNaN(this.b)) ? 0 : ((this.b > 255) ? 255 : this.b);

    this.toHex = function () {
        var r = this.r.toString(16);
        var g = this.g.toString(16);
        var b = this.b.toString(16);
        if (r.length == 1) r = '0' + r;
        if (g.length == 1) g = '0' + g;
        if (b.length == 1) b = '0' + b;
        return '#' + r + g + b;
    }
}


// LyTreeScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id: LyTreeScript.js 28422 2010-11-03 12:03:38Z ehelmste $

// Scroll down to the active node
function ShowActiveNode(name)
{
	var netscapeNavigation = (navigator.appName == "Netscape");

	if (!netscapeNavigation)
		location = "#" + name;
}

var lastTreeNodeSelected = "";

// Select a node.
function InvokeTreeNodeSelection(treeId, treeNodeId, controllerId, path, singleSelection, event)
{
	var extend = event.ctrlKey;
	var shift = event.shiftKey;

	if (singleSelection)
	{
		clearSelectionIds(treeId);
		addSelectionId(treeId, treeNodeId);
	}
	else if (!extend)
	{
		clearSelectionIds(treeId);

		if (shift)
			selectTreeNodes(treeId, lastTreeNodeSelected, treeNodeId);
		else
			addSelectionId(treeId, treeNodeId);
	}
	else
	{
		if (hasSelectionId(treeId, treeNodeId))
			removeSelectionId(treeId, treeNodeId);
		else
			addSelectionId(treeId, treeNodeId);
	}

	lastTreeNodeSelected = treeNodeId;

	var selectedIds = getSelectionIds(treeId);

	InvokeSelection("_select", selectedIds, controllerId, (extend ? "true" : "false"), path);
}

// Select tree nodes from beginIndex to endIndex
function selectTreeNodes(treeId, lastTreeNodeId, newTreeNodeId)
{
	var ie= (navigator.appName == "Microsoft Internet Explorer")?1:0;
	var tree = document.getElementById(treeId);
	var started = (lastTreeNodeId == "" ? true : false);
	var contentAll = tree.getElementsByTagName("TR");
	var length = contentAll.length;

	for (var i = 0; i < length; i++)
	{
		var divObject = contentAll[i];

		if ((divObject.id == lastTreeNodeId) || (divObject.id == newTreeNodeId))
		{
			started = !started;
			addSelectionId(treeId, divObject.id);
		}
		else if (started)
			addSelectionId(treeId, divObject.id);
	}
}

function EmptyFunction()
{
}

// Select a node.
function SelectTreeNode(treeNodeId, controllerId, path)
{
	InvokeSelection("_select", treeNodeId, controllerId, "false", path);
}

// Consult a node.
function ConsultTreeNode(nodeId, controllerId, treeId, path)
{
	InvokeAction(treeId, null, null, controllerId, nodeId, null);
}

// Change the expand state of a node
function ExpandTreeNode(nodeId, controllerId, path)
{
	InvokeAction(null, path, null, controllerId, nodeId, "expand");
}

// Change the color of a tree node
function SetTreeNodeColor(cellId, fontId, color, textColor)
{
	var frame = findTargetByContent(null, cellId);

	if (frame != null)
	{
		var tdObj = frame.document.getElementById(cellId);
		var fontObj = frame.document.getElementById(fontId);

		tdObj.style.backgroundColor = color;
		fontObj.style.color = textColor;
	}
}

// Called when a contextual menu is performed on a tree node
function InvokeTreeNodePopup(treeNodeId, htmlTreeId, treeId, controllerId, path, selectPath, event)
{
	if (!hasSelectionId(htmlTreeId, treeNodeId))
	{
		SelectTreeNode(treeNodeId, controllerId, selectPath);

		setTimeout("InvokePopup('" + treeId + "','" + ReplaceString(treeNodeId,"\\","\\\\") +
			"','" + path + "','" + controllerId + "',false," +
			event.clientX + "," + event.clientY + ")", 300);
	}
	else
		InvokePopup(treeId, treeNodeId, path, controllerId, false, event.clientX, event.clientY);
}
// LyUtilsScript.js
// Copyright (c) 2000-2009, Lyria-W4.
// All rights reserved.
// @version	$Id:

var mainFrameName = 'main_frame';
var targetFrameName = 'target_frame';
var ajaxControllerId;
var ajaxParam = '_ajax';
var questionAnswered = false;
var parentFrame = null;

// Array of characters that must be encoded in Ajax requests.
// Do not use escape method for the whole parameters string because it
// does not work with multiple relations.
// Special case for '+' character (not managed by the escape method).
var ajaxChars = new Array("%", "&", "=", "+");
var ajaxEncodedChars = new Array(escape("%"), escape("&"), escape("="), "%2B");


/**********************************************
 *     Management of components selection     *
 **********************************************/

var selectionIds = new Array();

// Adds an id to the list of selected elements for given component
function addSelectionId(componentId, selectionId)
{
	if (selectionId == "")
		return;

	var frame = findTargetByContent(null, componentId);

	if ((frame != null) && (frame != this))
	{
		frame.addSelectionId(componentId, selectionId);
		return;
	}

	var oldSelection = selectionIds[componentId];

	if ((typeof oldSelection == "undefined") || (oldSelection == null))
		oldSelection = new Array();

	var contains = false;

	for (var i = 0; i < oldSelection.length; i++)
	{
		if (oldSelection[i] == selectionId)
		{
			contains = true;
			break;
		}
	}

	if (!contains)
	{
		oldSelection[oldSelection.length] = selectionId;
		selectionIds[componentId] = oldSelection;
	}
}

// Removes an id from the list of selected elements for given component
function removeSelectionId(componentId, selectionId)
{
	if (selectionId == "")
		return;

	var frame = findTargetByContent(null, componentId);

	if ((frame != null) && (frame != this))
	{
		frame.removeSelectionId(componentId, selectionId);
		return;
	}

	var oldSelection = selectionIds[componentId];

	if ((typeof oldSelection != "undefined") && (oldSelection != null))
	{
		for (var i = 0; i < oldSelection.length; i++)
		{
			if (oldSelection[i] == selectionId)
			{
				oldSelection[i] = "";
				selectionIds[componentId] = oldSelection;
				break;
			}
		}
	}
}

// Clear the list of selected elements for given component
function clearSelectionIds(componentId)
{
	var frame = findTargetByContent(null, componentId);

	if ((frame != null) && (frame != this))
	{
		frame.clearSelectionIds(componentId);
		return;
	}

	selectionIds[componentId] = null;
}

// Indicates whether id is selected for given component
function hasSelectionId(componentId, selectionId)
{
	if (selectionId == "")
		return false;

	var frame = findTargetByContent(null, componentId);

	if ((frame != null) && (frame != this))
	{
		return frame.hasSelectionId(componentId);
	}

	var selection = selectionIds[componentId];

	if ((typeof selection != "undefined") && (selection != null))
	{
		for (var i = 0; i < selection.length; i++)
		{
			if (selection[i] == selectionId)
				return true;
		}
	}

	return false;
}

// Gets the list of selected ids for given component
function getSelectionIds(componentId)
{
	var frame = findTargetByContent(null, componentId);

	if ((frame != null) && (frame != this))
	{
		return frame.getSelectionIds(componentId);
	}

	var selection = selectionIds[componentId];
	var result = "";

	if ((typeof selection != "undefined") && (selection != null))
	{
		for (var i = 0; i < selection.length; i++)
		{
			if (selection[i] != "")
			{
				// Use the same separator as used in the getDemand() method in
				// LyStrutsSelectionEventAction.java
				if (result.length > 0)
					result += "__|__";

				result += selection[i];
			}
		}
	}

	return result;
}


/*********************************************
 *     Popup position, size and movement     *
 *********************************************/

var upFrameName = 'up_frame';
var popupFrameName = 'popup_view';
var popupDivName = 'popup_view_div';
var popupTableName = 'popup_view_table';
var popupTdName = 'popup_view_td';
var popupMovingDivName = 'popup_moving_div';
var popupShadowDivName = 'popup_view_shadow';
var modalDivName = 'popup_modal_div';
var waitDivShadowName = 'wait_window_shadow';
var waitDivPanelName = 'wait_window_panel';
var popupViewShown = true;
var popupDefaultLeftOffset = 200;
var popupDefaultTopOffset = 35;
var popupLeftOffset = popupDefaultLeftOffset;
var popupTopOffset = popupDefaultTopOffset;
var popupShadowOffset = 5;
var popupObj = null;
var popupShadowObj = null;
var popupTd = null;
var popupXPos = null;
var popupYPos = null;
var popupWidth = -1;
var popupHeight = -1;
var popupMoving = false;
var popupHadVerticalScrollbar = false;

// Starts the movement of the popup view
function startMovePopup(evt, movedName, movedShadowName, movedTd)
{
	var popupView = findTargetByContent(null, movedName);

	if (popupView == null)
		return;

	var popupViewDivId = movedName;
	var popupShadowViewId = movedShadowName;

	popupObj = popupView.document.getElementById ? popupView.document.getElementById(popupViewDivId) : popupView.document.all.popupViewDivId;
	popupShadowObj = popupView.document.getElementById ? popupView.document.getElementById(popupShadowViewId) : popupView.document.all.popupShadowViewId;
	popupTd = popupView.document.getElementById ? popupView.document.getElementById(movedTd) : popupView.document.all.movedTd;

	setMovingDivSize(false);
}

function setMovingDivSize(full)
{
	var topFrame = getLeonardiTopFrame();
	var popupMovingDiv = topFrame.document.getElementById(popupMovingDivName);

	if (popupMovingDiv == null)
		return;

	if (full)
	{
		popupMovingDiv.style.width = topFrame.document.body.clientWidth;
		popupMovingDiv.style.height = topFrame.document.body.clientHeight;
		popupMovingDiv.style.left = 0;
		popupMovingDiv.style.top = 0;
	}
	else
	{
		popupMovingDiv.style.width = cmGetWidth(popupTd) - (-1);
		popupMovingDiv.style.height = cmGetHeight(popupTd) - (-1);
		popupMovingDiv.style.left = cmGetX(popupTd);
		popupMovingDiv.style.top = cmGetY(popupTd);
		popupMovingDiv.style.visibility = "visible";
	}
}

function startPopupMoving(evt)
{
	setMovingDivSize(true);
	popupMoving = true;

	// Filter seems to change font aspect on IE7
//	if (popupObj != null)
//	{
//		popupObj.style.filter = "alpha(opacity=75)";
//		popupObj.style.MozOpacity  = 0.75;
//	}

//	if (popupShadowObj != null)
//		popupShadowObj.style.visibility = "hidden";
}

// Implements the movement of the popup view
function movePopup(evt)
{
	if (!popupMoving)
	{
		popupXPos = evt.clientX;
		popupYPos = evt.clientY;

		return;
	}

	if (document.getElementById && !(document.all))
	{
		// Firefox
		// Nothing to do
	}
	else if(document.all)
	{
		// IE
		evt = event;
	}

	if (popupXPos == null)
	{
		popupXPos = evt.clientX;
		popupYPos = evt.clientY;
	}

	var diffX = evt.clientX - popupXPos;
	var diffY = evt.clientY - popupYPos;

	var newX = parseInt(popupObj.style.left) + diffX;
	var newY = parseInt(popupObj.style.top) + diffY;

	popupXPos = evt.clientX;
	popupYPos = evt.clientY;

	if (newX <= (-0.90*parseInt(popupObj.style.width)))
		newX = -0.90*parseInt(popupObj.style.width);

	if (newY <= 0)
		newY = 0;

	if (parentFrame == null)
		parentFrame = getLeonardiTopFrame();

	if (parentFrame != null)
	{
		if (newY > (parseInt(parentFrame.document.body.clientHeight)*0.9) )
			newY = (parseInt(parentFrame.document.body.clientHeight)*0.9);

		if (newX > (parseInt(parentFrame.document.body.clientWidth)*0.9) )
			newX = (parseInt(parentFrame.document.body.clientWidth)*0.9);
	}

	popupObj.style.left = newX + "px";
	popupObj.style.top = newY + "px";

	if (popupShadowObj != null)
	{
		popupShadowObj.style.left = newX - (-popupShadowOffset) + "px";
		popupShadowObj.style.top = newY - (-popupShadowOffset) + "px";
	}
}

// Stops the movement of the popup view
function endPopupMoving(evt)
{
//	if (popupObj != null)
//	{
//		popupObj.style.filter = "alpha(opacity=100)";
//		popupObj.style.MozOpacity  = 1;
//	}

//	if (popupShadowObj != null)
//		popupShadowObj.style.visibility = "visible";

	setMovingDivSize(false);
	popupMoving = false;
}

// Show or hides the popup view
function ShowPopupView(show, title, path)
{
	popupViewShown = show;

	var topFrame = getLeonardiTopFrame();
	var parentIframes = topFrame.document.getElementsByTagName('iframe');
	var popupFrame = topFrame.frames[popupFrameName];
	var popupIFrame = parentIframes[popupFrameName];
	var popupShadowDiv = topFrame.document.getElementById(popupShadowDivName);
	var modalDiv = topFrame.document.getElementById(modalDivName);
	var popupDiv = topFrame.document.getElementById(popupDivName);
	var popupTable = topFrame.document.getElementById(popupTableName);
	var popupTd = topFrame.document.getElementById(popupTdName);

	if ((popupIFrame == null) || ((typeof popupIFrame) == "undefined"))
		return;

	if (popupIFrame.style.visibility != "visible")
	{
		popupIFrame.style.width = 80;
		popupIFrame.style.height = 40;
		popupDiv.style.width = 80;
		popupTable.width = 80;
		popupShadowDiv.style.width = 80;
		popupShadowDiv.style.height = 40;
	}

	// Change popup title
	if ((typeof title) != "undefined")
		popupTd.innerHTML = title;

	if (show)
	{
		// Reload the content of the popup view. Do not use the reload() function as it may
		// retrieve page from the cache with old data.
		popupFrame.document.location.replace(path);
	}

	if (!show)
	{
		// Hiding the popup view may change focus on a field and send a FieldChange event.
		// The matter is that the Ajax response for this FieldChange will never reach the client since
		// the IFrame has been closed. It will result in an infinite waiting popup...
		var setFieldChangeVar = (popupIFrame.style.visibility == "visible");

		if (setFieldChangeVar)
			sendFieldChange = false;

		popupDiv.style.visibility = "hidden";
		popupIFrame.style.visibility = "hidden";
		popupTable.style.visibility = "hidden";
		popupShadowDiv.style.visibility = "hidden";

		if (setFieldChangeVar)
			setTimeout("sendFieldChange = true", 300);

		if (modalDiv != null)
			modalDiv.style.visibility = "hidden";

		popupDiv.style.left = popupDefaultLeftOffset;
		popupDiv.style.top = popupDefaultTopOffset;
		popupShadowDiv.style.left = popupDefaultLeftOffset - (-popupShadowOffset);
		popupShadowDiv.style.top = popupDefaultTopOffset - (-popupShadowOffset);
	}
	else if ((popupLeftOffset != popupDefaultLeftOffset) || (popupTopOffset != popupDefaultTopOffset))
	{
		// If popupLeftOffset or popupTopOffset has been changed, use these new values
		// (may happen when using the popup frame from contextual event)
		popupDiv.style.left = popupLeftOffset;
		popupDiv.style.top = popupTopOffset;
		popupShadowDiv.style.left = popupLeftOffset - (-popupShadowOffset);
		popupShadowDiv.style.top = popupTopOffset - (-popupShadowOffset);
		popupLeftOffset = popupDefaultLeftOffset;
		popupTopOffset = popupDefaultTopOffset;
	}
}

// Sets the size of the popup
function setPopupDimension(width, height)
{
	var topFrame = getLeonardiTopFrame();

	topFrame.popupWidth = width;
	topFrame.popupHeight = height;
}

// Check the size of the popup view
function checkSizePopupView(currentWin, resetSize, noDecoration, title, modal, center)
{
	var topFrame = getLeonardiTopFrame();
	var parentIframes = topFrame.document.getElementsByTagName('iframe');
	var popupFrame = topFrame.frames[popupFrameName];
	var popupIFrame = parentIframes[popupFrameName];
	var popupDiv = topFrame.document.getElementById(popupDivName);
	var popupTable = topFrame.document.getElementById(popupTableName);
	var popupShadowDiv = topFrame.document.getElementById(popupShadowDivName);
	var modalDiv = topFrame.document.getElementById(modalDivName);
	var popupTd = topFrame.document.getElementById(popupTdName);
	var d;

	if (resetSize)
	{
		popupIFrame.style.width = 80;
		popupIFrame.style.height = 40;
		popupDiv.style.width = 80;
		popupTable.width = 80;
		popupShadowDiv.style.width = 80;
		popupShadowDiv.style.height = 40;
	}
	else if (popupHadVerticalScrollbar)
	{
		var frameOldWidth = popupIFrame.style.width.replace("px", "");
		var tableOldWidth = popupTable.width.replace("px", "");

		popupIFrame.style.width = frameOldWidth - 17;
		popupDiv.style.width = 80;
		popupTable.width = tableOldWidth - 17;
	}

	if (document.getElementById && !(document.all))
		d = popupIFrame.contentDocument;
	else
		d = popupFrame.document;

	// Change popup title
	if ((typeof title) != "undefined")
		popupTd.innerHTML = title;

	var totalWidth = topFrame.document.body.clientWidth;
	var totalHeight = topFrame.document.body.clientHeight;
	var width = d.body.scrollWidth;
	var height = d.body.scrollHeight;
	var fullWidth = true;
	var fullHeight = true;
	var xPos = popupDiv.style.left;
	var yPos = popupDiv.style.top;
	var titleWidth = cmGetWidth(popupTable);

	if (topFrame.popupWidth > 0)
		width = topFrame.popupWidth;

	if (topFrame.popupHeight > 0)
		height = topFrame.popupHeight - cmGetHeight(popupTable);

	xPos = xPos.replace("px", "");
	yPos = yPos.replace("px", "");

	if (titleWidth > width + 2)
		width = titleWidth - 2;

	if (width > totalWidth - xPos - 10)
	{
		if (noDecoration)
			popupDiv.style.left = xPos - (width - totalWidth - (-xPos) - (-10));
		else
		{
			width = totalWidth - xPos - 30;
			fullWidth = false;
		}
	}

	if (height > totalHeight - yPos - 2 * popupShadowOffset - cmGetHeight(popupTable))
	{
		if (noDecoration)
			popupDiv.style.top = yPos - (height - totalHeight - (-yPos) - (-cmGetHeight(popupTable)));
		else
		{
			height = totalHeight - yPos - 2 * popupShadowOffset - cmGetHeight(popupTable);
			fullHeight = false;
		}
	}

	popupHadVerticalScrollbar = false;

	if (fullWidth && !fullHeight)
	{
		// If there is not enough space for height, add 20 pixels to avoid
		// a useless horizontal scrollbar.
		width += 17;
		popupHadVerticalScrollbar = true;
	}
	else if (!fullWidth && fullHeight)
		// If there is not enough space for width, add 20 pixels to avoid
		// a useless horizontal scrollbar.
		height += 17;

	popupIFrame.style.width = width;
	popupIFrame.style.height = height;
	popupTable.width = width - (-2);
	popupShadowDiv.style.width = width - (-2);
	popupShadowDiv.style.height = cmGetHeight(popupDiv);

	if (center)
	{
		if (topFrame.popupWidth <= 0)
			width = d.body.scrollWidth;

		if (topFrame.popupHeight <= 0)
			height = d.body.scrollHeight;

		if (width > totalWidth - 10)
			width = totalWidth - 20;

		if (height > totalHeight - 10)
			height = totalHeight - 20;

		popupDiv.style.left = (totalWidth - width) / 2;
		popupDiv.style.top = (totalHeight - height) / 2;
		popupShadowDiv.style.left = (totalWidth - width) / 2 - (-popupShadowOffset);
		popupShadowDiv.style.top = (totalHeight - height) / 2 - (-popupShadowOffset);

		checkSizePopupView(currentWin, resetSize, noDecoration, title, modal, false);
		return;
	}

	if (modalDiv != null)
	{
		if (typeof modal != "undefined")
		{
			modalDiv.style.visibility = (modal ? "visible" : "hidden");

			if (modal)
				ShowPopupModalDiv(true);
		}
	}

	if (popupViewShown)
	{
		if (((typeof noDecoration) != "undefined") && noDecoration)
		{
			// If popup has no decoration, place it at the right place (remove title height)
			popupDiv.style.top = cmGetY(popupDiv) - cmGetHeight(popupTable);
			popupShadowDiv.style.top = cmGetY(popupShadowDiv) - cmGetHeight(popupTable);
		}

		popupDiv.style.visibility = "visible";
		popupIFrame.style.visibility = "visible";
		popupTable.style.visibility = (noDecoration ? "hidden" : "visible");
		popupShadowDiv.style.visibility = (noDecoration ? "hidden" : "visible");
	}

	// On IE, sometimes one pixel is missing and scrollbars may appear.
	if ((!document.getElementById || document.all) && (d.body.scrollWidth > d.body.clientWidth))
	{
		popupIFrame.style.width = width - (-1);
		popupTable.width = width - (-3);
		popupShadowDiv.style.width = width - (-3);
	}

	checkSizeMainView('true', 'false');
}

// Checks the size of the popup modal div
function ShowPopupModalDiv(force)
{
	var topFrame = getLeonardiTopFrame();
	var modalDiv = topFrame.document.getElementById(modalDivName);

	if ((modalDiv != null)
		&& (force || (modalDiv.style.visibility == "visible")))
	{
		var totalWidth = topFrame.document.body.clientWidth;
		var totalHeight = topFrame.document.body.clientHeight;

		modalDiv.style.width = totalWidth;
		modalDiv.style.height = totalHeight;
		modalDiv.style.left = 0;
		modalDiv.style.top = 0;
	}
}


/***********************************
 *     Miscellaneous functions     *
 ***********************************/

// Id of the last div shown
var _lastDivShownId = null;

// This function switches the visibility of a div
function SwitchDivVisibility(divId)
{
	if (!document.all && !document.getElementById)
		return;

	var parentFrame = findTargetByContent(null, divId);

	if (parentFrame == null)
		return;

	var divObj = parentFrame.document.getElementById ? parentFrame.document.getElementById(divId) : parentFrame.document.all.divId;

	if (divObj.style.visibility == "visible")
		divObj.style.visibility = "hidden";
	else
	{
		divObj.style.visibility = "visible";
		_lastDivShownId = divId;
		setTimeout("document.onclick = CloseLastDivShown", 100);
	}
}

// This function switches the display of an expand bar
function SwitchExpandBar(divId, switchImgId, hideImgPath, showImgPath, pageWriterId, toolbarId, target)
{
	if (!document.all && !document.getElementById)
		return;

	var parentFrame = findTargetByContent(null, divId);

	if (parentFrame == null)
		return;

	var divObj = parentFrame.document.getElementById ? parentFrame.document.getElementById(divId) : parentFrame.document.all.divId;
	var imgObj = parentFrame.document.getElementById ? parentFrame.document.getElementById(switchImgId) : parentFrame.document.all.switchImgId;
	var opened = (divObj.style.display == "none");

	if (opened)
	{
		divObj.style.display = "block";
		imgObj.src = hideImgPath;
	}
	else
	{
		divObj.style.display = "none";
		imgObj.src = showImgPath;
	}

	var params = pageParam + '=' + pageWriterId + '&' + sourceParam + '=switchToolbarState' +
		'&' + valueParam + '=' + toolbarId;

	if ((typeof target != "undefined") && (target != null) && (target != "null"))
		params += "&target_session=" + target;

	SendAjaxRequestParams(_rootUrl + STRUTS_EVENT_URL, params);
}

// This function closes the latest div that was shown
function CloseLastDivShown()
{
	document.onclick = null;

	if (_lastDivShownId != null)
		setTimeout("SetDivVisibility('" + _lastDivShownId + "', false)", 100);

	_lastDivShownId = null;
}

// This function sets the width and height of a div
function SetDivSize(divId, width, height)
{
	if (!document.all && !document.getElementById)
		return;

	var parentFrame = findTargetByContent(null, divId);

	if (parentFrame == null)
		return;

	var divObj = parentFrame.document.getElementById ? parentFrame.document.getElementById(divId) : parentFrame.document.all.divId;

	if (width >= 0)
		divObj.style.width = width;

	if (height >= 0)
		divObj.style.height = height;
}

// This function sets the left and top positions of a div
function SetDivPosition(divId, left, top)
{
	if (!document.all && !document.getElementById)
		return;

	var parentFrame = findTargetByContent(null, divId);

	if (parentFrame == null)
		return;

	var parentHScroll = parentFrame.document.body.scrollLeft;
	var parentVScroll = parentFrame.document.body.scrollTop;

	var divObj = parentFrame.document.getElementById ? parentFrame.document.getElementById(divId) : parentFrame.document.all.divId;

	divObj.style.left = left + parentHScroll;
	divObj.style.top = top + parentVScroll;
}

// Returns the position of an object
function GetObjectPosition(object)
{
	if (object.style.overflow == "auto")
		return new Array(0, 0);

	if (object.offsetParent)
	{
		var parentResult = GetObjectPosition(object.offsetParent);

		return new Array(object.offsetLeft + parentResult[0], object.offsetTop + parentResult[1]);
	}
	else
		return new Array(object.offsetLeft, object.offsetTop);
}

// This function sets the position of a div relatively to a given anchor object
function SetDivAnchor(divId, parentObjectId)
{
	if (!document.all && !document.getElementById)
		return;

	var parentFrame = findTargetByContent(null, divId);

	if (parentFrame == null)
		return;

	var divObj = parentFrame.document.getElementById ? parentFrame.document.getElementById(divId) : parentFrame.document.all.divId;
	var anchorObj = parentFrame.document.getElementById ? parentFrame.document.getElementById(parentObjectId) : parentFrame.document.all.parentObjectId;
	var anchorPos = GetObjectPosition(anchorObj);

	divObj.style.left = anchorPos[0];

	// Check if object is visible
	var totalWidth = document.body.clientWidth;
	var maxX = (cmGetX(divObj) - (-cmGetWidth(divObj)));

	if (maxX > totalWidth)
	{
		var leftPos = anchorPos[0] - cmGetWidth(divObj) - (-cmGetWidth(anchorObj));

		if (leftPos < 0)
			leftPos = 0;

		divObj.style.left = leftPos;
	}

	if (typeof anchorObj.height != "undefined" && anchorObj.height != "")
		divObj.style.top = anchorPos[1] + anchorObj.height;
	else
		divObj.style.top = anchorPos[1] + anchorObj.offsetHeight;
}

// This function shows or hides a div
function SetDivVisibility(divId, show)
{
	if (!document.all && !document.getElementById)
		return;

	var parentFrame = findTargetByContent(null, divId);

	if (parentFrame == null)
		return;

	var divObj = parentFrame.document.getElementById ? parentFrame.document.getElementById(divId) : parentFrame.document.all.divId;

	if (show)
		divObj.style.visibility = "visible";
	else
		divObj.style.visibility = "hidden";
}

// This function change the source of an iframe
function SetFrameSrc(frameId, url)
{
	var frame = findTarget(null, frameId, null);

	if (frame == null)
		return;

	frame.location.replace(url);
}

// This function checks the minimum width of a component
function CheckComponentMinWidth(compId, minWidth)
{
	CheckComponentMinMaxWidth(compId, minWidth, -1, null);
}

// This function checks the minimum and maximum width of a component
function CheckComponentMinMaxWidth(compId, minWidth, maxWidth, otherCompId)
{
	var parentFrame = findTargetByContent(null, compId);

	if (parentFrame == null)
		return;

	var comp = parentFrame.document.getElementById(compId);

	var compWidth = ComputeComponentWidth(compId, minWidth, maxWidth);
	var otherCompWidth = ComputeComponentWidth(otherCompId, minWidth, maxWidth);

	compWidth = Math.max(compWidth, otherCompWidth);

	if (compWidth > 0)
	{
		comp.style.width = compWidth;

		if ((typeof otherCompId != "undefined") && (otherCompId != null))
		{
			var otherComp = parentFrame.document.getElementById(otherCompId);

			otherComp.style.width = compWidth;
		}
	}
}

// This function computes the width of a component according to the given min and max width values
function ComputeComponentWidth(compId, minWidth, maxWidth)
{
	if ((typeof compId == "undefined") || (compId == null))
		return -1;

	var parentFrame = findTargetByContent(null, compId);

	if (parentFrame == null)
		return - 1;

	var comp = parentFrame.document.getElementById(compId);
	var compWidth = cmGetWidth(comp);
	var newWidth = compWidth;

	if ((minWidth > 0) && (compWidth <= minWidth + 2))
		newWidth = minWidth;

	if ((maxWidth > 0) && (compWidth > maxWidth - 2))
		newWidth = maxWidth;

	return newWidth;
}

var lastResizeTime = -1;

// This function checks the size of each splitter component trying to give them the size
// of their parent container (using the splitterIds var).
function checkSizeMainView(recurse, isResizing)
{
	var topFrame = getLeonardiTopFrame();

	if (topFrame != this)
	{
		topFrame.checkSizeMainView(recurse, isResizing);
		return;
	}

	if (document.getElementById && !(document.all))
	{
		// Nothing to do for Firefox
	}
	else if (document.all)
	{
		// IE needs another update at the end of a resize
		var date = (new Date().getTime());

		if (typeof recurse == "undefined" || recurse == 'true')
		{
			lastResizeTime = date;
			setTimeout("checkSizeMainView('false', '" + isResizing + "')", 200);
		}
		else if (recurse == 'false')
		{
			if (lastResizeTime > 0 && date - lastResizeTime > 300)
			{
				checkSizeMainView('stop', isResizing);
				return;
			}

			setTimeout("checkSizeMainView('false', '" + isResizing + "')", 200);
			return;
		}
		else
		{
			lastResizeTime = -1;
		}
	}

	if (document.all && (recurse == 'true'))
	{
		// On IE, when the horizontal scrollbar is displayed, main frame table with a 100% height
		// makes the vertical scrollbar appear. To avoid this, compute the main table height
		// from its frame height.
		var mainFrameFullHeightTableId = 'mainFrameFullHeightTable';
		var topFrame = findTargetByContent(null, mainFrameFullHeightTableId);

		if (topFrame != null)
		{
			var topTable = topFrame.document.getElementById(mainFrameFullHeightTableId);

			topTable.style.height = topFrame.document.body.clientHeight;
		}
	}

	for (var i = 0; i < splitterIds.length; i++)
	{
		var vars = splitterIds[i];
		var vertical = vars[0];
		var parentId = vars[1];
		var parentFrame = findTargetByContent(null, parentId);

		if (parentFrame == null)
			continue;

		var firstPartId = vars[2];
		var secondPartId = vars[3];
		var firstPartSize = vars[4];
		var setToAuto = vars[5];
		var parentDiv = parentFrame.document.getElementById(parentId);
		var firstDiv = parentFrame.document.getElementById(firstPartId);
		var secondDiv = parentFrame.document.getElementById(secondPartId);

		if ((parentDiv == null) || (typeof parentDiv == "undefined")
			|| (firstDiv == null) || (typeof firstDiv == "undefined")
		 	|| (((secondDiv == null) || (typeof secondDiv == "undefined")) && (secondPartId != '')))
			continue;

		if (isResizing == 'true')
		{
			var parentHeight = getSplitterHeight(parentDiv);

			firstDiv.style.height = "50px";

			if (secondDiv != null)
				secondDiv.style.height = "50px";
		}

		if (!vertical)
		{
			firstDiv.style.width = "50px";

			if (secondDiv != null)
				secondDiv.style.width = "50px";
		}

		// Prevent parent from displaying scrollbars
		parentDiv.style.overflow = "hidden";

		var parentWidth = getSplitterWidth(parentDiv);
		var parentHeight = getSplitterHeight(parentDiv);

		var borderOffset = 0;
		var parentDivComputedStyle = null;

		if (document.getElementById && !(document.all))
			parentDivComputedStyle = window.getComputedStyle(parentDiv, null);
		else
			parentDivComputedStyle = parentDiv.currentStyle;

		if ((parentDivComputedStyle != null) && (typeof parentDivComputedStyle != "undefined"))
		{
			if (vertical)
			{
				var topWidth = parentDivComputedStyle.borderTopWidth.replace("px", "");
				var bottomWidth = parentDivComputedStyle.borderBottomWidth.replace("px", "");
				var paddingBottom = parentDivComputedStyle.paddingBottom.replace("px", "");

				topWidth = parseInt(topWidth);
				bottomWidth = parseInt(bottomWidth);
				paddingBottom = parseInt(paddingBottom);

				if (!isNaN(topWidth))
					borderOffset = borderOffset - (-topWidth);

				if (!isNaN(bottomWidth))
					borderOffset = borderOffset - (-bottomWidth);

				if (!isNaN(paddingBottom))
					borderOffset = borderOffset - (-paddingBottom);
			}
			else
			{
				var leftWidth = parentDivComputedStyle.borderLeftWidth.replace("px", "");
				var rightWidth = parentDivComputedStyle.borderRightWidth.replace("px", "");
				var paddingRight = parentDivComputedStyle.paddingRight.replace("px", "");

				leftWidth = parseInt(leftWidth);
				rightWidth = parseInt(rightWidth);
				paddingRight = parseInt(paddingRight);

				if (!isNaN(leftWidth))
					borderOffset = borderOffset - (-leftWidth);

				if (!isNaN(rightWidth))
					borderOffset = borderOffset - (-rightWidth);

				if (!isNaN(paddingRight))
					borderOffset = borderOffset - (-paddingRight);
			}
		}

		if (vertical)
			parentHeight = parentHeight - cmGetYAt(firstDiv, parentDiv) - borderOffset - 8;
		else
			parentWidth = parentWidth - cmGetXAt(firstDiv, parentDiv) - borderOffset - 8;

		if (firstPartSize == 'full')
		{
			firstDiv.style.height = parentHeight;
			firstDiv.style.width = parentWidth;
			continue;
		}

		if (firstPartSize == 'fullWidth')
		{
			firstDiv.style.width = parentWidth;
			continue;
		}

		if (firstPartSize == 'fullHeight')
		{
			firstDiv.style.height = parentHeight;
			continue;
		}

		var firstSize = '';
		var secondSize = '';

		if (vertical)
		{
			firstDiv.style.visibility = "visible";

			if (secondDiv != null)
				secondDiv.style.visibility = "visible";

			var offset = 0;

			firstDiv.style.width = parentWidth - cmGetXAt(firstDiv, parentDiv) - offset;

			if (secondDiv != null)
				secondDiv.style.width = parentWidth - cmGetXAt(secondDiv, parentDiv) - offset;

			var newParentWidth = getSplitterWidth(parentDiv);

			if (newParentWidth > parentWidth)
			{
				var oldWidth = firstDiv.style.width.replace("px", "");

				firstDiv.style.width = oldWidth - (newParentWidth - parentWidth);

				if (secondDiv != null)
					secondDiv.style.width = oldWidth - (newParentWidth - parentWidth);
			}

			if ((firstPartSize.indexOf('0%') == 0) || (firstPartSize == "0"))
			{
				firstDiv.style.visibility = "hidden";
				secondDiv.style.visibility = "visible";
				firstDiv.style.height = "1px";
				secondDiv.style.height = (parentHeight - 1) + "px";
				continue;
			}
			else if ((firstPartSize.indexOf('100%') == 0) || (firstPartSize == "100"))
			{
				firstDiv.style.visibility = "visible";
				secondDiv.style.visibility = "hidden";
				firstDiv.style.height = (parentHeight - 1) + "px";
				secondDiv.style.height = "1px";
				continue;
			}

			if (firstPartSize.indexOf('px') > 0)
			{
				firstSize = firstPartSize;
				secondSize = (parentHeight - firstPartSize.replace("px", "") - 1) + "px";
			}
			else if (firstPartSize == "-1" || firstPartSize == "*")
			{
				firstDiv.style.height = "";
				firstSize = getSplitterHeight(firstDiv) + "px";
				secondSize = (parentHeight - firstSize.replace("px", "") - 1) + "px";
			}
			else
			{
				firstSize = parseInt((parentHeight * firstPartSize) / 100);
				secondSize = (parentHeight - firstSize - 1) + "px";
				firstSize += "px";

				if (setToAuto)
				{
					firstDiv.style.overflow = "auto";

					if (secondDiv != null)
						secondDiv.style.overflow = "auto";
				}
			}

			if (firstSize.indexOf('-') == 0)
				firstSize = "50px";
			firstDiv.style.height = firstSize;


			if (secondSize.indexOf('-') == 0)
				secondSize = "50px";

			if (secondDiv != null)
				secondDiv.style.height = secondSize;
		}
		else
		{
			firstDiv.style.visibility = "visible";

			if (secondDiv != null)
				secondDiv.style.visibility = "visible";

			var offset = 0;

			firstDiv.style.height = parentHeight - cmGetYAt(firstDiv, parentDiv) - offset;

			if (secondDiv != null)
				secondDiv.style.height = parentHeight - cmGetYAt(secondDiv, parentDiv) - offset;

			var newParentHeight = getSplitterHeight(parentDiv);

			if (newParentHeight > parentHeight)
			{
				var oldHeight = firstDiv.style.height.replace("px", "");

				firstDiv.style.height = oldHeight - (newParentHeight - parentHeight);

				if (secondDiv != null)
					secondDiv.style.height = oldHeight - (newParentHeight - parentHeight);
			}

			if ((firstPartSize.indexOf('0%') == 0) || (firstPartSize == "0"))
			{
				firstDiv.style.visibility = "hidden";
				firstDiv.style.width = "1px";

				if (secondDiv != null)
				{
					secondDiv.style.visibility = "visible";
					secondDiv.style.width = (parentWidth - 1) + "px";
				}

				continue;
			}
			else if ((firstPartSize.indexOf('100%') == 0) || (firstPartSize == "100"))
			{
				var widthOffset = (document.all ? 0 : 2);

				firstDiv.style.visibility = "visible";
				firstDiv.style.width = (parentWidth - widthOffset - 1) + "px";

				if (secondDiv != null)
				{
					secondDiv.style.visibility = "hidden";
					secondDiv.style.width = "1px";
				}

				continue;
			}

			if (firstPartSize.indexOf('px') > 0)
			{
				firstSize = firstPartSize;
				secondSize = (parentWidth - firstPartSize.replace("px", "") - 1) + "px";
			}
			else if (firstPartSize == "-1" || firstPartSize == "*")
			{
				firstDiv.style.width = "";
				firstSize = cmGetWidth(firstDiv) + "px";
				secondSize = (parentWidth - firstSize.replace("px", "") - 1) + "px";
			}
			else
			{
				firstSize = parseInt((parentWidth * firstPartSize) / 100);
				secondSize = (parentWidth - firstSize - 1) + "px";
				firstSize += "px";

				if (setToAuto)
				{
					firstDiv.style.overflow = "auto";

					if (secondDiv != null)
						secondDiv.style.overflow = "auto";
				}
			}

			firstDiv.style.width = firstSize;

			if (secondDiv != null)
				secondDiv.style.width = secondSize;
		}
	}
}

// Returns the width of a splitter component
function getSplitterWidth(obj)
{
	var width = obj.offsetWidth;

	if (width > 0)
		return width;

	if (!obj.firstChild)
		return 0;

	return obj.firstChild.offsetWidth;
}

// Returns the height of a splitter component
function getSplitterHeight(obj)
{
	var height = obj.offsetHeight;

	if (height > 0)
		return height;

	if (!obj.firstChild)
		return 0;

	return obj.firstChild.offsetHeight;
}

// look all frame and try to find a matching name for a form
function findForm(currentFrame,controllerId,elementName)
{
	if (currentFrame == null)
	{
		// First, try to look into popup view
		var popup = findTarget(null, popupFrameName);

		if (popup != null)
		{
			var	result = findForm(popup,controllerId,elementName);

			if (result != null)
				return result;
		}
	}

	var currentForm;
	var i;
	var found = false;

	if (currentFrame == null)
		currentFrame = getLeonardiTopFrame();

	var Form;

	// To avoid a potential 'Access refused' from the navigator if a page from another server is displayed,
	// use a try / catch.
	try
	{
		// recurse into sub frame
		for (i = 0; i < currentFrame.frames.length; i++)
		{
			Form = findForm(currentFrame.frames[i], controllerId, elementName);
			if ( Form != null )
				return Form;
		}

		// in the current frame, search for the good form
		for (i = 0 ; i < currentFrame.document.forms.length; i++ )
		{
			found = false;
			currentForm = currentFrame.document.forms[i];
			if ( currentForm.elements["_controller"] != null)
			{
				if ((elementName != null) && (typeof currentForm.elements[elementName] != "undefined"))
					found = true;
				else if (((currentForm.elements["_controller"].value == controllerId)
						|| (controllerId == null))
					&& (currentForm.elements[sourceParam] != null))
					found = true;

				if (found)
				{
					currentForm.elements[frameParam].value = currentFrame.name;

					return currentForm;
				}
			}
		}
	}
	catch (ex)
	{
	}

	return null;
}

// Gives the focus to the first input of the first form found in current frame
function ResetFormFocus(selectText, timeout)
{
	if ((timeout == null) || (typeof timeout == "undefined"))
	{
		timeout = 200;

		// Firefox needs more time to ensure page has been entirely loaded before reseting focus.
		if (document.getElementById && !(document.all))
			timeout = 400;
	}

	setTimeout("ResetFormFocusImmediatly(" + selectText + ")", timeout);
}

// Gives the focus to the first input of the first form found in current frame
function ResetFormFocusImmediatly(selectText)
{
	var forms = this.document.forms;

	if ((forms != null) && (forms.length > 0))
	{
		var firstForm = forms[0];
		var formElements = firstForm.elements;

		if ((formElements != null) && (formElements.length > 0))
		{
			var i, n = formElements.length;

			for (i = 0; i < n; i++)
			{
				var formElement = formElements[i];
				var noAutomaticFocus = formElement.getAttribute("noAutomaticFocus");

				if ((formElement.type != "hidden")
					&& (formElement.type != "button")
					&& !formElement.disabled
					&& !formElement.readOnly
					&& (noAutomaticFocus != "true"))
				{
					// Use a try catch because the focus() method may launch an error
					try
					{
						formElement.focus();

						if (formElement.type == "text")
						{
							SetEndCaret(formElement, selectText);
						}

						var elementFocus = formElements[formElement.id + "_focus_hidden_input"];

						if ((typeof elementFocus != "undefined") && (elementFocus.type == "hidden"))
							elementFocus.value = "true";

						return;
					}
					catch (ex)
					{
					}
				}
			}
		}
	}
}

// Checks if focus must be given to a CKEditor component
function CheckCKEditorFocus(form, fieldName)
{
	var focusField = form.elements[fieldName + "_focus_hidden_input"];

	if ((typeof focusField != "undefined") && (focusField.type == "hidden") && (focusField.value == "true"))
		CKEDITOR.instances[fieldName].focus();
}

// Gives the focus to a given field in a given form
function ForceFocus(formName, fieldId, selectText)
{
	var form = findForm(null, formName, fieldId);

	if (form == null)
		return;

	var field = form.elements[fieldId];

	if ((typeof field != "undefined")
		&& (field.type != "hidden")
		&& (field.type != "button")
		&& !field.disabled
		&& !field.readOnly)
	{
		// Use a try catch because the focus() method may launch an error
		try
		{
			field.focus();
		}
		catch (ex)
		{
		}

		if (field.type == "text")
		{
			SetEndCaret(field, selectText);
		}
	}
}

// Sets the caret at the end of an input of type text
function SetEndCaret(textInput, selectText)
{
	var caretStart = textInput.value.length;
	var caretEnd = textInput.value.length;

	textInput.focus();

	if (selectText)
	{
		textInput.select();
		return;
	}

	// IE support
	if (document.selection)
	{
		var oSel = document.selection.createRange();

		oSel.moveStart ('character', -textInput.value.length);
		oSel.moveEnd ('character', -textInput.value.length);

		if (caretEnd != null)
			oSel.moveEnd('character', caretEnd);
		else
			oSel.moveEnd('character', caretStart);

		oSel.moveStart('character', caretStart);
		oSel.select();
	}
	// Firefox support
	else if (textInput.selectionStart || textInput.selectionStart == '0')
	{
		textInput.selectionStart = caretStart;

		if (caretEnd != null)
			textInput.selectionEnd = caretEnd;
		else
			textInput.selectionEnd = caretStart;
	}
}

// Indicates if a Leonardi main frame is contained in the window
function hasLeonardiMainFrame()
{
	var parentFrame = this;

	while ((parentFrame != null) && (typeof parentFrame != "undefined") && (parentFrame != top))
	{
		if (parentFrame.name == targetFrameName || parentFrame.name == popupFrameName)
			return true;

		if ((parentFrame.frames != null)
				&& (parentFrame.frames.length > 0)
				&& (parentFrame.frames[targetFrameName] != null))
			return true;

		parentFrame = parentFrame.parent;
	}

	if ((parentFrame != null)
			&& (parentFrame.frames != null)
			&& (parentFrame.frames.length > 0)
			&& (parentFrame.frames[targetFrameName] != null))
		return true;

	return false;
}

// Returns the Leonardi application top frame
function getLeonardiTopFrame()
{
	// _topFrame variable may have been set
	if ((typeof _topFrame != "undefined") && (_topFrame != null))
		return _topFrame;

	var parentFrame = this;
	var loop = 0;

	for (var loop = 0; (loop < 10) && (parentFrame != null) && (typeof parentFrame != "undefined") && (parentFrame != top); loop++)
	{
		// If target frame was found, return its parent
		if (parentFrame.name == targetFrameName || parentFrame.name == popupFrameName)
			return parentFrame.parent;

		if ((parentFrame.frames != null)
				&& (parentFrame.frames.length > 0)
				&& (parentFrame.frames[targetFrameName] != null))
			return parentFrame;

		loop++;
		parentFrame = parentFrame.parent;
	}

	return top;
}

// Returns the Leonardi application target frame
function getLeonardiTargetFrame()
{
	var topFrame = getLeonardiTopFrame();

	return topFrame.frames[targetFrameName];
}

// look all frame and try to find a matching name
function findTarget(currentWindow, name, pageWriterId)
{
	var i;
	var retour;

	if (currentWindow == null)
	{
		var topFrame = getLeonardiTopFrame();

		if (name == 'top_frame')
			return topFrame; // Got it
		currentWindow = topFrame;
	}

	// TEMPORARY FIX for consult multiple objects ans using "next" button.
	if ((pageWriterId == popupFrameName) || ((pageWriterId != null) && endsWith2(pageWriterId, '_specific_frame')))
		pageWriterId = null;

	// To avoid a potential 'Access refused' from the navigator if a page from another server is displayed,
	// use a try / catch.
	try
	{
		if (currentWindow == null || currentWindow.name == name)
		{
			return currentWindow;
		}

		for (i= 0; i<currentWindow.frames.length; i++)
		{
			retour = findTarget(currentWindow.frames[i], name, pageWriterId);

			if (retour != null)
			{
				if ((pageWriterId != null) && ((typeof retour.pageWriterId) != "undefined") && (retour.pageWriterId != pageWriterId))
				{
					return null;
				}
				return retour;
			}
		}
	}
	catch (ex)
	{
	}

	return null;
}

// look all frames and try one containing specified element
function findTargetByContent(currentWindow, contentId)
{
	var i;
	var retour;

	if (currentWindow == null)
	{
		currentWindow = getLeonardiTopFrame();
	}

	// To avoid a potential 'Access refused' from the navigator if a page from another server is displayed,
	// use a try / catch.
	try
	{
		var obj = currentWindow.document.getElementById?  currentWindow.document.getElementById(contentId) : currentWindow.document.all.contentId;

		if ((typeof (obj) != "undefined") && (obj != null))
			return currentWindow; // FOUND

		for (i= 0; i<currentWindow.frames.length; i++)
		{
			retour = findTargetByContent(currentWindow.frames[i], contentId);

			if (retour != null)
				return retour;
		}
	}
	catch (ex)
	{
	}

	return null;
}

// this function load the url in the parent of MAIN_FRAME
function loadUrlPage(url)
{
	var targetFrame = findTarget(null,targetFrameName);

	if (targetFrame != null)
	{
		if (targetFrame.parent != "undefined")
			targetFrame.parent.location.replace(url); // was location=
		else
			getLeonardiTopFrame().window.location.replace(url);// was location=
	}
	else
		this.location.replace(url);// was location=
}

function endsWith2(source, pattern)
{
	n = pattern.length;
	m = source.length;

	temp = source.substring(m-n);

	if (temp == pattern)
		return true;
	else
		return false;
}

// Used to replace the HTML content of a DIV tag such as a menu, a tool or a message
// Used in DHTML only
function replaceDivInnerHtml(frameId, divId, newInnerHTML)
{
	var frame;

	if (this.name == frameId)
		frame = this;
	else
		frame = findTarget(null, frameId, null);

	if (frame != null)
	{
		var divObj = frame.document.getElementById(divId)

		if (divObj != null)
		{
			if (typeof(this.ReplaceString) == "undefined")
				return;

			newInnerHTML = ReplaceString(newInnerHTML, '&quot;', '"');
			divObj.innerHTML = newInnerHTML;
		}
	}
	// If not found, try to find div in the target frame
	else if (frameId != targetFrameName)
		replaceDivInnerHtml(targetFrameName, divId, newInnerHTML)
}

// This function removes an entire DIV tag
function removeDiv(frameId, divId)
{
	var frame = findTarget(null, frameId, null);

	if (frame != null)
	{
		var divObj = frame.document.getElementById(divId)

		if (divObj != null)
		{
			var ie= (navigator.appName == "Microsoft Internet Explorer")?1:0;

			if (ie)
			{
				var parentTag = divObj.parentElement;

				parentTag.removeChild(divObj);
			}
			else
			{
				var parentNode = divObj.parentNode;

				parentNode.removeChild(divObj);
			}
		}
	}
}

// This function moves a DIV tag to a new absolute position
function moveDiv(frameId, divId, x, y)
{
	var frame = findTarget(null, frameId, null);

	if (frameId == 'null')
		frame = this;

	if (frame != null)
	{
		var divObj = frame.document.getElementById(divId)
		if (divObj != null)
		{
			divObj.style.left = x + "px";
			divObj.style.top = y + "px";
		}
	}
}

// This function adds a DIV tag to an existing DIV tag
function addDiv(frameId, parentDivId, divContent, divId)
{
	var frame = findTarget(null, frameId, null);

	if (frame != null)
	{
		// Check if DIV already exists
		if ((divId != null) && (typeof divId != "undefined"))
		{
			var divObj = frame.document.getElementById(divId);

			if (divObj != null)
				return;
		}

		var parentDivObj = frame.document.getElementById(parentDivId)

		if (parentDivObj != null)
		{
			var	newDiv = document.createElement("DIV");

			newDiv.id = divId;
			newDiv.innerHTML = divContent;
			parentDivObj.appendChild(newDiv);

			return newDiv;
		}
	}
}

// This function resizes a DIV tag
function resizeDiv(frameId, divId, width, height)
{
	var frame = findTarget(null, frameId, null);

	if (frame != null)
	{
		var divObj = frame.document.getElementById(divId);

		if (divObj != null)
		{
			divObj.style.width = width;
			divObj.style.height = height;
		}
	}
}

// This function sets the clip zone and visibility of a div
function setDivClip(frameId, divId, clip, visible)
{
	var frame = findTarget(null, frameId, null);

	if (frame != null)
	{
		var divObj = frame.document.getElementById(divId)

		if (divObj != null)
		{
			divObj.style.clip = clip;

			if (visible)
				divObj.style.display = "block";
			else
				divObj.style.display = "none";
		}
	}
}

// This function displays or hides an element
function displayElement(frameId, elementId, display)
{
	var frame = findTarget(null, frameId, null);

	if (frame != null)
	{
		var element = frame.document.getElementById(elementId)

		if (element != null)
		{
			// Do not use block (may cause troubles with Firefox)
			if (display)
				element.style.display = "";
			else
				element.style.display = "none";
		}
	}
}

// Used to select : unselectAll in DHTML tables
// Used in DHTML only
function selectAllInTable(tableId, frameId, selected, color, selectFontColor)
{
	var frame = findTarget(null, frameId, null);

	if (frame != null)
		frame.selectAll(tableId, selected, color, selectFontColor);
}

// Change the css style of an HTML object
function ChangeObjectClass(objectId, cssClass)
{
	var frame = findTargetByContent(null, objectId);

	if (frame != null)
	{
		var htmlObj = frame.document.getElementById(objectId);

		htmlObj.className = cssClass;
	}
}

// Change the css position style of an HTML object
function ChangeObjectPositionStyle(objectId, position)
{
	var frame = findTargetByContent(null, objectId);

	if (frame != null)
	{
		var htmlObj = frame.document.getElementById(objectId);

		htmlObj.style.position = position;
	}
}

// Change the image of an HTML img
function SetImageSrc(imageId, imageSrc)
{
	var frame = findTargetByContent(null, imageId);

	if (frame != null)
	{
		var imgObj = frame.document.getElementById(imageId);

		imgObj.src = imageSrc;
	}
}

// Change the image background of an HTML object
function SetObjectBackgroundImage(objectId, imageSrc, repeatMode)
{
	var frame = findTargetByContent(null, objectId);

	if (frame != null)
	{
		var obj = frame.document.getElementById(objectId);

		obj.style.background = imageSrc;
		obj.style.backgroundRepeat = repeatMode;
	}
}

// Change the tooltip of an HTML img
function SetImageTooltip(imageId, imageTooltip)
{
	var frame = findTargetByContent(null, imageId);

	if (frame != null)
	{
		var imgObj = frame.document.getElementById(imageId);

		imgObj.alt = imageTooltip;
		imgObj.title = imageTooltip;
	}
}

// Change the title of the Leonardi top frame
function setTopTitle(title)
{
	var topFrame = getLeonardiTopFrame();

	if ((topFrame != null) && (typeof topFrame != "undefined"))
		topFrame.document.title = title;
}

// Scroll down to the active row
function ShowActiveRow(rowId, frameId)
{
	var frame = findTarget(null, frameId, null);

	if (frame != null)
	{
		var divObj = frame.document.getElementById(rowId)

		if (divObj != null)
		{
			if (typeof(divObj.scrollIntoView) == "undefined")
				return;

			divObj.scrollIntoView(false);
		}
	}
}

// Change the color of a row in a table
function SetRowColor(rowId, color, frameId, evenColor, oddColor)
{
	var frame = findTarget(null, frameId, null);

	if (frame != null)
	{
		var trObject = frame.document.getElementById(rowId)
		if (trObject != null)
		{
			trObject.style.backgroundColor = color;


			var ie= (navigator.appName == "Microsoft Internet Explorer")?1:0;
			var classStyle;
			if(ie)
			{
				for (var j = 0; j < trObject.children.length; j++)
				{
					if (trObject.childNodes[j].tagName == "TD")
					{
						var	td = trObject.children[j];
						td.style.backgroundColor = color;
						classStyle = td.className;
					}
				}
			}
			else
			{
				for (var j = 0; (j < trObject.cells.length); j++)
				{
					var	td = trObject.cells[j];
					td.style.backgroundColor = color;
					classStyle = td.className;
				}
			}
			if ((color == null) || (color == ""))
			{
				if ("RE" == classStyle)
					color = evenColor;
				else
					color = oddColor;
			}
			trObject.bgColor = color;
		}
	}
}


// Set the background color of an HTML object
function SetObjectColor(frameId, objId, color)
{
	var frame = findTarget(null, frameId, null);

	if (frame != null)
	{
		var obj = frame.document.getElementById(objId)

		if (obj != null)
		{
			if (color == null)
				color = "";

			// oldBackgroundColor is needed for table cells
			obj.style.oldBackgroundColor = color;
			obj.style.backgroundColor = color;
		}
	}
}

// Set the attribute value of a DIV
function SetDivAttribute(frameId, divId, name, value)
{
	var frame = findTarget(null, frameId, null);

	if (frame != null)
	{
		var obj = frame.document.getElementById(divId)

		if (obj != null)
			obj.setAttribute(name, value);
	}
}

// Update the position of the cell decorations in a given frame
function UpdateCellDecorations(frameId)
{
	var frame = findTarget(null, frameId, null);

	if ((frame != null) && (frame.cellDecorations != null) && (typeof frame.cellDecorations != "undefined"))
	{
		for (var i = 0; i < frame.cellDecorations.length; i++)
		{
			frame.UpdateCellDecoration(frame.cellDecorations[i], false, frameId);
		}
	}
}

// Scrolls the headers part of a tabs component
function scrollTabHeaders(next, frameId, elementId, tableElementId, tabsContentId)
{
	var frame = findTarget(null, frameId, null);

	if (frame != null)
	{
		var element = frame.document.getElementById(elementId);
		var tableElement = frame.document.getElementById(tableElementId);
		var parentElement = frame.document.getElementById(tabsContentId);
		var diff = tableElement.offsetWidth - parentElement.offsetWidth + 25;
		var newPos = parseInt(element.style.left) - (next ? parentElement.offsetWidth / 2 : -parentElement.offsetWidth / 2);

		if (tableElement.offsetWidth < parentElement.offsetWidth + 25)
			return;

		if (newPos > 0)
			newPos = 0;

		if (newPos < -diff)
			newPos = -diff;

		element.style.left = newPos + 'px';
	}
}

// Check the scroll position of a tabs component
function checkScrollTabHeaders(frameId, elementId, tableElementId, tabsContentId, leftImageId, rightImageId)
{
	var frame = findTarget(null, frameId, null);

	if (frame != null)
	{
		var element = frame.document.getElementById(elementId);
		var tableElement = frame.document.getElementById(tableElementId);
		var parentElement = frame.document.getElementById(tabsContentId);
		var leftImage = frame.document.getElementById(leftImageId);
		var rightImage = frame.document.getElementById(rightImageId);

		for (var i = 0; i < 10; i++)
		{
			var diffLeft = cmGetXAt(leftImage, tableElement) + parseInt(element.style.left);
			var diffRight = parentElement.offsetWidth - parseInt(element.style.left) - cmGetXAt(rightImage, tableElement) - 25;

			if (diffRight < 0)
				scrollTabHeaders(true, frameId, elementId, tableElementId, tabsContentId);
			else if (diffLeft < 0)
				scrollTabHeaders(false, frameId, elementId, tableElementId, tabsContentId);
			else
				break;
		}
	}
}


/*******************************************************
 *     Ajax functions used to refresh page content     *
 *******************************************************/

var waitShadowDelay = 1000;
var waitDivDelay = 1000;
var showWaitDivRequestTime = 0;

// Refresh the content of a div by sending an Ajax request
function RefreshDiv(frameId, writerId, divId, frameValue, path, separator, target)
{
	var ajaxRequest;

	if (window.XMLHttpRequest)
		ajaxRequest = new XMLHttpRequest();
	else if (window.ActiveXObject)
		ajaxRequest = new ActiveXObject("Microsoft.XMLHTTP");

	showWaitDiv(true, true);

	// Dynamic creation of a Javascript function to be sure to use the right ajax request in the response
	var ajaxCallback = function()
	{
		ProcessRefreshDiv(ajaxRequest, frameId, divId, separator);
	}

	var url = _rootUrl + path;
	var params = pageParam + "=" + writerId + "&" + frameParam + "=" + frameValue + "&" + ajaxParam + "=true";

	if ((typeof target != "undefined") && (target != null) && (target != "null"))
		params += "&target_session=" + target;

	ajaxRequest.open("POST", url, true);
	ajaxRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded;charset=UTF-8");
	ajaxRequest.onreadystatechange = ajaxCallback;
	ajaxRequest.send(params);
}

// This function implements the process of an ajax request used to refresh the content of a div
function ProcessRefreshDiv(ajaxRequest, frameId, divId, separator)
{
	if (ajaxRequest.readyState == 4)
	{
		if (ajaxRequest.status == 200)
		{
			var text = ajaxRequest.responseText;
			var scripts = StringToArray(text, separator);
			var content = scripts[0];
			var scriptsToEval = scripts[1];

			replaceDivInnerHtml(frameId, divId, content);

			EvalScripts(scriptsToEval);

			// If div is refreshed in the popup view, check its size
			if (frameId == popupFrameName)
				checkSizePopupView(null, false);
			else if ((typeof scriptsToEval != "undefined") && (scriptsToEval.indexOf('checkSizeMainView(') < 0))
				checkSizeMainView('true', 'false');

			showWaitDiv(false, true);
		}
	}
}

// Shows or hides the wait panel
function showWaitDiv(show, recurse)
{
	// Does nothing. Must be overridden in a specific home JSP for example.
	var topFrame = getLeonardiTopFrame();

	if (!recurse)
	{
		if (show)
		{

			if (showWaitDivRequestTime <= 0)
				showWaitDivRequestTime = new Date().getTime();

			if (waitShadowDelay == 0)
				ShowWaitShadow(true);
			else
				setTimeout("ShowWaitShadow(true)", waitShadowDelay);

			if (waitDivDelay == 0)
				RefreshWaitDiv();
			else
				setTimeout("RefreshWaitDiv()", waitDivDelay - (-100));
		}
		else
		{
			showWaitDivRequestTime = 0;
			ShowWaitShadow(false);
		}
	}
	else
		topFrame.showWaitDiv(show, false);
}

// Shows or hides the wait shadow
function ShowWaitShadow(show)
{
	var topFrame = getLeonardiTopFrame();
	var waitDivShadow = topFrame.document.getElementById(waitDivShadowName);

	if (waitDivShadow == null)
		return;

	if (show && (showWaitDivRequestTime > 0))
	{
		waitDivShadow.style.width = topFrame.document.body.clientWidth;
		waitDivShadow.style.height = topFrame.document.body.clientHeight;
		waitDivShadow.style.left = 0;
		waitDivShadow.style.top = 0;
		waitDivShadow.style.visibility = 'visible';
	}
	else
		waitDivShadow.style.visibility = 'hidden';
}

// Check the visibility state of the wait panel
function RefreshWaitDiv()
{
	var topFrame = getLeonardiTopFrame();
	var waitDivPanel = topFrame.document.getElementById(waitDivPanelName);
	var waitDivShadow = topFrame.document.getElementById(waitDivShadowName);

	if ((waitDivPanel == null) && (waitDivShadow == null))
		return;

	if ((showWaitDivRequestTime > 0) && (new Date().getTime() - showWaitDivRequestTime >= waitDivDelay))
	{
		ShowWaitShadow(true);
		// Center wait panel
		waitDivPanel.style.left = (topFrame.document.body.clientWidth - cmGetWidth(waitDivPanel)) / 2;
		waitDivPanel.style.top = (topFrame.document.body.clientHeight - cmGetHeight(waitDivPanel)) / 2;

		waitDivPanel.style.visibility = 'visible';
		setTimeout("RefreshWaitDiv()", 200);
	}
	else
	{
		waitDivPanel.style.visibility = 'hidden';
	}
}

// Indicates if Ajax mode must be used for a given form
function IsAjaxMode(form)
{
	var hasMainFrame = hasLeonardiMainFrame();

	if (!hasMainFrame)
		return false;

	// Check the AJAX_MODE param on the form
	if ((form != null) && (typeof form.elements['AJAX_MODE'] != "undefined"))
	{
		var ajaxMode = form.elements['AJAX_MODE'].value;
		return (ajaxMode == 'true');
	}

	// If the information was not found on the form, use Ajax mode from
	// current frame
	return AJAX_MODE;
}

// Send an Ajax request to the server
function SendAjaxRequest(form, path)
{
	var url = _rootUrl;

	if (((typeof path) != "undefined") && (path != null))
		url += path;
	else if (((typeof STRUTS_EVENT_URL) != "undefined") && (STRUTS_EVENT_URL != null))
		url = url + STRUTS_EVENT_URL;

	var	params = "";
	var	firstParam = true;

	for (var i = 0; i < form.elements.length; i++)
	{
		var add = true;
		var elementName = "", elementValue = "";

		if (((form.elements[i].type == "radio") || (form.elements[i].type == "checkbox"))
				&& (!form.elements[i].checked))
			add = false;

		if (add)
		{
			if (firstParam)
				firstParam = false;
			else
				params += "&";

			// Retrieve element name and value and replace special caracters
			// by their encoded string
			elementName = (form.elements[i].name);
			elementValue = (form.elements[i].value);

			if (typeof CKEDITOR != "undefined")
			{
				var ckInstance = CKEDITOR.instances[elementName];

				if (ckInstance != null)
					elementValue = ckInstance.getData();
			}

			for (var j = 0; j < ajaxEncodedChars.length; j++)
			{
				elementName = ReplaceString(elementName, ajaxChars[j], ajaxEncodedChars[j]);
				elementValue = ReplaceString(elementValue, ajaxChars[j], ajaxEncodedChars[j]);
			}

			params += elementName + "=" + elementValue;
		}
	}

	url = ReplaceString(url, "&#38;", "&");

	var	pos = url.indexOf('?');

	if (form == null)
		params = url.substring(pos + 1, url.length);

	if (pos > 0)
		url = url.substring(0, pos);

	if (form != null)
		ajaxControllerId = form.elements['_controller'].value;

	SendAjaxRequestParams(url, params);
}

// Send an Ajax request to the server
function SendAjaxRequestParams(url, params, showWait)
{
	var ajaxRequest;

	if (window.XMLHttpRequest)
		ajaxRequest = new XMLHttpRequest();
	else if (window.ActiveXObject)
		ajaxRequest = new ActiveXObject("Microsoft.XMLHTTP");

	if ((showWait == null) || (typeof showWait == "undefined") || (showWait != 'false'))
		showWaitDiv(true, true);

	// Dynamic creation of a Javascript function to be sure to use the right ajax request in the response
	var ajaxCallback = function()
	{
		ProcessAjaxRequest(ajaxRequest);
	}

	ajaxRequest.open("POST", url, true);
	ajaxRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded;charset=UTF-8");
	ajaxRequest.onreadystatechange = ajaxCallback;

	if (params.indexOf(ajaxParam) < 0)
		params += "&" + ajaxParam + "=true";

	// Specific process
	var topFrame = getLeonardiTopFrame();

	if (topFrame.beforeAjaxRequestSent)
	      topFrame.beforeAjaxRequestSent(ajaxRequest);

	ajaxRequest.send(params);
}

// This function implements the process of an ajax request
function ProcessAjaxRequest(ajaxRequest)
{
	// Specific process
	var topFrame = getLeonardiTopFrame();

	if (topFrame.beforeAjaxRequestProcessed)
	      topFrame.beforeAjaxRequestProcessed(ajaxRequest);

	if (ajaxRequest.readyState == 4)
	{
		if (ajaxRequest.status == 200)
		{
			changedField = null;

			var text = ajaxRequest.responseText;

			EvalScripts(text);
			showWaitDiv(false, true);

			var ajaxForm = findForm(null, ajaxControllerId);

			if ((ajaxForm != null) && (ajaxForm.elements['_submitted'] != null))
			{
				if (ajaxForm.elements['_submitted'].value == "submitted")
				{
					ajaxForm.elements['_submitted'].value = "";
					ajaxControllerId = null;
					return;
				}
			}
		}
		else if ((ajaxRequest.status == 0) || (ajaxRequest.status >= 500))
		{
			var topFrame = getLeonardiTopFrame();

			if ((topFrame != null) && (typeof topFrame != undefined))
			{
				showWaitDiv(false, true);
				topFrame.ServerDownNotification();
			}
		}
	}
}

// This function calls the eval() function on a text containing several scripts
function EvalScripts(text)
{
	if ((text == null) || ((typeof text) == "undefined"))
		return;

	// Handle exceptions from error page
	if (text.indexOf("LEONARDI_ERROR_PAGE_TAG") >= 0)
	{
		var targetFrame = getLeonardiTargetFrame();

		if ((targetFrame != null) && (typeof targetFrame != undefined))
		{
			targetFrame.document.write(text);
			targetFrame.document.close();
		}
		else
			alert(text);

		return;
	}

	var sep_begin = "//<![CDATA[";
	var sep_end = "//]]>";
	var checkSizePopup = null;
	var hasShowPopup = false;
	var addScript;

	if (text.indexOf("<LEONARDI_WINDOW ") == 0)
	{
		var pos1 = text.indexOf("<LEONARDI_WINDOW ");
		var pos2 = text.indexOf(">");
		var pos3 = text.indexOf("</LEONARDI_WINDOW>");
		var windowName = text.substring(pos1 + "<LEONARDI_WINDOW ".length, pos2);
		var windowText = text.substring(pos2 + 1, pos3);

		text = text.substring(pos3 + "</LEONARDI_WINDOW>".length);

		// Check if window is registered with this name
		for (var i = 0; i < newWindows.length; i++)
		{
			if (newWindows[i][0] == windowName)
			{
				newWindows[i][1].EvalScripts(windowText);
			}
		}
	}

	if (text.indexOf("<script") >= 0)
	{
		var scripts = SplitString(text,
			"<script type='text/javascript'>", "</script>");

		text = "";

		for (var i = 0; i < scripts.length; i++)
		{
			addScript = false;

			var pos1 = scripts[i].indexOf(sep_begin);

			if (pos1 >= 0)
				scripts[i] = scripts[i].substring(pos1 + sep_begin.length);

			var pos2 = scripts[i].indexOf(sep_end);

			if (pos2 > 0)
				scripts[i] = scripts[i].substring(0, pos2);

			if (scripts[i].indexOf("checkSizePopupView") >= 0)
				checkSizePopup = scripts[i];
			else
				addScript = true;

			if (scripts[i].indexOf("showPopupView") >= 0)
				hasShowPopup = true;

			if ((scripts[i].indexOf("hidePopupView") >= 0) && hasShowPopup)
				addScript = false;

			if (addScript)
				text += scripts[i];
		}
	}

	if (checkSizePopup != null)
		text = text + checkSizePopup;

//	alert(text);

	try
	{
		eval(text);
	}
	catch (ex)
	{
		// If an exception occured, reload top Leonardi frame to ensure view is up to date
		var topFrame = getLeonardiTopFrame();

		if (topFrame != null)
			topFrame.document.location.reload();
	}
}
